﻿/**
 * Created by Mnill on 27.03.15.
 */

function Achievement(_id, _name, _file, _description, _points, _init, _needsCount, _tier) {
    this.id = _id;
    this.tier = _tier || 1;
    this.name = _name;
    this.file = _file;
    this.description = _description;
    this.points = _points;
    this.earned = localStorage.getItem(Game.profile + 'achievement' + this.name) == "true";
    this.needsCount = _needsCount;
    if (!this.earned)
        _init.call(this);
}

Achievement.prototype.earn = function(){
    this.earned = true;
    localStorage.setItem(Game.profile + 'achievement'+this.name, true);
    //if (navigator.isCocoonJS)
    //    Cocoon.Social.Manager.submitAchievement(this.id);

    log('achievement'+this.name, Game.menu.selectedLvl);
    Game.globallogic.addSkulls(this.tier == 1 ? 50 : (this.tier == 2 ? 200 : 500));
    if (!Game.isMenu && Game.lvl && Game.lvl.loaded) {
        new AchievementEffect(this.name, this.file, this.description, this.tier == 1 ? 50 : (this.tier == 2 ? 200 : 500));
    }
    Game.events.emit('achievementEarn');
};

Achievement.prototype.toJSON = function () {
    return {achieved:this.earned, name:this.name, imageURL:'achievements/' + this.file, title:this.name, description:this.description, points:this.tier == 1 ? 50 : (this.tier == 2 ? 200 : 500)};
};

function AchievementEffect (name, file, description, skulls) {
    this.ts = 0;
    this.file = file;
    this.loader = new PIXI.loaders.Loader();
    this.loader.add('achievements/'+file,'achievements/'+file);
    this.loader.on('complete', function () {
        if (Game.isMenu || !Game.lvl.loaded) {
            return;
        }
        Game.lvl.objAchievemnts.push(this);

        this.container = new PIXI.Container();
        this.backClose = Game.lvl.pool.getSprite(Game.sprites.background);
        this.backClose.position.y = 204;
        this.backClose.position.x = 20;
        this.backClose.scale.set(28.2, 6);
        this.container.addChild(this.backClose);
        this.tBar = Game.lvl.pool.getSprite(Game.sprites.barUp_barDwn);
        this.tBar.position.y = 100;
        this.tBar.scale.set(1,1);
        this.container.addChild(this.tBar);
        this.bBar = Game.lvl.pool.getSprite(Game.sprites.barUp_barDwn);
        this.bBar.position.y = 301;
        this.bBar.scale.set(1,-1);
        this.container.addChild(this.bBar);

        this.lBar = Game.lvl.pool.getSprite(Game.sprites.barL_barR);
        this.lBar.position.x = -442;
        this.lBar.position.y = 200;
        this.lBar.scale.set(-1,2);
        this.container.addChild(this.lBar);
        this.rBar = Game.lvl.pool.getSprite(Game.sprites.barL_barR);
        this.rBar.position.x = 442;
        this.rBar.position.y = 200;
        this.rBar.scale.set(1,2);
        this.container.addChild(this.rBar);

        this.ltCorner = Game.lvl.pool.getSprite(Game.sprites.Corner);
        this.ltCorner.position.y = 105;
        this.ltCorner.position.x = -436;
        this.ltCorner.scale.set(-1,1);
        this.container.addChild(this.ltCorner);
        this.lbCorner = Game.lvl.pool.getSprite(Game.sprites.Corner);
        this.lbCorner.position.y = 297;
        this.lbCorner.position.x = -436;
        this.lbCorner.scale.set(-1,-1);
        this.container.addChild(this.lbCorner);
        this.rtCorner = Game.lvl.pool.getSprite(Game.sprites.Corner);
        this.rtCorner.position.y = 105;
        this.rtCorner.position.x = 436;
        this.rtCorner.scale.set(1,1);
        this.container.addChild(this.rtCorner);
        this.rlCorner = Game.lvl.pool.getSprite(Game.sprites.Corner);
        this.rlCorner.position.y = 297;
        this.rlCorner.position.x = 436;
        this.rlCorner.scale.set(1,-1);
        this.container.addChild(this.rlCorner);

        this.sprite =  new PIXI.Sprite(this.loader.resources['achievements/'+file].texture);
        this.sprite.anchor.set(0.5, 0.5);
        this.sprite.position.set(-354, 188);
        this.container.addChild(this.sprite);

        Game.font = Game.getFont(76);
        Game.fillStyle = "#FFF2B3";
        this.text = Game.lvl.achievementsText || new PIXI.Text(Game.strings[Game.language].achievementEarn, {
                font: Game.font,
                align: 'center',
                fill: Game.fillStyle
            });
        this.text.anchor.set(0.5, 0.5);
        this.text.position.set(0, 44);
        Game.lvl.achievementsText = this.text;

        Game.font = Game.getFont(62);
        Game.fillStyle = "#DED19D";
        this.textN = new PIXI.Text(name, {
            font: Game.font,
            align: 'center',
            fill: Game.fillStyle
        });
        this.textN.anchor.set(0.5,0.5);
        this.textN.position.set(64, 144);

        Game.font = Game.getFont(48);
        this.textR = new PIXI.Text(Game.strings[Game.language].achievementReward + skulls, {
            font: Game.font,
            align: 'center',
            fill: Game.fillStyle
        });
        this.textR.anchor.set(1, 0.5);
        this.textR.position.set(380, 248);

        this.skull = Game.lvl.pool.getSprite(Game.sprites['skullsShopPriceIcon']);
        this.skull.position.set(408, 248);
        this.skull.scale.set(0.7, 0.7);

        this.container.addChild(this.text);
        this.container.addChild(this.textN);
        this.container.addChild(this.textR);
        this.container.addChild(this.skull);
        this.container.position.set(1024, -400);
        Game.lvl.guiContainer.addChild(this.container);
    }.bind(this));
    this.loader.load();
}

AchievementEffect.prototype.update = function () {
    if ((this.ts+=50) <= 800) {
        this.container.position.y +=25;
    } else if (this.ts < 3500) {

    } else if (this.ts < 4400) {
        this.container.position.y -= 50;
    } else {
        if (Game.lvl.objAchievemnts.indexOf(this)!=-1)
            Game.lvl.objAchievemnts.splice(Game.lvl.objAchievemnts.indexOf(this), 1);

        Game.lvl.guiContainer.removeChild(this.container);
        this.loader.resources['achievements/'+this.file].texture.baseTexture && this.loader.resources['achievements/'+this.file].texture.baseTexture.source && this.loader.resources['achievements/'+this.file].texture.baseTexture.source.dispose && this.loader.resources['achievements/'+this.file].texture.baseTexture.source.dispose();
        this.loader.resources['achievements/'+this.file].texture.destroy(true);
        this.loader.resources['achievements/'+this.file].texture.baseTexture && this.loader.resources['achievements/'+this.file].texture.baseTexture.source && this.loader.resources['achievements/'+this.file].texture.baseTexture.source  && (this.loader.resources['achievements/'+this.file].texture.baseTexture.source = null);
        this.loader = null;

        this.textN._texture.baseTexture.source.dispose && this.textN._texture.baseTexture.source.dispose();
        this.textN.destroy(true);
        this.textN._texture.baseTexture && (this.textN._texture.baseTexture.source = null);

        this.textR._texture.baseTexture.source.dispose && this.textR._texture.baseTexture.source.dispose();
        this.textR.destroy(true);
        this.textR._texture.baseTexture && (this.textR._texture.baseTexture.source = null);
    }
};

function loadAchievements () {
    function killer() {
        if (!this.earned) {
            Game.events.on('enemyKilled', function(){
                if (!this.earned && Game.enemyKilled >= this.needsCount)
                    this.earn();
            }.bind(this))
        }
    }
    function builder () {
        if (!this.earned) {
            Game.events.on('towerBuild', function() {
                if (!this.earned && Game.towerBuild >= this.needsCount)
                    this.earn();
            }.bind(this))
        }
    }

    function livesOnEnd () {
        if (!this.earned) {
            Game.events.on('lvlWin', function() {
                if (!this.earned && Game.menu.selectedLvl != "0" && Game.lvl && Game.lvl.townHall && Game.lvl.townHall.hitPoints == this.needsCount && Game.menu.selectedLvl != "0")
                    this.earn();
            }.bind(this))
        }
    }

    function stars () {
        if (!this.earned) {
            Game.events.on('lvlWin', function() {
                if (!this.earned && Game.globallogic.allStars >= this.needsCount)
                    this.earn();
            }.bind(this))
        }
    }

    function crazy () {
        if (!this.earned) {
            Game.events.on('lvlWin', function() {
                if (!this.earned && Game.lvl.gameLogic.crazy && Game.menu.selectedLvl != "0")
                    this.earn();
            }.bind(this))
        }
    }

    function grumpy () {
        if (!this.earned) {
            Game.events.on('calledEarly', function() {
                if (!this.earned && Game.calledEarly >= this.needsCount){
                    this.earn();
                }
            }.bind(this))
        }
    }


    function headshot () {
        if (!this.earned)
            Game.events.on('enemyKilledByCrit', function() {
                if (!this.earned && Game.lvl.gameLogic.crazy)
                    this.earn();
            }.bind(this))
    }

    function lucky () {
        if (!this.earned)
            Game.events.on('criticalStrike', function() {
                if (!this.earned && Game.criticalStrike >= this.needsCount)
                    this.earn();
            }.bind(this))
    }

    function legend () {
        if (!this.earned) {
            if (Game.globallogic.selectedHero.lvl > 19)
                this.earn();
            else
                Game.events.on('heroLvlUp', function () {
                    if (!this.earned && Game.globallogic.selectedHero.lvl > 19)
                        this.earn();
                }.bind(this))
        }
    }

    function loneWolf () {
        if (!this.earned) {
            Game.events.on('lvlWin', function() {
                if (!this.earned && Game.lvl.gameLogic.loneWolf && Game.menu.selectedLvl != "0")
                    this.earn();
            }.bind(this))
        }
    }

    function lazarus () {
        if (!this.earned) {
            Game.events.on('lvlWin', function() {
                if (!this.earned && Game.lvl.gameLogic.lazarus)
                    this.earn();
            }.bind(this))
        }
    }


    function whereIsEverybody () {
        if (!this.earned) {
            Game.events.on('lvlWin', function() {
                if (!this.earned && Game.lvl.gameLogic.whereIsEverybody && Game.menu.selectedLvl != "0")
                    this.earn();
            }.bind(this))
        }
    }

    function loyalist () {
        if (!this.earned) {
            Game.events.on('lvlWin', function() {
                if (!this.earned && Game.lvl.gameLogic.loyalist && Game.menu.selectedLvl != "0")
                    this.earn();
            }.bind(this))
        }
    }

    function horde () {
        if (!this.earned) {
            Game.events.on('lvlWin', function() {
                if (!this.earned && Game.lvl.gameLogic.horde && Game.menu.selectedLvl != "0")
                    this.earn();
            }.bind(this))
        }
    }

    function heroAlife () {
        if (!this.earned) {
            Game.events.on('lvlWin', function() {
                if (!this.earned && Game.lvl.gameLogic.hero.deathCounter == 0 && this.needsCount == Game.menu.selectedLvl)
                    this.earn();
            }.bind(this))
        }
    }

    function bigaboom () {
        if (!this.earned) {
            Game.events.on('bigaboom', function() {
                if (!this.earned)
                    this.earn();
            }.bind(this))
        }
    }

    function killCannon() {
        if (!this.earned) {
            Game.events.on('cannonKill', function() {
                if (!this.earned && Game.cannonKill >= this.needsCount)
                    this.earn();
            }.bind(this))
        }
    }

    function killLighting() {
        if (!this.earned) {
            Game.events.on('lightingKill', function() {
                if (!this.earned && Game.lightingKill >= this.needsCount)
                    this.earn();
            }.bind(this))
        }
    }

    function hordeFlyingKill() {
        if (!this.earned) {
            Game.events.on('hordeFlyingKill', function() {
                if (!this.earned && Game.hordeFlyingKill >= this.needsCount)
                    this.earn();
            }.bind(this))
        }
    }

    function orcsKill() {
        if (!this.earned) {
            Game.events.on('orcsKill', function() {
                if (!this.earned && Game.orcsKill >= this.needsCount)
                    this.earn();
            }.bind(this))
        }
    }

    function goblinsKill() {
        if (!this.earned) {
            Game.events.on('goblinsKill', function() {
                if (!this.earned && Game.goblinsKill >= this.needsCount)
                    this.earn();
            }.bind(this))
        }
    }

    function bombKill() {
        if (!this.earned) {
            Game.events.on('bombKill', function() {
                if (!this.earned && Game.bombKill >= this.needsCount)
                    this.earn();
            }.bind(this))
        }
    }

    function dragonsKiller() {
        if (!this.earned) {
            Game.events.on('dragonsKiller', function() {
                if (!this.earned && Game.dragonsKiller >= this.needsCount)
                    this.earn();
            }.bind(this))
        }
    }

    function orcsKiller() {
        if (!this.earned) {
            Game.events.on('orcsKiller', function() {
                if (!this.earned && Game.orcsKiller >= this.needsCount)
                    this.earn();
            }.bind(this))
        }
    }

    function goblinsKiller() {
        if (!this.earned) {
            Game.events.on('goblinsKiller', function() {
                if (!this.earned && Game.goblinsKiller >= this.needsCount)
                    this.earn();
            }.bind(this))
        }
    }

    function zombiesKiller() {
        if (!this.earned) {
            Game.events.on('zombiesKiller', function() {
                if (!this.earned && Game.zombiesKiller >= this.needsCount)
                    this.earn();
            }.bind(this))
        }
    }

    function swarmarrows () {
        if (!this.earned) {
            Game.events.on('archerKill', function() {
                if (!this.earned && Game.archerKill >= this.needsCount)
                    this.earn();
            }.bind(this))
        }
    }

    function posioned () {
        if (!this.earned) {
            Game.events.on('poisoned', function(){
                if (!this.earned && Game.poisoned >= this.needsCount)
                    this.earn();
            }.bind(this))
        }
    }

    function heroKiller () {
        if (!this.earned) {
            Game.events.on('enemyKilledFromHero', function () {
                if (!this.earned && Game.enemyKilledFromHero >= this.needsCount)
                    this.earn();
            }.bind(this))
        }
    }

    function loser (){
        if (!this.earned) {
            Game.events.on('lvlLose', function () {
                if (!this.earned && Game.lvlLose >= this.needsCount)
                    this.earn();
            }.bind(this))
        }
    }

    function trader (){
        if (!this.earned) {
            Game.events.on('sellTower', function () {
                if (!this.earned && Game.sellTower >= this.needsCount)
                    this.earn();
            }.bind(this))
        }
    }

    function armageddon () { //TODO
        if (!this.earned) {
            Game.events.on('armageddon', function () {
                if (!this.earned)
                    this.earn();
            }.bind(this))
        }
    }

    function spendSkull () {
        if (!this.earned) {
            Game.events.on('spendSkull', function () {
                if (!this.earned && Game.spendSkull >= this.needsCount)
                    this.earn();
            }.bind(this))
        }
    }

    function medic () {
        if (!this.earned) {
            Game.events.on('medic', function () {
                if (!this.earned && Game.medic >= this.needsCount)
                    this.earn();
            }.bind(this))
        }
    }


    function bag () { //TODO
        if (!this.earned) {
            Game.events.on('bag', function () {
                if (!this.earned)
                    this.earn();
            }.bind(this))
        }
    }

    function killgragon () {
        if (!this.earned) {
            Game.events.on('killgragon', function () {
                if (!this.earned)
                    this.earn();
            }.bind(this))
        }
    }

    function killdragon () {
        if (!this.earned) {
            Game.events.on('killdragon', function () {
                if (!this.earned)
                    this.earn();
            }.bind(this))
        }
    }

    function killnecro () {
        if (!this.earned) {
            Game.events.on('killnecro', function () {
                if (!this.earned)
                    this.earn();
            }.bind(this))
        }
    }

    function easy () {
        if (!this.earned) {
            Game.events.on('lvlWin', function () {
                if (!this.earned && Game.globallogic.lvls.filter(function(lvl){return lvl.passed > 0 && (lvl.difficulty == 'easy' || lvl.difficulty == 'normal' || lvl.difficulty == 'hard')}).length === Game.globallogic.lvls.length) {
                    this.earn();
                }
            }.bind(this))
        }
    }

    function normal () {
        if (!this.earned) {
            Game.events.on('lvlWin', function () {
                if (!this.earned && Game.globallogic.lvls.filter(function(lvl){ return lvl.passed > 0 && (lvl.difficulty == 'normal' || lvl.difficulty == 'hard')}).length === Game.globallogic.lvls.length) {
                    this.earn();
                }
            }.bind(this))
        }
    }

    function hard () {
        if (!this.earned) {
            Game.events.on('lvlWin', function () {
                if (!this.earned && Game.globallogic.lvls.filter(function(lvl){return lvl.passed > 0 && lvl.difficulty == 'hard'}).length === Game.globallogic.lvls.length) {
                    this.earn();
                }
            }.bind(this))
        }
    }

    function chiken(){
        if (!this.earned) {
            Game.events.on('restarted', function () {
                if (!this.earned && Game.restarted >= this.needsCount) {
                    this.earn();
                }
            }.bind(this))
        }
    }

    function king () {
        var check = function() {
            var all = true;
            for(var i=0; i< 54; i++) {
                if (!Game.LOCAL_ACHIEVEMENTS_MAP[i].earned)
                    all = false;
            }
            if (all && !this.earned)
                this.earn();
        };
        if (!this.earned) {
            Game.events.on('achievementEarn', check.bind(this));
            setTimeout(check.bind(this), 1);
        }
    }

    if (Game.language != 'ru') {
        Game.LOCAL_ACHIEVEMENTS_MAP = {
            0: new Achievement(0, 'First Blood', 'firstblood.png', 'Kill your first enemy', 5, killer, 1, 1),
            1: new Achievement(1, 'Begin', 'begin.png', 'Build a tower', 20, builder, 1),
            2: new Achievement(2, 'Builder', 'builder.png', 'Build 50 towers', 20, builder, 100, 2),
            3: new Achievement(3, 'Grant builder', 'grantbuilder.png', 'Build 1000 towers', 20, builder, 1000, 3),
            4: new Achievement(4, 'Flawless victory', 'flawlessvictory.png', 'End a level without passed enemies', 20, livesOnEnd, 20, 1),
            5: new Achievement(5, 'Lets start', 'star.png', 'Earn 5 stars', 50, stars, 5, 1),
            6: new Achievement(6, 'Skilled', 'star2.png', 'Earn 25 stars', 75, stars, 25, 2),
            7: new Achievement(7, 'Fully equipped', 'star3.png', 'Earn 75 stars', 100, stars, 75, 3),
            8: new Achievement(8, 'Vigorous', 'crazy.png', 'Call all waves early in a single camp', 50, crazy, 1, 1),
            9: new Achievement(9, 'Grumpy', 'Spawn1000waves.png', 'Spawn early 100 waves', 10, grumpy, 100, 2),
            10: new Achievement(10, 'HeadShot', 'headshot.png', 'Kill enemy by a critical shot', 10, headshot, 10, 1),
            11: new Achievement(11, 'Lucky', 'lucky.png', 'Make a 1000 critical shots', 20, lucky, 1000, 2),
            12: new Achievement(12, 'Legend', 'legend.png', 'Train any hero up to 20 lvl', 100, legend, 2),
            13: new Achievement(13, 'For the tribe', 'forthetribe.png', '1000 enemies killed by any hero', 20, heroKiller, 1000, 2),
            14: new Achievement(14, 'Last Man Stand', 'LastManStand.png', 'Complete final mission from act 1 without hero death', 20, heroAlife, 7, 3),
            15: new Achievement(15, 'Survived', 'survived.png', 'Complete final mission from act 2 without hero death', 20, heroAlife, 18, 3),
            16: new Achievement(16, 'Demon Hunter', 'DemonHunter.png', 'Complete final mission from act 3 without hero death', 20, heroAlife, 27, 3),
            17: new Achievement(17, 'Lone Wolf', 'Lone-wolf.png', 'Pass a lvl without any buildings', 200, loneWolf, 3, 3),
            18: new Achievement(18, 'Loyalist', 'loyalist.png', 'Pass a camp with a only one type of towers', 50, loyalist, 2),
            19: new Achievement(19, 'Horde', 'horde.png', 'Pass a camp with only units', 50, horde, 2),
            20: new Achievement(20, 'Lazarus', 'Lazarus.png', 'Pass lvl without any hero help', 200, lazarus, 1),
            21: new Achievement(21, 'Where is everybody?!', 'WhereIsEverybody.png', 'Pass lvl without any units buildings', 50, whereIsEverybody, 1),
            22: new Achievement(22, 'On the edge', 'ontheedge.png', "Finish camp with one live", 20, livesOnEnd, 1),
            23: new Achievement(23, 'BigaBoom', 'bigaboom.png', 'Kill 5 or more enemies for one cannon shot', 20, bigaboom, 0, 2),
            24: new Achievement(24, 'Devastation', 'Devastation.png', 'Kill 2000 units with catapult or cannon', 20, killCannon, 2000, 1),
            25: new Achievement(25, 'Swarm of arrows', 'swarmofarrows.png', 'Kill 2000 enemies with archers towers', 20, swarmarrows, 2000, 1),
            26: new Achievement(26, 'Veil of poison', 'veilofpoison.png', '2000 poisoned enemies', 20, posioned, 2000, 1),
            27: new Achievement(27, 'High Voltage', 'highvoltage.png', 'Kill 2000 units with lightning tower', 20, killLighting, 2000, 1),
            28: new Achievement(28, 'Clear skyes', 'clearskyes.png', 'Kill 2000 flying units with horde tower', 20, hordeFlyingKill, 2000, 1),
            29: new Achievement(29, 'Army', 'Army.png', 'Kill 1000 units with orcs', 20, orcsKill, 1000, 1),
            30: new Achievement(30, 'Sharpshooters', 'Sharpshooters.png', 'Kill 2000 units with goblins', 20, goblinsKill, 2000, 1),
            31: new Achievement(31, 'Conjurror', 'Conjurror.png', 'Kill 1000 units with bomb and meteor spell', 20, bombKill, 1000, 3),
            32: new Achievement(32, 'Tenacity', 'tenacity.png', "Lose 10 camp's", 20, loser, 10),
            33: new Achievement(33, 'Trader', 'trader.png', "Sell 10 towers", 20, trader, 10, 1),
            34: new Achievement(34, 'Merchant', 'merchant.png', "Sell 50 towers", 20, trader, 50, 1),
            35: new Achievement(35, 'Negotiant', 'negotiant.png', "Sell 100 towers", 50, trader, 100, 2),
            36: new Achievement(36, 'Meteor', 'armageddon.png', "Use meteor scroll", 20, armageddon, 99, 1),
            37: new Achievement(37, 'Mountain of skulls', 'mountainofskulls.png', "Spend 5000 skulls", 20, spendSkull, 99, 1),
            38: new Achievement(38, 'СornucoMedicia', 'medic.png', "Heal 10 000 HP", 20, medic, 10000, 1),
            39: new Achievement(39, 'Saint', 'saint.png', "Heal 50 000 HP", 50, medic, 50000, 2),
            40: new Achievement(40, 'Dragon killer', 'Dragonkiller.png', "Kill 500 any dragons", 5, dragonsKiller, 500, 1),
            41: new Achievement(41, 'Orcs hunter', 'OrcsHunter.png', "Kill 500 orcs", 5, orcsKiller, 500, 1),
            42: new Achievement(42, 'Small Fry', 'smallfry.png', "kill 1000 goblins", 5, goblinsKiller, 1000, 1),
            43: new Achievement(43, 'Zombie apocalypse', 'Zombieapocalypse.png', "Kill 1000 zombies", 20, zombiesKiller, 1000, 1),
            44: new Achievement(44, 'Scramble', 'scramble.png', 'Kill 500 enemies', 10, killer, 500, 1),
            45: new Achievement(45, 'Battle', 'battle.png', 'Kill 5 000 enemies', 20, killer, 5000, 2),
            46: new Achievement(46, 'Epic battle', 'EpicBattle.png', 'Kill 100 000 enemies', 50, killer, 100000, 3),
            47: new Achievement(47, 'I am bigga!', 'gragonskiller.png', "Kill the chieftain of red orcs", 20, killgragon, 1, 3),
            48: new Achievement(48, 'Dragonslayer', 'dragonslayer.png', "Kill the dragon king", 50, killdragon, 1, 3),
            49: new Achievement(49, 'Redeemer', 'redeemer.png', "Kill the necromancer", 100, killnecro, 1, 3),
            50: new Achievement(50, 'Peasant', 'peasant.png', "Pass the game on easy difficulty", 20, easy, 1, 1),
            51: new Achievement(51, 'Grunt', 'peasant.png', "Pass the game on normal difficulty", 20, normal, 1, 2),
            52: new Achievement(52, 'WarChief', 'hardcore.png', "Pass the game on hard difficulty", 20, hard, 1, 3),
            53: new Achievement(53, 'Сhicken', 'chicken.png', "Restart 10 times", 20, chiken, 10, 1),
            54: new Achievement(54, 'King of achievements', 'kingofachievements.png', "Open all achievements", 100, king, 1, 3)
        };
    } else {
        Game.LOCAL_ACHIEVEMENTS_MAP = {
            0 : new Achievement(0, 'Первая кровь', 'firstblood.png', 'Убить первого врага', 5, killer, 1, 1),
            1 : new Achievement(1, 'Начало', 'begin.png', 'Построить первую башню', 20, builder, 1),
            2 : new Achievement(2, 'Строитель', 'builder.png', 'Построить 50 башен', 20, builder, 100, 2),
            3 : new Achievement(3, 'Зодчий', 'grantbuilder.png', 'Построить 1000 башен', 20, builder, 1000, 3),
            4 : new Achievement(4, 'Безупречная победа', 'flawlessvictory.png', 'Закончить уровень с 20 жизнями', 20, livesOnEnd, 20, 1),
            5 : new Achievement(5, 'Новичок', 'star.png', 'Заработать 5 звёзд', 50, stars, 5, 1),
            6 : new Achievement(6, 'Опытный', 'star2.png', 'Заработать 25 звёзд', 75, stars, 25, 2),
            7 : new Achievement(7, 'Полностью укомплектован', 'star3.png', 'Заработать 75 звёзд', 100, stars, 75, 3),
            8 : new Achievement(8, 'Нетерпеливый', 'crazy.png', 'Запустить все волны раньше времени на уровне', 50, crazy, 1, 1),
            9 : new Achievement(9, 'Раздражительный', 'Spawn1000waves.png', 'Вызвать 1000 ранних волн', 10, grumpy, 100, 2),
            10 : new Achievement(10, 'В яблочко!', 'headshot.png', 'Убить врага критическим попаданием', 10, headshot, 10, 1),
            11 : new Achievement(11, 'Счастливчик', 'lucky.png', 'Сделать 1000 критических попаданий', 20, lucky, 1000, 2),
            12 : new Achievement(12, 'Легенда', 'legend.png', 'Поднять уровень люього героя до 20', 100, legend, 2),
            13 : new Achievement(13, 'За племя!', 'forthetribe.png', 'Убить героем 1000 врагов', 20, heroKiller, 1000, 2),
            14 : new Achievement(14, 'Последний выживший', 'LastManStand.png', 'Завершить финальную миссию 1 акта без смерти героя', 20, heroAlife, 7, 3),
            15 : new Achievement(15, 'Уцелевший', 'survived.png', 'Завершить финальную миссию 2 акта без смерти героя', 20, heroAlife, 18, 3),
            16 : new Achievement(16, 'Охотник на нежить', 'DemonHunter.png', 'Завершить финальную миссию 3 акта без смерти героя', 20, heroAlife, 27, 3),
            17 : new Achievement(17, 'Одинокий волк', 'Lone-wolf.png', 'Выиграть уровень без единой постройки', 200, loneWolf, 3),
            18 : new Achievement(18, 'Приверженец', 'loyalist.png', 'Пройти уровень с одним типом построек', 50, loyalist, 2),
            19 : new Achievement(19, 'Орда', 'horde.png', 'Пройти уровень только войсками', 50, horde, 2),
            20 : new Achievement(20, 'Прокаженный', 'Lazarus.png', 'Пройти уровень без какой либо помощи героя', 200, lazarus, 1),
            21 : new Achievement(21, 'Где все?!', 'WhereIsEverybody.png', 'Пройти уровень без постройки войск', 50, whereIsEverybody, 1),
            22 : new Achievement(22, 'На грани', 'ontheedge.png', "Закончить уровень с 1 жизнью", 20, livesOnEnd, 1),
            23 : new Achievement(23, 'Бабах!', 'bigaboom.png', 'Убить 5 врагов одним попаданием пушки', 20, bigaboom, 0, 2),
            24 : new Achievement(24, 'Опустошение', 'Devastation.png', 'Убить 2000 врагов из пушки или катапульты', 20, killCannon, 2000, 1),
            25 : new Achievement(25, 'Рой стрел', 'swarmofarrows.png', 'Убить 2000 врагов стрелковыми башнями', 20, swarmarrows, 2000, 1),
            26 : new Achievement(26, 'Завеса яда', 'veilofpoison.png', 'Отравить 2000 врагов', 20, posioned, 2000, 1),
            27 : new Achievement(27, 'Высокое напряжение', 'highvoltage.png', 'Убить 2000 врагов обелиском бури', 20, killLighting, 2000, 1),
            28 : new Achievement(28, 'Чистые небеса', 'clearskyes.png', 'Убить 2000 летающих врагов башней орды', 20, hordeFlyingKill, 2000, 1),
            29 : new Achievement(29, 'Армия', 'Army.png', 'Убить 1000 врагов орками', 20, orcsKill, 1000, 1),
            30 : new Achievement(30, 'Стрелки', 'Sharpshooters.png', 'Убить 2000 врагов гоблинами', 20, goblinsKill, 2000, 1),
            31 : new Achievement(31, 'Заклинатель', 'Conjurror.png', 'Убить 1000 врагов свитками', 20, bombKill, 1000, 3),
            32 : new Achievement(32, 'Упорный', 'tenacity.png', "Проиграть 10 уровней", 20, loser, 10),
            33 : new Achievement(33, 'Барыга', 'trader.png', "Продать 10 башен", 20, trader, 10, 1),
            34 : new Achievement(34, 'Торговец', 'merchant.png', "Продать 50 башен", 20, trader, 50, 1),
            35 : new Achievement(35, 'Негоциант', 'negotiant.png', "Продать 100 башен", 50, trader, 100, 2),
            36 : new Achievement(36, 'Горящие небеса!', 'armageddon.png', "Использовать свиток метеора", 20, armageddon, 99, 1),
            37 : new Achievement(37, 'Гора черепов', 'mountainofskulls.png', "Потратить 5000 черепов", 20, spendSkull, 99, 1),
            38 : new Achievement(38, 'Целитель', 'medic.png', "Вылечить 10 000 жизней войскам", 20, medic, 10000, 1),
            39 : new Achievement(39, 'Святой', 'saint.png', "Вылечить 10 000 жизней войскам", 50, medic, 50000, 2),
            40 : new Achievement(40, 'Охотник на драконов', 'Dragonkiller.png', "Убить 500 драконов", 5, dragonsKiller, 500, 1),
            41 : new Achievement(41, 'Охотник на орков', 'OrcsHunter.png', "Убить 500 орков", 5, orcsKiller, 500, 1),
            42 : new Achievement(42, 'Мелкая сошка', 'smallfry.png', "Убить 1000 гоблинов", 5, goblinsKiller, 1000, 1),
            43 : new Achievement(43, 'Зомби апокалипсис!', 'Zombieapocalypse.png', "Убить 1000 зомби", 20, zombiesKiller, 1000, 1),
            44 : new Achievement(44, 'Потасовка', 'scramble.png', 'Убить 500 врагов', 10, killer, 500, 1),
            45 : new Achievement(45, 'Битва', 'battle.png', 'Убить 5000 врагов', 20, killer, 5000, 2),
            46 : new Achievement(46, 'Эпичное сражение', 'EpicBattle.png', 'Убить 100 000 врагов', 50, killer, 100000, 3),
            47 : new Achievement(47, 'Я больше!!!', 'gragonskiller.png', "Убить вожака красных орков", 20, killgragon, 1, 3),
            48 : new Achievement(48, 'Убийца драконов', 'dragonslayer.png', "Убить Черного дракона", 50, killdragon, 1, 3),
            49 : new Achievement(49, 'Избавитель', 'redeemer.png', "Победить Некроманта", 100, killnecro, 1, 3),
            50 : new Achievement(50, 'Крестьянин', 'peasant.png', "Пройти игру на лёгкой сложности", 20, easy, 1, 1),
            51 : new Achievement(51, 'Воин', 'peasant.png', "Пройти игру на нормальной сложности", 20, normal, 1, 2),
            52 : new Achievement(52, 'Боевой вождь', 'hardcore.png', "Пройти игру на максимаьной сложности", 20, hard, 1, 3),
            53 : new Achievement(53, 'Ципа', 'chicken.png', "Начать уровень заново 10 раз", 20, chiken, 10, 1),
            54 : new Achievement(54, 'Истинный за... Защитник!', 'kingofachievements.png', "Открыть все достижения", 100, king, 1, 3)
        };
    }
}