﻿function MyAudio(fileName, isLoop, volume) {
    this.audio = new Audio();
    this.audio.setAttribute("msAudioCategory", "GameMedia");
    this.audio.setAttribute('src', 'audio/' + fileName + Game.musicFormat);
    this.volume = volume;
    this.audio.volume = Game.isWindowsPhone ?  1 : volume;
    this.audio.preloaded = true;
    this.audio.load();
    if (isLoop)
        this.audio.loop = true;
    Game.audioList.push(this.audio);
}
MyAudio.prototype.play = function (){
    this.audio.volume = this.volume;
    Game.currentPlayedMusic && Game.currentPlayedMusic.stop();
    Game.currentPlayedMusic = this;
    if (Game.globallogic.musicEnable)
        this.audio.play();
};

MyAudio.prototype.stop = MyAudio.prototype.pause = function (){
    this.audio.pause();
};

function MyBackAudio(fileName, volume, limit) {
    this.fileName = fileName;
    this.array = Array.isArray(fileName);
    this.limit = limit || 1;
    this.played = 0;
    this.lastPlayed = -1;
    this.audio = [];
    this.volume = volume || 0.5;
    var audio;
    var loadAudio = this.array ? this.fileName : [this.fileName];
    for (var i =0 ; i < loadAudio.length; i++){
        audio = new Audio();
        audio.msAudioCategory = "GameEffects";
        audio.src ='baudio/' + loadAudio[i] + Game.audioFormat;
        audio.volume = this.volume;
        audio.addEventListener('ended', function (audioEvent) {
            this.played--;
        }.bind(this), false);
        //audio.load();
        this.audio.push(audio);
        Game.audioList.push(audio);
    }
    this.last = 0;
}

MyBackAudio.prototype.play = function (){
    if (Game.globallogic.soundEnable && (this.played < this.limit) && Game.lastTime - this.last > 150) {
        this.last = Game.lastTime;
        var toPlay = this.array ? this.fileName[myRandom(0, this.fileName.length)] : this.fileName;
        var limit = Math.max(this.limit, (this.array ? this.fileName.length : 1));
        for (var i = ++this.lastPlayed; i < limit + this.lastPlayed; i++) {
            var realI = i >= limit ? (i - limit) : i;
            if (!this.audio[realI]) {
                this.played++;
                this.audio[realI] = new Audio();
                this.audio[realI].msAudioCategory = "GameEffects";
                this.audio[realI].src = 'baudio/' + toPlay + Game.audioFormat;
                this.audio[realI].volume = this.volume;
                this.audio[realI].addEventListener('ended', function (audioEvent) {
                    this.played--;
                }.bind(this), false);
                Game.audioList.push(this.audio[realI]);
                //this.audio[realI].playbackRate = Game.speed;
                this.audio[realI].play();
                break;
            } else if (this.audio[realI].paused) {
                this.played++;
                if (this.audio[realI].currentTime > 0)
                    this.audio[realI].currentTime = 0;
                //this.audio[realI].playbackRate = Game.speed;
                this.audio[realI].play();
                break;
            }
        }
        if (this.lastPlayed >= limit-1 || !this.array) {
            this.lastPlayed = -1;
        }
    }
};

MyBackAudio.prototype.stop = function (){
    this.audio.pause();
};

MyBackAudio.prototype.pause = function () {
    this.audio.pause();
};


function AudioPool() {
    this.audios = {};
}

AudioPool.prototype.get = function (name, fileName, volume, limit) {
    var audio;
    if (Game.isWindowsPhone) {
        if (this.audios[name]) {
            audio = this.audios[name];
        } else {
            audio = new MyBackAudioWP(fileName, volume, limit);
            this.audios[name] = audio;
        }
        return audio;
    } else {
        if (this.audios[name]) {
            audio = this.audios[name];
        } else {
            audio = new MyBackAudio(fileName, volume, limit);
            this.audios[name] = audio;
        }
        return audio;
    }
};

function MyBackAudioWP(fileName, volume, limit) {
    this.fileName = fileName;
    this.array = Array.isArray(fileName);
    this.limit = limit || 1;
    this.played = 0;
    this.lastPlayed = -1;
    this.audio = [];
    this.volume = volume || 0.5;
    var audio;
    this.last = 0;
}

MyBackAudioWP.prototype.play = function () {
    if (Game.globallogic.soundEnable && (this.played < this.limit) && Game.lastTime - this.last > 150) {
        this.last = Game.lastTime;
        var toPlay = this.array ? this.fileName[myRandom(0, this.fileName.length)] : this.fileName;
        var limit = Math.max(this.limit, (this.array ? this.fileName.length : 1));
        try {
            Game.player.playSound(new Windows.Foundation.Uri("ms-appx:///baudio/" + toPlay + ".wav"));
        } catch (e) {
            console.log('Wrong sound');
            this.last = Date.now() * 2;
        }
    }
};