﻿/**
 * Created by Mnill on 08.01.15.
 */


function Buf(target, name, param, bufCounter, bufType, playTime, animation, animationLayer, applyAnimation, applyAnimationCb, from) {
    target.bufs[name] = this;
    this.name = name;
    this.target = target;
    this.playTime = playTime;
    this.paramToReturn = 0;
    this.bufType = bufType;
    this.bufCounter = bufCounter;
    this.param = param;
    this.from = from;
    if (animation) {
        this.animation = (Game.animations[animation] ? Game.lvl.pool.getAnimation(animation) : Game.lvl.pool.getSprite(Game.sprites[animation]));
        this.animation.position = target.position;
        if (target instanceof Building)
            this.animation.position = this.animation.position.clone().add(new Vec2(target.width*64/2, target.height*64/2));
        this.animation.loop = true;
        animationLayer.addChild(this.animation);
    }

    if (applyAnimation) {
        this.applyAnimation = Game.lvl.pool.getAnimation(applyAnimation);
        this.applyAnimation.position = target.position;
        //if (target instanceof Building)
        //    this.applyAnimation.position= this.applyAnimation.position.clone().add(new Vec2(target.width*64/2, target.height*64/2));
        this.applyAnimation.loop = false;
        this.applyAnimation.onComplete = function () {
            if (!applyAnimationCb)
                applyAnimationCb = function(){};
            this.applyAnimationPassed = applyAnimationCb;
        }.bind(this);
        Game.lvl.effectContainer.addChild(this.applyAnimation);
    }

    switch (bufType){
        case 'plus':
            target[param]+= bufCounter;
            this.paramToReturn = -bufCounter;
            break;

        case 'minus':
            target[param] -= bufCounter;
            this.paramToReturn = bufCounter;
            break;
        case 'multy':
            this.paramToReturn = -(target[param])*bufCounter;
            target[param] += -this.paramToReturn;
            break;

        case 'div':
            this.paramToReturn = (target[param])*bufCounter;
            target[param] -= this.paramToReturn;
            break;

        case 'multy1':
            this.paramToReturn = -(1-target[param])*bufCounter;
            target[param] += -this.paramToReturn;
            break;

        case 'div1':
            this.paramToReturn = (1-target[param])*bufCounter;
            target[param] -= this.paramToReturn;
            break;
        case 'heal':
            //Nothing
            break;
        case 'damage':
            this.ticker = 20;
            //Nothing
            break;
        case 'visual':
            //Nothing
            break;
        default :
            console.error('Wrong buf type');
            break;
    }
}

Buf.prototype.addBuf = function(target, name, param, bufCounter, bufType, playTime, animation, animationLayer, applyAnimation, applyAnimationCb, from) {
    if (!target.bufs || target.hitPoints <=0)
        return;

    if (target.bufs[name] && target.bufs[name] != null){
        if (target.bufs[name].bufCounter < bufCounter) {
            target.bufs[name].deleteBuf();
            new Buf(target, name, param, bufCounter, bufType, playTime, animation, animationLayer, applyAnimation, applyAnimationCb,from);
        } else if (target.bufs[name].playTime < playTime){
            target.bufs[name].playTime = playTime;
        }
    } else {
        if (name === 'acid')
            Game.events.emit('poisoned');

        new Buf(target, name, param, bufCounter, bufType, playTime, animation, animationLayer, applyAnimation, applyAnimationCb, from);
    }
};

Buf.prototype.update  = function () {
    this.playTime -= Game.cycleTickTime*Game.speed;

    if (this.applyAnimationPassed) {
        this.applyAnimationPassed();
        Game.lvl.pool.pull(this.applyAnimation);
        this.applyAnimationPassed = null;
        this.applyAnimation = null;
    }
    if (this.target.hitPoints <= 0) {
        this.playTime = 0;
    } else if (this.bufType == 'heal') {
        Game.medic += this.bufCounter*Game.speed;
        if (Game.medic <= 100000)
            Game.events.emit('medic');
        this.target.hitPoints += this.bufCounter*Game.speed/20;
        if (this.target.hitPoints > this.target.maxHitPoints)
            this.target.hitPoints = this.target.maxHitPoints;
    } else if (this.bufType == 'damage' && (this.ticker-=Game.speed) < 0) {
        this.ticker += 20;
        this.target.applyDamage(this.bufCounter*Game.speed, this.from);
    }
    if (this.playTime <= 0) {
        this.deleteBuf();
    }
};

Buf.prototype.deleteBuf = function() {
    if (this.applyAnimation) {
        this.applyAnimation.onComplete = function () {
            setTimeout(function() {
                Game.lvl.pool.pull(this.applyAnimation);
                this.applyAnimation = null;
            }.bind(this), 1);
            this.applyAnimation.onComplete = null;
        }.bind(this);
        this.applyAnimation.loop = false;
    }
    if (this.animation) {
        if (this.animation instanceof PIXI.extras.MovieClip) {
            if (this.animation.playing) {
                this.animation.onComplete = function () {
                    setTimeout(function () {
                        Game.lvl.pool.pull(this.animation);
                        this.animation = null;
                    }.bind(this), 1);
                    this.animation.onComplete = null;
                }.bind(this);
                this.animation.loop = false;
            } else {
                Game.lvl.pool.pull(this.animation);
            }
        } else {
            Game.lvl.pool.pull(this.animation);
        }
    }
    this.target[this.param] += this.paramToReturn;
    this.target.bufs[this.name] = null;
};



function BufFreeze(target, name, param, bufCounter, bufType, playTime, animation, animationLayer, applyAnimation, applyAnimationCb, from) {
    target.bufs[name] = this;
    this.name = name;
    this.target = target;
    this.playTime = playTime;
    this.paramToReturn = 0;
    this.bufType = bufType;
    this.bufCounter = bufCounter;
    this.param = param;
    this.from = from;
    if (animation) {
        this.animation = Game.lvl.pool.getAnimation(animation);
        this.animation.position = target.position;
        if (target instanceof Building)
            this.animation.position = this.animation.position.clone().add(new Vec2(target.width*64/2, target.height*64/2));
        this.animation.loop = true;
        animationLayer.addChild(this.animation);
    }

    if (applyAnimation) {
        this.applyAnimation = Game.lvl.pool.getAnimation(applyAnimation);
        this.applyAnimation.position = target.position;
        if (target instanceof Building)
            this.applyAnimation.position= this.applyAnimation.position.clone().add(new Vec2(target.width*64/2, target.height*64/2));
        this.applyAnimation.loop = false;
        this.applyAnimation.onComplete = function (){
            if (!applyAnimationCb)
                applyAnimationCb = function(){};
            this.applyAnimationPassed = applyAnimationCb;
        }.bind(this);
        Game.lvl.effectContainer.addChild(this.applyAnimation);
    }

    switch (bufType){
        case 'plus':
            target[param]+= bufCounter;
            this.paramToReturn = -bufCounter;
            break;

        case 'minus':
            target[param] -= bufCounter;
            this.paramToReturn = bufCounter;
            break;
        case 'multy':
            this.paramToReturn = -(target[param])*bufCounter;
            target[param] += -this.paramToReturn;
            break;

        case 'div':
            this.paramToReturn = (target[param])*bufCounter;
            target[param] -= this.paramToReturn;
            break;

        case 'multy1':
            this.paramToReturn = -(1-target[param])*bufCounter;
            target[param] += -this.paramToReturn;
            break;

        case 'div1':
            this.paramToReturn = (1-target[param])*bufCounter;
            target[param] -= this.paramToReturn;
            break;
        case 'heal':
            //Nothing
            break;
        case 'damage':
            //Nothing
            break;
        case 'visual':
            //Nothing
            break;
        default :
            console.error('Wrong buf type');
            break;
    }
    if (applyAnimationCb)
        console.error('applyAnimationCb');
}

BufFreeze.prototype.addBuf = function(target, name, param, bufCounter, bufType, playTime, animation, animationLayer, applyAnimation, applyAnimationCb, from) {
    if (!target.bufs || target.hitPoints <=0)
        return;

    if (target.bufs[name] && target.bufs[name] != null){
        if (target.bufs[name].bufCounter < bufCounter) {
            target.bufs[name].deleteBuf();
            new Buf(target, name, param, bufCounter, bufType, playTime, animation, animationLayer, applyAnimation, applyAnimationCb,from);
        } else if (target.bufs[name].playTime < playTime){
            target.bufs[name].playTime = playTime;
        }
    } else {
        if (name === 'acid')
            Game.events.emit('poisoned');

        new Buf(target, name, param, bufCounter, bufType, playTime, animation, animationLayer, applyAnimation, applyAnimationCb, from);
    }
};

BufFreeze.prototype.update  = function () {
    this.playTime -= Game.cycleTickTime*Game.speed;

    if (this.applyAnimationPassed) {
        this.applyAnimationPassed();
        Game.lvl.pool.pull(this.applyAnimation);
        this.applyAnimation = null;
    }
    if (this.target.hitPoints <= 0) {
        this.playTime = 0;
    } else if (this.bufType == 'heal') {
        this.target.hitPoints += this.bufCounter / (1000/(Game.cycleTickTime*Game.speed));
        if (this.target.hitPoints > this.target.maxHitPoints)
            this.target.hitPoints = this.target.maxHitPoints;
    } else if (this.bufType == 'damage') {
        this.target.applyDamage(this.bufCounter / (1000/(Game.cycleTickTime*Game.speed)), this.from);
    }
    if (this.playTime <= 0) {
        this.deleteBuf();
    }
};

BufFreeze.prototype.deleteBuf = function(){
    if (this.applyAnimation) {
        this.applyAnimation.onComplete = function () {
            setTimeout(function() {
                Game.lvl.pool.pull(this.applyAnimation);
                this.applyAnimation = null;
            }.bind(this), 1);
            this.applyAnimation.onComplete = null;
        }.bind(this);
        this.applyAnimation.loop = false;
    }
    if (this.animation) {
        this.animation.onComplete = function () {
            setTimeout(function () {
                Game.lvl.pool.pull(this.animation);
                this.animation = null;
            }.bind(this), 1);
            this.animation.onComplete = null;
        }.bind(this);
        this.animation.loop = false;
    }
    this.target[this.param] += this.paramToReturn;
    this.target.bufs[this.name] = null;
};