﻿function Building(params, x, y) {

    this.basicParams = params;
    this.base = params; //Костыль
	this.sellCost = params.sellCost;
	this.position = new Vec2(x,y);
	this.bufs = [];
    if (!params.sprite.playTime)
	    this.sprite = Game.lvl.pool.getSprite(params.sprite);
    else
        this.sprite = Game.lvl.pool.getAnimation(params.sprite.name);

	this.sprite.position = this.position;

    Game.lvl.gameContainer.addChild(this.sprite);
	this.type = params.type;
	this.type = params.type;
	this.hitPoints = params.hitPoints;
	this.maxHitPoints = params.hitPoints;
	this.hitPosition = params.hitPosition || new Vec2(0,0);
	this.hitRange = params.hitRange || 0;
	this.width = params.width;
	this.height = params.height;
	this.strategy = params.strategy;
	this.death = params.onDeath;
	this.penetration = params.penetration;
	this.armor = params.armor || 0;
	this.hitPoints = params.hitPoints || new Vec2(0,0);
	this.mainTile = null;
    this.damageType = params.damageType || 'normal';
	this.nextLvl = Game.buildingsList[params.nextLvl];
	this.children = Game.buildingsList[params.children];
	this.blockTiles = params.blockTiles;
    this.disabled = 0;

    if (params.sound)
        this.sound = Game.lvl.audioPool.get(params.soundGroup, params.sound, params.soundVolume || 1, params.soundLimit);

    this.init();
	if (params.onDraw)
		this.onDraw = params.onDraw;

	if (params.init)
		params.init.call(this, params);
}

Building.prototype.onDay  = function () {
	if (!this.basicParams.norepair)
		this.hitPoints = this.basicParams.hitPoints;
	if (this.basicParams.onDay)
		this.basicParams.onDay.call(this);

};

Building.prototype.onNight  = function () {
	if (this.basicParams.onNight)
		this.basicParams.onNight.call(this);
};


Building.prototype.init  = function () {
	var tile;
	this.mainTile = Game.lvl.objMap.getTile(this.position);
	this.mainTile.envObjects.push(this);
	for (var x = this.position.x.div(Game.tileWidth); x < this.position.x.div(Game.tileWidth) + this.width; x ++){
		for (var y = this.position.y.div(Game.tileHeight); y < this.position.y.div(Game.tileHeight) + this.height; y ++){
			tile = Game.lvl.objMap.getNodeAt(x, y);
			if (tile && tile.objects.indexOf(this) === -1)
				tile.objects.push(this);
		}
	}
};

Building.prototype.update  = function () {
	for (var key in this.bufs){
		if (this.bufs.hasOwnProperty(key) && this.bufs[key] != null)
			this.bufs[key].update();
	}
    if (this.hitPoints > 0 && this.disabled <=0)
	    this.strategy(this);
    else {
        this.disabled -= Game.cycleTickTime*Game.speed;
    }
};


Building.prototype.applyDamage = function (damage, source) {
	if (source&&source.penetration) {
		this.hitPoints -= Math.floor(damage);
	} else {
		this.hitPoints -= Math.floor(damage*(1 - this.armor));
	}

	if (this.hitPoints<=0)
		this.onDeath();
};

Building.prototype.del = function (damage) {
	var tile, key;
	for (var el in this.blockTiles)
		(tile = Game.lvl.objMap.getTile(this.mainTile.positionInArray.clone().add(this.blockTiles[el]).multiply(Game.tileWidth))) ? tile.setWalkable(true) : null;

	for (var x = this.position.x.div(Game.tileWidth); x < this.position.x.div(Game.tileWidth) + this.width; x ++){
		for (var y = this.position.y.div(Game.tileHeight); y < this.position.y.div(Game.tileHeight) + this.height; y ++){
			Game.lvl.objMap.tiles[x + y * Game.mapWidth].objects.splice(Game.lvl.objMap.tiles[x + y * Game.mapWidth].objects.indexOf(this), 1);
		}
	}

	this.mainTile.envObjects.splice(this.mainTile.envObjects.indexOf(this), 1);

    if (Game.lvl.objBuildings.indexOf(this)!=-1)
	    Game.lvl.objBuildings.splice(Game.lvl.objBuildings.indexOf(this), 1);

	for (var xTile= this.mainTile.positionInArray.x - this.basicParams.buildingRange; xTile <this.mainTile.positionInArray.x + this.basicParams.buildingRange + this.width; xTile++){
		for (var yTile= this.mainTile.positionInArray.y - this.basicParams.buildingRange; yTile <this.mainTile.positionInArray.y + this.basicParams.buildingRange + this.height; yTile++){
			Game.lvl.objMap.getTile(new Vec2(xTile*Game.tileWidth, yTile*Game.tileHeight)).buildingsAround--;
		}
	}

	for (key in this.special)
		Game.lvl.pool.pull(this.special[key]);

	if (this.catTop) {
		Game.lvl.pool.pull(this.catTop);
		this.catTop = null;
	}
	Game.lvl.pool.pullSprite(this.sprite);
	for (key in this.bufs){
		if (this.bufs.hasOwnProperty(key) && this.bufs[key] != null)
			this.bufs[key].deleteBuf();
	}
    this.disabled = 10000;
};

Building.prototype.onDeath = function (){
	if (this.death!=null)
		this.death();

	this.del();
    Game.lvl.objEffect.push(new BoomFx(this.position, 1));
};

