﻿function loadBuildings(){

    Game.buildingsList.sniperTower = {
        n: 'sniperTower',
        sprite: Game.sprites.sniperTower,
        damage: 4,
        range: 3*64,
        icon: {normal: 'usniperTower', disabled: 'usniperTowerY'},
        width:1,
        height:1,
        hitPoints:50,
        cost:85,
        sellCost:140,
        coolDownTime : 300,
        nextLvl:null,
        children: 'tower3',
        type:'building',
        subtype:'archer',
        hitPosition: new Vec2(0,-64),
        hitRange: 32,
        blockTiles:[new Vec2(0,0)],
        sound:'ArrowTower',
        soundGroup:'ArrowTower',
        soundVolume:0.2,
        soundLimit:4,
        scanAllAround : function(){
            var lng, target = null;
            for (var obj in Game.lvl.objEnemy) {
                if (Game.lvl.objEnemy[obj].hitPoints > 0 && Game.lvl.objEnemy[obj].invulnerable <= 0 && Game.lvl.objEnemy[obj].position.clone().sub(this.position).getLength() < this.range && (!target || target.armor > Game.lvl.objEnemy[obj].armor)) {
                    target = Game.lvl.objEnemy[obj];
                }
            }
            return target;
        },
        onTouch: function(touch){

        },
        strategy: function (){
            this.cooldown -= Game.cycleTickTime*Game.speed;
            if (this.cooldown < 0) {
                this.cooldown += this.coolDownTime;
                var enemy = this.scanAllAround();
                if (enemy){
                    this.sound.play();
                    //enemy.applyDamage(this.damage, this);
                    var from = this.position.clone().add(new Vec2(0, -64));
                    var arrow = new ArchersArrow(from, enemy, this, Game.sprites.snipper_arrow, false, function() {
                        if (this.target.hitPoints > 0)
                            this.target.applyDamage(this.parent.damage, this.parent);
                    }, 30);
                    Game.lvl.objEffect.push(arrow);
                }
            }
        },
        onDeath: function(){

        },
        init: function(params){
            this.range = params.range;
            this.damage =  params.damage;
            this.coolDownTime = params.coolDownTime;
            this.cooldown = 0;
            this.scanAllAround = params.scanAllAround;
        }
    };

    Game.buildingsList.hordeTower = {
        n: 'hordeTower',
        sprite: Game.sprites.hordeTower,
        damage: 4,
        range: 3*64,
        icon: {normal: 'uhordeTower', disabled: 'uhordeTowerY'},
        width:1,
        height:1,
        hitPoints:50,
        cost:85,
        sellCost:140,
        coolDownTime : 300,
        nextLvl:null,
        children: 'tower3',
        type:'building',
        subtype:'archer',
        subtype2:'horde',
        hitPosition: new Vec2(0,-64),
        hitRange: 32,
        blockTiles:[new Vec2(0,0)],
        onTouch: function(touch){},
        scan: function() {
            var enemyTemp;
            var flyingArray = [];
            for (var x = this.mainTile.position.x - this.range - 128; x  <= this.mainTile.position.x + this.range + 128; x += Game.tileWidth) {
                for (var y = this.mainTile.position.y - this.range - 128; y <= this.mainTile.position.y + this.range + 128; y += Game.tileHeight) {
                    var tile = Game.lvl.objMap.getTile(new Vec2(x, y));
                    if (tile)
                        for (var obj in tile.eObjects) {
                            if (tile.eObjects.hasOwnProperty(obj) && (tile.eObjects[obj].hitPoints > 0) && tile.eObjects[obj].invulnerable <= 0 && tile.eObjects[obj].position.clone().sub(this.mainTile.position).getLength() < this.range) {
                                if (tile.eObjects[obj].flying) {
                                    if (flyingArray.length < 6) {
                                        flyingArray.push(tile.eObjects[obj]);
                                    } else {
                                        break;
                                    }
                                } else {
                                    if (!enemyTemp || enemyTemp.path.length < tile.eObjects[obj].path.length)
                                        enemyTemp = tile.eObjects[obj];
                                }
                            }
                        }
                }
            }
            if (flyingArray.length > 0)
                return flyingArray;
            else
                return enemyTemp;
        },
        strategy: function (){
            var from, i;
            this.cooldown -= Game.cycleTickTime*Game.speed;
            if (this.cooldown < 0) {
                this.cooldown += this.coolDownTime;
                var enemy = this.scanAllAround();
                if (enemy && enemy.hitPoints) {
                    this.soundShoot.play();
                    from = this.position.clone().add(new Vec2(0, -32));
                    for (i = 0; i < 6; i++) {
                        switch (i%3) {
                            case 0:
                                from.add(new Vec2(-24, -15));
                                break;
                            case 1:
                                from.add(new Vec2(24, -15));
                                break;
                            case 2:
                                from.add(new Vec2(5, -30));
                                break;
                        }
                        if (this.tower > 2)
                            this.tower = 0;
                        Game.lvl.objEffect.push(new ArchersArrow(from, enemy, this, Game.sprites.arrow, true, i==0 ? function(){
                            var tmpTile;
                            for (var x = -1; x<2; x++) {
                                for (var y = -1; y<2; y++) {
                                    tmpTile =Game.lvl.objMap.getTruthTile(this.targetEndPosition.clone().add(64*x, 64*y));
                                    if (tmpTile) {
                                        tmpTile.eObjects.forEach(function(enemy){
                                            if (enemy.hitPoints > 0 && !enemy.flying) {
                                                enemy.applyDamage(this.parent.damage, this.parent);
                                            }
                                        }.bind(this))
                                    }
                                }
                            }
                        }:false));
                    }
                } else if (Array.isArray(enemy)) {
                    this.soundShoot.play();
                    for (i = 0; i <6; i++) {
                        //enemy[i%enemy.length].applyDamage(this.damage, this);
                        from = this.position.clone().add(new Vec2(0, -32));
                        switch (i%3) {
                            case 0:
                                from.add(new Vec2(-24, -15));
                                break;
                            case 1:
                                from.add(new Vec2(24, -15));
                                break;
                            case 2:
                                from.add(new Vec2(5, -30));
                                break;
                        }
                        if (this.tower > 2)
                            this.tower = 0;
                        Game.lvl.objEffect.push(new ArchersArrow(from, enemy[i%enemy.length], this, Game.sprites.arrow, false, function() {
                            this.target.applyDamage(this.parent.damage, this.parent);
                        }));
                    }
                } else {
                    this.cooldown = this.coolDownTime;
                }
            }
        },
        onDeath: function() {

        },
        init: function(params){
            this.soundShoot = Game.lvl.audioPool.get('HordeTower', 'Horde Tower', 0.3, 3);
            this.tower = 0;
            this.range = params.range;
            this.damage =  params.damage;
            this.coolDownTime = params.coolDownTime;
            this.cooldown = 0;
            this.scanAllAround = params.scan;
        }
    };

    Game.buildingsList.tower3 = {
        n: 'tower3',
        sprite: Game.sprites.tower3,
        damage: 3,
        range: 3,
        icon: {normal: 'towerIco', disabled: 'towerIcoDisabled'},
        width:1,
        height:1,
        hitPoints:30,
        coolDownTime: 350,
        cost:50,
        sellCost: 85,
        nextLvl: ['hordeTower', 'sniperTower'],
        children: 'tower2',
        type:'building',
        subtype:'archer',
        blockTiles:[new Vec2(0,0)],
        hitPosition: new Vec2(0,-64),
        hitRange: 64,
        sound:'ArrowTower',
        soundGroup:'ArrowTower',
        soundVolume:0.2,
        soundLimit:4,
        onTouch: function(touch){
        },
        strategy: function (){
            Game.buildingsList.tower.strategy.call(this);
        },
        onDeath: function(){
        },
        init: function(params){
            this.range = params.range;
            this.special = [];
            this.special.push(new banner('med', this.position.clone().add(new Vec2(60, 40)), this));
            this.damage =  params.damage;
            this.coolDownTime = params.coolDownTime;
            this.cooldown = 0;
            this.scanAllAround = Game.buildingsList.tower.scan;
        }
    };

    Game.buildingsList.tower2 = {
        n: 'tower2',
        sprite: Game.sprites.tower2,
        damage: 2,
        range: 2,
        icon: {normal: 'towerIco', disabled: 'towerIcoDisabled'},
        width:1,
        height:1,
        hitPoints:25,
        coolDownTime: 400,
        cost:50,
        sellCost: 40,
        nextLvl: ['tower3'],
        children: 'tower',
        type:'building',
        subtype:'archer',
        hitPosition: new Vec2(0,-64),
        hitRange: 64,
        sound:'ArrowTower',
        soundGroup:'ArrowTower',
        soundVolume:0.2,
        soundLimit:4,
        blockTiles:[new Vec2(0,0)],

        onTouch: function(touch){
        },
        strategy: function (){
            Game.buildingsList.tower.strategy.call(this);
        },
        onDeath: function(){
        },
        init: function(params){
            this.range = params.range;
            this.damage =  params.damage;
            this.coolDownTime = params.coolDownTime;
            this.cooldown = 0;
            this.scanAllAround = Game.buildingsList.tower.scan;
        }
    };

    Game.buildingsList.tower = {
        n: 'tower',
        sprite: Game.sprites.tower1,
        icon: {normal: 'towerIco', disabled: 'towerIcoDisabled'},
        width:1,
        height:1,
        hitPoints:20,
        damage:1,
        cost:30,
        coolDownTime: 500,
        sellCost:15,
        nextLvl: ['tower2'],
        children: null,
        range: 2,
        type:'building',
        subtype:'archer',
        hitPosition: new Vec2(0,-64),
        hitRange: 64,
        blockTiles:[new Vec2(0,0)],
        sound:'ArrowTower',
        soundGroup:'ArrowTower',
        soundVolume:0.2,
        soundLimit:4,
        scan: function() {
            for (var x = this.mainTile.position.x - this.range - 128; x  <= this.mainTile.position.x + this.range + 128; x += Game.tileWidth){
                for (var y = this.mainTile.position.y - this.range - 128; y <= this.mainTile.position.y + this.range + 128; y += Game.tileHeight){
                    var tile = Game.lvl.objMap.getTile(new Vec2(x, y));
                    if (tile)
                        for (var obj in tile.eObjects){
                            if (tile.eObjects.hasOwnProperty(obj) && (tile.eObjects[obj].hitPoints > 0) &&  tile.eObjects[obj].invulnerable <= 0 &&(tile.eObjects[obj].position.clone().sub(this.mainTile.position).getLength() < this.range))
                                return tile.eObjects[obj];
                        }
                }
            }
            return null;
        },
        onTouch: function(touch){
        },
        strategy: function (){
            this.cooldown -= Game.cycleTickTime*Game.speed;
            if (this.cooldown < 0){
                this.cooldown += this.coolDownTime;
                var enemy = this.scanAllAround();
                if (enemy){
                    var from = this.position.clone().add(new Vec2(0, -32));
                    this.sound.play();
                    Game.lvl.objEffect.push(new ArchersArrow(from, enemy, this, Game.sprites.arrow, false, function() {
                        this.target.applyDamage(this.parent.damage, this.parent);
                    }));
                }
            }
        },
        init: function(params){
            this.range = params.range;
            this.damage =  params.damage;
            this.coolDownTime = params.coolDownTime;
            this.cooldown = 0;
            this.scanAllAround = params.scan;
        }
    };

    Game.buildingsList.TownHall = {
        n: 'TownHall',
        sprite: Game.sprites.townHall1,
        icon: null,
        width: 4,
        height: 3,
        cost:222,
        nextLvl: ['TownHall2'],
        children: null,
        hitPoints:20,
        type:'building',
        norepair:true,
        hitPosition: new Vec2(64, 64),
        hitRange: 64,
        blockTiles:[new Vec2(1,0), new Vec2(2,0),new Vec2(1,1), new Vec2(2,1)],
        onTouch: function(touch) {},
        scan: function() {},
        strategy: function () {},
        init: function(params) {
            this.applyDamage = function (damage, source){
                if (!source)
                    return false;

                damage = 0;
                if (source.base.lifeCost)
                    damage = source.base.lifeCost;

                if (damage > this.hitPoints)
                    damage = this.hitPoints;

                this.hitPoints -= damage;

                if (damage > 0)
                    Game.lvl.objEffect.push(new LiveEffect(damage, this.position.clone().add(this.hitPosition).add(new Vec2(24,0))));

                if (!source.base.boss)
                    source.del();

                if (this.hitPoints<=0)
                    this.onDeath();

            };

            this.onDeath =function(){
                this.del();
                Game.lvl.objEffect.push(new BoomFx(this.position.clone().add(this.hitPosition), 1));
                if (Game.lvl.gameLogic.state != 'lose')
                    Game.lvl.gameLogic.lose();

            }
        }
    };

    Game.buildingsList.orcHouse5 = {
        n: 'orcHouse5',
        sprite: Game.sprites.orcHouse3,
        icon: {normal: 'uorcGuardian', disabled:'uorcGuardianY'},
        width: 1,
        height: 1,
        cost:30,
        sellCost: 50,
        nextLvl: null,
        children: 'orcHouse4',
        hitPoints:10,
        unit: 'orcGuardian',
        unitCount: 3,
        type:'building',
        subtype:'house',
        limitsGrand: 1,
        hitPosition: new Vec2(0,-48),
        hitRange: 64,
        isOpen:true,
        onTouch: function(touch){
        },
        strategy: function (){
        },
        init: function(){
            Game.buildingsList.house.init.call(this);
        },
        onDeath: function(){
            Game.buildingsList.house.onDeath.call(this);
        }
    };

    Game.buildingsList.orcHouse4 = {
        n: 'orcHouse4',
        sprite: Game.sprites.orcHouse3,
        icon: {normal: 'uorcGuardian', disabled:'uorcGuardianY'},
        width: 1,
        height: 1,
        cost:30,
        sellCost: 50,
        nextLvl: ['orcHouse5'],
        children: 'orcHouse3',
        hitPoints:10,
        unit: 'orcGuardian',
        unitCount: 2,
        type:'building',
        subtype:'house',
        limitsGrand: 1,
        hitPosition: new Vec2(0,-48),
        hitRange: 64,
        isOpen:true,
        onTouch: function(touch){
        },
        strategy: function (){
        },
        init: function(){
            Game.buildingsList.house.init.call(this);
        },
        onDeath: function(){
            Game.buildingsList.house.onDeath.call(this);
        }
    };

    Game.buildingsList.orcHouse3 = {
        n: 'orcHouse3',
        sprite: Game.sprites.orcHouse3,
        icon: {normal: 'uorcGuardian', disabled:'uorcGuardianY'},
        width: 1,
        height: 1,
        cost:30,
        sellCost: 50,
        nextLvl: ['orcHouse4'],
        children: 'orcHouse2',
        hitPoints:10,
        unit: 'orcGuardian',
        unitCount: 1,
        type:'building',
        subtype:'house',
        limitsGrand: 1,
        hitPosition: new Vec2(0,-48),
        hitRange: 64,
        onTouch: function(touch){
        },
        strategy: function (){
        },
        init: function(){
            Game.buildingsList.house.init.call(this);
        },
        onDeath: function(){
            Game.buildingsList.house.onDeath.call(this);
        }
    };

    Game.buildingsList.orcHouse2 = {
        n: 'orcHouse2',
        sprite: Game.sprites.orcHouse2,
        icon: {normal: 'uorcWolfRider', disabled:'uorcWolfRiderY'},
        width: 1,
        height: 1,
        cost:30,
        sellCost: 45,
        nextLvl: ['orcHouse3'],
        children: 'orcHouse',
        hitPoints:10,
        unit: 'orcWolfRider',
        unitCount: 3,
        type:'building',
        subtype:'house',
        limitsGrand: 1,
        hitPosition: new Vec2(0,-48),
        hitRange: 64,
        onTouch: function(touch){},
        strategy: function (){},
        init: function(){
            Game.buildingsList.house.init.call(this);
        },
        onDeath: function(){
            Game.buildingsList.house.onDeath.call(this);
        }
    };

    Game.buildingsList.orcHouse = {
        n: 'orcHouse',
        sprite: Game.sprites.orcHouse,
        icon: {normal: 'uorcWarrior', disabled:'uorcWarriorY'},
        width: 1,
        height: 1,
        cost:30,
        sellCost: 30,
        nextLvl: ['orcHouse2'],
        children: 'house',
        hitPoints:12,
        unit: 'orcWarrior',
        unitCount: 3,
        type:'building',
        subtype:'house',
        limitsGrand: 1,
        hitPosition: new Vec2(0,-48),
        hitRange: 64,
        onTouch: function(touch){},
        strategy: function (){},
        init: function(){
            Game.buildingsList.house.init.call(this);
        },
        onDeath: function(){
            Game.buildingsList.house.onDeath.call(this);
        }
    };

    Game.buildingsList.goblinHouse5 = {
        n: 'goblinHouse5',
        sprite: Game.sprites.goblinHouse3,
        icon: {normal: 'ugoblinShaman', disabled:'ugoblinShamanY'},
        width: 1,
        height: 1,
        cost:30,
        sellCost: 50,
        nextLvl: null,
        children: 'goblinHouse4',
        hitPoints:10,
        unit: 'goblinShaman',
        unitCount: 3,
        type:'building',
        subtype:'house',
        damageType:'magic',
        limitsGrand: 1,
        hitPosition: new Vec2(0,-48),
        hitRange: 64,
        isOpen:true,
        onTouch: function(touch){},
        strategy: function (){},
        init: function(){
            Game.buildingsList.house.init.call(this);
        },
        onDeath: function(){
            Game.buildingsList.house.onDeath.call(this);
        }
    };

    Game.buildingsList.goblinHouse4 = {
        n: 'goblinHouse4',
        sprite: Game.sprites.goblinHouse3,
        icon: {normal: 'ugoblinShaman', disabled:'ugoblinShamanY'},
        width: 1,
        height: 1,
        cost:30,
        sellCost: 50,
        nextLvl: ['goblinHouse5'],
        children: 'goblinHouse3',
        hitPoints:10,
        unit: 'goblinShaman',
        damageType:'magic',
        unitCount: 2,
        type:'building',
        subtype:'house',
        limitsGrand: 1,
        hitPosition: new Vec2(0,-48),
        hitRange: 64,
        isOpen:true,
        onTouch: function(touch){},
        strategy: function (){},
        init: function(){
            Game.buildingsList.house.init.call(this);
        },
        onDeath: function(){
            Game.buildingsList.house.onDeath.call(this);
        }
    };

    Game.buildingsList.goblinHouse3 = {
        n: 'goblinHouse3',
        sprite: Game.sprites.goblinHouse3,
        icon: {normal: 'ugoblinShaman', disabled:'ugoblinShamanY'},
        width: 1,
        height: 1,
        cost:30,
        sellCost: 50,
        nextLvl: ['goblinHouse4'],
        children: 'goblinHouse2',
        hitPoints:10,
        unit: 'goblinShaman',
        damageType:'magic',
        unitCount: 1,
        type:'building',
        subtype:'house',
        limitsGrand: 1,
        hitPosition: new Vec2(0,-48),
        hitRange: 64,
        onTouch: function(touch){},
        strategy: function (){},
        init: function(){
            Game.buildingsList.house.init.call(this);
        },
        onDeath: function(){
            Game.buildingsList.house.onDeath.call(this);
        }
    };

    Game.buildingsList.goblinHouse2 = {
        n: 'goblinHouse2',
        sprite: Game.sprites.goblinHouse2,
        icon: {normal: 'ugoblinSniper', disabled:'ugoblinSniperY'},
        width: 1,
        height: 1,
        cost:30,
        sellCost: 45,
        nextLvl: ['goblinHouse3'],
        children: 'goblinHouse',
        hitPoints:10,
        unit: 'goblinSniper',
        unitCount: 3,
        type:'building',
        subtype:'house',
        limitsGrand: 1,
        hitPosition: new Vec2(0,-48),
        hitRange: 64,
        onTouch: function(touch){},
        strategy: function (){},
        init: function(){
            Game.buildingsList.house.init.call(this);
        },
        onDeath: function(){
            Game.buildingsList.house.onDeath.call(this);
        }
    };

    Game.buildingsList.goblinHouse = {
        n: 'goblinHouse',
        sprite: Game.sprites.goblinHouse,
        icon: {normal: 'ugoblinArcher', disabled:'ugoblinArcherY'},
        width: 1,
        height: 1,
        cost:30,
        sellCost: 30,
        nextLvl: ['goblinHouse2'],
        children: 'house',
        hitPoints: 12,
        unit: 'goblinArcher',
        unitCount: 3,
        type:'building',
        subtype:'house',
        limitsGrand: 1,
        hitPosition: new Vec2(0,-48),
        hitRange: 64,
        onTouch: function(touch){},
        strategy: function (){},
        init: function(){
            Game.buildingsList.house.init.call(this);
        },
        onDeath: function(){
            Game.buildingsList.house.onDeath.call(this);
        }
    };

    Game.buildingsList.house = {
        n: 'house',
        sprite: Game.sprites.tent,
        icon: {normal: 'houseIco', disabled:'houseIcoDisabled'},
        width: 1,
        height: 1,
        cost:30,
        sellCost: 15,
        nextLvl: ['orcHouse', 'goblinHouse'],
        children: null,
        hitPoints:5,
        type:'building',
        subtype:'house',
        unit: 'goblinBase',
        unitCount: 3,
        limitsGrand: 1,
        hitPosition: new Vec2(0,-48),
        hitRange: 64,
        onTouch: function(touch){},
        strategy: function (){},
        init: function() {
            this.flag = Game.lvl.objMap.getClosesFlag(this.position);
            var unit, spawnPosition = this.position, tmpHpPercents = 1, vectors = [new Vec2(-31,-31), new Vec2(0,31), new Vec2(31,-31)];
            var tile = Game.lvl.objMap.getClosesWalkAbleTile(this.position, 2);
            this.units = [];

            if (!this.flag)
                console.log('nety flaga');

            for (i=0; i<3; i++) {
                if (this.flag.units[i]) {
                    this.flag.units[i].house = this;
                }
            }

            for (var i =0; i < this.base.unitCount; i++) {
                if (this.flag.units[i]) {
                    tmpHpPercents = this.flag.units[i].hitPoints / this.flag.units[i].maxHitPoints;
                    spawnPosition = this.flag.units[i].position;
                    this.flag.units[i].fullDelete();
                }

                unit = new Friendly(Game.friendlyList[this.basicParams.unit], spawnPosition.x, spawnPosition.y);
                unit.tileSdvig = vectors[i];
                unit.house = this;
                if (!this.flag.units[i]) {
                    unit.movePosition(tile.position);
                    unit.path = [tile];
                } else {
                    unit.movePosition(this.flag.units[i].basePosition);
                    unit.hitPoints = unit.maxHitPoints*tmpHpPercents;
                    if (unit.hitPoints <= 0) {
                        unit.alreadyDead = true;
                        unit.deadTimer = this.flag.units[i].deadTimer;
                        unit.animation = Game.lvl.pool.switchAnimation(unit.animations['die'], unit.animation);
                        unit.animation.loop = false;
                    }
                    Game.lvl.objEffect.push(new Effect(spawnPosition.clone(), new Vec2(0,0), Game.lvl.objEffect, Game.animations.LVLUP, Game.animations.LVLUP.playTime, 1, null, false, false))
                }
                if (Game.lvl.objFriendly.indexOf(unit) == -1)
                    Game.lvl.objFriendly.push(unit);
                this.flag.units[i] = unit;
            }
            this.units = this.flag.units;
        },
        onDeath: function() {
            for (var i =0; i < 3; i++) {
                if (this.flag.units[i]) {
                    this.flag.units[i].fullDelete();
                    this.flag.units[i] = null;
                }
            }
        }
    };

    Game.buildingsList.poisonTower = {
        n: 'poisonTower',
        sprite: Game.animations.PoisonTower,
        icon: {normal: 'upoisonTower', disabled:'upoisonTowerY'},
        range:3,
        width:1,
        height:1,
        hitPoints:40,
        damage:70,
        damageType:'magic',
        coolDownTime: 1200,
        cost:100,
        sellCost: 50,
        nextLvl: null,
        children: 'magicTower3',
        type:'building',
        subtype:'magic',
        hitPosition: new Vec2(0,-64),
        blockTiles:[new Vec2(0,0)],
        penetration: 1,
        scan: function() {
            this.targets = [];
            for (var x = this.mainTile.position.x - this.range - 128; x  <= this.mainTile.position.x + this.range + 128; x +=Game.tileWidth) {
                for (var y = this.mainTile.position.y - this.range - 128; y <= this.mainTile.position.y + this.range + 128; y +=Game.tileHeight) {
                    var tile = Game.lvl.objMap.getTile(new Vec2(x, y));
                    if (tile)
                        for (var obj in tile.eObjects) {
                            if (tile.eObjects.hasOwnProperty(obj) && (tile.eObjects[obj].hitPoints > 0) && tile.eObjects[obj].invulnerable <= 0 && (tile.eObjects[obj].position.clone().sub(this.mainTile.position).getLength() < this.range))
                                this.targets.push(tile.eObjects[obj]);
                        }
                }
            }
            return null;
        },
        onTouch: function(touch){

        },
        strategy: function () {
            this.splash.update(0.05*Game.speed);
            this.cooldown -= Game.cycleTickTime*Game.speed;
            if (this.cooldown < 0){
                this.scanAllAround();
                this.cooldown += this.coolDownTime;
                if (this.targets.length > 0) {
                    this.soundShoot.play();
                    this.targets.forEach(function(target){
                        Buf.prototype.addBuf(target, 'acid', 'hitPoints', this.basicParams.poisonDamagePerSecond, 'damage', this.basicParams.poisonTime, 'AcidBlastSmoke', Game.lvl.effectContainer, null, null, this);
                        Buf.prototype.addBuf(target, 'acidSlow', 'speed', this.basicParams.poisonSpeedMultiply, 'div', this.basicParams.poisonTime, null, null, null, null, this);
                    }.bind(this));
                    this.splash.emit = true;
                }
            } else {

            }
        },
        onDeath: function(){
            this.splash.emit = false;
            this.splash.destroy();
        },
        init: function(params){
            this.soundShoot = Game.lvl.audioPool.get('PosionCloud', 'Posion Cloud', 0.3, 3);

            this.targets = [];
            var config = clone(Game.particlesList['AcidSplash']);
            config.pos.x = this.position.x;
            config.pos.y = this.position.y;
            var textures = [];
            config.images.forEach(function(image){
                textures.push(PIXI.TextureCache[image])
            });
            this.splash = new cloudkid.Emitter(
                Game.lvl.containerForParticle(config),
                textures,
                config
            );
            this.splash.emit = false;
            this.damage =  params.damage;
            this.coolDownTime = params.coolDownTime;
            this.cooldown = 500;
            this.range = params.range;
            this.scanAllAround = params.scan;
        }
    };

    Game.buildingsList.lightningTower = {
        n: 'lightningTower',
        sprite: Game.animations.LightningTower,
        icon: {normal: 'ulightningTower', disabled:'ulightningTowerY'},
        range:3,
        width:1,
        height:1,
        hitPoints:40,
        damage:70,
        damageType:'magic',
        coolDownTime: 1200,
        cost:100,
        sellCost: 50,
        nextLvl: null,
        children: 'magicTower3',
        type:'building',
        subtype:'lighting',
        blockTiles:[new Vec2(0,0)],
        hitPosition: new Vec2(0,-64),
        penetration: 1,
        onTouch: function(touch){
        },
        strategy: function (){
            this.splash.update(0.05*Game.speed);
            this.light.update(0.05*Game.speed);
            this.cooldown -= Game.cycleTickTime*Game.speed;
            if (this.cooldown < 0) {
                var enemy = this.scanAllAround();
                this.cooldown += this.coolDownTime;
                if (enemy) {
                    this.soundShoot.play();
                    enemy.applyDamage(this.damage, this);
                    this.light.emit = true;
                    this.splash.emit = true;
                    var pos = enemy.fantomMove(6).clone().add(enemy.hitPosition);
                    this.light.spawnPos.set(pos.x, pos.y);
                    //var shockEffect = new EffectSmall(enemy.position, Game.lvl.effectContainer, Game.animations.LightningBolt, Game.animations.LightningBolt.playTime, false);
                    //Game.lvl.objEffect.push(shockEffect);
                }
            }
        },
        onDeath: function(){
            this.splash.emit = false;
            this.light.emit = false;
            this.light.destroy();
            this.splash.destroy();
        },
        init: function(params){
            this.soundShoot = Game.lvl.audioPool.get('LightningStrike', ['Lightning_Strike01', 'Lightning_Strike02', 'Lightning_Strike03'], 0.3, 3);
            var config = clone(Game.particlesList['LightningTowerIdle']);
            config.pos.x = this.position.x;
            config.pos.y = this.position.y;
            var textures = [];
            config.images.forEach(function(image){
                textures.push(PIXI.TextureCache[image])
            });
            this.splash = new cloudkid.Emitter(
                Game.lvl.containerForParticle(config),
                textures,
                config
            );
            config = clone(Game.particlesList['LightningStrike']);
            config.pos.x = this.position.x;
            config.pos.y = this.position.y;
            textures = [];
            config.images.forEach(function(image){
                textures.push(PIXI.TextureCache[image])
            });
            this.light = new cloudkid.Emitter(
                Game.lvl.containerForParticle(config),
                textures,
                config
            );
            this.light.emit = false;

            this.damage =  params.damage;
            this.coolDownTime = params.coolDownTime;
            this.cooldown = 500;
            this.range = params.range;
            this.scanAllAround = Game.buildingsList.magicTower.scan;
            this.lvl4 = true;
        }
    };

    Game.buildingsList.magicTower3 = {
        n: 'magicTower3',
        sprite: Game.sprites.magicTower4,
        icon: {normal: 'magicTowerIco', disabled:'magicTowerIcoDisabled'},
        range:2,
        width:1,
        height:1,
        hitPoints:30,
        damageType:'magic',
        damage:60,
        coolDownTime: 1700,
        cost:100,
        sellCost: 150,
        hitPosition: new Vec2(0,-48),
        nextLvl: ['poisonTower', 'lightningTower'],
        children: 'magicTower2',
        type:'building',
        subtype:'magic',
        blockTiles:[new Vec2(0,0)],
        penetration: 1,
        onTouch: function(touch){
        },
        strategy: function (){
            Game.buildingsList.magicTower.strategy.call(this);
        },
        onDeath: function(){
        },

        init: function(params){
            this.sound = Game.lvl.audioPool.get('magicTowerShot', 'Magic_Tower1-3LvL', 0.3, 3);
            this.shootPosition = new Vec2(0, -48);
            this.damage =  params.damage;
            this.coolDownTime = params.coolDownTime;
            this.cooldown = 500;
            this.range = params.range;
            this.scanAllAround = Game.buildingsList.magicTower.scan;
        }
    };

    Game.buildingsList.magicTower2 = {
        n: 'magicTower2',
        sprite: Game.sprites.magicTower3,
        icon: {normal: 'magicTowerIco', disabled:'magicTowerIcoDisabled'},
        range:2,
        width:1,
        height:1,
        hitPoints:25,
        damageType:'magic',
        damage:50,
        coolDownTime: 2000,
        cost:100,
        sellCost: 100,
        nextLvl: ['magicTower3'],
        children: 'magicTower',
        type:'building',
        subtype:'magic',
        hitPosition: new Vec2(0,-32),
        blockTiles:[new Vec2(0,0)],
        penetration: 1,
        onTouch: function(touch){},
        strategy: function (){
            Game.buildingsList.magicTower.strategy.call(this);
        },
        onDeath: function(){},
        init: function(params){
            this.sound = Game.lvl.audioPool.get('magicTowerShot', 'Magic_Tower1-3LvL', 0.3, 3);
            this.shootPosition = new Vec2(0, -32);
            this.damage =  params.damage;
            this.coolDownTime = params.coolDownTime;
            this.cooldown = 500;
            this.range = params.range;
            this.scanAllAround = Game.buildingsList.magicTower.scan;
        }
    };

    Game.buildingsList.magicTower = {
        n: 'magicTower',
        sprite: Game.sprites.magicTower1,
        icon: {normal: 'magicTowerIco', disabled:'magicTowerIcoDisabled'},
        range:2,
        width:1,
        height:1,
        hitPoints:20,
        damageType:'magic',
        damage:40,
        coolDownTime: 2500,
        cost:100,
        sellCost: 50,
        nextLvl: ['magicTower2'],
        children: null,
        type:'building',
        subtype:'magic',
        hitPosition: new Vec2(0,-32),
        blockTiles:[new Vec2(0,0)],
        penetration: 1,
        onTouch: function(touch){
        },
        strategy: function (){
            this.cooldown -= Game.cycleTickTime*Game.speed;
            if (this.cooldown < 0) {
                var enemy = this.scanAllAround();
                this.cooldown = this.coolDownTime;
                if (enemy) {
                    this.sound.play();
                    enemy.applyDamage(this.damage, this);
                    var shockEffect = new Arrow(this.position.clone().add(this.shootPosition), enemy, Game.animations['AcidBall'], 1, 700, true, function(){
                        if (this.target.hitPoints > 0) {
                            Buf.prototype.addBuf(this.target, 'acid', 'hitPoints', this.parent.basicParams.poisonDamagePerSecond, 'damage', this.parent.basicParams.poisonTime, 'AcidBlastSmoke', Game.lvl.effectContainer, 'AcidHit', null, this.parent);
                            Buf.prototype.addBuf(this.target, 'acidSlow', 'speed', this.parent.basicParams.poisonSpeedMultiply, 'div', this.parent.basicParams.poisonTime, null, null, null, null, this.parent);
                        }
                    }, null, this);
                    Game.lvl.objEffect.push(shockEffect);
                }
            }
        },
        scan: function() {
            for (var x = this.mainTile.position.x - this.range - 128; x  <= this.mainTile.position.x + this.range + 128; x +=Game.tileWidth) {
                for (var y = this.mainTile.position.y - this.range - 128; y <= this.mainTile.position.y + this.range + 128; y +=Game.tileHeight) {
                    var tile = Game.lvl.objMap.getTile(new Vec2(x, y));
                    if (tile)
                        for (var obj in tile.eObjects) {
                            if (tile.eObjects.hasOwnProperty(obj) && (tile.eObjects[obj].hitPoints > 0) && tile.eObjects[obj].invulnerable <= 0 && (tile.eObjects[obj].position.clone().sub(this.mainTile.position).getLength() < this.range))
                                return tile.eObjects[obj];
                        }
                }
            }
            return null;
        },
        onDeath: function(){
        },
        init: function(params) {
            this.sound = Game.lvl.audioPool.get('magicTowerShot', 'Magic_Tower1-3LvL', 0.3, 3);
            this.shootPosition = new Vec2(0, -32);
            this.damage = params.damage;
            this.coolDownTime = params.coolDownTime;
            this.cooldown = 500;
            this.range = params.range;
            this.scanAllAround = params.scan;
        }
    };

    Game.buildingsList.cannonTower = {
        n: 'cannonTower',
        sprite: Game.animations.cannonTower,
        icon: {normal: 'ucannonTower', disabled:'ucannonTowerY'},
        catapultaPosition: new Vec2(0,-84),
        range:6,
        minRange:1,
        width:1,
        height:1,
        hitPoints:20,
        damage:120,
        coolDownTime: 1000,
        cost:120,
        sellCost: 220,
        nextLvl: null,
        damageType:'magic',
        children: 'catapulta3',
        type:'building',
        subtype:'cannon',
        hitPosition: new Vec2(0,-64),
        hitRange: 64,
        onTouch: function(touch){
        },
        strategy: function () {
            this.cannonSmoke.update(0.05*Game.speed);
            this.cannonFire.update(0.05*Game.speed);
            this.cooldown -= Game.cycleTickTime*Game.speed;
            if (this.cooldown < 0){
                var enemy = this.scanAllAround();
                this.cooldown += this.coolDownTime;
                if (enemy) {
                    this.soundShoot.play();
                    var from = this.position.clone().add(new Vec2(0, -84));
                    var bombEffect = new Bomb(from, enemy.position.clone(), this);
                    Game.lvl.objEffect.push(bombEffect);
                    this.sprite._currentTime = 0;
                    this.sprite.play();
                    this.cannonSmoke.emit = true;
                    this.cannonFire.emit = true;
                }
            } else {

            }
        },
        scanAllAround : function() {
            var lng, units = 0, target = null;
            for (var obj in Game.lvl.objEnemy) {
                if (Game.lvl.objEnemy[obj].hitPoints > 0 && Game.lvl.objEnemy[obj].invulnerable <= 0 && !Game.lvl.objEnemy[obj].flying && (lng = Game.lvl.objEnemy[obj].position.clone().sub(this.position).getLength()) < this.range && units < Game.lvl.objEnemy[obj].tile.eObjects.length){
                    target = Game.lvl.objEnemy[obj];
                    units = target.tile.eObjects.length;
                    if (units > 4){
                        return target;
                    }
                }
            }
            return target;
        },
        onDeath: function() {
            this.cannonSmoke.emit = false;
            this.cannonFire.emit = false;
            this.cannonSmoke.destroy();
            this.cannonFire.destroy();
        },
        init: function(params) {
            this.soundShoot = Game.lvl.audioPool.get('CannonFire', 'CannonFire', 0.3, 3);

            var config = clone(Game.particlesList['Cannon_Smoke']);
            config.pos.x = this.position.x;
            config.pos.y = this.position.y;
            var textures = [];
            config.images.forEach(function(image){
                textures.push(PIXI.TextureCache[image])
            });
            this.cannonSmoke = new cloudkid.Emitter(
                Game.lvl.containerForParticle(config),
                textures,
                config
            );
            this.cannonSmoke.emit = false;
            config = clone(Game.particlesList['Cannon_Fire']);
            config.pos.x = this.position.x;
            config.pos.y = this.position.y;
            textures = [];
            config.images.forEach(function(image){
                textures.push(PIXI.TextureCache[image])
            });
            this.cannonFire = new cloudkid.Emitter(
                Game.lvl.containerForParticle(config),
                textures,
                config
            );
            this.cannonFire.emit = false;

            this.damage = params.damage;
            this.sprite.loop = false;
            this.sprite.stop();
            this.coolDownTime = params.coolDownTime;
            this.cooldown = 500;
            this.range = params.range;
            this.scanAllAround = params.scanAllAround;
        }
    };

    Game.buildingsList.ballistaTower = {
        n: 'ballistaTower',
        sprite: Game.sprites.ballistaBot,
        icon: {normal: 'uballistaTower', disabled:'uballistaTowerY'},
        catapultaPosition: new Vec2(0,-74),
        range:6,
        minRange:1,
        width:1,
        height:1,
        hitPoints:20,
        damage:120,
        coolDownTime: 1000,
        cost:120,
        sellCost: 220,
        nextLvl: null,
        children: 'catapulta3',
        type:'building',
        subtype:'catapulta',
        hitPosition: new Vec2(0,-64),
        hitRange: 64,
        scanAllAround : function() {
            var target = null;
            for (var obj in Game.lvl.objEnemy) {
                if (Game.lvl.objEnemy[obj].hitPoints > 0 && Game.lvl.objEnemy[obj].invulnerable <= 0 && !Game.lvl.objEnemy[obj].flying && Game.lvl.objEnemy[obj].position.clone().sub(this.firePosition).getLength() < this.fireRange && (!target || target.maxHitPoints < Game.lvl.objEnemy[obj].maxHitPoints)) {
                    target = Game.lvl.objEnemy[obj];
                }
            }
            return target;
        },
        onTouch: function(touch){
        },
        strategy: function () {
            var mirrod = false;
            this.cooldown -= Game.cycleTickTime*Game.speed;
            if (this.cooldown < 0) {
                var enemy = this.scanAllAround();
                this.cooldown += this.coolDownTime;
                if (enemy) {
                    this.soundShoot.play();
                    var from = this.catapultaPosition.clone().add(new Vec2(0, -64));
                    var direction = from.clone().sub(enemy.position);
                    this.catDirection =  (((direction.getRotate()*180/Math.PI + 22.5).div(45) * 45)  % 360);
                    if (this.catDirection > 180){
                        this.catDirection = 360 - this.catDirection;
                        mirrod = true;
                    }
                    this.catTop = Game.lvl.pool.switchAnimation('ballistaTop' + this.catDirection, this.catTop);
                    this.catTop.setDirectionWithoutPivot(mirrod ? 1 : -1);
                    this.catTop.pivot = this.basicParams.catapultaPosition.multiplyed(-1).add(this.catTop.texture.framePivot);
                    this.catTop.loop = false;
                    this.catTop._currentTime = 0;
                    this.catTop.play();
                    enemy.applyDamage(this.damage, this);
                    Game.lvl.objEffect.push(new Arrow(this.position.clone().add(new Vec2(0, -108)).add(direction.clone().normalize().multiply(-84)), enemy, Game.sprites.BallistaBolt, 1, direction.getLength(), false, null));
                }
            } else {

            }
        },
        onDeath: function(){
        },
        init: function(params) {
            this.soundShoot = Game.lvl.audioPool.get('BallistShoot', 'BallistShoot', 0.3, 2);
            this.strategy = params.strategy;
            this.scanAllAround = params.scanAllAround;
            this.catapultaPosition = params.catapultaPosition.clone().add(this.position);
            this.catDirection = 0;
            this.catTop = Game.lvl.pool.getAnimation('ballistaTop' + this.catDirection);
            this.catTop.position = this.position.clone(); this.catTop.pivot = this.basicParams.catapultaPosition.multiplyed(-1).add(this.catTop.texture.framePivot);
            this.catTop.stop();
            Game.lvl.gameContainer.addChild(this.catTop);
            this.frame = 0;
            this.damage =  params.damage;
            this.coolDownTime = params.coolDownTime;
            this.cooldown = 500;
            this.range = params.range;
            this.firePosition = this.catapultaPosition.clone().add(new Vec2(0,-88));
            this.fireRange = params.range;
        }
    };

    Game.buildingsList.catapulta3 = {
        n: 'catapulta3',
        sprite: Game.sprites.catapulta3,
        icon: {normal: 'catapultaIco', disabled:'catapultaIcoDisabled'},
        catapultaPosition: new Vec2(0, -64),
        range:5,
        minRange:1,
        width:1,
        height:1,
        hitPoints:20,
        damage:120,
        coolDownTime: 1300,
        cost:120,
        sellCost: 160,
        nextLvl: ['ballistaTower', 'cannonTower'],
        children: 'catapulta2',
        type:'building',
        subtype:'cannon',
        hitPosition: new Vec2(0,-64),
        hitRange: 64,
        onTouch: function(touch){
        },
        strategy: function (){
        },
        onDeath: function(){
        },

        init: function(params) {
            this.strategy = Game.buildingsList.catapulta.strategy;
            this.scanAllAround = Game.buildingsList.catapulta.scanAllAround;
            this.catapultaPosition = params.catapultaPosition.clone().add(this.position);
            this.catDirection = 0;
            this.catTop = Game.lvl.pool.getAnimation('catapultaTop' + this.catDirection);
            this.catTop.position = this.position.clone().add(new Vec2(0,1)); this.catTop.pivot = this.basicParams.catapultaPosition.multiplyed(-1);   this.catTop.stop();
            Game.lvl.gameContainer.addChild(this.catTop);
            this.frame = 0;
            this.damage =  params.damage;
            this.coolDownTime = params.coolDownTime;
            this.cooldown = 500;
            this.range = params.range;
            this.minRange = params.minRange;
            this.firePosition = this.position.clone().add(new Vec2(32,32));
            this.fireRange = params.range;
            this.minRange = params.minRange * 64;
        }
    };

    Game.buildingsList.catapulta2 = {
        n: 'catapulta2',
        sprite: Game.sprites.catapulta2,
        icon: {normal: 'catapultaIco', disabled:'catapultaIcoDisabled'},
        catapultaPosition: new Vec2(0, -32),
        range:5,
        minRange:1,
        width:1,
        height:1,
        hitPoints:20,
        damage:80,
        coolDownTime: 1600,
        cost:100,
        sellCost: 100,
        nextLvl: ['catapulta3'],
        children: 'catapulta',
        type:'building',
        subtype:'cannon',
        hitPosition: new Vec2(0,-48),
        hitRange: 64,
        onTouch: function(touch){
        },
        strategy: function () {
        },
        onDeath: function(){
        },
        init: function(params){
            this.strategy = Game.buildingsList.catapulta.strategy;
            this.scanAllAround = Game.buildingsList.catapulta.scanAllAround;
            this.catapultaPosition = params.catapultaPosition.clone().add(this.position);
            this.catDirection = 0;
            this.catTop = Game.lvl.pool.getAnimation('catapultaTop' + this.catDirection);
            this.catTop.position = this.position.clone().add(new Vec2(0,1)); this.catTop.pivot = this.basicParams.catapultaPosition.multiplyed(-1); this.catTop.stop();
            Game.lvl.gameContainer.addChild(this.catTop);
            this.frame = 0;
            this.damage =  params.damage;
            this.coolDownTime = params.coolDownTime;
            this.cooldown = 500;
            this.range = params.range;
            this.firePosition = this.position.clone().add(new Vec2(32,32));
            this.fireRange = params.range;
            this.minRange = params.minRange * 64;
        }
    };

    Game.buildingsList.catapulta = {
        n: 'catapulta',
        sprite: Game.sprites.catapulta1,
        icon: {normal: 'catapultaIco', disabled:'catapultaIcoDisabled'},
        catapultaPosition: new Vec2(0, -32),
        range:5,
        minRange:1,
        width:1,
        height:1,
        hitPoints:20,
        damage:40,
        coolDownTime: 2000,
        cost:100,
        sellCost: 50,
        nextLvl: ['catapulta2'],
        children: null,
        hitPosition: new Vec2(0,-48),
        hitRange: 64,
        type:'building',
        subtype:'cannon',
        onTouch: function(touch){
        },
        strategy: function () {
            this.cooldown -= Game.cycleTickTime*Game.speed;
            if (this.cooldown < 0){
                var enemy = this.scanAllAround();
                this.cooldown += this.coolDownTime;
                if (enemy) {
                    var from = this.catapultaPosition.clone().add(new Vec2(0, -64));
                    var direction = from.clone().sub(enemy.position);
                    this.catDirection = ((direction.getRotate()*180/Math.PI + 22.5).div(45) * 45)  % 360;
                    this.catTop = Game.lvl.pool.switchAnimation('catapultaTop' + this.catDirection, this.catTop);
                    this.catTop.loop = false; this.catTop.pivot = this.basicParams.catapultaPosition.multiplyed(-1); this.catTop._currentTime = 0;  this.catTop.play();
                    Game.lvl.audioPool.get('catapultaShoot', 'CatapultShoot', 0.3, 3).play();
                    var bulletEffect = new Bullet(from, enemy.position.clone().add(new Vec2(-64 + myRandom(0, 128), -64 + myRandom(0, 128))), 1400);
                    bulletEffect.damage = this.damage;
                    Game.lvl.objEffect.push(bulletEffect);
                }
            } else {
            }
        },
        onDeath: function(){},
        scanAllAround : function(){
            var lng, units = 0, target = null;
            for (var obj in Game.lvl.objEnemy) {
                if (Game.lvl.objEnemy[obj].hitPoints > 0 && Game.lvl.objEnemy[obj].invulnerable <= 0 && !Game.lvl.objEnemy[obj].flying && (lng = Game.lvl.objEnemy[obj].position.clone().sub(this.firePosition).getLength()) < this.fireRange && units < Game.lvl.objEnemy[obj].tile.eObjects.length){
                    target = Game.lvl.objEnemy[obj];
                    units = target.tile.eObjects.length;
                    if (units > 4){
                        return target;
                    }
                }
            }
            return target;
        },
        init: function(params) {
            var x, xe, y, ye, xi, yi;
            this.catapultaPosition = params.catapultaPosition.clone().add(this.position);
            this.catDirection = 0;
            this.catTop = Game.lvl.pool.getAnimation('catapultaTop' + this.catDirection);
            this.catTop.position = this.position.clone().add(new Vec2(0,1)); this.catTop.pivot = this.basicParams.catapultaPosition.multiplyed(-1);   this.catTop.stop();
            Game.lvl.gameContainer.addChild(this.catTop);
            this.frame = 0;
            this.damage =  params.damage;
            this.coolDownTime = params.coolDownTime;
            this.cooldown = 500;
            this.range = params.range;
            this.scanAllAround = Game.buildingsList.catapulta.scanAllAround;
            this.firePosition = this.position.clone().add(new Vec2(64, 64));
            this.fireRange = params.range;
        }
    };

}


