﻿function Cluster(center, maxLength){
	if ((!(center instanceof Tile)) || (!maxLength))
		throw "cluster argument error";

	this.center = center;
	this.maxLength = maxLength;
 	this.tiles = [];
	this.needRecalc = false;
	this.init(center, maxLength);
}

Cluster.prototype.update = function (){
	if (this.needRecalc)
		this.recalc();
	this.needRecalc = false;
};

Cluster.prototype.init = function(center, maxLength){
	this.center = center;
	this.maxLength = maxLength;
	var tile;
	if ((this.tiles)&&(this.tiles.length > 0))
		this.release();

	for (var x = center.positionInArray.x - maxLength/64; x <= center.positionInArray.x + maxLength/64; x++)
		for (var y = center.positionInArray.y - maxLength/64; y <= center.positionInArray.y + maxLength/64; y++)
			(tile = Game.lvl.objMap.getNodeAt(x, y)) ? this.tiles.push(tile.clone()) : null;

	this.needRecalc = true;
	return this;
};

Cluster.prototype.mapChanged = function (){
	this.needRecalc = true;
};

Cluster.prototype.release = function(){
	var tile;
	if ((!this.tiles)||(this.tiles.length == 0))
		console.log(Error("cluster is empty"));

	this.tiles =[];
};

Cluster.prototype.recalc = function(){
var tile;
for (var obj in this.tiles){
	tile = this.tiles[obj]
	if (tile.parentTile.isWalkable)
    	(Game.lvl.objMap.getPath(this.center.position, tile.position, this.center.position, this.maxLength)).length > 0 ? tile.isWalkable = true : tile.isWalkable = false;
    else 
    	tile.isWalkable = false;
}
};