﻿/**
 * Created by Mnill on 12.02.15.
 */

Number.prototype.div = function(by){
    return (this - this % by) / by;
};


function selectedEffect(target) {
    this.state = 'idle';
    this.position = target.position.clone();

    if (this.position.y > 1300)
        this.position.y = 1300;
    else if (this.position.y < 200)
        this.position.y = 200;

    if (this.position.x < 200)
        this.position.x = 200;
    else if (this.position.x > 1824)
        this.position.x = 1824;

    if (this.position.x < 600 && this.position.y < 400)
        this.position.y = 400;

    this.target = target;
    if (this.target.hero){
        this.state = 'relocate';
        this.selectedUnitEffect = new Effect(this.target.position, new Vec2(0,0), Game.lvl.objUnderEffect, Game.sprites.selectUnitEffect, 200, 1, null, false, true);
        Game.lvl.objUnderEffect.push(this.selectedUnitEffect);
    }
    this.container = new PIXI.Container();
    Game.lvl.onTop.addChild(this.container);
    if (!this.target.hero) {
        this.container.position = Game.lvl.camera.getUnMovedPosition(this.position);
        this.container.addChild(Game.lvl.pool.getSprite(Game.sprites.RadialGui_A));
    } else {
        this.container.position = this.position;
    }

    //this.container.scale.set(1/Game.lvl.camera.zoom, 1/Game.lvl.camera.zoom);
    if (target.range || (target.base && target.base.unit))
    {
        this.special = new PIXI.Container();
        this.specialRange = new PIXI.Graphics();
        this.specialRange.beginFill('rgba(0, 255, 0)', 0.2);
        this.specialRange.drawCircle(0, 0, target.range ? (target.range)  : 226);
        this.specialRange.endFill();
        this.special.addChild(this.specialRange);
        if (target.minRange){
            this.specialRange.beginFill('rgba(255, 0, 0)', 0.2);
            this.specialRange.drawCircle(0, 0,  target.basicParams.minRange*64);
            this.specialRange.endFill();
            this.special.addChild(this.specialRange);
        }
    }
    if (this.target instanceof Flag)
        this.target.update();
    this.updateTimer = 20;
    this.init();
}


selectedEffect.prototype.update  = function () {
    if (this.target instanceof Friendly)
        this.position = this.target.position;
    if ((this.selectedUnitEffect)||(this.target.hero)) {
        this.selectedUnitEffect.timePassed = 0;
        this.selectedUnitEffect.position = this.target.position;
    } else {
        this.container.position = Game.lvl.camera.getUnMovedPosition(this.position);
    }
    if (this.target instanceof Building){
        this.fillStyle = 0x00FF00;
    }
    //this.container.scale.set(1/Game.lvl.camera.zoom, 1/Game.lvl.camera.zoom);
    if (this.special)
        this.special.scale.set(1/this.container.scale.x , 1/this.container.scale.x);

    if (--this.updateTimer < 0){
        this.updateTimer = 2;
        this.init();
    }
    return true;
};

selectedEffect.prototype.del  = function () {
    this.container.children.forEach(function(obj){
        Game.lvl.pool.pull(obj);
    });
    Game.lvl.pool.pull(this.container);
};


selectedEffect.prototype.init = function () {
    var icon, i, back, key;
    for (i= this.container.children.length-1; i >=0; i--)
        Game.lvl.pool.pull(this.container.children[i]);

    if (this.special) {
        this.container.addChild(this.special);
    }


    if (this.target instanceof Building && this.state != 'flag'){
        this.container.addChild(Game.lvl.pool.getSprite(Game.sprites.RadialGui_A));
        if (this.allybar) {
            this.container.addChild(this.allybar.container);
            this.allybar.container.position = new Vec2(-450, 0);
            this.allybar.container.position = new Vec2(450 * (Game.lvl.camera.getUnMovedPosition(this.position.clone()).x < Game.width / 2 ? 1 : -1), 0);
        }
        this.fillStyle = 0x00FF00;

        if (this.target.base.nextLvl) {
            if (this.target.base.nextLvl.length == 1) {
                this.drawUpgrIcon(this.target.base.nextLvl[0], 0, 0, -170);
            } else if (this.target.base.nextLvl.length == 2) {
                this.drawUpgrIcon(this.target.base.nextLvl[0], 0, -120, -120);
                this.drawUpgrIcon(this.target.base.nextLvl[1], 1, 120, -120);
            }
        }
        if (Game.lvl.gameLogic.state == 'tutorUpgrade') {
            this.ballon = new MessageBalloon(this.state != 'upgrade0' ? Game.strings[Game.language].selectWarriors : Game.strings[Game.language].clickToConfirm, new Vec2(-120, -238), true, this.container);
        }
        if (this.target.basicParams.sellCost) {
            var pos = new Vec2(0, 170);
            if (this.target.base.unit)
                pos.set(-120, 120);

            icon = Game.lvl.pool.getSprite(Game.sprites['RadialGui_B']);
            icon.position = pos;
            icon.scale = new Vec2(1.3, 1.3);
            this.container.addChild(icon);
            if (this.state !='sell')
                icon = Game.lvl.pool.getSprite(Game.sprites['upgSellIcon']);
            else
                icon = Game.lvl.pool.getSprite(Game.sprites['upgConfirmIcon']);
            icon.position = pos;
            this.container.addChild(icon);
        }
        if (this.target.basicParams.unit){
            pos = new Vec2(120, 120);
            icon = Game.lvl.pool.getSprite(Game.sprites['RadialGui_B']);
            icon.position = pos;
            icon.scale = new Vec2(1.3, 1.3);
            this.container.addChild(icon);
            icon = Game.lvl.pool.getSprite(Game.sprites['upgFlagIcon']);
            icon.position = pos;
            this.container.addChild(icon);
        }
    } else if (this.target instanceof Flag) {
        this.container.addChild(Game.lvl.pool.getSprite(Game.sprites.RadialGui_A));
        if (this.allybar) {
            this.container.addChild(this.allybar.container);
            this.allybar.container.position = new Vec2(450*(Game.lvl.camera.getUnMovedPosition(this.position.clone()).x < Game.width/2 ? 1 : -1), 0);
        }
        var drawIcon = function  (target, position) {
            back = Game.lvl.pool.getSprite(Game.sprites['RadialGui_B']);
            this.container.addChild(back);
            back.position = position;
            back.scale = new Vec2(1.3, 1.3);
            if (target.isOpen && (target == Game.buildingsList.tower || Game.lvl.gameLogic.state !== 'tutorBuild')) {
                var price, color = 'white';
                if (target.cost <= Game.lvl.gameLogic.resource) {
                    if (this.state != target.n)
                        icon = Game.lvl.pool.getSprite(Game.sprites[target.icon.normal]);
                    else
                        icon = Game.lvl.pool.getSprite(Game.sprites['upgConfirmIcon']);
                } else {
                    color = 'red';
                    icon = Game.lvl.pool.getSprite(Game.sprites[target.icon.disabled]);
                }
                icon.position = position;
                this.container.addChild(icon);
                price = new SimpleFont(target.cost, color);
                price.container.position = position.clone().sub(new Vec2((target.cost +'').length * 12, -32));
                price.container.scale.set(0.5 ,0.5);
                this.container.addChild(price.container);
                if (target == Game.buildingsList.tower && Game.lvl.gameLogic.state == 'tutorBuild') {
                    this.ballon = new MessageBalloon(this.state != target.n ? Game.strings[Game.language].selectTower : Game.strings[Game.language].clickToConfirm, position.clone().add(new Vec2(0, -128)), true, this.container);
                }
            } else {
                icon = Game.lvl.pool.getSprite(Game.sprites['upgLockedIcon']);
                icon.position = position;
                this.container.addChild(icon);
            }
        }.bind(this);
        drawIcon(Game.buildingsList.house, new Vec2(120, -120));
        drawIcon(Game.buildingsList.tower, new Vec2(-120, -120));
        drawIcon(Game.buildingsList.magicTower, new Vec2(-120, 120));
        drawIcon(Game.buildingsList.catapulta, new Vec2(120, 120));
    }
};


selectedEffect.prototype.click = function (vector) {
    var touchVector = vector.clone().sub(this.position).multiply(Game.lvl.camera.zoom);

    if (this.target instanceof Building) {
        if (this.state == 'flag') {
            var tile = Game.lvl.objMap.getClosesWalkAbleTileFromWithRange(vector, this.target.position, 256);
            Game.lvl.objEffect.push(new Effect(tile.position, new Vec2(0,0), Game.lvl.objEffect, Game.animations.MoveMarker, Game.animations.MoveMarker.playTime, 1, null, false, true));
            this.target.units.forEach(function(unit){
                unit.movePosition(tile.position);
            });
            return false;
        } else {
            var targetUnit;
            if (this.target.base.nextLvl) {
                if (this.target.base.nextLvl.length == 1) {
                    if ((Math.abs(touchVector.x) < 64) && (touchVector.y > -170 - 64) && (touchVector.y < -170 + 64)) {
                        targetUnit = Game.buildingsList[this.target.base.nextLvl[0]];
                        if (targetUnit.isOpen) {
                            if (this.state != 'upgrade0') {
                                this.state = 'upgrade0';
                                this.allybar = new allyBar(targetUnit);
                                return true;
                            } else {
                                if (targetUnit.cost <= Game.lvl.gameLogic.resource) {
                                    Game.lvl.gameLogic.upgradeBuilding(this.target, targetUnit, this.target.position.x, this.target.position.y);
                                    return false;
                                } else {
                                    return true;
                                }
                            }
                        } else {
                            this.allybar = null;
                            return false;
                        }
                    }
                } else if (this.target.base.nextLvl.length == 2) {
                    if ((touchVector.x < -120 + 64) && (touchVector.x > -120 - 64) && (touchVector.y > -120 - 64) && (touchVector.y < -120 + 64)) {
                        targetUnit = Game.buildingsList[this.target.base.nextLvl[0]];
                        if (targetUnit.isOpen) {
                            if (this.state != 'upgrade0') {
                                this.state = 'upgrade0';
                                this.allybar = new allyBar(targetUnit);
                                return true;
                            } else {
                                if (targetUnit.cost <= Game.lvl.gameLogic.resource) {
                                    Game.lvl.gameLogic.upgradeBuilding(this.target, targetUnit, this.target.position.x, this.target.position.y);
                                    if (Game.lvl.gameLogic.state == 'tutorUpgrade') {
                                        Game.lvl.pool.pull(Game.lvl.gameLogic.ballon.container);
                                        Game.lvl.gameLogic.state = 'day';
                                        var waveIcon =  Game.lvl.objEffect.filter(function(eff){return eff.isWaveIcon}).pop();
                                        if (waveIcon) {
                                            Game.lvl.gameLogic.ballon = new MessageBalloon(Game.strings[Game.language].tutorStart, waveIcon.container.position.clone(), false, Game.lvl.effectContainer);
                                            Game.lvl.gameLogic.ballon.parental = waveIcon;
                                        }
                                    }
                                    return false;
                                } else {
                                    return true;
                                }
                            }
                        } else {
                            this.allybar = null;
                            return false;
                        }
                    } else if (Game.lvl.gameLogic.state !== 'tutorUpgrade' && (touchVector.x < 120 + 64) && (touchVector.x > 120 - 64) && (touchVector.y > -120 - 64) && (touchVector.y < -120 + 64)) {
                        targetUnit = Game.buildingsList[this.target.base.nextLvl[1]];
                        if (targetUnit.isOpen) {
                            if (this.state != 'upgrade1') {
                                this.state = 'upgrade1';
                                this.allybar = new allyBar(targetUnit);
                                return true;
                            } else {
                                if (targetUnit.cost <= Game.lvl.gameLogic.resource) {
                                    Game.lvl.gameLogic.upgradeBuilding(this.target, targetUnit, this.target.position.x, this.target.position.y);
                                } else {
                                    return true;
                                }
                            }
                        } else {
                            this.allybar = null;
                            return false;
                        }
                    }
                }
            }
            this.allybar = null;
            if (Game.lvl.gameLogic.state !== 'tutorUpgrade' && this.target.basicParams.sellCost ) {
                if (!this.target.base.unit) {
                    if ((Math.abs(touchVector.x) < 64) && (touchVector.y > 170 - 64) && (touchVector.y < 170 + 64)) {
                        if (this.state != 'sell') {
                            this.state = 'sell';
                            return true;
                        } else {
                            if (this.state == 'sell') {
                                //if (Game.lvl.gameLogic.state == 'day') {
                                if (this.target.basicParams.sellCost) {
                                    Game.lvl.gameLogic.sellBuilding(this.target);
                                }
                                //}
                                return false;
                            }
                        }
                    }
                } else {
                    if ((touchVector.x < -120 + 64) && (touchVector.x > -120 - 64) && (touchVector.y > 120 - 64) && (touchVector.y < 120 + 64)) {
                        if (this.state != 'sell') {
                            this.state = 'sell';
                            return true;
                        } else {
                            if (this.state == 'sell') {
                                //if (Game.lvl.gameLogic.state == 'day') {
                                if (this.target.basicParams.sellCost) {
                                    Game.lvl.gameLogic.sellBuilding(this.target);
                                }
                                //}
                                return false;
                            }
                        }
                    } else if ((touchVector.x < 120 + 64) && (touchVector.x > 120 - 64) && (touchVector.y > 120 - 64) && (touchVector.y < 120 + 64)) {
                        this.state = 'flag';
                        return true;
                    }
                }
            }
        }
    } else if (this.target instanceof  Flag) {
        var house =new Vec2(120, -120);
        var tower = new Vec2(-120, -120);
        var magicTower = new Vec2(-120, 120);
        var catapulta = new Vec2(120, 120);

        if (touchVector.clone().sub(house).getLength() < 70 && Game.lvl.gameLogic.resource >= Game.buildingsList.house.cost && Game.lvl.gameLogic.state !== 'tutorBuild') {
            if (this.state != Game.buildingsList.house.n) {
                this.state = Game.buildingsList.house.n;
                this.allybar = new allyBar(Game.buildingsList.house);
                return true;
            } else {
                Game.lvl.gameLogic.build(Game.buildingsList.house, this.target.position.x, this.target.position.y);
            }
        }

        if (touchVector.clone().sub(tower).getLength() < 70 && Game.lvl.gameLogic.resource >= Game.buildingsList.tower.cost) {
            if (this.state != Game.buildingsList.tower.n) {
                this.ballon && this.ballon.balloonText.setText('Click to confirm');
                this.state = Game.buildingsList.tower.n;
                this.allybar = new allyBar(Game.buildingsList.tower);
                return true;
            } else {
                Game.lvl.gameLogic.build(Game.buildingsList.tower, this.target.position.x, this.target.position.y);
            }
        }

        if (touchVector.clone().sub(magicTower).getLength() < 70 && Game.lvl.gameLogic.resource >= Game.buildingsList.magicTower.cost) {
            if (this.state != Game.buildingsList.magicTower.n) {
                this.state = Game.buildingsList.magicTower.n;
                this.allybar = new allyBar(Game.buildingsList.magicTower);
                return true;
            } else {
                Game.lvl.gameLogic.build(Game.buildingsList.magicTower, this.target.position.x, this.target.position.y);
            }
        }
        if (touchVector.clone().sub(catapulta).getLength() < 70 && Game.lvl.gameLogic.resource >= Game.buildingsList.catapulta.cost) {
            if (this.state != Game.buildingsList.catapulta.n) {
                this.state = Game.buildingsList.catapulta.n;
                this.allybar = new allyBar(Game.buildingsList.catapulta);
                return true;
            } else {
                Game.lvl.gameLogic.build(Game.buildingsList.catapulta, this.target.position.x, this.target.position.y);
            }
        }
    } else if (this.target instanceof Friendly) {
        if (this.target.hero) {
            Game.lvl.objEffect.push(new Effect(vector, new Vec2(0,0), Game.lvl.objEffect, Game.animations.MoveMarker, Game.animations.MoveMarker.playTime, 1, null, false, true));
            this.target.movePosition(vector);
        }
    }
    this.allybar = null;
    return false;
};

selectedEffect.prototype.drawUpgrIcon = function (name, number, x ,y) {
    var icon, back, price, container = new PIXI.Container();

    back = Game.lvl.pool.getSprite(Game.sprites['RadialGui_B']);
    back.position.x = x;
    back.position.y = y;
    back.scale.y = back.scale.x = 1.3;
    container.position.x = x;
    container.position.y = y;
    this.container.addChild(back);

    var targetBuilding = Game.buildingsList[name];

    if (targetBuilding.isOpen) {
        var color = 'white';
        if (targetBuilding.cost <= Game.lvl.gameLogic.resource) {
            if (this.state !='upgrade'+number) {
                icon = Game.lvl.pool.getSprite(Game.sprites[targetBuilding.icon.normal]); //.drawMultiplied(0.5);
            } else
                icon = Game.lvl.pool.getSprite(Game.sprites['upgConfirmIcon']); //Game.sprites[''].draw();
        } else {
            color = 'red';
            icon = Game.lvl.pool.getSprite(Game.sprites[targetBuilding.icon.normal]); //.drawMultiplied(0.5);
        }
        price = new SimpleFont(targetBuilding.cost, color);
        var pos = new Vec2(0,0);
        price.container.position = pos.sub(new Vec2((targetBuilding.cost +'').length * 12, -24));
        price.container.scale.set(0.5 ,0.5);
    } else {
        icon = Game.lvl.pool.getSprite(Game.sprites.upgLockedIcon); //.drawMultiplied(0.5);
    }
    icon.position.set(0,0);
    container.addChild(icon);
    if (price)
        container.addChild(price.container);
    this.container.addChild(container);
};

function allyBar(unit) {
    this.container = new PIXI.Container();
    this.back = Game.lvl.pool.getSprite(Game.sprites.AllyBar);
    this.line = Game.lvl.pool.getSprite(Game.sprites.AllyBarLine);
    this.container.addChild(this.back);
    this.container.addChild(this.line);

    this.damage = new SimpleFont(2000, '');this.damage.container.scale.set(0.7,0.7);this.damage.container.position.set(-125,-145);
    this.penetrate = new SimpleFont('0.0', '');this.penetrate.container.scale.set(0.7,0.7);this.penetrate.container.position.set(115,-145);

    this.damageIcon = Game.lvl.pool.getSprite(unit.damageType == 'magic' ? Game.sprites.magicattackIG: Game.sprites.attackIG);
    this.damageIcon.position.set(-180, -150);

    this.penetrationIcon = Game.lvl.pool.getSprite(Game.sprites.penitrateIG);
    this.penetrationIcon.position.set(60, -150);
    this.penetrationIcon.scale.set(0.9,0.9);



    this.container.addChild(this.damage.container);
    this.container.addChild(this.penetrate.container);

    this.container.addChild(this.damageIcon);
    this.container.addChild(this.penetrationIcon);

    this.name = new PIXI.extras.BitmapText(Game.strings[Game.language].buildings.short[unit.n],
        {
            font: Game.getFontBitmap(),
            align: "center"
        });
    this.name.scale.set(0.8,0.8);
    this.name.position.set(-this.name.width/2, -255);
    this.container.addChild(this.name);

    this.description = new PIXI.extras.BitmapText(Game.strings[Game.language].buildings.description[unit.n],
        {
            font: Game.getFontBitmap(),
            align: "center"
        });
    this.description.scale.set(0.8,0.8);
    this.description.position.set(-this.description.width/2, 20);
    this.container.addChild(this.description);

    if (unit.unit){
        this.description.position.set(-this.description.width/2, 90);

        this.damage.setText(parseInt(Game.friendlyList[unit.unit].damage*1000/Game.friendlyList[unit.unit].timeOut));
        this.penetrate.setText(parseFloat(Game.friendlyList[unit.unit].penetration).toFixed(1))
        this.hp = new SimpleFont(Game.friendlyList[unit.unit].hitPoints, '');this.hp.container.scale.set(0.7,0.7); this.hp.container.position.set(-125,-70);

        this.armor = new SimpleFont(parseFloat(Game.friendlyList[unit.unit].armor).toFixed(1), '');this.armor.container.scale.set(0.7,0.7);this.armor.container.position.set(115,-70);
        this.magicarmor = new SimpleFont(parseFloat(Game.friendlyList[unit.unit].armor).toFixed(1), '');this.magicarmor.container.scale.set(0.7,0.7); this.magicarmor.container.position.set(115,0);

        this.hpIcon = Game.lvl.pool.getSprite(Game.sprites.hpIG);
        this.hpIcon.position.set(-180, -75);

        this.coinsIcon = Game.lvl.pool.getSprite(Game.sprites.coinIG);
        this.coinsIcon.position.set(-180, 0);
        this.coins = new SimpleFont(unit.cost, '');this.coins.container.scale.set(0.7,0.7);this.coins.container.position.set(-125, 0);
        this.container.addChild(this.coins.container);
        this.container.addChild(this.coinsIcon);


        this.armoreIcon = Game.lvl.pool.getSprite(Game.sprites.armoreIG);
        this.armoreIcon.position.set(60, -75);

        this.magicarmoreIcon = Game.lvl.pool.getSprite(Game.sprites.magicArmoreIG);
        this.magicarmoreIcon.position.set(60, 0);
        this.container.addChild(this.hp.container);
        this.container.addChild(this.armor.container);
        this.container.addChild(this.magicarmor.container);
        this.container.addChild(this.hpIcon);
        this.container.addChild(this.armoreIcon);
        this.container.addChild(this.magicarmoreIcon);
        this.line.position.set(0,60);
    } else {
        this.damage.setText(parseInt(unit.damage));
        this.penetrate.setText(parseFloat(unit.penetration).toFixed(1));


        this.coinsIcon = Game.lvl.pool.getSprite(Game.sprites.coinIG);
        this.coinsIcon.position.set(-180, -75);
        this.coins = new SimpleFont(unit.cost, '');this.coins.container.scale.set(0.7,0.7);this.coins.container.position.set(-125, -70);
        this.container.addChild(this.coins.container);
        this.container.addChild(this.coinsIcon);

        this.rangeIcon = Game.lvl.pool.getSprite(Game.sprites.rangeIG);
        this.rangeIcon.position.set(60, -75);
        this.range = new SimpleFont(unit.range, '');this.range.container.scale.set(0.7,0.7);this.range.container.position.set(110, -70);
        this.container.addChild(this.range.container);
        this.container.addChild(this.rangeIcon);
        this.line.position.set(0,0);
    }


}

function banner(type, position, parent){
    if (type == 'med'){
        this.an = Game.lvl.pool.getAnimation(Game.animations.bannerMed.name);
        this.an.pivot = this.an.texture.framePivot;
    } else if (type == 'small'){
        this.an = Game.lvl.pool.getAnimation(Game.animations.bannerSmall.name);
        this.an.pivot = this.an.texture.framePivot;
    } else if (type == 'top'){
        this.an = Game.lvl.pool.getAnimation(Game.animations.bannerSmall.name);
        this.an.pivot = this.an.texture.framePivot;
        this.an.pivot.y = this.an.texture.framePivot.y+14;
    }
    this.an.position = position;
    Game.lvl.gameContainer.addChild(this.an);
    return this.an;
}

function moneyEffect(amount, position, toBot) {
    this.effect = new SimpleFont('+'+amount, '');
    this.effect.container.position = position.clone();
    if (!toBot)
        this.effect.container.position.x -= (('+'+amount).length/2)*32;

    this.effect.container.scale.set(0.8, 0.8);
    this.playTime = amount > 50 || toBot ? 3000 : 1000;
    this.amount = amount;
    this.played = 0;
    this.direction = toBot ? -2 : 2;
    Game.lvl.guiContainer.addChild(this.effect.container);
}

moneyEffect.prototype.update = function(){
    this.effect.container.position.y -= this.direction;
    if ((this.played += Game.cycleTickTime*Game.speed) > this.playTime) {
        Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
        Game.lvl.pool.pull(this.effect.container);
    }
};

function LiveEffect(amount, position) {
    this.effect = new SimpleFont('-'+amount, 'white');
    this.effect.container.position = position.clone();
    this.effect.container.position.x += (('-'+amount).length/2)*16;
    this.effect.container.scale.set(0.5, 0.5);
    this.playTime = 2000;
    this.played = 0;
    Game.lvl.effectContainer.addChild(this.effect.container);
}

LiveEffect.prototype.update = function(){
    this.effect.container.position.y -= 3;
    if ((this.played += Game.cycleTickTime*Game.speed) > this.playTime) {
        Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
        Game.lvl.pool.pull(this.effect.container);
    }
};


function hitPointsEffect(from){
    this.from = from;
    this.multiplyCounter = from.hitPointsMultiply || 1;

    if (from instanceof Friendly)
        this.back = Game.lvl.pool.getSprite(Game.sprites.hitPointsEffect);
    else
        this.back = Game.lvl.pool.getSprite(Game.sprites.hitPointsEffectEnemy);

    this.back.scale.x = 1;
    this.back.scale.y = this.multiplyCounter;
    this.lastHitPoints = from.maxHitPoints;
    this.back.position = from.position;
    this.back.pivot = new Vec2(25-25*this.from.hitPoints/this.from.maxHitPoints , 0);
    Game.lvl.particlesContainer.addChild(this.back);
    Game.lvl.objEffect.push(this);

    if (this.from.hitPoints > 0 && this.from.invulnerable <= 0) {
        if (this.lastHitPoints != this.from.hitPoints) {
            this.lastHitPoints = this.from.hitPoints;
            this.back.width = (this.from.hitPoints/this.from.maxHitPoints)*35*this.multiplyCounter;
            this.back.pivot = new Vec2(35-35*this.from.hitPoints/this.from.maxHitPoints , 0);
        }
    }
}

hitPointsEffect.prototype.update = function() {
    if (this.from.hitPoints > 0 && this.from.invulnerable <= 0) {
        if (this.lastHitPoints != this.from.hitPoints) {
            this.lastHitPoints = this.from.hitPoints;
            this.back.width = (this.from.hitPoints/this.from.maxHitPoints)*35*this.multiplyCounter;
            this.back.pivot = new Vec2(35-35*this.from.hitPoints/this.from.maxHitPoints , 0);
        }
    } else {
        this.del();
    }
};


hitPointsEffect.prototype.del = function(){
    if (Game.lvl.objEffect.indexOf(this)!=-1)
        Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
    this.back.width = 25;
    Game.lvl.pool.pull(this.back);
    this.from.hitPointsEffect = null;
};

function Arrow(startPosition, target, sprite, sizeMultiplyed, playTime, isAutoTarget, afterPlay, delay, parent) {
    this.target = target;
    this.parent = parent;
    this.delay = delay || 0;
    this.randomDirection = new Vec2(myPofigRandom(-target.hitRange/4 , target.hitRange/4), myPofigRandom(-target.hitRange/4 , target.hitRange/4));
    this.targetPosition = target.position.clone().add(this.randomDirection).add(target.hitPosition);
    this.position = startPosition.clone();
    this.direction = this.position.clone().sub(this.targetPosition);
    this.flyDistance = this.direction.getLength()/(playTime/(Game.cycleTickTime*Game.speed));
    this.direction.normalize();
    this.sizeMultiplyed = sizeMultiplyed;
    this.isAutoTarget = isAutoTarget;
    this.playTime = playTime;
    this.afterPlay = afterPlay;
    this.looped = true;
    this.timePassed = 0;
    if (sprite.playTime) {
        this.sprite = Game.lvl.pool.getAnimation(sprite.name);
    } else {
        this.sprite = Game.lvl.pool.getSprite(sprite);
    }
    this.sprite.position = this.position;
    this.sprite.loop = true;
    if (delay > 0)
        this.sprite.alpha = 0;
    Game.lvl.effectContainer.addChild(this.sprite);
}

Arrow.prototype.update = function () {

    if (this.delay > 0)
    {
        this.delay -= Game.cycleTickTime*Game.speed;
        if (this.delay <=0)
            this.sprite.alpha = 1;

        return;
    }
    if (this.direction)
        this.position.sub(this.direction.multiplyed(this.flyDistance));

    this.timePassed += Game.cycleTickTime*Game.speed;

    if (this.timePassed >= this.playTime){

        Game.lvl.pool.pull(this.sprite);
        Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);

        if (!this.isAutoTarget)
            this.position.set(this.targetPosition);
        else
            this.position.set(this.target.position.clone().add(this.randomDirection).add(this.target.hitPosition));

        if (this.afterPlay)
            this.afterPlay.call(this);
    } else if (this.isAutoTarget && this.target.position.clone().add(this.randomDirection).add(this.target.hitPosition).getLength() > 128 );
    {
        this.targetPosition = this.target.position.clone().add(this.randomDirection).add(this.target.hitPosition);
        this.direction = this.position.clone().sub(this.targetPosition);
        var time = (this.playTime - this.timePassed)/(Game.cycleTickTime*Game.speed);
        this.flyDistance = this.direction.getLength()/(time > 1 ? time : 1);
        this.direction.normalize();
        this.sprite.rotation = -this.direction.getRotate();
    }
};

function ArchersArrow(startPosition, target, parent, sprite, isRandom, onEnd, speed) {
    this.onEnd = onEnd;
    this.target = target;
    this.startPosition = startPosition;
    this.parent = parent;
    this.speed = speed || Game.cycleTickTime;
    this.targetEndPosition = target.fantomMove(900 / this.speed).clone();

    if (!isRandom) {
        this.randomDirection = new Vec2(myPofigRandom(-target.hitRange/4 , target.hitRange/4), myPofigRandom(-target.hitRange/4 , target.hitRange/4));
        this.targetPosition = this.targetEndPosition.clone().add(this.randomDirection).add(target.hitPosition);
    } else {
        this.phantom = true;
        this.randomDirection = new Vec2(myPofigRandom(-target.hitRange*4, target.hitRange*4), myPofigRandom(-target.hitRange*4, target.hitRange*4));
        this.targetPosition = this.targetEndPosition.clone().add(this.randomDirection).add(target.hitPosition);
    }
    this.position = startPosition.clone();

    this.timePassed = 0;
    if (sprite.playTime) {
        this.sprite = Game.lvl.pool.getAnimation(sprite.name);
    } else {
        this.sprite = Game.lvl.pool.getSprite(sprite);
    }
    this.sprite.position = this.position;
    Game.lvl.effectContainer.addChild(this.sprite);

    this.xDir = startPosition.x - this.targetPosition.x;
    var ydiv = Math.abs(startPosition.y - this.targetPosition.y);
    var xdiv = Math.abs(startPosition.x - this.targetPosition.x);
    if (xdiv < 5)
        xdiv = 5;
    if (ydiv < 5)
        ydiv = 5;
    this.parY = Math.min(startPosition.y, this.targetPosition.y) - (isRandom ? myPofigRandom(50, 100) : 50 );

    this.parXRange = (xdiv/2)*(ydiv/this.parent.range);
    if (startPosition.y < this.targetPosition.y) {
        if (startPosition.x <= this.targetPosition.x) {
            this.parX = startPosition.x + this.parXRange;
        } else {
            this.parX = startPosition.x - this.parXRange;
        }
    } else {
        if (startPosition.x <= this.targetPosition.x) {
            this.parX = this.targetPosition.x - this.parXRange;
        } else {
            this.parX = this.targetPosition.x + this.parXRange;
        }
    }
    this.par = new Vec2(this.parX, this.parY);
    this.direction = this.position.clone().sub(this.par);
    this.sprite.rotation = -this.direction.getRotate();

    var denom = (this.startPosition.x - this.targetPosition.x)*(this.startPosition.x - this.parX)*(this.targetPosition.x - this.parX);
    this.A = (this.parX * (this.targetPosition.y - this.startPosition.y) + this.targetPosition.x * (this.startPosition.y - this.parY) + this.startPosition.x * (this.parY - this.targetPosition.y)) / denom;
    this.B = (this.parX*this.parX * (this.startPosition.y - this.targetPosition.y) + this.targetPosition.x*this.targetPosition.x * (this.parY - this.startPosition.y) + this.startPosition.x*this.startPosition.x * (this.targetPosition.y - this.parY)) / denom;
    this.C = (this.targetPosition.x * this.parX * (this.targetPosition.x - this.parX) * this.startPosition.y + this.parX * this.startPosition.x * (this.parX - this.startPosition.x) * this.targetPosition.y + this.startPosition.x * this.targetPosition.x * (this.startPosition.x - this.targetPosition.x) * this.parY) / denom;
    //this.parabola = new Vec2(-this.B / (2*this.A), this.C - this.B*this.B / (4*this.A));
    if (this.A < 0)
        this.A *=-1;
}

ArchersArrow.prototype.update = function () {
    var speed = Game.speed;
    while(--speed >=0) {
        if ((this.timePassed += this.speed) > 800) {
            if (!this.phantom) {
                Game.lvl.pool.pull(this.sprite);
                if (this.onEnd) {
                    this.onEnd();
                    this.onEnd = null;
                }
                if (Game.lvl.objEffect.indexOf(this) != -1)
                    Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
                break;
            } else if (this.timePassed == 850) {
                if (this.onEnd)
                    this.onEnd();
                Game.lvl.pool.pull(this.sprite);
                this.sprite = Game.lvl.pool.getSprite(Game.sprites['halfarrow0' + myPofigRandom(1, 4)]);
                this.sprite.position = this.position;
                this.sprite.rotation = -this.direction.getRotate();
                Game.lvl.gameContainer.addChild(this.sprite);
            } else if (this.timePassed > 6000) {
                if (this.timePassed > 12000) {
                    this.sprite.alpha = 1;
                    Game.lvl.pool.pull(this.sprite);
                    if (Game.lvl.objEffect.indexOf(this) != -1)
                        Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
                    break;
                } else {
                    this.sprite.alpha = (12000 - this.timePassed) / 6000;
                }
            }
        } else {
            this.position.x -= (this.xDir / (800 / (this.speed)));
            this.position.y = this.A * this.position.x * this.position.x + this.B * this.position.x + this.C;
            var fly = Math.abs(this.position.x - this.startPosition.x) > Math.abs(this.startPosition.x - this.par.x);
            this.direction = this.position.clone().sub(fly ? this.targetPosition : this.par);
            if (this.direction.getLength() > 10)
                this.sprite.rotation = -this.direction.getRotate();
        }
    }
};


function blackSquare(position, isSmall, time, alpha){
    this.position = position;
    this.alpha = alpha || 1;
    this.guiContainer = new PIXI.Container();
    this.grap = new PIXI.Graphics();
    this.grap.beginFill(0x000000);
    if (!isSmall)
        this.grap.drawRect(0, 0, 64, 64);
    else
        this.grap.drawRect(0, 0, 6, 6);
    this.grap.endFill();
    this.guiContainer.addChild(this.grap);
    this.guiContainer.alpha = this.alpha;
    this.guiContainer.position = position;
    this.time = time || 10000;
    if (!isSmall)
        this.guiContainer.pivot.set(32, 32);
    else
        this.guiContainer.pivot.set(2, 2);

    Game.lvl.effectContainer.addChild(this.guiContainer);
    Game.lvl.objEffect.push(this);
}

blackSquare.prototype.update = function(){
    if ((this.time -= Game.cycleTickTime*Game.speed) <= 0){
        Game.lvl.pool.pull(this.guiContainer);
        if (Game.lvl.objEffect.indexOf(this) != -1){
            Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
        }
    }
};

function CritEffect(position){
    this.effect = new PIXI.Container();
    this.effect.anchor.x = 0.5;
    Game.lvl.effectContainer.addChild(this.effect);
    this.effect.position = position.clone().add(new Vec2(0, -64));
    this.effect.rotation = Math.PI/4 * (-0.5 + myPofigRandom(0, 100)/100);
    this.effect.scale.set(0,0);
    this.playTime = 1500;
    Game.lvl.objEffect.push(this);
}

CritEffect.prototype.update = function(){
    if (this.playTime > 1000){
        this.effect.scale.set(-(this.playTime-1500)/500, -(this.playTime-1500)/500);
        this.effect.position.y -= 100/(Game.cycleTickTime*Game.speed);
    }
    this.playTime -= Game.cycleTickTime*Game.speed;
    if (this.playTime <= 0) {
        Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
        Game.lvl.pool.pull(this.effect);
    }
};

function WaveIconEffect(params){
    this.params = params;
    this.baseSpriteCd = 5000;
    this.spriteCd = this.baseSpriteCd;
    this.isWaveIcon = true;
    this.container = new PIXI.DisplayObjectContainer();
    this.effectBack = Game.lvl.pool.getSprite(Game.sprites['wave_skull_ico']);
    this.effect = Game.lvl.pool.getSprite(Game.sprites['MonsterGui']);
    this.basePosition = new Vec2(params.x, params.y);
    this.effectBack.rotation = Math.PI/4 * (-0.5 + myPofigRandom(0, 100)/100);
    //this.container.addChild(this.effectBack);
    this.scale = 0;
    this.width = 200;
    this.height = 200;
    this.bonusLineButtons = 0;
    this.state = 'wait';
    this.closesEnemie = new Vec2(0 ,0);
    this.container.position = new Vec2(params.x, params.y);
    this.container.addChild(this.effect);
    this.container.addChild(this.effectBack);
    Game.lvl.effectContainer.addChild(this.container);
    this.del = function () {
        Game.lvl.pool.pull(this.effect);
        Game.lvl.pool.pull(this.effectBack);
        Game.lvl.pool.pull(this.container);
    };

    var lvl = Game.lvl;
    if (!lvl.gameLogic || lvl.gameLogic.currectWave == 0) {
        setTimeout(function () {
            lvl.objEffect.push(this);
        }.bind(this), 0);
    } else {
        lvl.objEffect.push(this);
    }
}

WaveIconEffect.prototype.update = function (){
    this.spriteCd -= Game.cycleTickTime*Game.speed;
    if (this.spriteCd < 0) {
        this.spriteCd = this.baseSpriteCd;
        Game.lvl.objEffect.push(new SpriteEffect(this.basePosition));
    }
    this.scale < 0.2 ? this.scale+=0.01 : this.scale =0;
    this.updatePosition();
    this.effect.scale.set((1+(this.scale <= 0.1 ? this.scale - 0.1 : 0.1 - this.scale))/Game.lvl.camera.zoom, (1+(this.scale <= 0.1 ? this.scale - 0.1 : 0.1 - this.scale))/Game.lvl.camera.zoom);
    this.effectBack.scale = this.effect.scale;
    //this.effect.scale.set(1/,1/Game.lvl.camera.zoom);
    //this.effectBack.rotation = Math.PI*2 - this.container.position.clone().sub(this.closesEnemie).getRotate() + Math.PI/2;
};

WaveIconEffect.prototype.updatePosition = function (){
    this.bonusLineButtons = 0;
    Game.lvl.objGui.forEach(function(gui){
        if (gui.bonusLineButtons && !gui.hidden)
            this.bonusLineButtons++;
    }.bind(this));

    this.container.position = Game.lvl.camera.getWaveIconPosition(new Vec2(this.params.x, this.params.y), this.bonusLineButtons);
    //this.effectBack.rotation = Math.PI*2 - this.container.position.clone().sub(this.closesEnemie).getRotate() + Math.PI/2;
};


WaveIconEffect.prototype.checkWaveTouch = function (position) {
    if (this.container.position.clone().sub(position).getLength() < 90) {
        if (this.state != 'wait') {
            Game.lvl.gameLogic.night();
        } else {
            this.state = 'confirm';
            this.effectBack = Game.lvl.pool.switchSprite(Game.sprites['upgConfirmIcon'], this.effectBack);
        }
        return true;
    }
    if (this.state != 'wait') {
        this.state = 'wait';
        this.effectBack = Game.lvl.pool.switchSprite(Game.sprites['wave_skull_ico'], this.effectBack);
    }
    return false;
};

function SpriteEffect (position) {
    this.position = position.clone();
    this.path = Game.lvl.objMap.getPathForMonster(this.position, Game.lvl.townHall.position.clone().add(Game.lvl.townHall.hitPosition), this);
    this.speed = 32;
    this.toDeath = 0;
    var config = clone(Game.particlesList['Sprite']);
    config.pos.x = 0;
    config.pos.y = 0;
    var textures = [];
    config.images.forEach(function(image){
        textures.push(PIXI.TextureCache[image])
    });
    this.particle = new cloudkid.Emitter(
        Game.lvl.containerForParticle(config),
        textures,
        config
    );
    this.particle.emit = true;
    this.particle.updateSpawnPos(this.position.x, this.position.y);
}

SpriteEffect.prototype.update = function () {
    this.particle.update(0.05*Game.speed);
    this.particle.updateSpawnPos(this.position.x, this.position.y);
    if (this.path.length > 0) {
        this.move();
    } else {
        this.particle.emit = false;
        this.toDeath += Game.cycleTickTime*Game.speed;
        if (this.toDeath > 5000) {
            this.particle.destroy();
            if(Game.lvl.objEffect.indexOf(this) !==  -1)
                Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
        }
    }
};

SpriteEffect.prototype.move = function () {
    var direction, len, target, key;
    var gameSpeed = Game.speed;
    while (--gameSpeed >= 0) {
        while ((this.path.length > 0) && ((direction = this.path[this.path.length - 1].position.clone().sub(this.position)).getLength() <= this.speed + 10)) {
            this.path.pop();
        }
        if (this.path.length > 0) {
            this.position.add(direction.normalize().multiply(this.speed));
        }
    }
};



function FireBall(startPosition, targetPosition, playTime, onEnd){
    this.startPosition = startPosition.clone();
    this.targPosition = targetPosition;
    this.position = this.startPosition.clone();
    this.playTime = playTime;
    this.timePassed = 0;
    this.sprite = Game.lvl.pool.getAnimation('fireBall');
    this.sprite.position = this.position;
    this.onEnd = onEnd;
    Game.lvl.gameContainer.addChild(this.sprite);
}

FireBall.prototype.update = function () {
    this.timePassed += Game.cycleTickTime*Game.speed;
    if (this.timePassed < this.playTime) {
        this.position.x -= (this.position.x - this.targPosition.x)/((this.playTime - this.timePassed)/(Game.cycleTickTime*Game.speed));
        this.position.y -= (this.startPosition.y - this.targPosition.y + 40)/((this.playTime)/(Game.cycleTickTime*Game.speed));
        this.position.y += (this.timePassed - this.playTime/2)/5;
    } else {
        Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
        Game.lvl.pool.pullAnimation(this.sprite);
        this.onEnd();
    }
};


function Bullet(startPosition, targetPosition, playTime, onEnd) {
    this.startPosition = startPosition.clone();
    this.targPosition = targetPosition.clone();
    this.position = this.startPosition.clone();
    this.playTime = playTime;
    this.timePassed = 0;
    this.afterPlay = null;
    this.xdiv = targetPosition.x - startPosition.x;
    this.ydiv =  targetPosition.y - startPosition.y;
    this.sprite = Game.lvl.pool.getAnimation('bullet');
    this.sprite.randomizeTime = 0;
    this.sprite.position = this.position;
    Game.lvl.effectContainer.addChild(this.sprite);
    if (onEnd)
        this.onEnd = onEnd;
}

Bullet.prototype.update = function () {
    this.timePassed += (Game.cycleTickTime*Game.speed);
    if (this.timePassed < this.playTime) {
        this.position.x += this.xdiv/(this.playTime/(Game.cycleTickTime*Game.speed));
        this.position.y += this.ydiv/(this.playTime/(Game.cycleTickTime*Game.speed));
        this.position.y += ((this.timePassed - this.playTime/2)*Game.speed)/(Game.cycleTickTime);
    } else {
        Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
        Game.lvl.pool.pullAnimation(this.sprite);
        this.onEnd();
    }
};

Bullet.prototype.onEnd = function(){
    var damage, counter, range;
    Game.lvl.objEffect.push(new BoomFx(this.targPosition, 1));
    Game.lvl.objEffect.push(new BulletLoonka(this.targPosition));

    this.targPosition = Game.lvl.objMap.getTile(this.targPosition).position;

    for (var x = this.targPosition.x - Game.tileWidth * 2; x < this.targPosition.x + Game.tileWidth * 3; x += Game.tileWidth) {
        for (var y = this.targPosition.y - Game.tileHeight * 2; y < this.targPosition.y + Game.tileHeight * 3; y += Game.tileHeight) {
            var tile = Game.lvl.objMap.getTruthTile(new Vec2(x, y));
            if (tile) {
                range = tile.position.clone().sub(this.targPosition).getLength();
                if (range < 10){
                    counter = 1;
                } else  if (range < 76) {
                    counter = 0.6;
                } else  if (range < 92) {
                    counter = 0.3;
                } else  if (range < 130) {
                    counter = 0.1;
                } else {
                    counter = 0;
                }
                if (counter > 0) {
                    //new blackSquare(tile.position, false, 5000, counter);
                    for (var enemy in tile.eObjects)
                        if (!tile.eObjects[enemy].flying)
                            tile.eObjects[enemy].applyDamage(this.damage*counter);

                }
            }
        }
    }
};

function BombLoonka(startPosition, scale) {
    this.position = startPosition.clone();
    this.timePassed = 0;
    this.sprite = Game.lvl.pool.getSprite(Game.sprites['CannonCrater0'+myPofigRandom(1,3)]);
    this.sprite.position = this.position;
    this.sprite.addChild(this.sprite);
    this.sprite.scale.set(scale || 1,  scale || 1);
    Game.lvl.underEffectContainer.addChild(this.sprite);
}

BombLoonka.prototype.update = function () {
    this.timePassed += Game.cycleTickTime*Game.speed;
    if (this.timePassed > 10000) {
        this.sprite.alpha = (5000 + (10000-this.timePassed))/5000;
        if (this.timePassed >= 15000) {
            Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
            this.sprite.alpha = 1;
            Game.lvl.pool.pull(this.sprite);
        }
    }
};


function BulletLoonka(startPosition){
    this.position = startPosition.clone();
    this.timePassed = 0;
    this.sprite = Game.lvl.pool.getSprite(Game.sprites['crater'+myPofigRandom(0,3)]);
    this.sprite.position = this.position;
    this.sprite.scale.set(1.5, 1.5);
    Game.lvl.underEffectContainer.addChild(this.sprite);
}

BulletLoonka.prototype.update = function () {
    this.timePassed += Game.cycleTickTime*Game.speed;
    if (this.timePassed > 10000) {
        this.sprite.alpha = (5000 + (10000-this.timePassed))/5000;
        if (this.timePassed >= 15000) {
            Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
            this.sprite.alpha = 1;
            Game.lvl.pool.pull(this.sprite);
        }
    }
};

function Bomb(startPosition, targetPosition, parent){
    this.parent = parent;
    this.startPosition = startPosition;
    this.targPosition = targetPosition;
    this.position = startPosition;
    this.timePassed = 0;
    this.sprite = Game.lvl.pool.getAnimation('bullet');
    this.sprite.position = this.position;

    this.xDir = this.startPosition.x - this.targPosition.x;
    var ydiv = Math.abs(startPosition.y - targetPosition.y);
    var xdiv = Math.abs(startPosition.x - targetPosition.x);
    if (xdiv < 1)
        xdiv = 1;
    if (ydiv < 1)
        ydiv = 1;
    this.parY = Math.min(startPosition.y, targetPosition.y) - 100;
    if (startPosition.y < targetPosition.y) {
        if (startPosition.x < targetPosition.x) {
            this.parX = startPosition.x + (xdiv/2)*(ydiv/this.parent.range);
        } else {
            this.parX = startPosition.x - (xdiv/2)*(ydiv/this.parent.range);
        }
    } else {
        if (startPosition.x < targetPosition.x) {
            this.parX = targetPosition.x - (xdiv/2)*(ydiv/this.parent.range);
        } else {
            this.parX = targetPosition.x + (xdiv/2)*(ydiv/this.parent.range);
        }
    }
    var denom = (this.startPosition.x - targetPosition.x)*(this.startPosition.x - this.parX)*(targetPosition.x - this.parX);
    this.A = (this.parX * (targetPosition.y - this.startPosition.y) + targetPosition.x * (this.startPosition.y - this.parY) + this.startPosition.x * (this.parY - targetPosition.y)) / denom;
    this.B = (this.parX*this.parX * (this.startPosition.y - targetPosition.y) + targetPosition.x*targetPosition.x * (this.parY - this.startPosition.y) + this.startPosition.x*this.startPosition.x * (targetPosition.y - this.parY)) / denom;
    this.C = (targetPosition.x * this.parX * (targetPosition.x - this.parX) * this.startPosition.y + this.parX * this.startPosition.x * (this.parX - this.startPosition.x) * targetPosition.y + this.startPosition.x * targetPosition.x * (this.startPosition.x - targetPosition.x) * this.parY) / denom;

    Game.lvl.effectContainer.addChild(this.sprite);
}

Bomb.prototype.update = function () {
    if ((this.timePassed += Game.cycleTickTime*Game.speed) > 800) {
        Game.lvl.pool.pull(this.sprite);
        if (Game.lvl.objEffect.indexOf(this)!= -1)
            Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);

        Game.lvl.audioPool.get('CannonExplosion', 'CannonExplosion', 0.3, 3).play();
        Game.lvl.objEffect.push(new EffectParticles(this.targPosition, 'FlameExplRing'));
        Game.lvl.objEffect.push(new EffectParticles(this.targPosition, 'FlameExplosionFlash'));
        Game.lvl.objEffect.push(new BombLoonka(this.targPosition));
        var range, counter = 1;
        for (var x = this.targPosition.x - Game.tileWidth * 2; x < this.targPosition.x + Game.tileWidth * 3; x += Game.tileWidth) {
            for (var y = this.targPosition.y - Game.tileHeight * 2; y < this.targPosition.y + Game.tileHeight * 3; y += Game.tileHeight) {
                var tile = Game.lvl.objMap.getTruthTile(new Vec2(x, y));
                if (tile) {
                    range = tile.position.clone().sub(this.targPosition).getLength();
                    if (range < 10){
                        counter = 1;
                    } else  if (range < 76) {
                        counter = 0.6;
                    } else  if (range < 92) {
                        counter = 0.3;
                    } else  if (range < 130) {
                        counter = 0.1;
                    } else {
                        counter = 0;
                    }
                    if (counter > 0) {
                        var bigaboom = 0, target;
                        //new blackSquare(tile.position, false, 5000, counter);
                        for (var enemy in tile.eObjects)
                            if (!tile.eObjects[enemy].flying) {
                                target = tile.eObjects[enemy];
                                target.applyDamage(this.parent.damage * counter, this.parent);
                                if (target.hitPoints <= 0)
                                    bigaboom ++;
                            }

                        if (bigaboom >=5)
                            Game.events.emit('bigaboom');

                    }
                }
            }
        }
    } else {
        this.position.x -= (this.xDir/(800/(Game.cycleTickTime*Game.speed)));
        this.position.y =  this.A * this.position.x*this.position.x + this.B * this.position.x + this.C;
    }
};

function Phantom(startPosition, sprite, playTime, waitForDay) {
    this.position = startPosition.clone();
    this.timePassed = 0;
    this.playTime = playTime;
    this.waitForDay = waitForDay || false;
    if (sprite.playTime){
        this.sprite = Game.lvl.pool.getAnimation(sprite.name);
    } else {
        this.sprite = Game.lvl.pool.getSprite(sprite);
    }
    this.sprite.position = this.position;
    Game.lvl.gameContainer.addChild(this.sprite);
}


Phantom.prototype.update = function () {
    this.timePassed += Game.cycleTickTime*Game.speed;
    if (this.timePassed >= this.playTime) {
        Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
        Game.lvl.pool.pull(this.sprite);
    }
    if (this.waitForDay){
        if (Game.lvl.gameLogic.state != 'day' || Game.lvl.gameLogic.state !='tutorStart'){
            this.timePassed = 0;
        } else {
            this.timePassed = 0;
            this.waitForDay = false;
        }
    }
};

function MoneyPhantom(money, time) {
    this.timePassed = 0;
    this.time = time;
    this.money = money;
    Game.multiplayerLvl.lvlsMy.gameLogic.resource -= this.money;
}


MoneyPhantom.prototype.update = function () {
    this.timePassed += Game.cycleTickTime*Game.speed;
    if (this.timePassed >= this.time) {
        Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
        Game.multiplayerLvl.lvlsMy.gameLogic.resource += this.money;
    }
};



function CustomArcherArrow(startPosition, playtime, targetPosition, parent, sprite, isRandom, onEnd) {
    this.onEnd = onEnd;
    this.playtime = playtime;
    this.parent = parent;
    this.targetPosition = targetPosition;
    this.startPosition = startPosition;
    this.position = startPosition.clone();

    this.timePassed = 0;
    if (sprite.playTime) {
        this.sprite = Game.lvl.pool.getAnimation(sprite.name);
    } else {
        this.sprite = Game.lvl.pool.getSprite(sprite);
    }
    this.sprite.position = this.position;
    this.sprite.scale.set(1.5,1.5);
    Game.lvl.effectContainer.addChild(this.sprite);

    this.xDir = startPosition.x - this.targetPosition.x;
    var ydiv = Math.abs(startPosition.y - this.targetPosition.y);
    var xdiv = Math.abs(startPosition.x - this.targetPosition.x);
    if (xdiv < 50)
        xdiv = 50;
    if (ydiv < 50)
        ydiv = 50;
    this.parY = Math.min(startPosition.y, this.targetPosition.y) - 50;

    this.parXRange = (xdiv/2)*(ydiv/xdiv);
    if (startPosition.y < this.targetPosition.y) {
        if (startPosition.x < this.targetPosition.x) {
            this.parX = startPosition.x + this.parXRange;
        } else {
            this.parX = startPosition.x - this.parXRange;
        }
    } else {
        if (startPosition.x < this.targetPosition.x) {
            this.parX = this.targetPosition.x - this.parXRange;
        } else {
            this.parX = this.targetPosition.x + this.parXRange;
        }
    }
    this.par = new Vec2(this.parX, this.parY);
    this.direction = this.position.clone().sub(this.par);
    this.sprite.rotation = -this.direction.getRotate();
    var denom = (this.startPosition.x - this.targetPosition.x)*(this.startPosition.x - this.parX)*(this.targetPosition.x - this.parX);
    this.A = (this.parX * (this.targetPosition.y - this.startPosition.y) + this.targetPosition.x * (this.startPosition.y - this.parY) + this.startPosition.x * (this.parY - this.targetPosition.y)) / denom;
    this.B = (this.parX*this.parX * (this.startPosition.y - this.targetPosition.y) + this.targetPosition.x*this.targetPosition.x * (this.parY - this.startPosition.y) + this.startPosition.x*this.startPosition.x * (this.targetPosition.y - this.parY)) / denom;
    this.C = (this.targetPosition.x * this.parX * (this.targetPosition.x - this.parX) * this.startPosition.y + this.parX * this.startPosition.x * (this.parX - this.startPosition.x) * this.targetPosition.y + this.startPosition.x * this.targetPosition.x * (this.startPosition.x - this.targetPosition.x) * this.parY) / denom;
    //this.parabola = new Vec2(-this.B / (2*this.A), this.C - this.B*this.B / (4*this.A));
}

CustomArcherArrow.prototype.update = function () {
    if ((this.timePassed += Game.cycleTickTime*Game.speed) > this.playtime) {
        if (this.onEnd)
            this.onEnd();
        Game.lvl.pool.pull(this.sprite);
        if (Game.lvl.objEffect.indexOf(this) != -1)
            Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
    } else {
        this.position.x -= (this.xDir/(this.playtime/(Game.cycleTickTime*Game.speed)));
        this.position.y =  this.A * this.position.x*this.position.x + this.B * this.position.x + this.C;
        var fly = Math.abs(this.position.x - this.startPosition.x) > Math.abs(this.startPosition.x - this.par.x);
        this.direction = this.position.clone().sub( fly ? this.targetPosition : this.par);
        if (this.direction.getLength() > 10)
            this.sprite.rotation = -this.direction.getRotate();
    }
};

function MarkerEffect (position) {
    this.container = new PIXI.Container();
    this.container.position = position;
    this.baseY = position.y;
    this.sdvig = 0;
    this.container.addChild(Game.lvl.pool.getSprite(Game.sprites.marker));
    this.cd = 3500;
    Game.lvl.effectContainer.addChild(this.container);
}

MarkerEffect.prototype.update = function(){
    this.cd -= Game.cycleTickTime*Game.speed;
    this.container.position.y = this.baseY - (this.sdvig > 25 ? Math.abs(this.sdvig-50) : this.sdvig);
    this.sdvig += Game.speed;
    if (this.sdvig >= 50)
        this.sdvig = 0;

    if (this.cd <= 0) {
        Game.lvl.pool.pull(this.container);
        if (Game.lvl.objEffect.indexOf(this) !== -1)
            Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1)
    }
};


function DeathRay (position, length, rotation, time, parent, timeout, target) {
    this.position = position;
    this.length = length;
    this.rotation = rotation;
    this.parent = parent;
    this.timeout = timeout;
    this.target = target;

    this.hitEffect = Game.lvl.pool.getSprite(Game.sprites.deathRaySpark);
    this.hitEffect.position = this.target.position.clone().add(this.target.hitPosition);
    this.hitEffect.alpha = 0;

    this.blinkEffect = Game.lvl.pool.getSprite(Game.sprites.deathRaySpark2);
    this.blinkEffect.position = this.target.position.clone().add(this.target.hitPosition);
    this.blinkEffect.alpha = 0;

    var texture = PIXI.Texture.fromImage('ray.png');
    this.time = time;
    this.ray = new PIXI.TilingSprite(texture, 64*0.3, length);
    this.ray.alpha = 0;
    this.ray.tileScale.x = 0.3*0.75;
    //this.ray.tilePosition.x -= 64*0.3*0.5;
    this.ray.anchor.set(0.5, 0.5);
    this.ray.position = this.position;
    this.ray.rotation =  Math.PI*2 - this.rotation;
    Game.lvl.effectContainer.addChild(this.ray);
    Game.lvl.particlesContainer.addChild(this.hitEffect);
    Game.lvl.particlesContainer.addChild(this.blinkEffect);
    Game.lvl.objEffect.push(this);
}

DeathRay.prototype.update = function() {
    this.time -= Game.cycleTickTime*Game.speed;
    if (this.time < 0){
        this.parent.deathRay = null;
        Game.lvl.pool.pull(this.ray);
        if (Game.lvl.objEffect.indexOf(this) !== -1)
            Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);

        Game.lvl.pool.pull(this.hitEffect);
        Game.lvl.pool.pull(this.blinkEffect);
    } else {
        this.hitEffect.position = this.target.position.clone().add(this.target.hitPosition);
        this.ray.tilePosition.y -= 3*Game.speed;
        this.ray.position = this.position;
        this.ray.rotation = Math.PI*2 - this.rotation;
        this.blinkEffect.rotation += 0.05*Game.speed;
        if (this.timeout <=0) {
            this.ray.alpha = 1;
            this.hitEffect.alpha = 1;
            this.blinkEffect.alpha =1;
        } else
           this.timeout -= Game.cycleTickTime*Game.speed;

        this.ray.height = this.length;
    }
};


function RootsEffect (position, time) {
    this.cd = time;
    this.start = 2000;
    this.position = position;
}

RootsEffect.prototype.update = function(){
    this.cd -= Game.cycleTickTime*Game.speed;
    this.start -= Game.cycleTickTime*Game.speed;
    if (this.start < 0 && !this.started) {
        this.started = true;
        this.sprite = Game.lvl.pool.getAnimation('Roots02');
        this.sprite.position = this.position;
        Game.lvl.effectContainer.addChild(this.sprite);
    }
    if (this.cd <= 0) {
        Game.lvl.pool.pull(this.sprite);
        if (Game.lvl.objEffect.indexOf(this) !== -1)
            Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1)
    }
};

function NecroRootsEffect (position, time) {
    this.cd = time;
    this.sprite = Game.lvl.pool.getSprite(Game.sprites.NecroCrystall);
    this.sprite.position = position;
    Game.lvl.effectContainer.addChild(this.sprite);
}

NecroRootsEffect.prototype.update = function(){
    this.cd -= Game.cycleTickTime*Game.speed;
    if (this.cd <= 0) {
        Game.lvl.pool.pull(this.sprite);
        if (Game.lvl.objEffect.indexOf(this) !== -1)
            Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1)
    }
};

function Meteoritte(position, damage, isDragon, timeout) {
    this.timeout = timeout || 1000;
    this.isDragon = isDragon;
    this.damage = damage;
    this.metPosition = new Vec2(position.x + parseInt(position.y/5), 0);
    this.startPosition = this.metPosition.clone();
    this.targetPosition = position.clone();
    this.bombanulo = false;


    var config = clone(Game.particlesList['MeteorSmoke']);
    config.pos.x = 0;
    config.pos.y = 0;
    var textures = [];
    config.images.forEach(function(image){
        textures.push(PIXI.TextureCache[image])
    });
    this.smoke = new cloudkid.Emitter(
        Game.lvl.containerForParticle(config),
        textures,
        config
    );
    this.smoke.emit = false;
    this.smoke.updateSpawnPos(this.metPosition.x, this.metPosition.y);


    config = clone(Game.particlesList['MeteorFire']);
    config.pos.x = 0;
    config.pos.y = 0;
    textures = [];
    config.images.forEach(function(image){
        textures.push(PIXI.TextureCache[image])
    });
    this.fire = new cloudkid.Emitter(
        Game.lvl.containerForParticle(config),
        textures,
        config
    );
    this.fire.emit = false;
    this.fire.updateSpawnPos(this.metPosition.x, this.metPosition.y);
};

Meteoritte.prototype.update = function() {
    if (this.timeout > 0) {
        this.timeout -= Game.cycleTickTime*Game.speed;
        if (this.timeout <=0) {
            this.smoke.emit = true;
            this.fire.emit = true;
            Game.lvl.audioPool.get('MeteorSingle', 'MeteorSingle', 0.3, 3).play();
        }
    } else {
        this.fire.update(0.05*Game.speed);
        this.smoke.update(0.05*Game.speed);
        this.metPosition.y += 40*Game.speed;
        this.metPosition.x -= 8*Game.speed;
        this.fire.updateSpawnPos(this.metPosition.x, this.metPosition.y);
        this.smoke.updateSpawnPos(this.metPosition.x + 8, this.metPosition.y - 40);
        if (this.metPosition.y > this.targetPosition.y) {
            if (!this.bombanulo) {
                Game.lvl.audioPool.get('CannonExplosion', 'CannonExplosion', 0.3, 3).play();
                var loonka = new BulletLoonka(this.targetPosition);
                loonka.sprite.scale.set(2, 2);
                Game.lvl.objEffect.push(loonka);
                Game.lvl.objEffect.push(new BoomFx(this.targetPosition, 1.5));
                this.bombanulo = true;
                if (!this.isDragon) {
                    var tiles = [], tempPos, tempTile;
                    for (var x = -64; x <= 64; x += 64) {
                        for (var y = -64; y <= 64; y += 64) {
                            tempTile = Game.lvl.objMap.getTruthTile(this.targetPosition.clone().add(new Vec2(x, y)));
                            if (tempTile && tiles.indexOf(tempTile) == -1) {
                                tiles.push(tempTile);
                            }
                        }
                    }
                    tiles.forEach(function (tile) {
                        tile.wObjects.forEach(function (friendly) {
                            friendly.applyDamage(this.damage);
                        }.bind(this));
                    }.bind(this));
                } else {
                    var buildPos = this.targetPosition;
                    var building = Game.lvl.objBuildings.filter(function(building){return building.position.x == buildPos.x && building.position.y == buildPos.y}.bind(this)).pop();
                    building && building.del();
                    if (building && building.mainTile) {
                        var flag = Game.lvl.flags.filter(function(flag){return flag.tile == building.mainTile;}).pop();
                        if (flag) {
                            flag.disabled = 50*20*20;
                            Game.lvl.objEffect.push(new EffectParticles(building.mainTile.position, 'flagfire', 50*20*20));
                        }
                    }
                }
            }
            this.smoke.emit = false;
            this.fire.emit = false;
            this.fire.update(0.05*Game.speed);
            this.smoke.update(0.05*Game.speed);

            if (this.metPosition.y > this.targetPosition.y * 3) {
                this.fire.destroy();
                this.smoke.destroy();
                if (Game.lvl.objEffect.indexOf(this) !== -1)
                    Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
            }
        }
    }
};

function BoomFx (position, scale) {

    this.timeout = 3000;
    Game.lvl.audioPool.get('catapultaExpl', 'CatapultExplosion', 0.3, 4).play();
    var config = clone(Game.particlesList['ExplosionDirt']);
    config.pos.x = position.x;
    config.pos.y = position.y;
    config.scale = clone(config.scale);
    config.scale.start *=scale;
    config.scale.end *=scale;
    var textures = [];
    config.images.forEach(function(image){
        textures.push(PIXI.TextureCache[image])
    });
    this.dirt = new cloudkid.Emitter(
        Game.lvl.containerForParticle(config),
        textures,
        config
    );
    this.dirt.emit = true;


    config = clone(Game.particlesList['ExplosionFlame']);
    config.pos.x = position.x;
    config.pos.y = position.y;
    config.scale = clone(config.scale);
    config.scale.start *=scale;
    config.scale.end *=scale;
    textures = [];
    config.images.forEach(function(image){
        textures.push(PIXI.TextureCache[image])
    });
    this.fire = new cloudkid.Emitter(
        Game.lvl.containerForParticle(config),
        textures,
        config
    );
    this.fire.emit = true;

    config = clone(Game.particlesList['ExplosionRing']);
    config.pos.x = position.x;
    config.pos.y = position.y;
    config.scale = clone(config.scale);
    config.scale.start *=scale;
    config.scale.end *=scale;
    textures = [];
    config.images.forEach(function(image){
        textures.push(PIXI.TextureCache[image])
    });
    this.ring = new cloudkid.Emitter(
        Game.lvl.containerForParticle(config),
        textures,
        config
    );
    this.ring.emit = true;
};

BoomFx.prototype.update = function() {
    if (this.timeout > 0) {
        this.timeout -= Game.cycleTickTime*Game.speed;
        this.dirt.update(0.05*Game.speed);
        this.ring.update(0.05*Game.speed);
        this.fire.update(0.05*Game.speed);
    } else {
        this.fire.destroy();
        this.dirt.destroy();
        this.ring.destroy();
        if (Game.lvl.objEffect.indexOf(this) !== -1)
            Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
    }
};

function MeteoritteFireMage(position, damage, radius, isMage) {
    if (isMage) {
        this.sound = Game.lvl.audioPool.get('MeteorSingle', 'MeteorSingle', 0.3, 3);
    } else {
        this.sound = Game.lvl.audioPool.get('MeteorSpell', 'MeteorSpell', 0.3, 3);
    }
    this.timeout = 1000;
    this.damage = damage;
    this.radius = radius || 1;
    this.metPosition = new Vec2(position.x + parseInt(position.y/5), 0);
    this.isMage = isMage || false;
    this.startPosition = this.metPosition.clone();
    this.targetPosition = position.clone();
    this.bombanulo = false;

    var config = clone(Game.particlesList['MeteorSmoke']);
    config.pos.x = 0;
    config.pos.y = 0;
    var textures = [];
    config.images.forEach(function(image){
        textures.push(PIXI.TextureCache[image])
    });
    this.smoke = new cloudkid.Emitter(
        Game.lvl.containerForParticle(config),
        textures,
        config
    );
    this.smoke.emit = false;
    this.smoke.updateSpawnPos(this.metPosition.x, this.metPosition.y);


    config = clone(Game.particlesList['MeteorFire']);
    config.pos.x = 0;
    config.pos.y = 0;
    textures = [];
    config.images.forEach(function(image){
        textures.push(PIXI.TextureCache[image])
    });
    this.fire = new cloudkid.Emitter(
        Game.lvl.containerForParticle(config),
        textures,
        config
    );
    this.fire.emit = false;
    this.fire.updateSpawnPos(this.metPosition.x, this.metPosition.y);
};

MeteoritteFireMage.prototype.update = function() {
    if (this.timeout > 0) {
        this.timeout -= Game.cycleTickTime*Game.speed;
        if (this.timeout <=0){
            this.sound && this.sound.play();
            this.smoke.emit = true;
            this.fire.emit = true;
        }
    } else {
        this.fire.update(0.05*Game.speed);
        this.smoke.update(0.05*Game.speed);
        this.metPosition.y += 40*Game.speed;
        this.metPosition.x -= 8*Game.speed;
        this.fire.updateSpawnPos(this.metPosition.x, this.metPosition.y);
        this.smoke.updateSpawnPos(this.metPosition.x + 8, this.metPosition.y - 40);
        if (this.metPosition.y > this.targetPosition.y) {
            if (!this.bombanulo) {
                if (this.isMage) {
                    Game.lvl.audioPool.get('CannonExplosion', 'CannonExplosion', 0.3, 3).play();
                    Game.lvl.objEffect.push(new EffectParticles(this.targetPosition, 'FlameExplRing'));
                    Game.lvl.objEffect.push(new EffectParticles(this.targetPosition, 'FlameExplosionFlash'));
                    Game.lvl.objEffect.push(new BombLoonka(this.targetPosition, 1.5));
                } else {
                    Game.lvl.objEffect.push(new BulletLoonka(this.targetPosition, 2));
                    Game.lvl.objEffect.push(new BoomFx(this.targetPosition, 1.3));
                }
                this.bombanulo = true;
                var tiles = [], tempPos, tempTile;
                for (var x = -64*this.radius; x <= 64*this.radius; x += 64) {
                    for (var y = -64*this.radius; y <= 64*this.radius; y += 64) {
                        tempTile = Game.lvl.objMap.getTruthTile(this.targetPosition.clone().add(new Vec2(x, y)));
                        if (tempTile && tiles.indexOf(tempTile) == -1) {
                            tiles.push(tempTile);
                        }
                    }
                }
                tiles.forEach(function (tile) {
                    tile.eObjects.forEach(function (enemy) {
                        enemy.applyDamage(this.damage);

                        if (enemy.hitPoints <=0 && !this.isMage)
                            Game.events.emit('bombKill');

                    }.bind(this));
                }.bind(this));
            }
            this.smoke.emit = false;
            this.fire.emit = false;
            this.fire.update(0.05*Game.speed);
            this.smoke.update(0.05*Game.speed);

            if (this.metPosition.y > this.targetPosition.y * 3) {
                this.fire.destroy();
                this.smoke.destroy();
                if (Game.lvl.objEffect.indexOf(this) !== -1)
                    Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
            }
        }
    }
};

function SplashFx (position, color) {
    this.timeout = 5000;
    var config = clone(Game.particlesList['AcidSplash']);
    config.pos.x = position.x;
    config.pos.y = position.y;
    var textures = [];
    config.images.forEach(function(image){
        textures.push(PIXI.TextureCache[image])
    });
    this.ring = new cloudkid.Emitter(
        Game.lvl.containerForParticle(config),
        textures,
        config
    );
    this.ring.emit = true;
};

SplashFx.prototype.update = function() {
    if (this.timeout > 0) {
        this.timeout -= Game.cycleTickTime*Game.speed;
        this.ring.update(0.05*Game.speed);
    } else {
        this.ring.destroy();
        if (Game.lvl.objEffect.indexOf(this) !== -1)
            Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
    }
};


function BoombScrollFX(position, damage) {
    this.basePosition = position.clone();
    this.damage = damage;
    this.passed = 0;

    this.sprite = Game.lvl.pool.getSprite(Game.sprites.Bomb_S);
    this.sprite.position = position;
    Game.lvl.effectContainer.addChild(this.sprite);
}

BoombScrollFX.prototype.update = function() {
    var speed = 0;
    this.passed+=2*Game.speed;
    this.sprite.rotation += 0.33;
    if (this.passed < 15) {
        speed = 16/this.passed;
        if (speed > 4) speed = 5;
        this.sprite.position.y -= speed*2;
        this.sprite.scale.x += 0.02;
        this.sprite.scale.y += 0.02;
    } else if (this.passed < 30) {
        speed = 16/(30 - this.passed);
        if (speed > 4) speed = 5;
        this.sprite.position.y += speed*2;
        this.sprite.scale.x -= 0.02;
        this.sprite.scale.y -= 0.02;
    } else {
        this.sprite.scale.x = 1;
        this.sprite.scale.y = 1;

        this.sprite.rotation = 0;
        if (Game.lvl.objEffect.indexOf(this))
            Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);

        Game.lvl.pool.pull(this.sprite);
        var that = this;
        var tiles = [], tempTile;
        for (var x = -2; x <=2; x++) {
            for (var y = -2; y <=2; y++) {
                tempTile = Game.lvl.objMap.getTruthTile(this.basePosition.clone().add(x*64, y*64));
                if (tempTile)
                    tiles.push(tempTile);
            }
        }
        tiles.forEach(function (tile) {
            tile.eObjects.forEach(function (enemy){
                enemy.applyDamage(that.damage);
                if (enemy.hitPoints <=0)
                    Game.events.emit('bombKill');
            });
        });
        Game.lvl.audioPool.get('catapultaExpl', 'CatapultExplosion', 0.3, 4).play();
        Game.lvl.objEffect.push(new BoomFx(this.basePosition, 1));
        Game.lvl.objEffect.push(new BulletLoonka(this.basePosition));
    }
};


function FireBallDragon(position, damage, target) {
    this.timeout = 600;
    this.damage = damage;
    this.metPosition = position.clone();
    this.targetPosition = target.clone();
    this.bombanulo = false;

    var config = clone(Game.particlesList['MeteorSmoke']);
    config.pos.x = 0;
    config.pos.y = 0;
    var textures = [];
    config.images.forEach(function(image){
        textures.push(PIXI.TextureCache[image])
    });
    this.smoke = new cloudkid.Emitter(
        Game.lvl.containerForParticle(config),
        textures,
        config
    );
    this.smoke.emit = false;
    this.smoke.updateSpawnPos(this.metPosition.x, this.metPosition.y);

    config = clone(Game.particlesList['MeteorFire']);
    config.pos.x = 0;
    config.pos.y = 0;
    textures = [];
    config.images.forEach(function(image){
        textures.push(PIXI.TextureCache[image])
    });
    this.fire = new cloudkid.Emitter(
        Game.lvl.containerForParticle(config),
        textures,
        config
    );
    this.fire.emit = false;
    this.fire.updateSpawnPos(this.metPosition.x, this.metPosition.y);
};

FireBallDragon.prototype.update = function() {
    if (this.timeout > 0) {
        this.timeout -= Game.cycleTickTime*Game.speed;
        if (this.timeout <=0) {
            this.smoke.emit = true;
            this.fire.emit = true;
        }
    } else {
        this.fire.update(0.05*Game.speed);
        this.smoke.update(0.05*Game.speed);
        var direction = this.targetPosition.clone().sub(this.metPosition);
        if (direction.getLength() > 64) {
            direction.normalize().multiply(24);
            this.metPosition.y += direction.y*Game.speed;
            this.metPosition.x += direction.x*Game.speed;
            this.fire.updateSpawnPos(this.metPosition.x, this.metPosition.y);
            this.smoke.updateSpawnPos(this.metPosition.x + 8, this.metPosition.y - 40);
        } else {
            if (!this.bombanulo) {
                Game.lvl.audioPool.get('CannonExplosion', 'CannonExplosion', 0.3, 3).play();
                Game.lvl.objEffect.push(new EffectParticles(this.targetPosition, 'FlameExplRing'));
                Game.lvl.objEffect.push(new EffectParticles(this.targetPosition, 'FlameExplosionFlash'));
                direction.normalize().multiply(32);
                this.metPosition.x += direction.x;
                this.metPosition.y += direction.y;
                this.bombanulo = true;
                var tiles = [], tempPos, tempTile;
                for (var x = -64; x <= 64; x += 64) {
                    for (var y = -64; y <= 64; y += 64) {
                        tempTile = Game.lvl.objMap.getTruthTile(this.targetPosition.clone().add(new Vec2(x, y)));
                        if (tempTile && tiles.indexOf(tempTile) == -1) {
                            tiles.push(tempTile);
                        }
                    }
                }
                tiles.forEach(function (tile) {
                    tile.wObjects.forEach(function (enemy) {
                        enemy.applyDamage(this.damage);
                    }.bind(this));
                }.bind(this));
                this.smoke.emit = false;
                this.fire.emit = false;
            }
            this.fire.update(0.05*Game.speed);
            this.smoke.update(0.05*Game.speed);
            this.timeout -= Game.cycleTickTime*Game.speed;
            if (this.timeout < 5000) {
                this.fire.destroy();
                this.smoke.destroy();
                if (Game.lvl.objEffect.indexOf(this) !== -1)
                    Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
            }
        }
    }
};


function DumFx (position, scale) {
    this.timeout = 3000;
    var config = clone(Game.particlesList['ExplosionDirt']);
    config.pos.x = position.x;
    config.pos.y = position.y;
    config.scale = clone(config.scale);
    config.scale.start *=scale;
    config.scale.end *=scale;
    var textures = [];
    config.images.forEach(function(image){
        textures.push(PIXI.TextureCache[image])
    });
    this.dirt = new cloudkid.Emitter(
        Game.lvl.containerForParticle(config),
        textures,
        config
    );
    this.dirt.emit = true;

    config = clone(Game.particlesList['ExplosionRing']);
    config.pos.x = position.x;
    config.pos.y = position.y;
    config.scale = clone(config.scale);
    config.scale.start *=scale;
    config.scale.end *=scale;
    textures = [];
    config.images.forEach(function(image){
        textures.push(PIXI.TextureCache[image])
    });
    this.ring = new cloudkid.Emitter(
        Game.lvl.containerForParticle(config),
        textures,
        config
    );
    this.ring.emit = true;
}

DumFx.prototype.update = function() {
    if (this.timeout > 0) {
        this.timeout -= Game.cycleTickTime*Game.speed;
        this.dirt.update(0.05*Game.speed);
        this.ring.update(0.05*Game.speed);
    } else {
        this.dirt.destroy();
        this.ring.destroy();
        if (Game.lvl.objEffect.indexOf(this) !== -1)
            Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
    }
};

function DragonFlame(position, direction) {
    this.position = position.clone();
    this.bombanulo = false;
    this.timeout = 1500;
    var config = clone(Game.particlesList['FlameThrower']);
    config.pos.x = this.position.x;
    config.pos.y = this.position.y;
    config.acceleration = {
        x: -500 * direction,
        y: 0
    };
    config.speed = {
        start: 700 * direction,
        end: 0
    };
    var textures = [];
    config.images.forEach(function(image){
        textures.push(PIXI.TextureCache[image])
    });
    this.flame = new cloudkid.Emitter(
        Game.lvl.containerForParticle(config),
        textures,
        config
    );
    this.flame.emit = true;
}

DragonFlame.prototype.update = function() {
    this.flame.update(0.05*Game.speed);
    if (this.timeout > 0) {
        this.timeout -= Game.cycleTickTime*Game.speed;
        if (this.timeout <=0){
            this.flame.emit = false;
        }
    } else {
        this.flame.destroy();
        if (Game.lvl.objEffect.indexOf(this) !== -1)
            Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
    }
};


function Soul (position) {
    this.timeout = 1000;
    var config = clone(Game.particlesList['UndeadMage']);
    config.pos.x = position.x;
    config.pos.y = position.y;
    var textures = [];
    config.images.forEach(function(image){
        textures.push(PIXI.TextureCache[image])
    });
    this.soul = new cloudkid.Emitter(
        Game.lvl.containerForParticle(config),
        textures,
        config
    );
    this.soul.emit = false;
};

Soul.prototype.update = function() {
    this.timeout -= Game.cycleTickTime*Game.speed;
    if (this.timeout == 0) {
        this.soul.emit = true;
    } else {
        this.soul.update(0.05*Game.speed);
        if (this.timeout < -5000){
            this.soul.destroy();
            if (Game.lvl.objEffect.indexOf(this) !== -1)
                Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
        }
    }
};

function CritBlood (position) {
    this.timeout = 3500;
    var config = Game.particlesList['Blood_Crit'];
    config.pos.x = position.x;
    config.pos.y = position.y;
    var textures = [];
    config.images.forEach(function(image){
        textures.push(PIXI.TextureCache[image])
    });
    this.blood = new cloudkid.Emitter(
        Game.lvl.containerForParticle(config),
        textures,
        config
    );
    this.blood.emit = true;
};

CritBlood.prototype.update = function() {
    this.timeout -= Game.cycleTickTime*Game.speed;
    this.blood.update(0.05*Game.speed);
    if (this.timeout < 0) {
        this.blood.destroy();
        if (Game.lvl.objEffect.indexOf(this) !== -1)
            Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
    }
};

function AssasinFx (position, withA) {
    this.timeout = 5000;
    var config = clone(Game.particlesList['Assasis smoke B']);
    config.pos.x = position.x;
    config.pos.y = position.y;
    var textures = [];
    config.images.forEach(function(image){
        textures.push(PIXI.TextureCache[image])
    });
    this.smokeB = new cloudkid.Emitter(
        Game.lvl.containerForParticle(config),
        textures,
        config
    );
    this.smokeB.emit = true;

    config = withA ? clone(Game.particlesList['Assasis smoke A']) : clone(Game.particlesList['Assasins swords']) ;
    config.pos.x = position.x;
    config.pos.y = position.y;
    textures = [];
    config.images.forEach(function(image){
        textures.push(PIXI.TextureCache[image])
    });
    this.smokeA = new cloudkid.Emitter(
        Game.lvl.containerForParticle(config),
        textures,
        config
    );
    this.smokeA.emit = true;
};

AssasinFx.prototype.update = function() {
    if (this.timeout > 0) {
        this.timeout -= Game.cycleTickTime*Game.speed;
        this.smokeB.update(0.05*Game.speed);
        this.smokeA.update(0.05*Game.speed);
    } else {
        this.smokeB.destroy();
        this.smokeA.destroy();
        if (Game.lvl.objEffect.indexOf(this) !== -1)
            Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
    }
};

function Knifes (position, rotation) {
    this.timeout = 5000;
    var config = clone(Game.particlesList['Warrior swords']);
    config.pos.x = position.x;
    config.pos.y = position.y;
    config.startRotation = {
        "min": -20 + rotation*180/Math.PI,
        "max": +20 + rotation*180/Math.PI
    };
    var textures = [];
    config.images.forEach(function(image){
        textures.push(PIXI.TextureCache[image])
    });
    this.knifes = new cloudkid.Emitter(
        Game.lvl.containerForParticle(config),
        textures,
        config
    );
    this.knifes.emit = true;
}

Knifes.prototype.update = function() {
    if (this.timeout > 0) {
        this.timeout -= Game.cycleTickTime*Game.speed;
        this.knifes.update(0.05*Game.speed);
    } else {
        this.knifes.destroy();
        if (Game.lvl.objEffect.indexOf(this) !== -1)
            Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
    }
};

function MessageBalloon(message, position, onTop, parent){
    this.container = new PIXI.DisplayObjectContainer();
    this.balloon = Game.isMenu ?  Game.menu.pool.getSprite(Game.sprites[onTop ? 'F_A' : 'F_B']) : Game.lvl.pool.getSprite(Game.sprites[onTop ? 'F_A' : 'F_B']);
    this.balloon.scale.set(0.75, 0.6);
    this.container.addChild(this.balloon);
    Game.font = Game.getFont(42);
    this.balloonText = new PIXI.Text(message, {
        font: Game.font,
        align: 'center',
        fill: 'rgba(1, 1, 1, 1);'
    });
    this.balloonText.anchor.set(0.5, 0.5);
    if (onTop)
        this.balloonText.position.set(0, -24);
    else {
        this.balloon.position.set(-196, 0);
        this.balloonText.position.set(-226, -8);
        if (this.balloonText.width > 300) {
            this.balloon.position.set(-236, 0);
            this.balloonText.position.set(-276, -8);
            this.balloon.scale.set(1, this.balloon.scale.y)
        }
    }

    if (this.balloonText.height > 100) {
        this.balloon.scale.set(this.balloon.scale.x, 0.85);
    }

    this.container.addChild(this.balloonText);
    this.container.position = position;
    parent.addChild(this.container);
}

MessageBalloon.prototype.update = function() {
};


function MessageBalloonMenu(message, position, onTop) {
    this.container = new PIXI.DisplayObjectContainer();
    this.balloon = Game.menu.pool.getSprite(Game.sprites.dialog);
    this.balloon.scale.set(0.7, 0.7);
    this.container.addChild(this.balloon);
    Game.font = Game.getFont(42);
    this.balloonText = new PIXI.Text(message, {
        font: Game.font,
        align: 'left',
        fill: 'rgba(1, 1, 1, 1);',
        wordWrap: true,
        wordWrapWidth: 300
    });


    this.balloonText.anchor.set(0.5, 0.5);
    if (onTop)
        this.balloonText.position.set(28, -24);
    else {
        this.balloon.position.set(-196, 0);
        this.balloonText.position.set(-196, -8);
    }
    this.container.addChild(this.balloonText);
    this.container.position = position;
    return this.container;
}
MessageBalloon.prototype.update = function() {};