﻿function Effect(position, direction, layer, sprite, playTime, sizeMultiplyed, target, looped, isUnder) {
    if (playTime < 150)
      playTime = 150;

   	this.position = position;
    this.afterPlay = null;
    if (direction)
   	  this.flyDistance = direction.getLength()/(playTime/(Game.cycleTickTime*Game.speed));
    if (direction)
    	this.direction = direction.normalize();
    else 
      (this.direction = new Vec2(0,0));

    if (target)
       this.target = target;

    if (this.target instanceof Enemy)
        this.randomDirection = new Vec2(this.target.hitRange/2 - myPofigRandom(0,this.target.hitRange), this.target.hitRange/2 - myPofigRandom(0,this.target.hitRange));

    this.looped = looped;
  	this.layer = layer;
  	this.animationPlayTime = playTime;
  	this.timePassed = 0;
	this.sizeMultiplyed = sizeMultiplyed;

    if (sprite.playTime) {
        this.sprite = Game.lvl.pool.getAnimation(sprite.name);
    } else {
        this.sprite = Game.lvl.pool.getSprite(sprite);
    }
    this.sprite.scale.set(this.sizeMultiplyed, this.sizeMultiplyed);
    this.sprite.position = this.position;
    this.sprite.loop = looped;
    if (!isUnder)
        Game.lvl.effectContainer.addChild(this.sprite);
    else
        Game.lvl.underEffectContainer.addChild(this.sprite);
    this.weblayer = Game.lvl.effectContainer;
}

Effect.prototype.setAfterPlay =function(functionToset){
  this.afterPlay = functionToset;
  return this;
};

Effect.prototype.update  = function () {
    if (this.direction)
        this.position.sub(this.direction.multiplyed(this.flyDistance));

    if ((this.timePassed += Game.cycleTickTime*Game.speed) > this.animationPlayTime){
        this.sprite.scale.set(1,1);
        Game.lvl.pool.pull(this.sprite);

        if (this.layer.indexOf(this) != -1)
            this.layer.splice(this.layer.indexOf(this), 1);

        if (this.afterPlay)
            this.afterPlay.call(this);
    }
    if (this.target)
    {
        this.direction = this.position.clone().sub(this.target);

        if (this.target instanceof Enemy)
            this.direction.add(this.target.hitPosition).add(this.randomDirection);

        this.flyDistance = this.direction.getLength()/((this.animationPlayTime - this.timePassed)/(Game.cycleTickTime*Game.speed));
        this.direction.normalize();
    }
};


function EffectSmall(position, layer, sprite, playTime, looped, callback) {
    this.position = position;
    this.timePassed = 0;
    this.playTime = playTime;
    if (sprite.playTime) {
        this.sprite = Game.lvl.pool.getAnimation(sprite.name);
    } else {
        this.sprite = Game.lvl.pool.getSprite(sprite);
    }
    this.sprite.position = this.position;
    this.sprite.loop = looped;
    layer.addChild(this.sprite);
    this.callback = callback;
}

EffectSmall.prototype.update  = function () {
    if ((this.timePassed += Game.cycleTickTime*Game.speed) > this.playTime) {
        Game.lvl.pool.pull(this.sprite);
        Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
        if (this.callback) {
            this.callback();
            this.callback = null;
        }
    }
};

function Timer(time, callback) {
    this.timePassed = 0;
    this.playTime = time;
    this.callback = callback;
}

Timer.prototype.update  = function () {
    if ((this.timePassed += Game.cycleTickTime*Game.speed) > this.playTime) {
        if (Game.lvl.objEffect.indexOf(this) !== -1)
            Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
        if (this.callback){
            this.callback();
            this.callback = null;
        }
    }
};


function EffectSmallAlpa(position, layer, sprite, playTime, looped, callback) {
    this.position = position;
    this.timePassed = 0;
    this.playTime = playTime;
    if (sprite.playTime) {
        this.sprite = Game.lvl.pool.getAnimation(sprite.name);
    } else {
        this.sprite = Game.lvl.pool.getSprite(sprite);
    }
    this.sprite.position = this.position;
    this.sprite.loop = looped;
    layer.addChild(this.sprite);
    this.callback = callback;
}

EffectSmallAlpa.prototype.update  = function () {
    if ((this.timePassed += Game.cycleTickTime*Game.speed) > this.playTime) {
        this.sprite.alpha -= 0.05;
        if (this.sprite.alpha <=0){
            this.sprite.alpha = 1;
            Game.lvl.pool.pull(this.sprite);
            Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
            if (this.callback) {
                this.callback();
                this.callback = null;
            }
        }
    }
};

function EffectParticles (position, particle, time) {
    var config = clone(Game.particlesList[particle]);
    config.pos.x = position.x;
    config.pos.y = position.y;
    this.timeout = time ? time : config.emitterLifetime * 1000 + config.lifetime.max*1000 + (Game.cycleTickTime*Game.speed);
    var textures = [];
    config.images.forEach(function(image){
        textures.push(PIXI.TextureCache[image])
    });
    this.particles = new cloudkid.Emitter(
        Game.lvl.containerForParticle(config),
        textures,
        config
    );
    this.particles.emit = true;
}

EffectParticles.prototype.update = function() {
    if (this.timeout > 0) {
        this.timeout -= Game.cycleTickTime*Game.speed;
        this.particles.update(0.05*Game.speed);
    } else {
        this.particles.destroy();
        if (Game.lvl.objEffect.indexOf(this) !== -1)
            Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
    }
};
