﻿function loadEnemy() {

    Game.enemyList.wolf = {
        cost:10,
        icon: 'wolfRun0',
        n:'wolf',
        e:'any',
        hitPoints: 10,
        damage: 1,
        lifeCost: 1,
        timeOut: 500,
        speed: 12,
        hitPosition: new Vec2(0,-15),
        attackRange: Game.tileWidth,
        animations:{fight:['wolfFight1', 'wolfFight2'], die:'wolfDie', run:'wolfRun'},
        type: "enemy",
        soundDeathGroup:'enemyWolfDeath',
        soundDeath:'WolfDeath',
        soundDeathVolume:0.3,
        soundDeathLimit:2,
        scaleHint: 2
    };

    Game.enemyList.goblin = {
        cost:10,
        icon: 'goblinRun0',
        n:'goblin',
        e:'any',
        hitPoints: 5,
        damage: 1,
        timeOut: 500,
        speed: 12,
        lifeCost: 1,
        hitPosition: new Vec2(0,-40),
        hitRange: 10,
        attackRange: Game.tileWidth,
        animations:{fight:['goblinFight1', 'goblinFight2'], die:'goblinDie', run:'goblinRun'},
        type: "enemy",
        soundDeathGroup:'enemyGoblinDeath',
        soundDeath:['Goblin Death 1', 'Goblin Death 2'],
        soundDeathVolume:0.3,
        soundDeathLimit:2,
        scaleHint: 2,
        subtype:'goblins'
    };

    Game.enemyList.orcWarrior = {
        cost:10,
        icon: 'redOrcWarRun0',
        n:'orcWarrior',
        e:'desert',
        hitPoints: 10,
        damage: 1,
        timeOut: 500,
        speed: 6,
        lifeCost: 1,
        hitPosition: new Vec2(0,-40),
        hitRange: 10,
        attackRange: Game.tileWidth,
        animations:{fight:['redOrcWarFight1', 'redOrcWarFight2'], die:'redOrcWarDie', run:'redOrcWarRun'},
        type: "enemy",
        soundDeathGroup:'enemyOrcDeath',
        soundDeath:'Orc Enemy Death',
        soundDeathVolume:0.3,
        soundDeathLimit:2,
        scaleHint: 2,
        subtype:'orcs'
    };

    Game.enemyList.harpy = {
        cost:10,
        icon: 'harpyFly0',
        n:'harpy',
        e:'any',
        hitPoints: 10,
        damage: 1,
        timeOut: 500,
        speed: 12,
        lifeCost: 1,
        hitPosition: new Vec2(0,-120),
        hitRange: 20,
        flying: true,
        attackRange: Game.tileWidth*2,
        animations:{fight:['harpyFight1'], die:'harpyDie', run:'harpyFly'},
        type: "enemy",
        soundDeathGroup:'enemyHarpyDeath',
        soundDeath:'HarpyDeath',
        soundDeathVolume:0.3,
        soundDeathLimit:2,
        scaleHint: 1.8
    };


    Game.enemyList.barbarian = {
        cost:10,
        icon: 'barbarianRun0',
        n:'barbarian',
        e:'any',
        hitPoints: 5,
        damage: 1,
        timeOut: 500,
        speed: 12,
        lifeCost: 2,
        hitPosition: new Vec2(0,-80),
        hitRange: 10,
        attackRange: Game.tileWidth,
        animations:{fight:['barbarianFight1', 'barbarianFight2'], die:'barbarianDie', run:'barbarianRun'},
        type: "enemy",
        soundDeathGroup:'enemyHumanDeath',
        soundDeath:['HumanDeath01','HumanDeath02', 'HumanDeath03', 'HumanDeath04'],
        soundDeathVolume:0.3,
        soundDeathLimit:4,
        scaleHint: 1.5
    };

    Game.enemyList.ogreBoss = {
        cost:10,
        icon: 'ogreBossRun0',
        n:'ogreBoss',
        e:'desert',
        boss: true,
        hitPoints: 120,
        damage: 10,
        bulletDamage: 200,
        bulletRange: 10,
        bulletCd:20000,
        timeOut: 500,
        speed: 6,
        lifeCost: 1,
        hitPosition: new Vec2(0,-100),
        hitRange: 64,
        attackRange: Game.tileWidth,
        animations:{fight:['ogreBossFight1', 'ogreBossFight2', 'ogreBossFight3'], die:'ogreBossDie', run:'ogreBossRun', cast:'ogreBossRoar1', cast2:'ogreBossRoar2'},
        type: "enemy",
        soundCCGroup:'ogreBossAttack',
        soundCC:['OgreBossAttack01','OgreBossAttack02','OgreBossAttack03'],
        soundCCVolume:0.3,
        soundCCLimit:2,
        soundDeathGroup:'ogreBossDeath',
        soundDeath:'OgreBossRoar02',
        soundDeathVolume:0.4,
        soundDeathLimit:1,
        onDeath : function (){
            Game.events.emit('killgragon');
        },
        strategy: function(){
            var len, target, key;
            this.scanTimeOut -= Game.cycleTickTime*Game.speed;
            this.timeOut -= Game.cycleTickTime*Game.speed;
            this.bulletTimeout -= Game.cycleTickTime*Game.speed;

            if (this.timeOut > 0)
                return;


            if (this.bulletTimeout <=0) {
                this.fight = false;
                this.bulletTimeout = this.base.bulletCd;
                var friendlyes = [];
                //Game.lvl.objFriendly.forEach(function(friendly){
                //    var distance = this.position.clone().sub(friendly.position).getLength();
                //    if (distance > 64*2 && distance < 64*this.bulletRange && friendly.hitPoints > 0)
                //        friendlyes.push(friendly);
                //}.bind(this));
                Game.lvl.objBuildings.forEach(function(friendly){
                    var distance = this.position.clone().sub(friendly.position).getLength();
                    if (distance > 64*2 && distance < 64*8 && friendly != Game.lvl.townHall)
                        friendlyes.push(friendly);
                }.bind(this));
                if (friendlyes.length > 0){
                    Game.lvl.audioPool.get('OgreBossRoar02', 'OgreBossRoar02', 0.5, 1).play();
                    var damaged = [];
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['cast2'], this.animation);
                    this.animation.loop = 0;
                    this.timeOut = Game.animations[this.animations['cast2']].playTime + Game.animations[this.animations['fight'][0]].playTime;

                    target = friendlyes[myPofigRandom(0, friendlyes.length)];
                    this.animation.setDirection(target.position.clone().sub(this.position).getDirection());

                    var pos = target.position.clone();
                    if (target.hitPosition)
                        pos.add(target.hitPosition);

                    Game.lvl.objEffect.push(new MarkerEffect(pos));
                    setTimeout(function(){
                        if (this.hitPoints <= 0)
                            return;
                        this.animation = Game.lvl.pool.switchAnimation(this.animations['fight'][0], this.animation);
                        this.animation.play();
                        setTimeout(function() {
                            if (this.hitPoints <= 0)
                                return;
                            var bulletEffect = new Bullet(this.position.clone().add(this.hitPosition), target.position.clone().add(new Vec2(-32 + myPofigRandom(0, 64), -32 + myPofigRandom(0, 32))), 1400, function () {
                                Game.lvl.objEffect.push(new BoomFx(this.targPosition, 1));
                                for (var x = this.targPosition.x - Game.tileWidth; x < this.targPosition.x + Game.tileWidth * 2; x += Game.tileWidth) {
                                    for (var y = this.targPosition.y - Game.tileHeight; y < this.targPosition.y + Game.tileHeight * 2; y += Game.tileHeight) {
                                        var tile = Game.lvl.objMap.getTile(new Vec2(x, y));
                                        if (tile) {
                                            var flag = Game.lvl.flags.filter(function(flag){return flag.tile == tile;}).pop();
                                            if (flag) {
                                                flag.disabled = 50*20*20;
                                                Game.lvl.objEffect.push(new EffectParticles(tile.position, 'flagfire', 50*20*20));
                                            }

                                            for (var building in tile.objects) {
                                                if (damaged.indexOf(tile.objects[building]) == -1) {
                                                    damaged.push(tile.objects[building]);
                                                    tile.objects[building].applyDamage(this.damage);
                                                }
                                            }
                                            for (var friendlyy in tile.wObjects) {
                                                tile.wObjects[friendlyy].applyDamage(this.damage);
                                            }
                                        }
                                    }
                                }
                                Game.lvl.objEffect.push(new BulletLoonka(this.targPosition));
                            });
                            bulletEffect.damage = this.base.bulletDamage;
                            Game.lvl.objEffect.push(bulletEffect);
                        }.bind(this), 400);
                    }.bind(this), 2000);
                    return;
                }
            }
            this.scanEnemyAround();
            if (this.target) {
                this.fight = true;
                this.soundCC.play();
                this.animation = Game.lvl.pool.switchAnimation(this.animations['fight'][this.fightAnim], this.animation);
                this.timeOut = this.base.timeOut;
                this.target.applyDamage(this.damage, this);
                this.animation.setDirection(this.target.position.clone().sub(this.position).getDirection());
            } else {
                this.fight = false;
                this.animation = Game.lvl.pool.switchAnimation(this.animations['run'], this.animation);
                if (this.path.length > 0) {
                    if (this.currectTarget.hitPoints > 0) {
                        this.move();
                    } else {
                        this.path = [];
                    }
                } else {
                    this.timeOut = 100;
                    this.searchPath();
                }
            }
        },
        init: function() {
            this.music = new MyAudio('desertboss', true, 0.4);
            this.music.play();

            Game.lvl.audioPool.get('OgreBossRoar01', 'OgreBossRoar01', 0.3, 1).play();
            this.bulletTimeout = this.base.bulletCd;
            this.bulletRange = this.base.bulletRange;
            this.fight = false;

            var tiles = [new Vec2(96,352),new Vec2(328,570),new Vec2(264,634), new Vec2(200,698),new Vec2(136,826), new Vec2(136,954), new Vec2(200, 1082), new Vec2(288, 1120),  new Vec2(350,972), new Vec2(360, 882), new Vec2(430, 802), new Vec2(558,738), new Vec2(654,772), new Vec2(736,800), new Vec2(800,800), new Vec2(864,864), new Vec2(928,928), new Vec2(1056,928), new Vec2(1120,928), new Vec2(1184,928),new Vec2(1312,928), new Vec2(1440,992), new Vec2(1440,992), new Vec2(1376,1056), new Vec2(1312,1056), new Vec2(1248,1056), new Vec2(1184,1056), new Vec2(1056,1056), new Vec2(928,1120), new Vec2(736,1184), new Vec2(800,1248), new Vec2(928,1312), new Vec2(1696,1156), new Vec2(1760,1056), new Vec2(1824,992), new Vec2(1824,864), new Vec2(1824,800), new Vec2(1824,480), new Vec2(1824,416), new Vec2(1760,352), new Vec2(1632,416), new Vec2(1632,480), new Vec2(1504,480), new Vec2(1568,608), new Vec2(1504,672), new Vec2(1376,672), new Vec2(1312,672), new Vec2(1248,544), new Vec2(1184,480), new Vec2(928,480), new Vec2(864,480), new Vec2(800,416), new Vec2(1056,224), new Vec2(1056,160), new Vec2(1056,96)];
            this.path = [];
            this.directionDirect = true;
            tiles.forEach(function(position){
                this.path.push(Game.lvl.objMap.getTile(position));
            }.bind(this));
            this.animation.onComplete = function () {
                if (this.animation.name == this.animations.fight[this.fightAnim] && this.fight) {
                    var newFightAnim = myPofigRandom(0, this.animations['fight'].length);
                    if (this.fightAnim != newFightAnim) {
                        this.fightAnim = newFightAnim;
                        this.nextAnimation = this.animations.fight[this.fightAnim];
                    }
                }
            }.bind(this);
            this.hitPointsMultiply = 3;
            this.hitPointsEffect = new hitPointsEffect(this, true);
            //var a = [new Vec2(1056,160), new Vec2(1632,480) , new Vec2(1696,1184) , new Vec2(928,928) , new Vec2(288, 1120)];
            //a.forEach(function(tile){new blackSquare(tile);});
            this.animation.setDirection(-1);
            this.checkMove = function (){
                var newTile = Game.lvl.objMap.getTile(this.position);
                if (newTile!= this.tile) {
                    if ((newTile.objects.length > 0)&&(!this.flying)&&((this.directionDirect)||(newTile.objects[0]==this.currectTarget))){
                        this.target = newTile.objects[0];
                        this.animation = Game.lvl.pool.switchAnimation(this.animations['fight'][this.fightAnim], this.animation);
                        return false;
                    }
                    if (this.tile)
                        this.tile.eObjects.splice(this.tile.eObjects.indexOf(this), 1);
                    this.tile = newTile;
                    this.tile.eObjects.push(this);

                    if (newTile.position.clone().sub(new Vec2(1056,160)).getLength() < 10) {
                        this.animation = Game.lvl.pool.switchAnimation(this.animations['cast'], this.animation);
                        this.animation.loop = false;
                        this.timeOut = 3000;
                        setTimeout(function(){
                            this.summon('');
                        }.bind(this), 1000);
                    }
                    if (newTile.position.clone().sub(new Vec2(1632,480)).getLength() < 10){
                        this.animation = Game.lvl.pool.switchAnimation(this.animations['cast'], this.animation);
                        this.animation.loop = false;
                        this.timeOut = 3000;
                        setTimeout(function(){
                            this.summon('2');
                        }.bind(this), 1000);
                    }
                    if (newTile.position.clone().sub(new Vec2(1696,1184)).getLength() < 10){
                        this.animation = Game.lvl.pool.switchAnimation(this.animations['cast'], this.animation);
                        this.animation.loop = false;
                        this.timeOut = 3000;
                        setTimeout(function(){
                            this.summon('3');
                        }.bind(this), 1000);
                    }
                    if (newTile.position.clone().sub(new Vec2(928,928)).getLength() < 10){
                        this.animation = Game.lvl.pool.switchAnimation(this.animations['cast'], this.animation);
                        this.animation.loop = false;
                        this.timeOut = 3000;
                        setTimeout(function(){
                            this.summon('4');
                        }.bind(this), 1000);
                    }
                    if (newTile.position.clone().sub(new Vec2(288, 1120)).getLength() < 10){
                        this.animation = Game.lvl.pool.switchAnimation(this.animations['cast'], this.animation);
                        this.animation.loop = false;
                        this.timeOut = 3000;
                        setTimeout(function(){
                            this.summon('5');
                        }.bind(this), 1000);
                    }
                }
                return true;
            };

            this.summon = function(numb){
                Game.lvl.audioPool.get('OgreBossRoar02', 'OgreBossRoar02', 0.3, 1).play();
                var i = 0, rndX, rndY;
                for (i =0; i < this.base['summonOgres'+numb]; i++){
                    rndX = myPofigRandom(-192, +192); rndY = myPofigRandom(-192, +192);
                    Game.lvl.objEffect.push(new Effect(this.position.clone().add(new Vec2(rndX, rndY)), new Vec2(0,0), Game.lvl.objEffect, Game.animations.Orc_Summon_A, Game.animations.Orc_Summon_A.playTime, 1));
                    Game.lvl.objEnemy.push(new Enemy(Game.enemyList.ogre, this.position.x + rndX, this.position.y + rndY, 'TownHall', 1));
                }
                for (i =0; i < this.base['summonWarriors'+numb]; i++){
                    rndX = myPofigRandom(-192, +192); rndY = myPofigRandom(-192, +192);Game.lvl.objEffect.push(new Effect(this.position.clone().add(new Vec2(rndX, rndY)), new Vec2(0,0), Game.lvl.objEffect, Game.animations.Orc_Summon_A, Game.animations.Orc_Summon_A.playTime, 1));

                    Game.lvl.objEnemy.push(new Enemy(Game.enemyList.orcWarrior, this.position.x + rndX, this.position.y + rndY, 'TownHall', 1));
                }
                for (i =0; i < this.base['summonShamans'+numb]; i++){
                    rndX = myPofigRandom(-192, +192); rndY = myPofigRandom(-192, +192);
                    Game.lvl.objEffect.push(new Effect(this.position.clone().add(new Vec2(rndX, rndY)), new Vec2(0,0), Game.lvl.objEffect, Game.animations.Orc_Summon_A, Game.animations.Orc_Summon_A.playTime, 1));
                    Game.lvl.objEnemy.push(new Enemy(Game.enemyList.goblinShaman, this.position.x + rndX, this.position.y + rndY, 'TownHall', 1));
                }
                for (i =0; i < this.base['summonRiders'+numb]; i++){
                    rndX = myPofigRandom(-192, +192); rndY = myPofigRandom(-192, +192);
                    Game.lvl.objEffect.push(new Effect(this.position.clone().add(new Vec2(rndX, rndY)), new Vec2(0,0), Game.lvl.objEffect, Game.animations.Orc_Summon_A, Game.animations.Orc_Summon_A.playTime, 1));
                    Game.lvl.objEnemy.push(new Enemy(Game.enemyList.goblinRider, this.position.x + rndX, this.position.y + rndY, 'TownHall', 1));
                }
                for (i =0; i < this.base['summonGoblins'+numb]; i++){
                    rndX = myPofigRandom(-192, +192); rndY = myPofigRandom(-192, +192);
                    Game.lvl.objEffect.push(new Effect(this.position.clone().add(new Vec2(rndX, rndY)), new Vec2(0,0), Game.lvl.objEffect, Game.animations.Orc_Summon_A, Game.animations.Orc_Summon_A.playTime, 1));
                    Game.lvl.objEnemy.push(new Enemy(Game.enemyList.goblin, this.position.x + rndX, this.position.y + rndY, 'TownHall', 1));
                }
            }
        }
    };

    Game.enemyList.goblinRider = {
        cost:10,
        icon: 'goblinRiderRun0',
        n:'goblinRider',
        e:'desert',
        hitPoints: 10,
        damage: 1,
        timeOut: 500,
        speed: 8,
        lifeCost: 1,
        hitPosition: new Vec2(0,-40),
        hitRange: 10,
        attackRange: Game.tileWidth,
        animations:{fight:['goblinRiderFight1'], die:'goblinRiderDie', run:'goblinRiderRun'},
        type: "enemy",
        soundDeathGroup:'enemyOrcDeath',
        soundDeath:'Orc Enemy Death',
        soundDeathVolume:0.3,
        soundDeathLimit:2,
        scaleHint: 1.5,
        subtype:'goblins'
    };

    Game.enemyList.ogre = {
        cost:10,
        icon: 'ogreRun0',
        n:'ogre',
        e:'desert',
        hitPoints: 50,
        damage: 5,
        timeOut: 500,
        speed: 2,
        lifeCost: 3,
        hitPosition: new Vec2(0,-60),
        hitRange: 32,
        attackRange: Game.tileWidth,
        animations:{fight:['ogreFight1'], die:'ogreDie', run:'ogreRun'},
        type: "enemy",
        soundDeathGroup:'enemyOgrDeath',
        soundDeath:'OgreDeath',
        soundDeathVolume:0.3,
        soundDeathLimit:2,
        soundCCGroup:'OgreAttac',
        soundCC:['OgreAttack01', 'OgreAttack02'],
        soundCCVolume:0.3,
        soundCCLimit:3
    };

    Game.enemyList.goblinShaman = {
        cost:10,
        icon: 'goblinShamanRun0',
        n:'goblinShaman',
        e:'desert',
        timeOut: 500,
        hitPoints: 10,
        attackRange:4*Game.tileWidth,
        healAmount: 5,
        healTimeOut: 10000,
        damage: 3.0,
        speed: 7,
        lifeCost: 1,
        hitPosition: new Vec2(0,-40),
        hitRange: 10,
        meteoriteDamage: 5000,
        meteoriteTimeOut: 10000,
        meteoriteRange:1500,
        animations:{fight:['goblinShamanFight2'], heal:['goblinShamanFight1'], die:'goblinShamanDie', run:'goblinShamanRun'},
        type: "enemy",
        soundDeathGroup:'enemyGoblinDeath',
        soundDeath:['Goblin Death 1', 'Goblin Death 2'],
        soundDeathVolume:0.3,
        soundDeathLimit:2,
        scaleHint: 2,
        subtype:'goblins',
        strategy: function(){
            var direction, len, target;
            this.timeOut -= Game.cycleTickTime*Game.speed;
            this.healTimeOut -= Game.cycleTickTime*Game.speed;
            this.scanTimeOut -= Game.cycleTickTime*Game.speed;
            this.meteoriteTimeOut -= Game.cycleTickTime*Game.speed;

            if (this.timeOut > 0 && this.healTimeOut > 0)
                return;

            this.scanEnemyAround();
            if (this.healTimeOut <= 0) {
                this.healTimeOut = this.base.healTimeOut;
                var toHeal = [];
                Game.lvl.objEnemy.forEach(function(enemy){
                    if (enemy.hitPoints < enemy.base.hitPoints && enemy.position.clone().sub(this.position).getLength() < this.attackRange * 1.5)
                        toHeal.push(enemy);
                }.bind(this));
                if (toHeal.length > 0){
                    this.healSound.play();
                    toHeal.forEach(function(enemy) {
                        Buf.prototype.addBuf(enemy, 'heal', 'hitPoints', this.base.healAmount, 'heal', 1000, null, Game.lvl.effectContainer, 'heal', null);
                    }.bind(this));
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['heal'], this.animation);
                    this.animation.loop = false;
                    this.animation._currentTime = 0;
                    this.timeOut = this.base.timeOut;
                    return;
                }
            }

            if (this.meteoriteTimeOut <= 0) {
                this.scanTimeOut = 0;
                this.meteoriteTimeOut = this.base.meteoriteTimeOut;
                this.scanEnemyAroundMeteorite();

                if (this.target) {
                    this.timeOut = this.base.timeOut * 3;
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['heal'], this.animation);
                    this.animation.loop = false;

                    Game.lvl.objEffect.push(new Meteoritte(this.target.position, this.base.meteoriteDamage));
                    return;
                }
            }

            if (this.target) {
                direction = this.target.position.clone().sub(this.position);
                this.animation.setDirection(direction.getDirection());
                this.timeOut = this.base.timeOut;
                this.animation = Game.lvl.pool.switchAnimation(this.animations['fight'][this.fightAnim], this.animation);
                direction.sub(direction.clone().normalize().multiply(32));
                Game.lvl.objEffect.push(new Arrow(this.position.clone().add(new Vec2(0, -64)), this.target, Game.animations['fireBall'], 1.25,  direction.getLength()*1.5, true,
                    function(){
                        Game.lvl.objEffect.push(new Effect(this.position.clone(), this.direction.normalize(), Game.lvl.objEffect, Game.animations.fireHit, 400, 2));
                    }));
                this.target.applyDamage(this.damage, this);
            } else {
                if (this.path.length > 0) {
                    if (this.currectTarget && this.currectTarget.hitPoints > 0){
                        this.move();
                    } else {
                        this.path = [];
                    }
                } else {
                    this.searchPath();
                }
            }
        },
        init: function(){
            this.healSound = Game.lvl.audioPool.get('EnemyHeal', 'EnemyHeal', 0.3, 2);
            this.meteoriteTimeOut = this.base.meteoriteTimeOut;
            this.healTimeOut = this.base.healTimeOut;
            this.scanEnemyAroundMeteorite = function() {
                this.attackRangeTemp = this.attackRange;
                this.attackRange = this.base.meteoriteRange;
                Enemy.prototype.scanEnemyAroundArcher.call(this);
                this.attackRange = this.attackRangeTemp;
            };
        }
    };

    Game.enemyList.bug = {
        cost:10,
        icon: 'VBugRun0',
        n:'bug',
        e:'forest',
        hitPoints: 50,
        damage: 5,
        timeOut: 500,
        speed: 3,
        lifeCost: 1,
        hitPosition: new Vec2(0,-20),
        hitRange: 30,
        attackRange: Game.tileWidth,
        animations:{fight:['GBugAttack'], die:'GBugDeath', run:'GBugRun'},
        type: "enemy",
        soundDeathGroup:'enemyHornetDeath',
        soundDeath:'Bugs_And_Flyes_Death',
        soundDeathVolume:0.3,
        soundDeathLimit:3,
        scaleHint: 2,
        init:function(){
            var color;
            switch(myPofigRandom(0,4)){
                case 0:
                    color = 'G';
                    break;
                case 1:
                    color = 'R';
                    break;
                case 2:
                    color = 'V';
                    break;
                case 3:
                    color = 'B';
                    break;
            };
            this.animations ={fight:[color+'BugAttack'], die:color+'BugDeath', run:color+'BugRun'}
        }
    };


    Game.enemyList.hornet = {
        cost:10,
        icon: 'HornetRun0',
        n:'hornet',
        e:'forest',
        flying: true,
        hitPoints: 50,
        damage: 5,
        timeOut: 500,
        speed: 3,
        lifeCost: 1,
        hitPosition: new Vec2(0,-100),
        hitRange: 30,
        attackRange: Game.tileWidth,
        animations:{fight:['HornetRun'], die:'HornetDeath', run:'HornetRun'},
        type: "enemy",
        soundDeathGroup:'enemyHornetDeath',
        soundDeath:'Bugs_And_Flyes_Death',
        soundDeathVolume:0.3,
        soundDeathLimit:3,
        scaleHint: 2
    };

    Game.enemyList.stump = {
        cost:10,
        icon: 'StumpWalk0',
        n:'stump',
        e:'forest',
        hitPoints: 50,
        damage: 5,
        timeOut: 500,
        speed: 3,
        lifeCost: 1,
        hitPosition: new Vec2(0,-64),
        hitRange: 30,
        attackRange: Game.tileWidth,
        animations:{fight:['StumpAttack'], die:'StumpDeath', run:'StumpWalk'},
        type: "enemy",
        soundDeathGroup:'enemyStumpDeath',
        soundDeath:'StumpDeath',
        soundDeathVolume:0.3,
        soundDeathLimit:2,
        scaleHint: 2,
        onDeath: function(){
            for (var i = 0; i < 3; i++) {
                (function() {
                    var pos = new Vec2(this.position.x + myRandom(-96, 96), this.position.y + myRandom(-96, 96));
                    Game.lvl.objEffect.push(new Timer(Game.animations['StumpDeath'].playTime-150, function () {
                        Game.lvl.objEffect.push(new EffectSmall(pos.clone(), Game.lvl.effectContainer, Game.animations['Stump_Summon_A'], Game.animations['Stump_Summon_A'].playTime, false, function () {
                        }));
                        var hornet = new Enemy(Game.enemyList.hornet, pos.x, pos.y, 'TownHall', 1);
                        hornet.path = this.path.slice(0);
                        Game.lvl.objEnemy.push(hornet);
                    }.bind(this)));
                }.bind(this))();
            }
        }
    };

    Game.enemyList.elfWarrior = {
        cost:10,
        icon: 'elfWarriorRun0',
        n:'elfWarrior',
        e:'forest',
        hitPoints: 20,
        damage: 3,
        timeOut: 500,
        speed: 6,
        lifeCost: 1,
        hitPosition: new Vec2(0,-64),
        hitRange: 10,
        attackRange: Game.tileWidth,
        animations:{fight:['elfWarriorFight1'], die:'elfWarriorDie', run:'elfWarriorRun'},
        type: "enemy",
        soundDeathGroup:'enemyHumanDeath',
        soundDeath:['HumanDeath01','HumanDeath02', 'HumanDeath03', 'HumanDeath04'],
        soundDeathVolume:0.3,
        soundDeathLimit:4,
        scaleHint: 2
    };

    Game.enemyList.elfRanger = {
        cost:10,
        icon: 'elfRangerRun0',
        n:'elfRanger',
        e:'forest',
        timeOut: 500,
        hitPoints: 10,
        attackRange:4*Game.tileWidth,
        healAmount: 5.0,
        damage: 3.0,
        speed: 7,
        lifeCost: 1,
        hitPosition: new Vec2(0,-64),
        hitRange: 10,
        animations:{arrow:'elfRangerFight1', fight:['elfRangerMele1'], die:'elfRangerDie', run:'elfRangerRun'},
        type: "enemy",
        soundDeathGroup:'enemyHumanDeath',
        soundDeath:['HumanDeath01','HumanDeath02', 'HumanDeath03', 'HumanDeath04'],
        soundDeathVolume:0.3,
        soundDeathLimit:4,
        soundShootGroup:'ArrowTower',
        soundShoot:'ArrowTower',
        soundShootVolume:0.2,
        soundShootLimit:4,
        scaleHint: 2,
        strategy: function(){
            var direction;
            this.timeOut -= Game.cycleTickTime*Game.speed;

            if (this.shadowTimeout > 0)
                this.shadowTimeout -= Game.cycleTickTime*Game.speed;

            if (this.timeOut > 0)
                return;

            this.scanEnemyAround();

            if (this.target && this.invulnerable <=0) {
                direction = this.target.position.clone().sub(this.position);
                this.animation.setDirection(direction.getDirection());
                this.timeOut = this.base.timeOut;
                if (direction.getLength() > 96) {
                    this.soundShoot && this.soundShoot.play();
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['arrow'], this.animation);
                    this.animation.loop = false;
                    this.animation.play();
                    this.animation._currentTime = 0;
                    direction.sub(direction.clone().normalize().multiply(32));
                    Game.lvl.objEffect.push(new Arrow(this.position.clone().add(new Vec2(0, -64)), this.target, Game.sprites.arrow, 1.25, direction.getLength() * 1.5, false, null));
                } else {
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['fight'][this.fightAnim], this.animation);
                }
                this.target.applyDamage(this.damage, this);

            } else {
                if (this.path.length > 0)
                    this.move();
            }
        },
        init: function(){
            this.shadowTimeout = 0;
            this.scanEnemyAround = this.scanEnemyAroundArcher;
            this.move = function() {
                var direction, len, target, key;
                var gameSpeed = Game.speed;
                while (--gameSpeed >= 0) {
                    while ((this.path.length > 0) && ((direction = this.path[this.path.length - 1].position.clone().sub(this.position).add(this.tileRandomizer)).getLength() <= this.speed * 2)) {
                        this.path.pop();
                        this.animation.direction = direction.getDirection();
                    }
                    if (this.path.length > 0) {
                        this.position.add(direction.normalize().multiply(this.speed * (this.invulnerable > 0 ? 2 : 1)));
                        this.animation.setDirection(direction.getDirection());
                        this.animation = Game.lvl.pool.switchAnimation(this.animations['run'], this.animation);

                        if (this.invulnerable > 0)
                            this.animation.alpha = 0.2;
                        else
                            this.animation.alpha = 1;

                        if (!this.checkMove())
                            break;
                    } else {
                        if (Game.lvl.townHall.hitPoints > 0) {
                            Game.lvl.townHall.applyDamage(this.damage, this);
                            break;
                        }
                    }
                }
            };

            this.applyDamage = function(damage, source) {
                if (this.shadowTimeout <=0 && this.target == null) {
                    this.shadowTimeout = this.base.shadowTimeout;
                    this.invulnerable = this.base.invulnerable;
                }
                Enemy.prototype.applyDamage.call(this, damage, source);
            }
        }
    };

    Game.enemyList.elfDruid = {
        cost:10,
        icon: 'elfDruidRun0',
        n:'elfDruid',
        e:'forest',
        timeOut: 500,
        hitPoints: 10,
        attackRange:4*Game.tileWidth,
        healAmount: 5.0,
        damage: 3.0,
        speed: 7,
        lifeCost: 1,
        hitPosition: new Vec2(0,-40),
        hitRange: 10,
        animations:{cast:'elfDruidFight1', fight:['elfDruidMele1'], die:'elfDruidDie', run:'elfDruidRun', heal:'elfDruidHeal', aoe:'elfDruidAoe'},
        type: "enemy",
        soundDeathGroup:'enemyHumanDeath',
        soundDeath:['HumanDeath01','HumanDeath02', 'HumanDeath03', 'HumanDeath04'],
        soundDeathVolume:0.3,
        soundDeathLimit:4,
        soundShootGroup:'DruidArrow',
        soundShoot:['Enemy_Magic_Attack_01', 'Enemy_Magic_Attack_02'],
        soundShootVolume:0.3,
        soundShootLimit:3,
        scaleHint: 2,
        strategy: function() {
            var direction, len, target;
            this.timeOut -= Game.cycleTickTime*Game.speed;
            this.healTimeOut -= Game.cycleTickTime*Game.speed;
            this.scanTimeOut -= Game.cycleTickTime*Game.speed;

            if (this.healTimeOut <= 0) {
                this.healTimeOut = this.base.healTimeOut;
                var toHeal = null;
                Game.lvl.objEnemy.forEach(function(enemy){
                    if (enemy.hitPoints < enemy.base.hitPoints && enemy.position.clone().sub(this.position).getLength() < this.attackRange * 1.5 && (!toHeal || (toHeal.base.hitPoints - toHeal.hitPoints < enemy.base.hitPoints - enemy.hitPoints)))
                        toHeal = enemy;
                }.bind(this));
                if (toHeal) {
                    this.healSound.play();
                    Buf.prototype.addBuf(toHeal, 'heal', 'hitPoints', this.base.healAmount, 'heal', 1000, null, Game.lvl.effectContainer, 'heal', null);
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['heal'], this.animation);
                    this.animation.loop = false;
                    this.animation._currentTime = 0;
                    this.timeOut = this.base.timeOut*3;
                    return;
                }
            }
            if (this.timeOut > 0)
                return;

            this.scanEnemyAround();

            if (this.target) {
                direction = this.target.position.clone().sub(this.position);
                this.animation.setDirection(direction.getDirection());
                this.timeOut = this.base.timeOut;
                if (direction.getLength() < 64) {
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['fight'][this.fightAnim], this.animation);
                    this.target.applyDamage(this.damage, this);
                } else {
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['cast'], this.animation);
                    direction.sub(direction.clone().normalize().multiply(32));
                    this.soundShoot && this.soundShoot.play();
                    Game.lvl.objEffect.push(new Arrow(this.position.clone().add(new Vec2(0, -64)), this.target, Game.animations['DruidBolt'], 1.25,  direction.getLength()*3, true,
                        function(){
                            Game.lvl.objEffect.push(new Effect(this.position.clone(), this.direction.normalize(), Game.lvl.objEffect, Game.animations['DruidBoltHit'], Game.animations['DruidBoltHit'].playTime, 1));
                        }));
                    this.target.applyDamage(this.damage, this);
                }
            } else {
                if (this.path.length > 0) {
                    if (this.currectTarget && this.currectTarget.hitPoints > 0){
                        this.move();
                    } else {
                        this.path = [];
                    }
                } else {
                    this.searchPath();
                }
            }
        },
        init: function(){
            this.healSound = Game.lvl.audioPool.get('EnemyHeal', 'EnemyHeal', 0.3, 2);
            this.healTimeOut = this.base.healTimeOut;
            this.scanEnemyAround = this.scanEnemyAroundArcher;
        }
    };

    Game.enemyList.ent = {
        cost:10,
        icon: 'entRun0',
        n:'ent',
        e:'forest',
        hitPoints: 50,
        damage: 5,
        timeOut: 500,
        speed: 3,
        lifeCost: 3,
        hitPosition: new Vec2(0,-100),
        hitRange: 30,
        attackRange: Game.tileWidth,
        animations:{fight:['entFight1'], die:'entDie', run:'entRun'},
        type: "enemy",
        soundDeathGroup:'enemyEntDeath',
        soundDeath:'Ent_Death',
        soundDeathVolume:0.3,
        soundDeathLimit:2,
        soundCCGroup:'EntAttac',
        soundCC:['Ent_Attack_01', 'Ent_Attack_02'],
        soundCCVolume:0.3,
        soundCCLimit:3,
        onDeath: function () {
            if (Game.lvl.objBuildings.length > 1) {
                var tower = Game.lvl.objBuildings[myRandom(1, Game.lvl.objBuildings.length)];
                if (tower) {
                    tower.disabled = this.base.rootsTime;
                    Game.lvl.objEffect.push(new RootsEffect(tower.position, this.base.rootsTime-3000));
                }
            }
        }
    };

    Game.enemyList.griffon = {
        cost:10,
        icon: 'griffon',
        n:'griffon',
        e:'forest',
        hitPoints: 50,
        damage: 5,
        timeOut: 500,
        speed: 3,
        lifeCost: 3,
        hitPosition: new Vec2(0,-100),
        hitRange: 30,
        attackRange: Game.tileWidth,
        animations:{fight:['GriffonA1'], die:'GriffonDeath', run:'GriffonRun'},
        type: "enemy",
        soundDeathGroup:'enemyGriffonDeath',
        soundDeath:'GriffonDeath',
        soundDeathVolume:0.3,
        soundDeathLimit:2,
        soundCCGroup:'GriffonAttact',
        soundCC:['GriffonAttack01', 'GriffonAttack02'],
        soundCCVolume:0.3,
        soundCCLimit:3,
        scaleHint: 1.5,
        init: function() {
            this.applyDamage = function(damage, source) {
                Enemy.prototype.applyDamage.call(this, damage, source);
                if (this.hitPoints > 0 && this.hitPoints <= this.base.hitPoints * parseFloat(this.base.flyOn) && !this.flying){
                    this.flying = true;
                    this.target = null;
                    this.strategy = Enemy.prototype.flyingStrategy;
                    //this.path = Game.lvl.objMap.getPathForFlying(this.position, Game.lvl.townHall.position.clone().add(Game.lvl.townHall.hitPosition), this);
                    this.directionDirect = true;
                    this.timeOut = Game.animations['GriffonToAir'].playTime;
                    this.invulnerable = Game.animations['GriffonToAir'].playTime * 2;
                    this.animation = Game.lvl.pool.switchAnimation('GriffonToAir', this.animation);
                    this.animation._currentTime = 0;
                    this.animation.play();
                    this.animation.loop = false;
                    this.fightAnim = 0;
                    this.speed = this.speed + this.speed*0.2;
                    this.animations = {fight:['GriffonFly','GriffonFly','GriffonFly'], die:'GriffonDeath', run:'GriffonFly'};
                }
            }
        }
    };

    Game.enemyList.smallDragon = {
        cost:10,
        icon: 'smallDragonWalk0',
        n:'smallDragon',
        e:'forest',
        hitPoints: 50,
        damage: 5,
        timeOut: 500,
        speed: 7,
        lifeCost: 3,
        hitPosition: new Vec2(0,-40),
        hitRange: 32,
        fireBallTimeout: 15000,
        fireBallRange: 1,
        fireBallDamage: 1,
        attackRange: Game.tileWidth,
        animations:{fight:['smallDragonAttack'], die:'smallDragonDie', run:'smallDragonWalk', fireBall:'smallDragonFireBall'},
        type: "enemy",
        soundDeathGroup:'enemySmallDragonDeath',
        soundDeath:['SmallDragonDeath01', 'SmallDragonDeath02'],
        soundDeathVolume:0.3,
        soundDeathLimit:2,
        scaleHint: 1.2,
        subtype:'dragons',
        init: function(){
            this.fireBallSound = Game.lvl.audioPool.get('smalldragonfireball', 'SmallDragonFireball', 0.3, 2);
            this.animation = Game.lvl.pool.switchAnimation(this.animations['run'], this.animation);
            this.fireBallTimeout = this.base.fireBallTimeout;
            this.checkFireBall = function (){
                this.fireBallTimeout = this.base.fireBallTimeout;
                if (Game.lvl.objFriendly.length === 0)
                    return false;
                var fireBallTarget;
                for (var key in Game.lvl.objFriendly)
                {
                    if (Game.lvl.objFriendly[key].hitPoints > 0 && Game.lvl.objFriendly[key].position.clone().sub(this.position).getLength() < parseInt(this.base.fireBallRange)){
                        fireBallTarget = Game.lvl.objFriendly[key];
                        break;
                    }
                }
                if (fireBallTarget) {
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['fireBall'], this.animation);
                    this.timeOut = Game.animations[this.animations['fireBall']].playTime;
                    var direction =  fireBallTarget.position.clone().sub(this.position);
                    this.animation.setDirection(direction.getDirection());
                    this.fireBallSound.play();
                    Game.lvl.objEffect.push(new Arrow(this.position.clone().add(new Vec2(65*this.animation.direction, -26)), fireBallTarget, Game.animations['SDragonFireball'], 1,  direction.getLength()*2, true,
                        function(){
                            this.target.applyDamage(Game.enemyList.smallDragon.fireBallDamage, {source:{damageType:'magic', penetration:1}});
                            Game.lvl.objEffect.push(new Effect(this.target.position.clone(), this.direction.normalize(), Game.lvl.objEffect, Game.animations['fireHit'], 400, 2));
                        }, 400));
                    return true;
                }
                return false;
            };

            this.strategy = function() {
                this.timeOut -= Game.cycleTickTime*Game.speed;
                this.scanTimeOut -= Game.cycleTickTime*Game.speed;
                this.fireBallTimeout -= Game.cycleTickTime*Game.speed;

                if (this.timeOut > 0)
                    return;

                if (this.fireBallTimeout <=0)
                    if (this.checkFireBall())
                        return;

                this.scanEnemyAround();

                if (this.target){
                    this.timeOut = this.base.timeOut;
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['fight'][0], this.animation);
                    this.animation.setDirection(this.target.position.clone().sub(this.position).getDirection());
                    this.target.applyDamage(this.damage, this);
                } else {
                    if (this.path.length > 0)
                        this.move();
                }
            };
        }
    };

    Game.enemyList.elfArchDruid = {
        cost:10,
        icon: 'elfDruidRun0',
        n:'elfArchDruid',
        e:'forest',
        timeOut: 1500,
        hitPoints: 10,
        attackRange:4*Game.tileWidth,
        healAmount: 5.0,
        damage: 3.0,
        speed: 7,
        lifeCost: 1,
        hitPosition: new Vec2(0,-40),
        hitRange: 10,
        animations:{cast:'ArchDruidSummon', fight:['ArchDruidMele01'], die:'ArchDruidDeath', run:'ArchDruidWalk', shot:'ArchDruidShoot'},
        type: "enemy",
        soundDeathGroup:'enemyHumanDeath',
        soundDeath:['HumanDeath01','HumanDeath02', 'HumanDeath03', 'HumanDeath04'],
        soundDeathVolume:0.3,
        soundDeathLimit:4,
        soundShootGroup:'DruidArrow',
        soundShoot:['Enemy_Magic_Attack_01', 'Enemy_Magic_Attack_02'],
        soundShootVolume:0.3,
        soundShootLimit:3,
        scaleHint: 2,
        onDeath: function() {
            if (--Game.lvl.shamans == 0) {
                Game.lvl.objEnemy.push(new Enemy(Game.enemyList.dragonBoss, 2328, 768, 'townHall', 1));
            }
        },
        strategy: function(){
            var direction, len, target;
            this.timeOut -= Game.cycleTickTime*Game.speed;
            this.scanTimeOut -= Game.cycleTickTime*Game.speed;

            if (this.summonTimeOut <= 0) {
                this.animation = Game.lvl.pool.switchAnimation(this.animations['cast'], this.animation);
                this.animation._currentTime = 0;
                this.timeOut = Game.animations[this.animations['cast']].playTime*2;
                this.summonTimeOut = this.base.summonTimeOut;
                var hp = this.base.summonHp;
                this.animation.onComplete = function() {
                    if (this.hitPoints > 0) {
                        var rndX, rndY, enemyType, ent;
                        enemyType = null;
                        switch (myRandom(0,9)) {
                            case 0:
                                enemyType = Game.enemyList.elfWarrior;
                                break;
                            case 1:
                                if (!ent){
                                    ent = true;
                                    enemyType = Game.enemyList.ent;
                                }
                                break;
                            case 2:
                                enemyType = Game.enemyList.smallDragon;
                                break;
                            case 3:
                                enemyType = Game.enemyList.griffon;
                                break;
                            case 4:
                                enemyType = Game.enemyList.elfRanger;
                                break;
                            case 5:
                                enemyType = Game.enemyList.elfDruid;
                                break;
                            case 6:
                                enemyType = Game.enemyList.bug;
                                break;
                            case 7:
                                enemyType = Game.enemyList.stump;
                                break;
                            case 8:
                                enemyType = Game.enemyList.hornet;
                                break;
                        }
                        if (enemyType) {
                            hp -= enemyType.hitPoints;
                            var tile = Game.lvl.objMap.getClosesEmptyTile(new Vec2(this.position.x + myPofigRandom(-128, +128), this.position.y - myPofigRandom(-128, + 128)));
                            Game.lvl.objEffect.push(new Effect(tile.position, new Vec2(0, 0), Game.lvl.objEffect, Game.animations.Orc_Summon_A, Game.animations.Orc_Summon_A.playTime, 1));
                            var enemy = new Enemy(enemyType, tile.position.x, tile.position.y, 'TownHall', 1);
                            Game.lvl.objEnemy.push(enemy);
                        }

                        if (hp < 0) {
                            this.timeOut = 0;
                            this.animation.onComplete = null;
                        } else {
                            this.timeOut = Game.animations[this.animations['cast']].playTime*2;
                        }
                    }
                }.bind(this);
                return;
            }

            this.summonTimeOut -= Game.cycleTickTime*Game.speed;

            if (this.timeOut > 0)
                return;

            this.scanEnemyAround();
            if (this.target) {
                direction = this.target.position.clone().sub(this.position);
                this.animation.setDirection(direction.getDirection());
                this.timeOut = this.base.timeOut;
                if (direction.getLength() < 64) {
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['fight'][this.fightAnim], this.animation);
                    this.target.applyDamage(this.damage, this);
                } else {
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['shot'], this.animation);
                    this.soundShoot && this.soundShoot.play();
                    direction.sub(direction.clone().normalize().multiply(32));
                    Game.lvl.objEffect.push(new Arrow(this.position.clone().add(new Vec2(0, -64)), this.target, Game.animations['DruidBolt'], 1.25,  direction.getLength()*3, true,
                        function(){
                            Game.lvl.objEffect.push(new Effect(this.position.clone(), this.direction.normalize(), Game.lvl.objEffect, Game.animations['DruidBoltHit'], Game.animations['DruidBoltHit'].playTime, 1));
                        }));
                    this.target.applyDamage(this.damage, this);
                }
            } else {
                if (this.path.length > 0) {
                    if (this.currectTarget && this.currectTarget.hitPoints > 0){
                        this.move();
                    } else {
                        this.path = [];
                    }
                } else {
                    this.searchPath();
                }
            }
        },
        init: function(){
            this.summonTimeOut =  myRandom(6000, this.base.summonTimeOut);
            this.scanEnemyAround = this.scanEnemyAroundArcher;
        }
    };

    Game.enemyList.dragonBoss = {
        cost:10,
        icon: 'dragonBossGroundWalk0',
        n:'dragonBoss',
        e:'forest',
        hitPoints: 50,
        damage: 5,
        boss:true,
        timeOut: 500,
        speed: 3,
        lifeCost: 1000,
        hitPosition: new Vec2(0,-64),
        hitRange: 64,
        fireBallTimeout: 5000,
        attackRange: Game.tileWidth*2,
        animations:{fight:['DBOSSA1', 'DBOSSA2'], standup:'DBOSSStandUp', air:'DBOSSInAirIdle', fall:'DBOSSFalling(AirDeath)', toAir:'DBOSSToAir', die:'DBOSSDeathOnGroud', run:'DBOSSWalk', fireBall:'DBOSSInAirFireball', flame:'DBOSSFlame'},
        type: "enemy",
        soundDeathGroup:'DragonBossDeath',
        soundDeath:'DragonDeath',
        soundDeathVolume:0.3,
        soundDeathLimit:2,
        soundCCGroup:'DragonBossAttack',
        soundCC:['DragonAttack01', 'DragonAttack02', 'DragonAttack03'],
        soundCCVolume:0.3,
        soundCCLimit:3,
        subtype:'dragons',
        strategy: function(){
            var len, target, key;
            this.scanTimeOut -= Game.cycleTickTime*Game.speed;
            this.timeOut -= Game.cycleTickTime*Game.speed;

            if (this.timeOut > 0)
                return;

            if (this.state == 'ground') {
                if ((this.cryTimeout -= Game.cycleTickTime*Game.speed) < 0) {
                    Game.lvl.audioPool.get('DragonRoar', 'DragonRoar', 0.3, 1).play();
                    this.cryTimeout = this.base.cryTimeout;
                    this.timeOut = Game.animations[this.animations['flame']].playTime;
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['flame'], this.animation);
                    if (Game.lvl.objBuildings.length > 1) {
                        var mtarget = Game.lvl.objBuildings[myRandom(1, Game.lvl.objBuildings.length)];
                        var pos = mtarget.position.clone();
                        if (mtarget.hitPosition)
                            pos.add(mtarget.hitPosition);

                        Game.lvl.objEffect.push(new MarkerEffect(pos));
                        Game.lvl.objEffect.push(new Meteoritte(mtarget.position, 0, true, 2000));
                    }
                    return;
                }

                if ((this.brewDamageTimeout -= Game.cycleTickTime*Game.speed) < 0) {
                    var flameTargets = [];
                    Game.lvl.objFriendly.forEach(function(friendly){
                        if (friendly.position.clone().sub(this.position).getLength() < 396 && friendly.hitPoints > 0)
                            flameTargets.push(friendly);
                    }.bind(this));
                    if (flameTargets.length > 0) {
                        Game.lvl.audioPool.get('DragonFlame', 'DragonFlame', 0.3, 1).play();
                        this.brewDamageTimeout = this.base.brewDamageTimeout;
                        this.timeOut = Game.animations[this.animations['flame']].playTime;
                        this.animation = Game.lvl.pool.switchAnimation(this.animations['flame'], this.animation);
                        this.animation._currentFrame = 0;
                        Game.lvl.objEffect.push(new DragonFlame(this.position.clone().add(new Vec2(128*this.animation.direction, -52)), this.animation.direction));
                        flameTargets.forEach(function(friendly) {
                            if (friendly.position.clone().sub(this.position).getDirection() == this.animation.direction)
                                Buf.prototype.addBuf(friendly, 'fire', 'hitPoints', this.base.brewDamageGround, 'damage', 1000, null, Game.lvl.effectContainer, null, null, this);
                        }.bind(this));
                        return;
                    }
                }

                this.scanEnemyAround();
                if (this.target) {
                    this.fight = true;
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['fight'][this.fightAnim], this.animation);
                    this.animation.onComplete = Enemy.prototype.switchFight.bind(this);
                    this.timeOut = this.base.timeOut;
                    this.target.applyDamage(this.damage, this);
                    this.soundCC.play();
                    this.animation.setDirection(this.target.position.clone().sub(this.position).getDirection());
                } else {
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['run'], this.animation);
                    if (this.path.length > 0) {
                        if (this.currectTarget.hitPoints > 0) {
                            this.move();
                        } else {
                            this.path = [];
                        }
                    } else {
                        this.timeOut = 100;
                        this.searchPath();
                    }
                }
            } else if (this.state == 'air') {
                Game.lvl.audioPool.get('DragonSwing', ['DragonSwing01', 'DragonSwing02', 'DragonSwing03'], 0.3, 1).play();
                this.fireBallTimeout -= Game.cycleTickTime*Game.speed;
                this.spawnTimeout -= Game.cycleTickTime*Game.speed;
                this.fallDownTime -= Game.cycleTickTime*Game.speed;

                if (this.fallDownTime < 0 || this.hitPoints < this.fallOn) {
                    Game.lvl.audioPool.get('DragonFall', 'DragonFall', 0.3, 1).play();
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['fall'], this.animation);
                    this.animation.loop = false;
                    this.animation.onComplete = null;
                    this.timeOut = 6000;
                    this.invulnerable = 8000;
                    this.state = 'death';
                    this.hitPosition = new Vec2(0, -64);
                    this.flying = false;
                    return;
                }

                if (this.fireBallTimeout < 0) {
                    this.fireBallTimeout = this.base.fireBallTimeout;
                    var fTarget, targets = [];
                    Game.lvl.objFriendly.forEach(function(friendly){
                        if (friendly.position.x < this.position.x)
                            targets.push(friendly);
                    }.bind(this));

                    if (targets.length > 0)
                        fTarget = targets[myRandom(0, targets.length)];

                    if (fTarget) {
                        this.animation.loop = false;
                        this.animation.onComplete = function() {
                            this.animation.loop = true;
                            this.animation.onComplete = null;
                            setTimeout(function() {
                                if (this.hitPoints > 0) {
                                    this.animation = Game.lvl.pool.switchAnimation(this.animations['fireBall'], this.animation);
                                    Game.lvl.objEffect.push(new FireBallDragon(this.position.clone().add(-96, -276), this.base.fireBallDamage, fTarget.position.clone()));
                                    this.animation.loop = false;
                                    this.animation.onComplete = function() {
                                        this.animation.loop = true;
                                        this.animation.onComplete = null;
                                        if (this.hitPoints > 0) {
                                            setTimeout(function(){
                                                this.animation = Game.lvl.pool.switchAnimation(this.animations['air'], this.animation);
                                            }.bind(this),1)
                                        }
                                    }.bind(this);
                                }
                            }.bind(this), 1);
                        }.bind(this);
                    }
                }

                if (this.spawnTimeout < 0) {
                    this.spawnTimeout = this.base.spawnTimeout*(0.5 + 0.5*this.hitPoints/this.maxHitPoints) ;
                    Game.lvl.objEnemy.push(new Enemy(Game.enemyList.smallDragon, -96, 256, 'TownHall', 1));
                    Game.lvl.objEnemy.push(new Enemy(Game.enemyList.smallDragon, 2130, 256, 'TownHall', 1));
                    Game.lvl.objEnemy.push(new Enemy(Game.enemyList.smallDragon, -96, 1306, 'TownHall', 1));
                    Game.lvl.objEnemy.push(new Enemy(Game.enemyList.smallDragon, 2130, 1306, 'TownHall', 1));
                }
            } else {
                this.state = 'ground';
                this.animation = Game.lvl.pool.switchAnimation(this.animations['standup'], this.animation);
                this.animation.loop = false;
                this.timeOut = 6000;
                this.animation.onComplete = function() {
                    this.animation.onComplete = null;
                    if (this.hitPoints > 0) {
                        setTimeout(function() {
                            this.timeOut = 0;
                            this.animation = Game.lvl.pool.switchAnimation(this.animations['run'], this.animation);
                            this.animation.onComplete = null;
                        }.bind(this),1)
                    }
                }.bind(this);
            }
        },
        init: function() {
            this.music = new MyAudio('forestboss', true, 0.4);
            this.music.play();
            Game.lvl.audioPool.get('DragonSpawn', 'DragonSpawn', 0.3, 1).play();
            this.hitPointsMultiply = 3;
            this.animation = Game.lvl.pool.switchAnimation(this.animations['run'], this.animation);
            this.fireBallTimeout = this.base.fireBallTimeout;
            this.spawnTimeout = this.base.spawnTimeout;
            this.cryTimeout = 9000;
            this.spawnTimeout = this.base.spawnTimeout;
            this.brewDamageTimeout = this.base.brewDamageTimeout;
            this.spawnTimeout = this.base.spawnTimeout;
            this.fallDownTime = this.base.fallDownTime;

            this.flyOn = this.hitPoints - 10000;

            this.path = [Game.lvl.objMap.getTile(new Vec2(192, 768+64)), Game.lvl.objMap.getTile(new Vec2(640, 768)), Game.lvl.objMap.getTile(new Vec2(1056, 864))];
            this.state = 'ground';

            this.applyDamage = function(damage, source) {
                Enemy.prototype.applyDamage.call(this, damage, source);
                if (this.hitPoints > 0) {
                    if (this.hitPoints < this.flyOn && this.state == 'ground' && this.hitPoints >= 16000) {
                        Game.lvl.audioPool.get('DragonGoUp', 'DragonGoUp', 0.3, 1).play();
                        this.fallDownTime = this.base.fallDownTime;
                        this.fallOn = this.hitPoints - 10000;
                        this.flyOn = this.hitPoints - 20000;
                        this.animation = Game.lvl.pool.switchAnimation(this.animations['toAir'], this.animation);
                        this.animation.setDirection(-1);
                        this.animation.loop = false;
                        this.timeOut = 3000;
                        this.invulnerable = 3000;
                        this.state = 'air';
                        this.hitPosition = new Vec2(0, -128);
                        this.flying = true;
                        this.animation.onComplete = function(){
                            setTimeout(function(){
                                this.animation = Game.lvl.pool.switchAnimation(this.animations['air'], this.animation);
                                this.animation.onComplete = null;
                            }.bind(this),1)
                        }.bind(this);
                    }
                }
            };

            this.checkMove = function () {
                var newTile = Game.lvl.objMap.getTile(this.position);
                if (newTile!= this.tile) {
                    if ((newTile.objects.length > 0)&&(!this.flying)&&((this.directionDirect)||(newTile.objects[0]==this.currectTarget))) {
                        this.target = newTile.objects[0];
                        this.animation = Game.lvl.pool.switchAnimation(this.animations['fight'][this.fightAnim], this.animation);
                        return false;
                    }

                    if (this.tile)
                        this.tile.eObjects.splice(this.tile.eObjects.indexOf(this), 1);

                    this.tile = newTile;
                    this.tile.eObjects.push(this);
                    if (newTile.position.clone().sub(Game.lvl.objMap.getTile(new Vec2(1056, 864)).position).getLength() < 32) {
                        var flag = Game.lvl.flags.filter(function(flag){return flag.position.x == 1056 && flag.position.y == 864}).pop();
                        if (flag) {
                            Game.lvl.objEffect.push(new DumFx(flag.tile.position, 1));
                            flag.remove();
                            if (Game.lvl.flags.indexOf(flag) != -1)
                                Game.lvl.flags.splice(Game.lvl.flags.indexOf(flag), 1);

                            flag.tile.isWalkable = true;
                        }
                    }
                }
                return true;
            };

            this.onDeath = function() {
                Game.events.emit('killdragon');
                Game.events.emit('dragonsKiller');
                this.animation = Game.lvl.pool.switchAnimation(this.animations['die'], this.animation);
                this.animation.loop = false;
                this.animation.onComplete = function(){
                    if (Game.lvl.objEnemy.indexOf(this)!=-1)
                        Game.lvl.objEnemy.splice(Game.lvl.objEnemy.indexOf(this), 1);
                }.bind(this)
            };
        }
    };

    function isOnScreen (position) {
        return position.x > 0 && position.x < 2048 && position.y > 0 && position.y < 1536;
    }

    Game.enemyList.zombie = {
        cost:10,
        icon: 'zombieRun0',
        n:'zombie',
        e:'graveyard',
        hitPoints: 5,
        damage: 1,
        timeOut: 500,
        speed: 6,
        lifeCost: 1,
        hitPosition: new Vec2(0,-48),
        hitRange: 10,
        attackRange: Game.tileWidth,
        animations:{fight:['zombieFight1', 'zombieFight2', 'zombieFight3'], die:'zombieDie', run:'zombieRun', rising:'zombieRecover', zombieRise:'zombieRise'},
        type: "enemy",
        risingChance: 0.5,
        soundDeathGroup:'enemyZombieDeath',
        soundDeath:['ZombieDeath01', 'ZombieDeath02'],
        soundDeathVolume:0.3,
        soundDeathLimit:2,
        soundRiseGroup:'enemyZombieRise',
        soundRise:'ZombieRise',
        soundRiseVolume:0.3,
        soundRiseLimit:2,
        scaleHint: 2,
        subtype:'zombies',
        applyDamage: function(damage, source) {
            var armor = source && source.damageType == 'magic' ? this.magicArmor : this.armor;
            var penetration = source ? source.penetration || 0 : 1;
            if (source && source.criticalChance && checkCritical(source.criticalChance)){
                var crit = new CritBlood(this.position.clone().add(this.hitPosition));
                Game.lvl.objEffect.push(crit);
                damage *= 2;
                penetration = 1;
                Game.events.emit('criticalStrike');
            }

            if (this.invulnerable <= 0)
                this.hitPoints -= damage*(1 - armor*(1-penetration));

            if (this.hitPoints<=0) {
                if (!this.alreadyRising) {
                    this.alreadyRising = true;
                    if (myRandom(0, 100) < this.base.risingChance * 100) {
                        this.soundDeath && this.soundDeath.play();
                        this.rising = true;
                        this.invulnerable = 8000 + Game.animations[this.animations.rising].playTime + Game.animations[this.animations.die].playTime;
                        this.timeOut = 8000 + Game.animations[this.animations.die].playTime;
                        this.hitPoints = this.maxHitPoints;
                        this.animation = Game.lvl.pool.switchAnimation(this.animations['die'], this.animation);
                        this.animation.loop = false;
                    }
                }
                if (!this.alreadyDead && !this.rising) {
                    this.soundDeath && this.soundDeath.play();
                    Game.events.emit('enemyKilled');
                    if (source === Game.lvl.gameLogic.hero) {
                        Game.events.emit('enemyKilledFromHero');
                        Game.lvl.gameLogic.lazarus = false;
                        Game.lvl.gameLogic.hero.addExperience(this.base.bounty || 0);
                    } else if (source && source.base.subtype)
                        Game.events.emit(source.base.subtype + 'Kill');

                    if (this.base.subtype)
                        Game.events.emit(this.base.subtype + 'Killer');

                    if (crit)
                        Game.events.emit('enemyKilledByCrit');

                    this.onDeath();
                    this.alreadyDead = true;
                }
            } else {
                if (!this.hitPointsEffect && this.invulnerable <=0)
                    this.hitPointsEffect = new hitPointsEffect(this);
            }
        },
        init : function () {
            this.alreadyRising = false;
            this.rising = false;
            this.applyDamage = Game.enemyList.zombie.applyDamage;
            this.animation = Game.lvl.pool.switchAnimation(this.animations['zombieRise'], this.animation);
            this.animation.loop = false;
            this.timeOut = Game.animations[this.animations.zombieRise].playTime + 50;
        },
        strategy: function() {
            if (this.rising) {
                if (this.timeOut > 0) {
                    this.timeOut -= Game.cycleTickTime*Game.speed;
                } else {
                    this.rising = false;
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['rising'], this.animation);
                    this.animation.loop = false;
                    this.timeOut = Game.animations[this.animations.rising].playTime + 50;
                }
            } else {
                Enemy.prototype.strategy.call(this);
            }
        }
    };

    Game.enemyList.skeleton = {
        cost:10,
        icon: 'skeletonRun0',
        n:'skeleton',
        e:'graveyard',
        hitPoints: 5,
        damage: 1,
        timeOut: 500,
        speed: 9,
        lifeCost: 1,
        hitPosition: new Vec2(0,-64),
        hitRange: 10,
        attackRange: Game.tileWidth,
        animations:{fight:['skeletonFight1', 'skeletonFight2'], die:'skeletonDie', run:'skeletonRun', rising:'skeletonRise'},
        type: "enemy",
        risingChance: 0.5,
        soundDeathGroup:'SceletonDeath',
        soundDeath:'SceletonDeath',
        soundDeathVolume:0.3,
        soundDeathLimit:3,
        scaleHint: 2,
        applyDamage: function(damage, source) {
            var armor = source && source.damageType == 'magic' ? this.magicArmor : this.armor;
            var penetration = source ? source.penetration || 0 : 1;
            if (source && source.criticalChance && checkCritical(source.criticalChance)){
                var crit = new CritBlood(this.position.clone().add(this.hitPosition));
                Game.lvl.objEffect.push(crit);
                damage *= 2;
                penetration = 1;
                Game.events.emit('criticalStrike');
            }

            if (this.invulnerable <= 0)
                this.hitPoints -= damage*(1 - armor*(1-penetration));

            if (this.hitPoints<=0) {
                if (!this.alreadyRising) {
                    this.alreadyRising = true;
                    if (myRandom(0, 100) < this.base.risingChance * 100) {
                        this.rising = true;
                        this.invulnerable = 8000 + Game.animations[this.animations.rising].playTime + Game.animations[this.animations.die].playTime;
                        this.timeOut = 8000 + Game.animations[this.animations.die].playTime;
                        this.hitPoints = this.maxHitPoints;
                        this.animation = Game.lvl.pool.switchAnimation(this.animations['die'], this.animation);
                        this.animation.loop = false;
                    }
                }
                if(!this.alreadyDead && !this.rising) {
                    Game.events.emit('enemyKilled');
                    if (source === Game.lvl.gameLogic.hero) {
                        Game.events.emit('enemyKilledFromHero');
                        Game.lvl.gameLogic.lazarus = false;
                        Game.lvl.gameLogic.hero.addExperience(this.base.bounty || 0);
                    } else if (source && source.base.subtype)
                        Game.events.emit(source.base.subtype + 'Kill');

                    if (crit)
                        Game.events.emit('enemyKilledByCrit');

                    this.onDeath();
                    this.alreadyDead = true;
                }
            } else {
                if (!this.hitPointsEffect)
                    this.hitPointsEffect = new hitPointsEffect(this);
            }
        },
        init : function () {
            this.alreadyRising = false;
            this.rising = false;
            this.applyDamage = Game.enemyList.zombie.applyDamage;

            if (isOnScreen(this.position)) {
                Game.lvl.objEffect.push(new Effect(this.position, new Vec2(0, 0), Game.lvl.objEffect, Game.animations.UndeadSummon, Game.animations.UndeadSummon.playTime, 1));
                this.timeOut = Game.animations.UndeadSummon.playTime/2;
            }
        },
        strategy: function() {
            if (this.rising) {
                if (this.timeOut > 0) {
                    this.timeOut -= Game.cycleTickTime*Game.speed;
                } else {
                    this.rising = false;
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['rising'], this.animation);
                    this.animation.loop = false;
                    this.timeOut = Game.animations[this.animations.rising].playTime + 50;
                }
            } else {
                Enemy.prototype.strategy.call(this);
            }
        }
    };

    Game.enemyList.redSkeleton = {
        cost:10,
        icon: 'SceletonBA10',
        n:'redSkeleton',
        e:'graveyard',
        hitPoints: 5,
        damage: 1,
        timeOut: 500,
        speed: 9,
        lifeCost: 1,
        hitPosition: new Vec2(0,-64),
        hitRange: 10,
        attackRange: Game.tileWidth,
        animations:{fight:['SceletonBA1', 'SceletonBA2'], die:'SceletonBDeath', run:'SceletonBWalk', rising:'SceletonBRise'},
        type: "enemy",
        risingChance: 0.5,
        soundDeathGroup:'SceletonDeath',
        soundDeath:'SceletonDeath',
        soundDeathVolume:0.3,
        soundDeathLimit:3,
        scaleHint: 2,
        applyDamage: function(damage, source) {
            var armor = source && source.damageType == 'magic' ? this.magicArmor : this.armor;
            var penetration = source ? source.penetration || 0 : 1;
            if (source && source.criticalChance && checkCritical(source.criticalChance)){
                var crit = new CritBlood(this.position.clone().add(this.hitPosition));
                Game.lvl.objEffect.push(crit);
                damage *= 2;
                penetration = 1;
                Game.events.emit('criticalStrike');
            }

            if (this.invulnerable <= 0)
                this.hitPoints -= damage*(1 - armor*(1-penetration));

            if (this.hitPoints<=0) {
                if (!this.alreadyRising) {
                    this.alreadyRising = true;
                    if (myRandom(0, 100) < this.base.risingChance * 100) {
                        this.soundDeath && this.soundDeath.play();
                        this.rising = true;
                        this.invulnerable = 8000 + Game.animations[this.animations.rising].playTime + Game.animations[this.animations.die].playTime;
                        this.timeOut = 8000 + Game.animations[this.animations.die].playTime;
                        this.hitPoints = this.maxHitPoints;
                        this.animation = Game.lvl.pool.switchAnimation(this.animations['die'], this.animation);
                        this.animation.loop = false;
                    }
                }
                if(!this.alreadyDead && !this.rising) {
                    this.soundDeath && this.soundDeath.play();
                    Game.events.emit('enemyKilled');
                    if (source === Game.lvl.gameLogic.hero) {
                        Game.events.emit('enemyKilledFromHero');
                        Game.lvl.gameLogic.lazarus = false;
                        Game.lvl.gameLogic.hero.addExperience(this.base.bounty || 0);
                    } else if (source && source.base.subtype)
                        Game.events.emit(source.base.subtype + 'Kill');

                    if (crit)
                        Game.events.emit('enemyKilledByCrit');

                    this.onDeath();
                    this.alreadyDead = true;
                }
            } else {
                if (!this.hitPointsEffect)
                    this.hitPointsEffect = new hitPointsEffect(this);
            }
        },
        init : function () {
            this.alreadyRising = false;
            this.rising = false;
            this.applyDamage = Game.enemyList.zombie.applyDamage;
            if (isOnScreen(this.position)) {
                Game.lvl.objEffect.push(new Effect(this.position, new Vec2(0, 0), Game.lvl.objEffect, Game.animations.UndeadSummon, Game.animations.UndeadSummon.playTime, 1));
                this.timeOut = Game.animations.UndeadSummon.playTime/2;
            }
        },
        strategy: function() {
            if (this.rising) {
                if (this.timeOut > 0) {
                    this.timeOut -= Game.cycleTickTime*Game.speed;
                } else {
                    this.rising = false;
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['rising'], this.animation);
                    this.animation.loop = false;
                    this.timeOut = Game.animations[this.animations.rising].playTime + 50;
                }
            } else {
                Enemy.prototype.strategy.call(this);
            }
        }
    };

    Game.enemyList.skeletonArcher = {
        cost:10,
        icon: 'SceletonArcherDeath0',
        n:'skeletonArcher',
        e:'graveyard',
        hitPoints: 5,
        damage: 1,
        timeOut: 500,
        speed: 9,
        lifeCost: 1,
        hitPosition: new Vec2(0,-64),
        hitRange: 10,
        attackRange: 4*Game.tileWidth,
        animations: {fight:['SceletonArcherFight2', 'SceletonArcherFight1'], arrow:'SceletonArcherShoot', die:'SceletonArcherDeath', run:'SceletonArcherWalk', rising:'SceletonArcherRise'},
        type: "enemy",
        risingChance: 0.5,
        soundDeathGroup:'SceletonDeath',
        soundDeath:'SceletonDeath',
        soundDeathVolume:0.3,
        soundDeathLimit:3,
        soundShootGroup:'ArrowTower',
        soundShoot:'ArrowTower',
        soundShootVolume:0.2,
        soundShootLimit:4,
        scaleHint: 2,
        applyDamage: function(damage, source) {
            var armor = source && source.damageType == 'magic' ? this.magicArmor : this.armor;
            var penetration = source ? source.penetration || 0 : 1;
            if (source && source.criticalChance && checkCritical(source.criticalChance)){
                var crit = new CritBlood(this.position.clone().add(this.hitPosition));
                Game.lvl.objEffect.push(crit);
                damage *= 2;
                penetration = 1;
                Game.events.emit('criticalStrike');
            }

            if (this.invulnerable <= 0)
                this.hitPoints -= damage*(1 - armor*(1-penetration));

            if (this.hitPoints<=0) {
                if (!this.alreadyRising) {
                    this.alreadyRising = true;
                    if (myRandom(0, 100) < this.base.risingChance * 100) {
                        this.soundDeath && this.soundDeath.play();
                        this.rising = true;
                        this.invulnerable = 8000 + Game.animations[this.animations.rising].playTime + Game.animations[this.animations.die].playTime;
                        this.timeOut = 8000 + Game.animations[this.animations.die].playTime;
                        this.hitPoints = this.maxHitPoints;
                        this.animation = Game.lvl.pool.switchAnimation(this.animations['die'], this.animation);
                        this.animation.loop = false;
                    }
                }
                if(!this.alreadyDead && !this.rising) {
                    this.soundDeath && this.soundDeath.play();
                    Game.events.emit('enemyKilled');
                    if (source === Game.lvl.gameLogic.hero) {
                        Game.events.emit('enemyKilledFromHero');
                        Game.lvl.gameLogic.lazarus = false;
                        Game.lvl.gameLogic.hero.addExperience(this.base.bounty || 0);
                    } else if (source && source.base.subtype)
                        Game.events.emit(source.base.subtype + 'Kill');

                    if (crit)
                        Game.events.emit('enemyKilledByCrit');

                    this.onDeath();
                    this.alreadyDead = true;
                }
            } else {
                if (!this.hitPointsEffect)
                    this.hitPointsEffect = new hitPointsEffect(this);
            }
        },
        init : function () {
            this.alreadyRising = false;
            this.rising = false;
            this.applyDamage = Game.enemyList.skeletonArcher.applyDamage;
            if (isOnScreen(this.position)) {
                Game.lvl.objEffect.push(new Effect(this.position, new Vec2(0, 0), Game.lvl.objEffect, Game.animations.UndeadSummon, Game.animations.UndeadSummon.playTime, 1));
                this.timeOut = Game.animations.UndeadSummon.playTime/2;
            }
        },
        strategy: function() {
            if (this.rising) {
                if (this.timeOut > 0) {
                    this.timeOut -= Game.cycleTickTime*Game.speed;
                } else {
                    this.rising = false;
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['rising'], this.animation);
                    this.animation.loop = false;
                    this.timeOut = Game.animations[this.animations.rising].playTime + 50;
                }
            } else {
                Game.enemyList.skeletonArcher.strategyArcher.call(this);
            }
        },
        strategyArcher: function() {
            var direction;
            this.timeOut -= Game.cycleTickTime*Game.speed;

            if (this.timeOut > 0)
                return;

            this.scanEnemyAroundArcher();

            if (this.target) {
                direction = this.target.position.clone().sub(this.position);
                this.animation.setDirection(direction.getDirection());
                this.timeOut = this.base.timeOut;
                if (direction.getLength() > 96) {
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['arrow'], this.animation);
                    this.animation.loop = false;
                    this.animation._currentTime = 0;
                    this.animation.play();
                    direction.sub(direction.clone().normalize().multiply(32));
                    Game.lvl.objEffect.push(new Arrow(this.position.clone().add(new Vec2(0, -54)), this.target, Game.sprites.arrow, 1.25, direction.getLength() * 1.5, false, null, Game.animations[this.animations['arrow']].playTime - 400));
                } else {
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['fight'][this.fightAnim], this.animation);
                }
                this.target.applyDamage(this.damage, this);
            } else {
                if (this.path.length > 0)
                    this.move();
            }
        }
    };

    Game.enemyList.werwolf = {
        cost:10,
        icon: 'werwolfRun20',
        n:'werwolf',
        e:'graveyard',
        hitPoints: 15,
        damage: 5,
        timeOut: 500,
        speed: 9,
        lifeCost: 2,
        hitPosition: new Vec2(0,-80),
        hitRange: 30,
        runOn: 0.5,
        attackRange: Game.tileWidth,
        animations:{fight:['werwolfFight1', 'werwolfFight2'], fury:'werwolfFight3', die:'werwolfDie', roar:'werwolfRoar', run2:'werwolfRun', run:'werwolfRun2'},
        type: "enemy",
        soundDeathGroup:'nemyWerwolfDeath',
        soundDeath:'WerwolfDeath',
        soundDeathVolume:0.3,
        soundDeathLimit:2,
        soundCCGroup:'WerworlAttact',
        soundCC:['WerwolfAttack01', 'WerwolfAttack02'],
        soundCCVolume:0.3,
        soundCCLimit:3,
        scaleHint: 1.5,
        strategy: function() {
            this.scanTimeOut -= Game.cycleTickTime*Game.speed;
            this.timeOut -= Game.cycleTickTime*Game.speed;
            this.furyTimeOut -= Game.cycleTickTime*Game.speed;

            if (this.furyTime > 0) {
                this.furyTime -= Game.cycleTickTime;
                if (this.hitPoints < this.maxHitPoints)
                    this.hitPoints += this.base.furyHeal*Game.cycleTickTime*Game.speed/this.base.furyTime;

                if (this.target && this.target.hitPoints > 0)
                    this.target.applyDamage(this.base.furyDamage*Game.cycleTickTime*Game.speed/this.base.furyTime, this);

                return;
            }

            if (this.timeOut > 0)
                return;

            this.scanEnemyAround();

            if (this.target) {
                if (this.furyTimeOut < 0) {
                    this.furyTime = this.base.furyTime;
                    this.furyTimeOut = this.base.furyTimeOut;
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['fury'], this.animation);
                    this.timeOut = this.base.furyTime;
                    this.soundSpecial.play();
                } else {
                    this.soundCC.play();
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['fight'][this.fightAnim], this.animation);
                    this.timeOut = this.base.timeOut;
                    this.target.applyDamage(this.damage, this);
                    this.animation.setDirection(this.target.position.clone().sub(this.position).getDirection());
                }
            } else {
                this.animation = Game.lvl.pool.switchAnimation(this.animations['run'], this.animation);
                if (this.path.length > 0)
                    this.move();
            }
        },
        init: function() {
            this.soundSpecial =  Game.lvl.audioPool.get('werwolfSpecial', 'WerwolfSpecial', 0.3, 2);
            this.furyTimeOut = myRandom(5000, this.base.furyTimeOut);
            this.furyTime = 0;
            this.animations = clone(this.base.animations);
            this.runer = false;
            this.applyDamage = function(damage, source) {
                Enemy.prototype.applyDamage.call(this, damage, source);
                if (!this.runer && this.furyTime <=0 && this.hitPoints < this.maxHitPoints*this.base.runOn && this.hitPoints > 0) {
                    this.runer = true;
                    this.timeOut = Game.animations['werwolfRoar'].playTime - 100;
                    this.animation = Game.lvl.pool.switchAnimation('werwolfRoar', this.animation);
                    this.animation.loop = false;
                    this.speed *=2;
                    this.animations.run = this.animations.run2;
                }
            };
            if (isOnScreen(this.position)) {
                Game.lvl.objEffect.push(new Effect(this.position, new Vec2(0, 0), Game.lvl.objEffect, Game.animations.UndeadSummon, Game.animations.UndeadSummon.playTime, 1));
                this.timeOut = Game.animations.UndeadSummon.playTime/2;
            }
        }
    };

    Game.enemyList.vampire = {
        cost:10,
        icon: 'vampireRun0',
        n:'vampire',
        e:'graveyard',
        hitPoints: 15,
        damage: 5,
        timeOut: 500,
        speed: 9,
        lifeCost: 1,
        hitPosition: new Vec2(0,-64),
        hitRange: 10,
        attackRange: Game.tileWidth,
        animations:{fight:['vampireFight1', 'vampireFight2', 'vampireFight3'], die:'vampireDie', run:'vampireRun'},
        type: "enemy",
        soundDeathGroup:'nemyVampireDeath',
        soundDeath:'VampireDeath',
        soundDeathVolume:0.3,
        soundDeathLimit:2,
        scaleHint: 1.5,
        strategy: function() {
            this.scanTimeOut -= Game.cycleTickTime*Game.speed;
            this.timeOut -= Game.cycleTickTime*Game.speed;

            if (this.timeOut > 0)
                return;

            this.scanEnemyAround();
            if (this.target) {
                this.animation = Game.lvl.pool.switchAnimation(this.animations['fight'][this.fightAnim], this.animation);
                this.animation.onComplete = this.switchFight.bind(this);
                this.timeOut = this.base.timeOut;
                this.target.applyDamage(this.damage, this);
                if (this.hitPoints < this.maxHitPoints) {
                    this.hitPoints += this.base.vampire;
                }
                this.animation.setDirection(this.target.position.clone().sub(this.position).getDirection());
            } else {
                this.animation = Game.lvl.pool.switchAnimation(this.animations['run'], this.animation);
                if (this.path.length > 0)
                    this.move();
            }
        },
        init: function(){
            if (isOnScreen(this.position)) {
                Game.lvl.objEffect.push(new Effect(this.position, new Vec2(0, 0), Game.lvl.objEffect, Game.animations.UndeadSummon, Game.animations.UndeadSummon.playTime, 1));                this.timeOut = Game.animations.UndeadSummon.playTime;
            }
        }
    };


    Game.animations.UndedPosohUp = {playTime: 2600*21/38, count: 21, sprites:["UndeadMageDeathRay0", "UndeadMageDeathRay1", "UndeadMageDeathRay2", "UndeadMageDeathRay3", "UndeadMageDeathRay4", "UndeadMageDeathRay5", "UndeadMageDeathRay6", "UndeadMageDeathRay7", "UndeadMageDeathRay8", "UndeadMageDeathRay9", "UndeadMageDeathRay10", "UndeadMageDeathRay11", "UndeadMageDeathRay12", "UndeadMageDeathRay13", "UndeadMageDeathRay14", "UndeadMageDeathRay15", "UndeadMageDeathRay16", "UndeadMageDeathRay17", "UndeadMageDeathRay18", "UndeadMageDeathRay19", "UndeadMageDeathRay20"]};
    Game.animations.UndedPosohDeath = {playTime: 1500, count: 14, sprites:["UndeadMageDeathRay21", "UndeadMageDeathRay22", "UndeadMageDeathRay23", "UndeadMageDeathRay24", "UndeadMageDeathRay25", "UndeadMageDeathRay26", "UndeadMageDeathRay27", "UndeadMageDeathRay28", "UndeadMageDeathRay29"]};
    Game.animations.UndedPosohDeath.sprites.push("UndeadMageDeathRay28", "UndeadMageDeathRay27", "UndeadMageDeathRay26", "UndeadMageDeathRay25", "UndeadMageDeathRay24", "UndeadMageDeathRay23", "UndeadMageDeathRay22");
    Game.animations.UndedPosohDown = {playTime: 2600*21/38, count: 21, sprites:["UndeadMageDeathRay0", "UndeadMageDeathRay1", "UndeadMageDeathRay2", "UndeadMageDeathRay3", "UndeadMageDeathRay4", "UndeadMageDeathRay5", "UndeadMageDeathRay6", "UndeadMageDeathRay7", "UndeadMageDeathRay8", "UndeadMageDeathRay9", "UndeadMageDeathRay10", "UndeadMageDeathRay11", "UndeadMageDeathRay12", "UndeadMageDeathRay13", "UndeadMageDeathRay14", "UndeadMageDeathRay15", "UndeadMageDeathRay16", "UndeadMageDeathRay17", "UndeadMageDeathRay18", "UndeadMageDeathRay19", "UndeadMageDeathRay20"]};
    Game.animations.UndedPosohDown.sprites.reverse();

    Game.enemyList.undeadMage = {
        cost:10,
        icon: 'undeadMageMele0',
        n:'undeadMage',
        e:'graveyard',
        hitPoints: 5,
        damage: 1,
        timeOut: 500,
        speed: 9,
        lifeCost: 1,
        hitPosition: new Vec2(0,-32),
        hitRange: 10,
        attackRange: Game.tileWidth*8,
        zombieTimeout: 10000,
        zombieCount: 5,
        deathRayTime: 5000,
        deathRayHeal: 2000,
        deathRayDamage: 1000,
        deathRayRange: 1000,
        deathRayTimeout: 1,
        posoh: new Vec2(32, -96),
        animations:{fight:['UndeadMageMele'], die:'UndeadMageDeath', run:'UndeadMageWalk', cast:'UndeadMageDeathRay', posohUp:'UndedPosohUp', posohDeath:'UndedPosohDeath', posohDown:'UndedPosohDown'},
        type: "enemy",
        soundDeathGroup:'enemyNecromantMageDeath',
        soundDeath:'Necromant_Mage_death',
        soundDeathVolume:0.3,
        soundDeathLimit:2,
        soundShootGroup:'Necromant_Mage_Shoot',
        soundShoot:'Necromant_Mage_Shoot',
        soundShootVolume:0.2,
        soundShootLimit:2,
        scaleHint: 2,
        onDeath:function(){
            Game.lvl.objEffect.push(new Soul(this.position));
        },
        strategy: function() {
            var direction, len, target, rayDirection, rayPosition, dir;
            this.timeOut -= Game.cycleTickTime*Game.speed;
            this.zombieTimeout -= Game.cycleTickTime*Game.speed;
            this.scanTimeOut -= Game.cycleTickTime*Game.speed;
            this.deathRayTimeout -= Game.cycleTickTime*Game.speed;

            if (this.deathRayInProgress > 0) {
                this.deathRayInProgress -= Game.cycleTickTime*Game.speed;
                if (this.deathRay) {
                    direction = this.target.position.clone().sub(this.position);
                    this.animation.setDirection(direction.getDirection());

                    dir = this.base.posoh.clone();
                    dir.x *= direction.getDirection();
                    rayDirection = this.target.position.clone().add(this.target.hitPosition).sub(dir).sub(this.position);
                    rayPosition = this.position.clone().add(dir).add(rayDirection.multiplyed(0.5));

                    this.deathRay.time += Game.cycleTickTime*Game.speed;
                    this.deathRay.position = rayPosition;
                    this.deathRay.length = rayDirection.getLength();
                    this.deathRay.rotation = rayDirection.getRotate();
                    this.deathRay.blinkEffect.position = this.position.clone().add(dir);
                }
                if (this.hitPoints < this.maxHitPoints)
                    this.hitPoints += this.base.deathRayHeal/(this.base.deathRayTime/(Game.cycleTickTime*Game.speed));
                if (this.target  && this.target.hitPoints > 0) {
                    this.target.applyDamage(this.base.deathRayDamage/(this.base.deathRayTime/(Game.cycleTickTime*Game.speed)))
                }

                if (this.deathRayInProgress <= 0) {
                    this.deathRay && (this.deathRay.time = 800);
                    this.animation.loop = false;
                    this.animation.onComplete = function(){
                        this.animation = Game.lvl.pool.switchAnimation(this.animations['posohDown'], this.animation);
                        this.animation.loop = false;
                        this.timeOut = 2600*18/38;
                    }.bind(this);
                    this.timeOut = 3600;
                }
                return;
            }

            if (this.timeOut > 0 && this.zombieTimeout > 0)
                return;

            if (this.zombieTimeout <= 0) {
                this.summonSound.play();
                this.zombieTimeout = this.base.zombieTimeout;
                var pos, zombie;
                for (var i = 0; i < this.base.zombieCount; i++) {
                    pos = new Vec2(this.position.x + myRandom(-200, 200), this.position.y + myRandom(-200, 200));

                    Game.lvl.objEffect.push(new Effect(pos, new Vec2(0,0), Game.lvl.objEffect, Game.animations.UndeadSummon, Game.animations.UndeadSummon.playTime, 1));
                    zombie = new Enemy(Game.enemyList.zombie, pos.x, pos.y, 'TownHall', 1);
                    zombie.bounty = 0;

                    zombie.animation = Game.lvl.pool.switchAnimation(zombie.animations['run'], zombie.animation);
                    this.timeOut = Game.animations.UndeadSummon.playTime/2;


                    this.animation = Game.lvl.pool.switchAnimation(this.animations['cast'], this.animation);
                    this.timeOut = Game.animations[this.animations['cast']].playTime;
                    zombie.path = this.path.slice(0);
                    Game.lvl.objEnemy.push(zombie);
                }
                return;
            }

            if (this.deathRayTimeout <= 0) {
                this.deathRayTimeout = this.base.deathRayTimeout;
                this.scanEnemyAroundRay();
                if (this.target) {
                    this.raySound.play();
                    this.timeOut =  this.base.deathRayTimeout + 250;
                    direction = this.target.position.clone().sub(this.position);
                    this.animation.setDirection(direction.getDirection());
                    this.timeOut = this.base.timeOut;

                    this.animation = Game.lvl.pool.switchAnimation(this.animations['posohUp'], this.animation);
                    this.animation.loop = false;
                    this.animation.onComplete = function() {
                        this.animation = Game.lvl.pool.switchAnimation(this.animations['posohDeath'], this.animation);
                        this.animation.loop = true;
                    }.bind(this);

                    dir = this.base.posoh.clone();
                    dir.x *= direction.getDirection();
                    rayDirection = this.target.position.clone().add(this.target.hitPosition).sub(dir).sub(this.position);
                    rayPosition = this.position.clone().add(dir).add(rayDirection.multiplyed(0.5));

                    this.deathRay = new DeathRay(rayPosition, rayDirection.getLength(), rayDirection.getRotate(), 150,  this, 700, this.target);
                    this.deathRayInProgress = this.base.deathRayTime;
                    return;
                }
            }

            this.scanEnemyAround();
            if (this.target) {
                direction = this.target.position.clone().sub(this.position);
                this.animation.setDirection(direction.getDirection());
                this.timeOut = this.base.timeOut;
                if (direction.getLength() < 76) {
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['fight'][this.fightAnim], this.animation);
                    this.target.applyDamage(this.damage, this);
                } else {
                    this.soundShoot.play();
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['cast'], this.animation);
                    this.animation.loop = true;

                    Game.lvl.objEffect.push(new Arrow(this.position.clone().add(new Vec2(0, -64)).add(direction.clone().normalize().multiply(32)), this.target, Game.animations['UndeadMageBolt'], 1.25,  direction.getLength()*3, true,
                        function () {
                            Game.lvl.objEffect.push(new Effect(this.position.clone(), this.direction.normalize(), Game.lvl.objEffect, Game.animations['UndeadMageBoltHit'], Game.animations['UndeadMageBoltHit'].playTime, 1));
                        }));
                    this.target.applyDamage(this.damage, this);
                }
            } else {
                if (this.path.length > 0) {
                    if (this.currectTarget && this.currectTarget.hitPoints > 0){
                        this.move();
                    } else {
                        this.path = [];
                    }
                } else {
                    this.searchPath();
                }
            }
        },
        init: function(){
            this.summonSound =  Game.lvl.audioPool.get('undeadMageSummon', 'Necromant_Mage_Summon', 0.3, 1);
            this.raySound =  Game.lvl.audioPool.get('undeadMageSpecial', 'Necromant_Mage_Specia', 0.3, 3);
            this.zombieTimeout = this.base.zombieTimeout/3;
            this.deathRayTimeout =  this.base.deathRayTimeout/3;
            this.deathRayInProgress = 0;
            this.scanEnemyAround = this.scanEnemyAroundArcher;
            this.scanEnemyAroundRay = function() {
                this.scanTimeOut = 0;
                this.attackRangeTemp = this.attackRange;
                this.attackRange = this.base.deathRayRange;
                Enemy.prototype.scanEnemyAroundArcher.call(this);
                this.attackRange = this.attackRangeTemp;
            };
            if (isOnScreen(this.position)) {
                Game.lvl.objEffect.push(new Effect(this.position, new Vec2(0, 0), Game.lvl.objEffect, Game.animations.UndeadSummon, Game.animations.UndeadSummon.playTime, 1));
                this.timeOut = Game.animations.UndeadSummon.playTime/2;
            }
        }
    };

    Game.enemyList.bat = {
        cost:10,
        icon: 'batRun0',
        n:'bat',
        e:'graveyard',
        hitPoints: 5,
        damage: 1,
        timeOut: 500,
        speed: 9,
        lifeCost: 1,
        hitPosition: new Vec2(0,-100),
        hitRange: 10,
        flying: true,
        attackRange: Game.tileWidth,
        animations:{fight:['batRun'], die:'batDie', run:'batRun'},
        type: "enemy",
        soundDeathGroup:'enemyBatDeathDeath',
        soundDeath:'BatDeath',
        soundDeathVolume:0.3,
        soundDeathLimit:2,
        scaleHint: 2,
    };

    //Game.animations.necromantBossPosohDown = {playTime: 2500*20/26, count: 20, sprites:["necromantBossSpecial0", "necromantBossSpecial1", "necromantBossSpecial2", "necromantBossSpecial3", "necromantBossSpecial4", "necromantBossSpecial5", "necromantBossSpecial6", "necromantBossSpecial7", "necromantBossSpecial8", "necromantBossSpecial9", "necromantBossSpecial10", "necromantBossSpecial11", "necromantBossSpecial12", "necromantBossSpecial13", "necromantBossSpecial14", "necromantBossSpecial15", "necromantBossSpecial16", "necromantBossSpecial17", "necromantBossSpecial18", "necromantBossSpecial19"]};
    //Game.animations.necromantBossPosohUp = {playTime: 2500*6/26, count: 6, sprites:["necromantBossSpecial20", "necromantBossSpecial21", "necromantBossSpecial22", "necromantBossSpecial23", "necromantBossSpecial24", "necromantBossSpecial25"]};
    Game.animations.necromantBossPosohDown = {playTime: 2500*13/26, count: 13, sprites:["necromantBossSpecial0", "necromantBossSpecial1", "necromantBossSpecial2", "necromantBossSpecial3", "necromantBossSpecial4", "necromantBossSpecial5", "necromantBossSpecial6", "necromantBossSpecial7", "necromantBossSpecial8", "necromantBossSpecial9", "necromantBossSpecial10", "necromantBossSpecial11", "necromantBossSpecial12"]};
    Game.animations.necromantBossPosohUp = {playTime: 2500*13/26, count: 13, sprites:["necromantBossSpecial13", "necromantBossSpecial14", "necromantBossSpecial15", "necromantBossSpecial16", "necromantBossSpecial17", "necromantBossSpecial18", "necromantBossSpecial19", "necromantBossSpecial20", "necromantBossSpecial21", "necromantBossSpecial22", "necromantBossSpecial23", "necromantBossSpecial24", "necromantBossSpecial25"]};

    Game.enemyList.necromantBoss = {
        cost:10,
        icon: 'necromantBossRun0',
        n:'necromantBoss',
        e:'graveyard',
        boss:true,
        hitPoints: 115,
        damage: 25,
        timeOut: 1500,
        speed: 9,
        penetration: 0.5,
        lifeCost: 1000,
        hitPosition: new Vec2(0,-120),
        hitRange: 10,
        attackRange: Game.tileWidth,
        animations:{fight:['necromantBossFight1', 'necromantBossFight2'], idle:'necromantBossIdle', die:'necromantBossDie', cast1:'necromantBossPosohDown', cast2:'necromantBossPosohUp', cast:'necromantBossSpecial', run:'necromantBossRun'},
        type: "enemy",
        strategy: function(){
            var len, target, key;
            this.scanTimeOut -= Game.cycleTickTime*Game.speed;
            this.timeOut -= Game.cycleTickTime*Game.speed;
            this.freezeTimeout -= Game.cycleTickTime*Game.speed;

            if (this.timeOut > 0)
                return;

            if (this.state == 'walk') {
                if (this.freezeTimeout  < 0) {
                    this.freezeTimeout = this.base.freezeTimeout;
                    this.timeOut = Game.animations[this.animations['cast']].playTime;
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['cast'], this.animation);

                    var buildings = [];
                    if (Game.lvl.objBuildings.length >= (this.deathCounter * 2) + 1) {
                        Game.lvl.audioPool.get('NecroCast', 'NecroCast', 0.3, 1).play();
                        while (buildings.length < this.deathCounter*2) {
                            var mtarget = Game.lvl.objBuildings[myRandom(1, Game.lvl.objBuildings.length)];
                            if (buildings.indexOf(mtarget) == -1)
                                buildings.push(mtarget);
                        }
                        buildings.forEach(function(building) {
                            building.disabled = this.base.freezeTime;
                            Game.lvl.objEffect.push(new NecroRootsEffect(building.position, this.base.freezeTime));
                            if (building.units && building.units.length > 0){
                                building.units.forEach(function(unit) {
                                    if (unit.hitPoints > 0) {
                                        Game.lvl.objEnemy.push(new Enemy(Game.enemyList.zombie, unit.position.x, unit.position.y, 'TownHall', 1));
                                        unit.applyDamage(100000, null);
                                    }
                                }.bind(this))
                            }
                        }.bind(this))
                    }
                    return;
                }

                this.scanEnemyAround();
                if (this.target) {
                    this.fight = true;
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['fight'][this.fightAnim], this.animation);
                    this.animation.onComplete = Enemy.prototype.switchFight.bind(this);
                    this.timeOut = this.base.timeOut;
                    this.target.applyDamage(this.damage, this);
                    this.animation.setDirection(this.target.position.clone().sub(this.position).getDirection());
                } else {
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['run'], this.animation);
                    if (this.path.length > 0) {
                        if (this.currectTarget.hitPoints > 0) {
                            this.move();
                        } else {
                            this.path = [];
                        }
                    } else {
                        this.timeOut = 100;
                        this.searchPath();
                    }
                }
            } else if (this.state == 'summon') {
                Game.lvl.audioPool.get('NecroBloodSpawn', 'NecroBloodSpawn', 0.3, 1).play();
                this.spawnTimeout -= Game.cycleTickTime*Game.speed;
                this.summonStayTime -= Game.cycleTickTime*Game.speed;

                if (this.spawnTimeout < 0) {
                    this.spawnTimeout = this.spawnTimeoutBase;
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['cast1'], this.animation);
                    this.animation.loop = false;
                    this.animation.onComplete = function() {
                        this.staff.emit = true;
                        this.animation.onComplete = null;
                        setTimeout(function() {
                            if (this.hitPoints > 0) {
                                this.animation = Game.lvl.pool.switchAnimation(this.animations['cast2'], this.animation);
                                this.animation.loop = false;
                                this.animation.onComplete = function(){
                                    this.animation.onComplete = null;
                                    setTimeout(function() {
                                        if (this.hitPoints > 0) {
                                            this.animation = Game.lvl.pool.switchAnimation(this.animations['idle'], this.animation);
                                        }
                                    }.bind(this),1);
                                }.bind(this);
                            }
                        }.bind(this),1);
                        var hp = this.spawnHpBase;
                        while (hp > 0) {
                            var rndX, rndY, enemyType, ent;
                            enemyType = null;
                            switch (myRandom(0, 5)) {
                                case 0:
                                    enemyType = Game.enemyList.skeleton;
                                    break;
                                case 1:
                                    enemyType = Game.enemyList.undeadMage;
                                    break;
                                case 3:
                                    enemyType = Game.enemyList.redSkeleton;
                                    break;
                                case 4:
                                    enemyType = Game.enemyList.skeletonArcher;
                                    break;
                            }
                            if (enemyType) {
                                hp -= enemyType.hitPoints;
                                var tile = Game.lvl.objMap.getClosesEmptyTile(new Vec2(128 + myPofigRandom(-96, +96), 832 - myPofigRandom(-96, +96)));
                                var enemy = new Enemy(enemyType, tile.position.x, tile.position.y, 'TownHall', 1);
                                Game.lvl.objEnemy.push(enemy);
                            }
                        }
                    }.bind(this);
                    return;
                }

                if (this.summonStayTime < 0) {
                    this.state = 'walk';
                    this.blood.emit = false;
                    return;
                }
            } else {

            }
        },
        onDeath : function (){
        },
        init: function(){
            this.music = new MyAudio('graveyardboss', true, 0.4);
            this.music.play();
            Game.lvl.audioPool.get('NecroSpawn', 'NecroSpawn', 0.3, 1).play();
            this.hitPointsMultiply = 3;
            this.deathCounter = 1;
            this.animation = Game.lvl.pool.switchAnimation(this.animations['run'], this.animation);

            this.spawnTimeout = this.base.spawnTimeout;
            this.spawnTimeoutBase  = this.base.spawnTimeout;
            this.spawnHpBase  = this.base.spawnHp;

            this.alredySummoned = false;

            this.freezeTimeout = myRandom(5000, this.base.freezeTimeout);
            this.summonStayTime = this.base.summonStayTime;

            this.path3 = [Game.lvl.objMap.getTile(new Vec2(1248,736)),Game.lvl.objMap.getTile(new Vec2(1248,800)),Game.lvl.objMap.getTile(new Vec2(1184,864)),Game.lvl.objMap.getTile(new Vec2(608,864)),Game.lvl.objMap.getTile(new Vec2(544,800)), Game.lvl.objMap.getTile(new Vec2(256, 768)), Game.lvl.objMap.getTile(new Vec2(128, 768)), Game.lvl.objMap.getTile(new Vec2(160,416)),Game.lvl.objMap.getTile(new Vec2(160,288)),Game.lvl.objMap.getTile(new Vec2(224,224)),Game.lvl.objMap.getTile(new Vec2(544,224)),Game.lvl.objMap.getTile(new Vec2(736,416)),Game.lvl.objMap.getTile(new Vec2(800,480)),Game.lvl.objMap.getTile(new Vec2(1760,480)),Game.lvl.objMap.getTile(new Vec2(1824,544)),Game.lvl.objMap.getTile(new Vec2(1952,672)),Game.lvl.objMap.getTile(new Vec2(2016,672))];
            this.path2 = [Game.lvl.objMap.getTile(new Vec2(1248,736)),Game.lvl.objMap.getTile(new Vec2(608,736)),Game.lvl.objMap.getTile(new Vec2(544,800)), Game.lvl.objMap.getTile(new Vec2(256, 768)), Game.lvl.objMap.getTile(new Vec2(128, 832)), Game.lvl.objMap.getTile(new Vec2(160,1184)), Game.lvl.objMap.getTile(new Vec2(160,1312)),Game.lvl.objMap.getTile(new Vec2(224,1376)),Game.lvl.objMap.getTile(new Vec2(544,1376)),Game.lvl.objMap.getTile(new Vec2(736,1184)),Game.lvl.objMap.getTile(new Vec2(800,1184)),Game.lvl.objMap.getTile(new Vec2(1120,1184)),Game.lvl.objMap.getTile(new Vec2(1312,1184)),Game.lvl.objMap.getTile(new Vec2(1376,1184)),Game.lvl.objMap.getTile(new Vec2(1632,1184)),Game.lvl.objMap.getTile(new Vec2(1696,1120)),Game.lvl.objMap.getTile(new Vec2(1760,1120)),Game.lvl.objMap.getTile(new Vec2(1824,1056)),Game.lvl.objMap.getTile(new Vec2(1824,992)),Game.lvl.objMap.getTile(new Vec2(2016,800))];
            this.path = [Game.lvl.objMap.getTile(new Vec2(1248,736)),Game.lvl.objMap.getTile(new Vec2(1248,800)),Game.lvl.objMap.getTile(new Vec2(1184,864)),Game.lvl.objMap.getTile(new Vec2(608,864)),Game.lvl.objMap.getTile(new Vec2(544,800)), Game.lvl.objMap.getTile(new Vec2(256, 768)), Game.lvl.objMap.getTile(new Vec2(128, 768)), Game.lvl.objMap.getTile(new Vec2(160,416)),Game.lvl.objMap.getTile(new Vec2(160,288)),Game.lvl.objMap.getTile(new Vec2(224,224)),Game.lvl.objMap.getTile(new Vec2(544,224)),Game.lvl.objMap.getTile(new Vec2(736,416)),Game.lvl.objMap.getTile(new Vec2(800,480)),Game.lvl.objMap.getTile(new Vec2(1760,480)),Game.lvl.objMap.getTile(new Vec2(1824,544)),Game.lvl.objMap.getTile(new Vec2(1952,672)),Game.lvl.objMap.getTile(new Vec2(2016,672))];

            this.state = 'walk';

            this.checkMove = function () {
                var newTile = Game.lvl.objMap.getTile(this.position);
                if (newTile!= this.tile) {
                    if ((newTile.objects.length > 0)&&(!this.flying)&&((this.directionDirect)||(newTile.objects[0]==this.currectTarget))) {
                        this.target = newTile.objects[0];
                        this.animation = Game.lvl.pool.switchAnimation(this.animations['fight'][this.fightAnim], this.animation);
                        return false;
                    }

                    if (this.tile)
                        this.tile.eObjects.splice(this.tile.eObjects.indexOf(this), 1);

                    this.tile = newTile;
                    this.tile.eObjects.push(this);
                    if (!this.alredySummoned && newTile.position.clone().sub(Game.lvl.objMap.getTile(new Vec2(256, 768)).position).getLength() < 32) {
                        this.alredySummoned = true;
                        this.summonStayTime = this.base.summonStayTime;
                        this.spawnTimeout = 0;
                        this.state = 'summon';
                        this.blood.emit = true;
                        this.timeOut = 2000;
                        this.invulnerable = 2000;

                        this.animation = Game.lvl.pool.switchAnimation(this.animations['idle'], this.animation);
                        this.animation.setDirection(1);
                        this.staff.updateSpawnPos(this.position.x + 96, this.position.y);
                        this.animation.onComplete = null;
                    }
                }
                return true;
            };

            var config = clone(Game.particlesList['Blood_Bath']);
            config.pos.x = 128;
            config.pos.y = 812;
            var textures = [];
            config.images.forEach(function(image){
                textures.push(PIXI.TextureCache[image])
            });
            this.blood = new cloudkid.Emitter(
                Game.lvl.containerForParticle(config),
                textures,
                config
            );
            this.blood.emit = false;

            config = clone(Game.particlesList['Necroboss staff splash']);
            config.pos.x = 0;
            config.pos.y = 0;
            textures = [];
            config.images.forEach(function(image){
                textures.push(PIXI.TextureCache[image])
            });
            this.staff = new cloudkid.Emitter(
                Game.lvl.containerForParticle(config),
                textures,
                config
            );
            this.staff.emit = false;

            config = clone(Game.particlesList['UndeadBOSS']);
            config.pos.x = 0;
            config.pos.y = 0;
            textures = [];
            config.images.forEach(function(image){
                textures.push(PIXI.TextureCache[image])
            });
            this.souls = new cloudkid.Emitter(
                Game.lvl.containerForParticle(config),
                textures,
                config
            );
            this.souls.emit = false;

            Game.lvl.objPartilces.push(this.souls);
            Game.lvl.objPartilces.push(this.staff);
            Game.lvl.objPartilces.push(this.blood);

            this.onDeath = function() {
                this.alreadyDead = true;
                if (this.deathCounter < 3) {
                    this.blood.emit = false;
                    this.alredySummoned = false;
                    this.state = 'walk';
                    this.deathCounter++;
                    this.spawnTimeoutBase  = this.base['spawnTimeout'+this.deathCounter];
                    this.spawnHpBase = this.base['spawnHp'+this.deathCounter];
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['die'], this.animation);
                    this.animation.loop = false;
                    this.animation.onComplete = function() {
                        this.animation.onComplete = null;
                        this.alreadyDead = false;
                        this.position.set(2148, 768);
                        this.path = this['path'+this.deathCounter];
                        this.hitPoints = this.maxHitPoints*(this.deathCounter == 2 ? 0.75 : 0.5);
                        if (!this.hitPointsEffect)
                            this.hitPointsEffect = new hitPointsEffect(this);
                        this.invulnerable = 5000;
                        this.timeOut = 5000;
                        Game.lvl.audioPool.get('NecroRise', 'NecroRise', 0.3, 1).play();
                    }.bind(this)
                } else {
                    Game.events.emit('killnecro');
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['die'], this.animation);
                    this.animation.loop = false;
                    this.animation.onComplete = function(){
                        this.souls.updateSpawnPos(this.position.x, this.position.y);
                        this.souls.emit = true;
                        setTimeout(function(){
                            if (Game.lvl.objEnemy.indexOf(this)!=-1)
                                Game.lvl.objEnemy.splice(Game.lvl.objEnemy.indexOf(this), 1);
                        }.bind(this), 5000);
                    }.bind(this)
                }
            };
        }
    };
}