﻿function loadFriendly(){

    Game.friendlyList.warrior = {
        canAttackFly: false,
        height: 100,
        hitPoints: 40,
        timeOut: 300,
        moveRange: 2*Game.tileWidth,
        attackRange: Game.tileWidth,
        icon: 'gruntIco',
        damage: 4,
        speed: 6,
        hitPosition: new Vec2(0,-50),
        hitRange: 10,
        animations:{idle:'heroIdle', fight:['heroFight1', 'heroFight2', 'heroFight3'], die:'heroDie', run:'heroRun'},
        unitName: 'hero',
        type: "friendly",
        cost: 3,
        soundCCGroup:'CCSword',
        soundCC:['Mele_01',	'Mele_02', 'Mele_03', 'Mele_04', 'Mele_05'],
        soundCCVolume:0.2,
        soundCCLimit:4,
        soundDeathGroup:'heroDeath',
        soundDeath:'HeroOrcWarDeath',
        soundDeathVolume:0.3,
        soundDeathLimit:1,
        subtype:'orcs',
        onDeath: function () {
            this.animation = Game.lvl.pool.switchAnimation(this.animations['die'], this.animation); this.animation.loop = false; this.animation.randomizeTime = 0; this.animation._currentTime = 0;
            if (this.moveRange > 0)
                this.cluster.release();
            this.animation.loop = false;
            this.deadTimer = 30*20;
            this.animation.onComplete = function(){
            }.bind(this);
        },
        init: function(){
            this.ability1Sound = Game.lvl.audioPool.get('ability1', 'OrcHeroWarCharge', 0.3, 1);
            this.ability2Sound = Game.lvl.audioPool.get('ability2', 'OrcHeroWarBuf', 0.3, 1);
            this.heroSelect = Game.lvl.audioPool.get('select', 'HeroOrcOrder01', 0.3, 1);
            this.heroOrder = Game.lvl.audioPool.get('heroOrder', ['HeroOrcOrder02', 'HeroOrcOrder03', 'HeroOrcOrder04', 'HeroOrcOrder05', 'HeroOrcOrder06', 'HeroOrcOrder07'], 0.3, 1);

            this.hero = true;
            this.abilityPlay = 0;
            this.nextAbility = '';
            this.ability1 = function(position, gui) {
                var that = this;
                gui.cd = this.base.chargeCD;
                gui.fullCd = this.base.chargeCD;
                var tiles = [], tempPos, tempTile;
                for (var i = 0; i <= 4; i+=1){
                    tempPos = this.position.clone().add(position.clone().sub(this.position).normalize().multiply(i*64));
                    for (var x = -64; x <=64; x+=64){
                        for (var y = -64; y <=64; y+=64){
                            tempTile = Game.lvl.objMap.getTruthTile(tempPos.clone().add(new Vec2(x, y)));
                            if (tempTile && tiles.indexOf(tempTile) == -1) {
                                tempTile.queue = i;
                                tiles.push(tempTile);
                            }
                        }
                    }
                }
                tiles.forEach(function (tile) {
                    tile.eObjects.forEach(function (enemy){
                        enemy.applyDamage(that.base.chargeDamage*(1+Game.globallogic.selectedHero.lvl/20));
                    });
                });
                var effect = new Knifes(this.position, Math.PI/2 - position.clone().sub(this.position).getRotate());
                Game.lvl.objEffect.push(effect);
            }.bind(this);

            this.ability2 = function(position, gui) {
                var that = this;
                this.animation = Game.lvl.pool.switchAnimation('heroTaunt', this.animation);
                this.animation.loop = false;
                this.abilityPlay =  1500;
                gui.cd = this.base.auraCD*(1-Game.globallogic.selectedHero.lvl/40);
                gui.fullCd = this.base.auraCD*(1-Game.globallogic.selectedHero.lvl/40);
                Game.lvl.objFriendly.forEach(function(friendly){
                    Buf.prototype.addBuf(friendly, 'armor', 'armor', this.base.auraArmorBoost, 'multy1', this.base.auraTime, 'Buff01', Game.lvl.underEffectContainer, 'ArmorBuff', null);
                }.bind(this))
            }.bind(this)
        }
    };

    Game.friendlyList.fireMage = {
        canAttackFly: true,
        height: 100,
        hitPoints: 40,
        timeOut: 300,
        moveRange: 0,
        attackRange: 390,
        icon: 'gruntIco',
        damageType:'magic',
        damage: 4,
        speed: 6,
        hitPosition: new Vec2(0,-32),
        hitRange: 10,
        animations:{idle:'HeroShamanIdle', fight:['HeroShamanCast1', 'HeroShamanCast2'], die:'HeroShamanDeath1', run:'HeroShamanRun', cc:'HeroShamanCC'},
        unitName: 'hero',
        type: "friendly",
        cost: 3,
        soundShootGroup:'FireMageArrow',
        soundShoot:'ShamnHeroShoot',
        soundShootVolume:0.2,
        soundShootLimit:3,
        soundDeathGroup:'heroDeath',
        soundDeath:['Goblin Death 1', 'Goblin Death 2'],
        soundDeathVolume:0.3,
        soundDeathLimit:1,
        soundCCGroup:'CCLightSword',
        soundCC:['LightMele01', 'LightMele02', 'LightMele03'],
        soundCCVolume:0.2,
        soundCCLimit:3,
        subtype:'goblins',
        strategy: function() {
            var direction;
            this.timeOut -= Game.cycleTickTime;
            this.scanTimeOut -= Game.cycleTickTime;
            if (this.timeOut > 0)
                return;

            if (this.basePosition.clone().sub(this.position).getLength() < 32) {
                this.scanEnemyAround();
                if (this.target){
                    direction = this.target.position.clone().sub(this.position);
                    this.animation.setDirection(direction.getDirection());
                    if (direction.getLength() < this.attackRange){
                        this.timeOut = this.base.timeOut;
                        this.animation = Game.lvl.pool.switchAnimation(this.animations['fight'][this.fightAnim], this.animation);

                        if (direction.getLength() > 64) {
                            this.soundShoot && this.soundShoot.play();
                            direction.sub(direction.clone().normalize().multiply(32));
                            Game.lvl.objEffect.push(new Arrow(this.position.clone().add(new Vec2(0, -76)), this.target, Game.animations.fireBall, 1.25,  direction.getLength()*1.5, true,
                                function(){
                                    Game.lvl.objEffect.push(new Effect(this.target.position.clone(), this.direction.normalize(), Game.lvl.objEffect, Game.animations.fireHit, 400, 2));
                                    this.target.applyDamage(this.parent.damage, this.parent);
                                }, null, this));
                        } else {
                            this.soundCC && this.soundCC.play();
                            this.target.applyDamage(this.damage, this);
                            this.animation.setDirection(direction.getDirection());
                            this.animation = Game.lvl.pool.switchAnimation(this.animations['cc'], this.animation);
                        }
                    }
                } else {
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['idle'], this.animation);
                }
            } else {
                if (this.path.length > 0)
                    this.move();
                else if ((direction = this.basePosition.clone().sub(this.position)).getLength() > 32){
                    if ((this.path = Game.lvl.objMap.getPath(this.position, this.basePosition, this.basePosition, this.moveRange + this.attackRange)).length == 0){
                        if ((this.path = Game.lvl.objMap.getPath(this.position, this.basePosition)).length == 0)
                            this.path = [Game.lvl.objMap.getTile(this.basePosition)]
                    }
                } else {
                    this.timeOut = this.base.timeOut;
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['idle'][this.fightAnim], this.animation);
                }
            }
        },
        onDeath: function () {
            this.deadTimer = 30*20;
            this.animation = Game.lvl.pool.switchAnimation(this.animations['die'], this.animation); this.animation.loop = false; this.animation.randomizeTime = 0; this.animation._currentTime = 0;
            if (this.moveRange > 0)
                this.cluster.release();
            this.animation.onComplete = function(){
            }.bind(this);
        },
        init: function(){
            this.ability1Sound = Game.lvl.audioPool.get('ability1', 'ShamnHeroMeteorCast', 0.3, 1);
            this.ability2Sound = Game.lvl.audioPool.get('ability2', 'Heal_Scroll', 0.3, 1);
            this.heroSelect = Game.lvl.audioPool.get('select', ['Hero Goblin Order 1', 'Hero Goblin Order 2'], 0.3, 1);
            this.heroOrder = Game.lvl.audioPool.get('heroOrder', ['Hero Goblin Order 3', 'Hero Goblin Order 4', 'Hero Goblin Order 4', 'Hero Goblin Order 5', 'Hero Goblin Order 6'], 0.3, 1);

            this.scanEnemyAround = this.scanEnemyAroundArcher;
            this.strategy = this.base.strategy;
            this.hero = true;
            this.abilityPlay = 0;
            this.nextAbility = '';
            this.ability1 = function(position, gui) {
                gui.cd = this.base.meteoriteCD;
                gui.fullCd = this.base.meteoriteCD;
                this.animation = Game.lvl.pool.switchAnimation(this.animations['fight'][0], this.animation);
                this.animation._currentTime = 0;
                this.abilityPlay = 700;
                Game.lvl.objEffect.push(new MeteoritteFireMage(position, this.base.meteoriteDamageMain*(1+Game.globallogic.selectedHero.lvl/20), 2, true));
            }.bind(this);

            this.ability2 = function(position, gui){
                var that = this;
                this.animation = Game.lvl.pool.switchAnimation(this.animations['fight'][0], this.animation);
                this.animation._currentTime = 0;
                this.abilityPlay = 700;
                gui.cd = this.base.buffCD*(1-Game.globallogic.selectedHero.lvl/40);
                gui.fullCd = this.base.buffCD*(1-Game.globallogic.selectedHero.lvl/40);
                Game.lvl.objFriendly.forEach(function(friendly){
                    Buf.prototype.addBuf(friendly, 'healHero', 'hitPoints', this.base.buffHealPerSecond, 'heal', this.base.buffTime, 'heal', Game.lvl.effectContainer, 'LVLUP', null);
                }.bind(this))
            }.bind(this)
        }
    };

    Game.friendlyList.archer = {
        canAttackFly: true,
        height: 100,
        hitPoints: 40,
        timeOut: 300,
        attackRange: 520,
        icon: 'gruntIco',
        damage: 4,
        moveRange: 0,
        speed: 6,
        hitPosition: new Vec2(0,-32),
        hitRange: 10,
        animations:{idle:'heroSnipperIdle', shoot:'heroSnipperShoot', die:'heroSnipperDie', fight:['heroSnipperCC', 'heroSnipperCC2'], cast:'heroSnipperCast', run:'heroSnipperRun'},
        unitName: 'hero',
        type: "friendly",
        cost: 3,
        soundShootGroup:'ArrowTower',
        soundShoot:'ArrowTower',
        soundShootVolume:0.2,
        soundShootLimit:4,
        soundCCGroup:'CCLightSword',
        soundCC:['LightMele01', 'LightMele02', 'LightMele03'],
        soundCCVolume:0.2,
        soundCCLimit:3,
        soundDeathGroup:'heroDeath',
        soundDeath:['Goblin Death 1', 'Goblin Death 2'],
        soundDeathVolume:0.3,
        soundDeathLimit:1,
        subtype:'goblins',
        strategy: function(){
            var direction;
            this.timeOut -= Game.cycleTickTime*Game.speed;
            this.scanTimeOut -= Game.cycleTickTime*Game.speed;
            if (this.timeOut > 0)
                return;

            if (this.basePosition.clone().sub(this.position).getLength() < 32) {
                this.scanEnemyAround();
                if (this.target) {
                    direction = this.target.position.clone().sub(this.position);
                    if (direction.getLength() > 64) {
                        this.animation.setDirection(direction.getDirection());
                        this.animation = Game.lvl.pool.switchAnimation(this.animations['shoot'], this.animation);
                        this.animation._currentTime = 0;
                        this.animation.play();
                        this.animation.loop = false;
                        direction = this.position.clone().sub(this.target.position);
                        direction.sub(direction.clone().normalize().multiply(32));
                        this.soundShoot && this.soundShoot.play();
                        Game.lvl.objEffect.push(new Arrow(this.position.clone().add(new Vec2(0, -48)), this.target, Game.sprites.arrow, 1, direction.getLength(), false, function(){
                            this.target.applyDamage(this.parent.damage, this.parent);
                        }, 400, this));
                    } else {
                        this.soundCC && this.soundCC.play();
                        this.target.applyDamage(this.damage, this);
                        this.animation.setDirection(direction.getDirection());
                        this.animation = Game.lvl.pool.switchAnimation(this.animations['fight'][this.fightAnim], this.animation);
                    }
                    this.timeOut = this.base.timeOut;
                } else {
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['idle'], this.animation);
                }
            } else {
                if (this.path.length > 0)
                    this.move();
                else if ((direction = this.basePosition.clone().sub(this.position)).getLength() > 32){
                    if ((this.path = Game.lvl.objMap.getPath(this.position, this.basePosition, this.basePosition, this.moveRange + this.attackRange)).length == 0){
                        if ((this.path = Game.lvl.objMap.getPath(this.position, this.basePosition)).length == 0)
                            this.path = [Game.lvl.objMap.getTile(this.basePosition)]
                    }
                } else {
                    this.timeOut = this.base.timeOut;
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['idle'][this.fightAnim], this.animation);
                }
            }
        },
        onDeath: function () {
            this.deadTimer = 30*20;
            this.animation = Game.lvl.pool.switchAnimation(this.animations['die'], this.animation); this.animation.loop = false; this.animation.randomizeTime = 0; this.animation._currentTime = 0;
            if (this.moveRange > 0)
                this.cluster.release();
            this.animation.onComplete = function(){
            }.bind(this);
        },
        init: function(){
            this.ability1Sound = Game.lvl.audioPool.get('ability1', 'ArrowTower', 0.3, 1);
            this.ability2Sound = Game.lvl.audioPool.get('ability2', 'HeroRanger_Buff', 0.3, 1);
            this.heroSelect = Game.lvl.audioPool.get('select', ['Hero Goblin Order 1', 'Hero Goblin Order 2'], 0.3, 1);
            this.heroOrder = Game.lvl.audioPool.get('heroOrder', ['Hero Goblin Order 3', 'Hero Goblin Order 4', 'Hero Goblin Order 4', 'Hero Goblin Order 5', 'Hero Goblin Order 6'], 0.3, 1);

            this.scanEnemyAround = this.scanEnemyAroundArcher;
            this.strategy = this.base.strategy;
            this.hero = true;
            this.abilityPlay = 0;
            this.nextAbility = '';
            this.ability1 = function(position, gui){
                gui.cd = this.base.rocketCD;
                gui.fullCd = this.base.rocketCD;
                this.animation = Game.lvl.pool.switchAnimation(this.animations['fight'][0], this.animation);
                this.animation._currentTime = 0;
                this.animation.setDirection(position.clone().sub(this.position).getDirection());
                var oldAnim = this.animation;
                oldAnim.loop = false;
                this.abilityPlay = 700;
                var tempTile;
                Game.lvl.objEffect.push(
                    new CustomArcherArrow(this.position.clone(), this.position.clone().sub(position) > 800 ? this.position.clone().sub(position)*2 : 600, position, this, Game.sprites.arrow, false, function() {
                        oldAnim.loop = true;
                        for (var x = -64 * 2; x <=64*2; x+=64){
                            for (var y = -64*2; y <=64*2; y+=64){
                                tempTile = Game.lvl.objMap.getTruthTile(position.clone().add(new Vec2(x, y)));
                                if (tempTile) {
                                    tempTile.eObjects.forEach(function(enemy){
                                        enemy.applyDamage(this.base.rocketDamage*(1+Game.globallogic.selectedHero.lvl/20));
                                    }.bind(this));
                                }
                            }
                        }
                        Game.lvl.objEffect.push(new BoomFx(position, 1));
                    }.bind(this)))
            }.bind(this);

            this.ability2 = function(position, gui){
                var that = this;
                this.animation = Game.lvl.pool.switchAnimation(this.animations.cast, this.animation);
                this.animation.loop = false;
                this.abilityPlay =  1500;
                gui.cd = this.base.buffTime*(1-Game.globallogic.selectedHero.lvl/40);
                gui.fullCd = this.base.buffTime*(1-Game.globallogic.selectedHero.lvl/40);
                Game.lvl.objFriendly.forEach(function(friendly) {
                    if (friendly.base.canAttackFly) {
                        Buf.prototype.addBuf(friendly, 'critical', 'criticalChance', this.base.buffCriticalGain, 'multy1', this.base.buffTime, 'Buff01', Game.lvl.underEffectContainer, 'LVLUP', null);
                        Buf.prototype.addBuf(friendly, 'range', 'attackRange', this.base.buffRangeGain, 'multy', this.base.buffTime, null, null, null, null);
                    }
                }.bind(this));
                Game.lvl.objBuildings.forEach(function(friendly) {
                    if (friendly.range && !friendly.catapultaPosition) {
                        //Buf.prototype.addBuf(friendly, 'critical', 'criticalChance', this.base.buffCriticalGain, 'multy1', this.base.buffTime, 'Buff01', Game.lvl.underEffectContainer, 'LVLUP', null);
                        Buf.prototype.addBuf(friendly, 'range', 'range', this.base.buffRangeGain, 'multy', this.base.buffTime, null, null, null, null);
                    }
                }.bind(this))
            }.bind(this)        }
    };

    Game.friendlyList.wolfRider = {
        canAttackFly: false,
        height: 100,
        hitPoints: 40,
        timeOut: 300,
        moveRange: 3*Game.tileWidth,
        attackRange: Game.tileWidth,
        icon: 'gruntIco',
        damage: 4,
        speed: 6,
        hitPosition: new Vec2(0,-64),
        hitRange: 10,
        animations:{idle:'heroRiderIdle', fight:['heroRiderAttack1'], die:'heroRiderDie', run:'heroRiderRun', cast:'heroRiderCast'},
        unitName: 'hero',
        type: "friendly",
        cost: 3,
        soundCCGroup:'CCSword',
        soundCC:['Mele_01',	'Mele_02', 'Mele_03', 'Mele_04', 'Mele_05'],
        soundCCVolume:0.2,
        soundCCLimit:4,
        soundDeathGroup:'heroDeath',
        soundDeath:'HeroWolfDeath',
        soundDeathVolume:0.3,
        soundDeathLimit:1,
        subtype:'orcs',
        onDeath: function () {
            this.animation = Game.lvl.pool.switchAnimation(this.animations['die'], this.animation); this.animation.loop = false; this.animation.randomizeTime = 0; this.animation._currentTime = 0;
            if (this.moveRange > 0)
                this.cluster.release();
            this.deadTimer = 30*20;
            this.animation.onComplete = function(){
            }.bind(this);
        },
        init: function(){
            this.ability1Sound = Game.lvl.audioPool.get('ability1', 'HeroWolfWeb', 0.3, 1);
            this.ability2Sound = Game.lvl.audioPool.get('ability2', 'HeroWolfBuf', 0.3, 1);
            this.heroSelect = Game.lvl.audioPool.get('select', 'HeroOrcOrder01', 0.3, 1);
            this.heroOrder = Game.lvl.audioPool.get('heroOrder', ['HeroOrcOrder02', 'HeroOrcOrder03', 'HeroOrcOrder04', 'HeroOrcOrder05', 'HeroOrcOrder06', 'HeroOrcOrder07'], 0.3, 1);

            this.hero = true;
            this.abilityPlay = 0;
            this.nextAbility = '';
            this.ability1 = function(position, gui) {
                var that = this;
                gui.cd = this.base.webCD;
                gui.fullCd = this.base.webCD;
                Game.lvl.objEffect.push(new EffectSmallAlpa(this.position.clone(),Game.lvl.effectContainer, Game.sprites.WebField, that.base.webTime));
                var tiles = [], tempPos, tempTile;
                //for (var i = 0; i <= 4; i+=1) {
                    //tempPos = this.position.clone().add(position.clone().sub(this.position).normalize().multiply(i*64));
                    for (var x = -64*3; x <=64*3; x+=64){
                        for (var y = -64*3; y <=64*3; y+=64){
                            tempTile = Game.lvl.objMap.getTruthTile(this.position.clone().add(new Vec2(x, y)));
                            if (tempTile && tiles.indexOf(tempTile) == -1) {
                                tempTile.eObjects.forEach(function(enemy) {
                                    if (enemy.hitPoints > 0 && !enemy.base.boss) {
                                        Buf.prototype.addBuf(enemy, 'freze', 'speed', 1, 'div', that.base.webTime, 'WebCage', Game.lvl.effectContainer, null, null, this);
                                        enemy.frezeTimeout = that.base.webTime;
                                        enemy.animation.stop();
                                    }
                                });
                                tiles.push(tempTile);
                            }
                        }
                    }
                //}
            }.bind(this);

            this.ability2 = function(position, gui){
                var that = this;
                this.animation = Game.lvl.pool.switchAnimation('heroRiderCast', this.animation);
                this.animation.loop = false;
                this.abilityPlay =  1500;
                gui.cd = this.base.buffCD*(1-Game.globallogic.selectedHero.lvl/40);
                gui.fullCd = this.base.buffCD*(1-Game.globallogic.selectedHero.lvl/40);
                Game.lvl.objFriendly.forEach(function(friendly){
                    Buf.prototype.addBuf(friendly, 'timeout', 'timeout', this.base.buffAttackSpeedGain, 'minus', this.base.buffTime, 'Buff01', Game.lvl.underEffectContainer, 'ArmorBuff', null);
                }.bind(this))
            }.bind(this)
        }
    };

    Game.friendlyList.ogre = {
        canAttackFly: false,
        height: 100,
        hitPoints: 40,
        timeOut: 300,
        moveRange: 3*Game.tileWidth,
        attackRange: Game.tileWidth,
        icon: 'gruntIco',
        damage: 4,
        speed: 6,
        hitPosition: new Vec2(0,-80),
        hitRange: 10,
        animations:{idle:'heroOgreIdle', fight:['heroOgreAttack1', 'heroOgreAttack2', 'heroOgreAttack3'], die:'heroOgreDie', run:'heroOgreRun', cast:'heroOgreCast'},
        unitName: 'hero',
        type: "friendly",
        cost: 3,
        soundCCGroup:'CCOgre',
        soundCC:['Ogre_Hero_Mele_01', 'Ogre_Hero_Mele_02', 'Ogre_Hero_Mele_03', 'Ogre_Hero_Mele_04'],
        soundCCVolume:0.2,
        soundCCLimit:1,
        soundDeathGroup:'heroDeath',
        soundDeath:'Hero Ogre Death',
        soundDeathVolume:0.3,
        soundDeathLimit:1,
        subtype:'ogres',
        onDeath: function () {
            this.animation = Game.lvl.pool.switchAnimation(this.animations['die'], this.animation); this.animation.loop = false; this.animation.randomizeTime = 0; this.animation._currentTime = 0;
            if (this.moveRange > 0)
                this.cluster.release();
            this.deadTimer = 30*20;
            this.animation.onComplete = function(){
            }.bind(this);
        },
        init: function(){
            this.ability1Sound = Game.lvl.audioPool.get('ability1', 'Hero Ogre Splash', 0.3, 1);
            this.ability2Sound = Game.lvl.audioPool.get('ability2', 'Hero Ogre Regen', 0.3, 1);
            this.heroSelect = Game.lvl.audioPool.get('select', 'HeroOrcOrder01', 0.3, 1);
            this.heroOrder = Game.lvl.audioPool.get('heroOrder', ['HeroOrcOrder02', 'HeroOrcOrder03', 'HeroOrcOrder04', 'HeroOrcOrder05', 'HeroOrcOrder06', 'HeroOrcOrder07'], 0.3, 1);

            this.hero = true;
            this.abilityPlay = 0;
            this.nextAbility = '';
            this.ability1 = function(position, gui){
                this.animation = Game.lvl.pool.switchAnimation(this.animations.cast, this.animation);
                this.animation.loop = false;
                this.abilityPlay =  1500;
                this.timeOut = 1500;
                var that = this;
                gui.cd = this.base.smashCD;
                gui.fullCd = this.base.smashCD;
                var tiles = [], tempPos, tempTile;
                    tempPos = this.position.clone();
                    for (var x = -64*3; x <=64*3; x+=64) {
                        for (var y = -64*3; y <=64*3; y+=64) {
                            tempTile = Game.lvl.objMap.getTruthTile(tempPos.clone().add(new Vec2(x, y)));
                            if (tempTile && tiles.indexOf(tempTile) == -1) {
                                tiles.push(tempTile);
                            }
                        }
                    }
                tiles.forEach(function (tile) {
                    tile.eObjects.forEach(function (enemy) {
                        enemy.applyDamage(that.base.smashDamage*(1+Game.globallogic.selectedHero.lvl/20), that);
                    });
                });
                Game.lvl.objEffect.push(new EffectParticles(this.position, 'FlameSplash'));
                Game.lvl.objEffect.push(new BombLoonka(this.position, 2));
            }.bind(this);

            this.ability2 = function(position, gui){
                var that = this;
                this.animation = Game.lvl.pool.switchAnimation(this.animations.cast, this.animation);
                this.animation.loop = false;
                this.abilityPlay =  1500;
                this.timeOut = 1500;
                gui.cd = this.base.regenCD*(1-Game.globallogic.selectedHero.lvl/40);
                gui.fullCd = this.base.regenCD*(1-Game.globallogic.selectedHero.lvl/40);
                Buf.prototype.addBuf(this, 'armor', 'armor', this.base.regenArmorBoost, 'multy1', this.base.regenTime, 'Buff01', Game.lvl.underEffectContainer, 'ArmorBuff', null);
                Buf.prototype.addBuf(this, 'healHero', 'hitPoints', this.base.regenAmount, 'heal', this.base.regenTime, 'heal', Game.lvl.effectContainer, 'LVLUP', null);
            }.bind(this)
        }
    };

    Game.friendlyList.templarAssassin = {
        canAttackFly: false,
        height: 100,
        hitPoints: 40,
        timeOut: 300,
        moveRange: 3*Game.tileWidth,
        attackRange: Game.tileWidth,
        icon: 'gruntIco',
        damage: 4,
        speed: 6,
        hitPosition: new Vec2(0,-50),
        hitRange: 10,
        animations:{idle:'heroAssasinIdle', fight:['heroAssasinAttack1', 'heroAssasinAttack2', 'heroAssasinAttack3'], die:'heroAssasinDie', run:'heroAssasinRun', cast:'heroAssasinCast'},
        unitName: 'hero',
        type: "friendly",
        cost: 3,
        soundCCGroup:'CCSword',
        soundCC:['Mele_01', 'Mele_02', 'Mele_03', 'Mele_04', 'Mele_05'],
        soundCCVolume:0.2,
        soundCCLimit:4,
        soundDeathGroup:'heroDeath',
        soundDeath:'HeroAssasinDeath',
        soundDeathVolume:0.3,
        soundDeathLimit:1,
        subtype:'orcs',
        onDeath: function () {
            this.deadTimer = 30*20;
            this.animation = Game.lvl.pool.switchAnimation(this.animations['die'], this.animation); this.animation.loop = false; this.animation.randomizeTime = 0; this.animation._currentTime = 0;
            if (this.moveRange > 0)
                this.cluster.release();

            this.animation.onComplete = function(){

            }.bind(this);
        },
        init: function() {
            this.ability1Sound = Game.lvl.audioPool.get('ability1', 'AssasinShadowStrike', 0.3, 1);
            this.ability2Sound = Game.lvl.audioPool.get('ability2', 'Hero Ogre Regen', 0.3, 1);
            this.heroSelect = Game.lvl.audioPool.get('select', 'HeroOrcOrder01', 0.3, 1);
            this.heroOrder = Game.lvl.audioPool.get('heroOrder', ['HeroOrcOrder02', 'HeroOrcOrder03', 'HeroOrcOrder04', 'HeroOrcOrder05', 'HeroOrcOrder06', 'HeroOrcOrder07'], 0.3, 1);

            this.hero = true;
            this.abilityPlay = 0;
            this.nextAbility = '';


            this.ability1 = function(position, gui) {
                var that = this;
                gui.cd = this.base.shadowStrikeCD;
                gui.fullCd = this.base.shadowStrikeCD;
                var tiles = [], tempPos, tempTile;
                this.animation = Game.lvl.pool.switchAnimation(this.animations.cast, this.animation);
                this.animation.loop = false;
                this.abilityPlay = Game.animations[this.animations.cast].playTime;

                setTimeout(function(){
                    Game.lvl.objEffect.push(new AssasinFx(this.position, true));
                }.bind(this), (Game.animations[this.animations.cast].playTime-900)/Game.speed);
                setTimeout(function(){
                    Game.lvl.objEffect.push(new AssasinFx(Game.lvl.objMap.getClosesEmptyTile(position).position, false));
                }.bind(this), (Game.animations[this.animations.cast].playTime-700)/Game.speed);
                setTimeout(function() {
                    if (this.hitPoints <=0)
                        return;
                    tempPos = Game.lvl.objMap.getClosesEmptyTile(position).position;
                    this.position.set(tempPos.x, tempPos.y);
                    this.basePosition = tempPos.clone();
                    this.initCluster();
                    this.target = null;
                    for (var x = -64*this.base.shadowStrikeRadius; x <=64*this.base.shadowStrikeRadius; x+=64){
                        for (var y = -64*this.base.shadowStrikeRadius; y <=64*this.base.shadowStrikeRadius; y+=64){
                            tempTile = Game.lvl.objMap.getTruthTile(tempPos.clone().add(new Vec2(x, y)));
                            if (tempTile && tiles.indexOf(tempTile) == -1) {
                                tiles.push(tempTile);
                            }
                        }
                    }
                    tiles.forEach(function (tile) {
                        tile.eObjects.forEach(function (enemy){
                            enemy.applyDamage(that.base.shadowStrikeDamage*(1+Game.globallogic.selectedHero.lvl/20), that);
                        });
                    });
                }.bind(this), (Game.animations[this.animations.cast].playTime-400)/Game.speed);

            }.bind(this);

            this.ability2 = function(position, gui){
                var that = this;
                this.animation = Game.lvl.pool.switchAnimation(this.animations.cast, this.animation);
                this.animation.loop = false;
                this.abilityPlay =  1500;
                gui.cd = this.base.poisonCD*(1-Game.globallogic.selectedHero.lvl/40);
                gui.fullCd = this.base.poisonCD*(1-Game.globallogic.selectedHero.lvl/40);
                setTimeout(function() {
                    var tiles = [], tempPos = this.position.clone(), tempTile;
                    for (var x = -64*this.base.poisonRadius; x <=64*this.base.poisonRadius; x+=64){
                        for (var y = -64*this.base.poisonRadius; y <=64*this.base.poisonRadius; y+=64){
                            tempTile = Game.lvl.objMap.getTruthTile(tempPos.clone().add(new Vec2(x, y)));
                            if (tempTile && tiles.indexOf(tempTile) == -1) {
                                tiles.push(tempTile);
                            }
                        }
                    }
                    tiles.forEach(function (tile) {
                        tile.eObjects.forEach(function (enemy){
                            Buf.prototype.addBuf(enemy, 'acid', 'hitPoints', that.base.poisonDamage, 'damage', that.base.poisonTime, 'AcidBlastSmoke', Game.lvl.effectContainer, null, null, that);
                        });
                    });
                    Game.lvl.objEffect.push(new SplashFx(this.position, '#ffffff'));
                }.bind(this), Game.animations[this.animations.cast].playTime-400);
            }.bind(this)
        }
    };


    Game.friendlyList.orcGrunt = {
        n: 'orcGrunt',
        canAttackFly: false,
        hitPoints: 10,
        timeOut: 500,
        moveRange: 3*Game.tileWidth,
        attackRange: Game.tileWidth,
        icon: 'gruntIco',
        damage: 1,
        speed: 6,
        hitPosition: new Vec2(0,-32),
        hitRange: 10,
        nextLvl:['orcWarrior'],
        animations:{idle:'orcGruntIdle', fight:['orcGruntFight'], die:'orcGruntDie', run:'orcGruntRun'},
        unitName: 'grunt',
        type: "friendly",
        cost: 3,
        soundCCGroup:'CCSword',
        soundCC:['Mele_01', 'Mele_02', 'Mele_03', 'Mele_04', 'Mele_05'],
        soundCCVolume:0.2,
        soundCCLimit:4,
        soundDeathGroup:'orcDeath',
        soundDeath:['Orc Death01','Orc Death02'],
        soundDeathVolume:0.3,
        soundDeathLimit:2,
        soundOrderGroup:'OrcOrder',
        soundOrder:['OrcOrder01', 'OrcOrder02'],
        soundOrderVolume:0.3,
        soundOrderLimit:1,
        limitCost: 1,
        subtype:'orcs',
    };

    Game.friendlyList.orcWarrior = {
        n: 'orcWarrior',
        canAttackFly: false,
        timeOut: 500,
        hitPoints: 15,
        moveRange: 3*Game.tileWidth,
        attackRange:Game.tileWidth,
        damage: 2,
        speed: 7,
        cost:10,
        soundCCGroup:'CCSword',
        soundCC:['Mele_01', 'Mele_02', 'Mele_03', 'Mele_04', 'Mele_05'],
        soundCCVolume:0.2,
        soundCCLimit:4,
        soundDeathGroup:'orcDeath',
        soundDeath:['Orc Death01','Orc Death02'],
        soundDeathVolume:0.3,
        soundDeathLimit:2,
        soundOrderGroup:'OrcOrder',
        soundOrder:['OrcOrder01', 'OrcOrder02'],
        soundOrderVolume:0.3,
        soundOrderLimit:1,
        limitCost: 1,
        hitPosition: new Vec2(0,-64),
        hitRange: 10,
        unitName: 'warrior',
        icon: 'warriorIco',
        nextLvl:['orcGuardian', 'orcWolfRider'],
        animations:{idle:'orcWarriorIdle', fight:['orcWarriorFight1' ,'orcWarriorFight2'], die:'orcWarriorDie', run:'orcWarriorRun'},
        type: "friendly",
        subtype:'orcs'
    };

    Game.friendlyList.orcGuardian = {
        n: 'orcGuardian',
        canAttackFly: false,
        timeOut: 500,
        hitPoints: 15,
        moveRange: 3*Game.tileWidth,
        attackRange:Game.tileWidth,
        damage: 2,
        speed: 7,
        cost:10,
        soundCCGroup:'CCSword',
        soundCC:['Mele_01', 'Mele_02', 'Mele_03', 'Mele_04', 'Mele_05'],
        soundCCVolume:0.2,
        soundCCLimit:4,
        soundDeathGroup:'orcDeath',
        soundDeath:['Orc Death01','Orc Death02'],
        soundDeathVolume:0.3,
        soundDeathLimit:2,
        soundOrderGroup:'OrcOrder',
        soundOrder:['OrcOrder01', 'OrcOrder02'],
        soundOrderVolume:0.3,
        soundOrderLimit:1,
        limitCost: 1,
        hitPosition: new Vec2(0,-40),
        hitRange: 10,
        unitName: 'guardian',
        icon: 'guardianIco',
        nextLvl: [],
        animations:{idle:'orcGuardianIdle', fight:['orcGuardianFight1','orcGuardianFight2'], die:'orcGuardianDie', run:'orcGuardianRun'},
        type: "friendly",
        subtype:'orcs'
    };

    Game.friendlyList.orcWolfRider = {
        n: 'orcWolfRider',
        canAttackFly: false,
        timeOut: 500,
        hitPoints: 15,
        moveRange: 3*Game.tileWidth,
        attackRange:Game.tileWidth,
        damage: 2,
        speed: 7,
        cost:10,
        soundCCGroup:'CCSword',
        soundCC:['Mele_01', 'Mele_02', 'Mele_03', 'Mele_04', 'Mele_05'],
        soundCCVolume:0.2,
        soundCCLimit:4,
        soundDeathGroup:'orcDeath',
        soundDeath:['Orc Death01','Orc Death02'],
        soundDeathVolume:0.3,
        soundDeathLimit:2,
        soundOrderGroup:'OrcOrder',
        soundOrder:['OrcOrder01', 'OrcOrder02'],
        soundOrderVolume:0.3,
        soundOrderLimit:1,
        hitPosition: new Vec2(0,-48),
        hitRange: 10,
        limitCost: 1,
        unitName: 'wolfRider',
        icon: 'wolfRiderIco',
        nextLvl: [],
        animations:{idle:'wolfRiderIdle', fight:['wolfRiderFight'], die:'wolfRiderDie', run:'wolfRiderRun'},
        type: "friendly",
        subtype:'orcs'
    };

    Game.friendlyList.goblinSpearMan = {
        n: 'goblinSpearMan',
        timeOut: 600,
        canAttackFly: true,
        hitPoints: 20,
        moveRange: 0,
        attackRange:2*Game.tileWidth,
        damage: 5,
        speed: 6,
        cost:10,
        soundShootGroup:'ArrowTower',
        soundShoot:'ArrowTower',
        soundShootVolume:0.2,
        soundShootLimit:4,
        limitCost: 1,
        hitPosition: new Vec2(0,-32),
        hitRange: 10,
        unitName: 'archer',
        icon: 'archerIco',
        nextLvl: ['goblinArcher'],
        animations:{idle:'spearManIdle', fight:['spearManFight1'], die:'spearManDie', run:'spearManMove'},
        type: "friendly",
        soundDeathGroup:'goblinDeath',
        soundDeath:['Goblin Death 1', 'Goblin Death 2'],
        soundDeathVolume:0.3,
        soundDeathLimit:2,
        soundOrderGroup:'GoblinOrder',
        soundOrder:['Goblin Order01'],
        soundOrderVolume:0.3,
        soundOrderLimit:1,
        subtype:'goblins',
        init: function() {
            this.scanEnemyAround = this.scanEnemyAroundArcher;
            this.strategy = this.strategyArcher;
        }
    };

    Game.friendlyList.goblinBase = {
        n: 'goblinBase',
        timeOut: 600,
        canAttackFly: false,
        hitPoints: 20,
        moveRange: 3*Game.tileWidth,
        attackRange:Game.tileWidth,
        damage: 5,
        armor: 0,
        speed: 6,
        cost:10,
        limitCost: 1,
        hitPosition: new Vec2(0,-32),
        hitRange: 10,
        unitName: 'archer',
        icon: 'archerIco',
        nextLvl: [],
        soundCCGroup:'CCLightSword',
        soundCC:['LightMele01', 'LightMele02', 'LightMele03'],
        soundCCVolume:0.3,
        soundCCLimit:3,
        animations:{idle:'goblinBaseIdle', fight:['goblinBaseAttack1','goblinBaseAttack2'], die:'goblinBaseDie', run:'goblinBaseRun'},
        type: "friendly",
        soundDeathGroup:'goblinDeath',
        soundDeath:['Goblin Death 1', 'Goblin Death 2'],
        soundDeathVolume:0.3,
        soundDeathLimit:2,
        soundOrderGroup:'GoblinOrder',
        soundOrder:['Goblin Order01'],
        soundOrderVolume:0.3,
        soundOrderLimit:1,
        subtype:'goblins'
    };


    Game.friendlyList.goblinArcher = {
        n: 'goblinArcher',
        timeOut: 600,
        canAttackFly: true,
        hitPoints: 20,
        moveRange: 0,
        attackRange:2*Game.tileWidth,
        damage: 5,
        speed: 6,
        cost:10,
        limitCost: 1,
        hitPosition: new Vec2(0,-32),
        hitRange: 10,
        unitName: 'archer',
        icon: 'archerIco',
        soundShootGroup:'ArrowTower',
        soundShoot:'ArrowTower',
        soundShootVolume:0.2,
        soundShootLimit:4,
        nextLvl: ['goblinSniper', 'goblinShaman'],
        animations:{idle:'orcArcherIdle', fight:['orcArcherFight'], die:'orcArcherDie', run:'orcArcherRun'},
        type: "friendly",
        soundDeathGroup:'goblinDeath',
        soundDeath:['Goblin Death 1', 'Goblin Death 2'],
        soundDeathVolume:0.3,
        soundDeathLimit:2,
        soundOrderGroup:'GoblinOrder',
        soundOrder:['Goblin Order01'],
        soundOrderVolume:0.3,
        soundOrderLimit:1,
        subtype:'goblins',
        init: function() {
            this.scanEnemyAround = this.scanEnemyAroundArcher;
            this.strategy = this.strategyArcher;
        }
    };

    Game.friendlyList.goblinSniper = {
        n: 'goblinSniper',
        timeOut: 600,
        canAttackFly: true,
        hitPoints: 20,
        moveRange: 0,
        attackRange:3*Game.tileWidth,
        damage: 5,
        speed: 6,
        cost:10,
        limitCost: 1,
        hitPosition: new Vec2(0,-32),
        hitRange: 10,
        unitName: 'archer',
        icon: 'archerIco',
        nextLvl: [],
        soundShootGroup:'ArrowTower',
        soundShoot:'ArrowTower',
        soundShootVolume:0.2,
        soundShootLimit:5,
        animations:{idle:'sniperIdle', fight:['sniperFight1'], die:'sniperDie', run:'sniperRun'},
        type: "friendly",
        soundDeathGroup:'goblinDeath',
        soundDeath:['Goblin Death 1', 'Goblin Death 2'],
        soundDeathVolume:0.3,
        soundDeathLimit:2,
        soundOrderGroup:'GoblinOrder',
        soundOrder:['Goblin Order01'],
        soundOrderVolume:0.3,
        soundOrderLimit:1,
        subtype:'goblins',
        init: function() {
            this.scanEnemyAround = this.scanEnemyAroundArcher;
            this.strategy = this.strategyArcher;
        }
    };


    Game.friendlyList.goblinShaman = {
        n: 'goblinShaman',
        timeOut: 1000,
        healTimeOut: 500,
        canAttackFly: true,
        hitPoints: 20,
        moveRange: 0,
        attackRange:4*Game.tileWidth,
        healAmount: 5.0,
        damageType:'magic',
        damage: 1.0,
        speed: 7,
        cost:10,
        limitCost: 1,
        hitPosition: new Vec2(0,-32),
        hitRange: 10,
        unitName: 'shaman',
        icon: 'shamanIco',
        nextLvl: [],
        animations:{idle:'orcShamanIdle', fight:['orcShamanFight'], die:'orcShamanDie', heal:'orcShamanHeal', run:'orcShamanRun'},
        type: "friendly",
        soundDeathGroup:'goblinDeath',
        soundDeath:['Goblin Death 1', 'Goblin Death 2'],
        soundDeathVolume:0.3,
        soundDeathLimit:2,
        soundOrderGroup:'GoblinOrder',
        soundOrder:['Goblin Order01'],
        soundOrderVolume:0.3,
        soundOrderLimit:1,
        subtype:'goblins',
        strategy: function() {
            var direction, len, target;
            this.timeOut -= Game.cycleTickTime*Game.speed;

            this.healTimeOut -= Game.cycleTickTime*Game.speed;
            if (this.timeOut > 0 && this.healTimeOut > 0)
                return;

            if (this.basePosition.clone().add(this.tileSdvig).sub(this.position).getLength() < this.speed*2) {
                this.scanTimeOut -= Game.cycleTickTime*Game.speed;
                this.scanEnemyAround();
                if (this.healTimeOut <= 0) {
                    this.healTimeOut = this.base.healTimeOut;
                    var toHeal = [];
                    Game.lvl.objFriendly.forEach(function(friendly){
                        if (friendly.hitPoints < friendly.base.hitPoints && friendly.position.clone().sub(this.position).getLength() < this.attackRange * 1.5)
                            toHeal.push(friendly);
                    }.bind(this));
                    if (toHeal.length > 0){
                        toHeal.forEach(function(friendly) {
                            Buf.prototype.addBuf(friendly, 'heal', 'hitPoints', this.base.healAmount, 'heal', 1000, null, Game.lvl.effectContainer, 'heal', null);
                        }.bind(this));
                        this.animation = Game.lvl.pool.switchAnimation(this.animations['heal'], this.animation);
                        this.animation.loop = false;
                        this.animation._currentTime = 0;
                        this.timeOut = this.base.timeOut*2;
                        return;
                    }
                }
                if (this.target) {
                    direction = this.target.position.clone().sub(this.position);
                    this.animation.setDirection(direction.getDirection());
                    this.timeOut = this.base.timeOut;
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['fight'][this.fightAnim], this.animation);
                    direction.sub(direction.clone().normalize().multiply(32));
                    Game.lvl.objEffect.push(new Arrow(this.position.clone().add(new Vec2(0, -64)), this.target, Game.animations['fireBall'], 1.25,  direction.getLength()*1.5, true,
                        function(){
                            Game.lvl.objEffect.push(new Effect(this.target.position.clone().add(this.target.hitPosition), this.direction.normalize(), Game.lvl.objEffect, Game.animations.fireHit, 400, 2));
                            this.target.applyDamage(this.parent.damage, this.parent);
                        }, 600, this));
                } else {
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['idle'], this.animation);
                }
            } else {
                if (this.path.length > 0)
                    this.move();
                else if ((direction = this.basePosition.clone().add(this.tileSdvig).sub(this.position)).getLength() > 32){
                    if ((this.path = Game.lvl.objMap.getPath(this.position, this.basePosition, this.basePosition, this.moveRange + this.attackRange)).length == 0) {
                        if ((this.path = Game.lvl.objMap.getPath(this.position, this.basePosition)).length == 0)
                            this.path = [Game.lvl.objMap.getTile(this.basePosition)]
                    }
                } else {
                    this.timeOut = this.base.timeOut;
                    this.animation = Game.lvl.pool.switchAnimation(this.animations['idle'], this.animation);
                }
            }
        },
        init: function(){
            this.healAmount = this.base.healAmount;
            this.healTimeOut = this.base.healTimeOut;
            this.scanEnemyAround = this.scanEnemyAroundArcher;
        }
    }
}

