﻿function loadGui() {

    Game.guiList.supportGui = {
        noLock:true,
        sprite : null,
        x: 0,
        y: 0,
        width: Game.width,
        height: Game.heightShift,
        init:function() {
            this.container = new PIXI.DisplayObjectContainer();
            Game.lvl.guiContainer.addChild(this.container);
            Game.lvl.onTop = this.container;
            this.checkTouch  = function(touch) {
                if (Game.touchList.length > 1)
                    return;
                var touchedWave = false;
                if (Game.lvl.gameLogic.state == 'day' || Game.lvl.gameLogic.state =='tutorStart') {
                    Game.lvl.objEffect.forEach(function(eff){
                        var tmp;
                        if (eff.checkWaveTouch) {
                            tmp = eff.checkWaveTouch(Game.lvl.camera.getMovedPosition(touch.startPosition.clone()));
                            if (tmp)
                                touchedWave = tmp;
                        }
                    })
                }
                if (touchedWave)
                    return true;

                if (Game.lvl.objGui[0].selectedEffect && Game.lvl.objGui[0].selectedEffect.target != Game.lvl.gameLogic.hero) {
                    if (Game.lvl.objGui[0].selectedEffect.click(Game.lvl.camera.getMovedPosition(touch.startPosition.clone()))) {
                        Game.lvl.objGui[0].selectedEffect.init();
                        return true;
                    } else {
                        Game.lvl.objGui[0].selectedEffect.del();
                        Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(Game.lvl.objGui[0].selectedEffect), 1);
                        Game.lvl.objGui[0].selectedEffect = null;
                        return true;
                    }
                }
                return false;
            }
        }
    };

    Game.guiList.map = {
        noLock:true,
        sprite : null,
        x: 0,
        y: 0,
        width: Game.width,
        height: Game.heightShift,
        onTouch: function(touch) {
            if (this.handleClick) {
                this.handleClick(touch);
                return;
            }
            if (this.touches.indexOf(touch)== -1) {
                this.touches.push(touch);
                if (this.touches.length == 1) {
                    this.isMoved  = false;
                    this.state = 'move';
                    this.lastX = touch.lastPosition.x;
                    this.lastY = touch.lastPosition.y;
                } else if (this.touches.length == 2) {
                    this.isMoved = true;
                    this.state = 'scale';
                    this.lastScale = this.touches[0].lastPosition.clone().sub(this.touches[1].lastPosition).getLength()*(4/Game.windowWidth);
                    if (this.selectedItem) {
                        this.selectedItem = null;
                        Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this.selectedEffect), 1);
                    }
                } else {
                    this.state = 'idle';
                    if (this.selectedItem) {
                        this.selectedItem = null;
                        Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this.selectedEffect), 1);
                    }
                }
            }
            if (this.state === 'move') {
                if (this.selectedItem) {
                    if (this.selectedEffect.isPressed(Game.lvl.camera.getMovedPosition(touch.startPosition.clone())) == null) {
                        Game.lvl.camera.move(new Vec2(this.lastX-touch.lastPosition.x, this.lastY-touch.lastPosition.y));
                        this.lastX = touch.lastPosition.x;
                        this.lastY = touch.lastPosition.y;
                        if (touch.lastPosition.clone().sub(touch.startPosition).getLength()> 50)
                            this.isMoved = true;
                    } else {
                        this.selectedEffect.touchPosition = Game.lvl.camera.getMovedPosition(touch.lastPosition.clone());
                    }
                } else {
                    Game.lvl.camera.move(new Vec2(this.lastX-touch.lastPosition.x, this.lastY-touch.lastPosition.y));
                    this.lastX = touch.lastPosition.x;
                    this.lastY = touch.lastPosition.y;
                    if (touch.lastPosition.clone().sub(touch.startPosition).getLength()> 50)
                        this.isMoved = true;
                }
            } else if(this.state == 'scale') {
                Game.lvl.camera.scale(this.touches[0].lastPosition.clone().sub(this.touches[1].lastPosition).getLength()*(4/Game.windowWidth) - this.lastScale, this.touches[0].startPosition.clone().add(this.touches[1].startPosition).multiply(0.5));
                this.lastScale = this.touches[0].lastPosition.clone().sub(this.touches[1].lastPosition).getLength()*(4/Game.windowWidth);
            }
            if (touch.touchedEnd) {
                Game.lvl.selectedInfo.setUnit(null);
                if (this.state === 'move') {
                    if (!this.isMoved){
                        var touchedWave = false;
                        if (!touchedWave && !Game.lvl.enemy) {
                            if (this.selectedEffect) {
                                if (Game.lvl.objGui[0].selectedEffect.target == Game.lvl.gameLogic.hero) {
                                    if (!Game.lvl.objGui[0].selectedEffect.click(Game.lvl.camera.getMovedPosition(touch.startPosition.clone()))) {
                                        Game.lvl.gameLogic.hero.heroOrder && Game.lvl.gameLogic.hero.heroOrder.play();
                                        Game.lvl.gameLogic.hero.button.select(false);
                                    }
                                }
                            } else {
                                var selectedItem = Game.lvl.objMap.getSelected(Game.lvl.camera.getMovedPosition(touch.lastPosition.clone()));
                                if (selectedItem) {
                                    this.selectedEffect = new selectedEffect(selectedItem);
                                    Game.lvl.objEffect.push(this.selectedEffect);

                                    if (selectedItem instanceof  Flag)
                                        selectedItem.update();

                                    if (selectedItem == Game.lvl.gameLogic.hero)
                                        Game.lvl.gameLogic.hero.button.select(true);
                                } else {
                                    Game.lvl.selectedInfo.setUnit(Game.lvl.objMap.getClosedEnemy(Game.lvl.camera.getMovedPosition(touch.lastPosition.clone())));
                                }
                            }
                        }
                    }
                } else {
                    if (this.selectedItem) {
                        this.selectedItem = null;
                        if (this.selectedEffect.target == Game.lvl.gameLogic.hero)
                            Game.lvl.gameLogic.hero.button.select(false);
                        else {
                            this.selectedEffect.del();
                            Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this.selectedEffect), 1);
                        }
                    }
                }
                this.state = 'idle';
                this.touches.splice(this.touches.indexOf(touch),1);
            }
        },
        draw: function(){
        },
        init:function(){
            this.handleClick = null;
            this.selectedUnit = null;
            this.touches = [];
            this.state = 'idle';
            this.isMoved = false;
            this.lastX = 0;
            this.lastY = 0;
            this.lastScale = 0;
            this.selectedItem = null;
            this.selectedEffect = null;
            this.subState = 'idle';
            this.moveInfoWindow = 0;
            this.infoWindowX = -500;
            this.infoWindowY = 260;
            //this.infoWindowWidth;
            //this.onNight = function (){
            //    if (this.selectedItem){
            //        this.selectedItem = null;
            //        Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this.selectedEffect), 1);
            //    }
            //};
            //Game.lvl.gameLogic.onNightCallBack.push(this.onNight.bind(this));
        }
    };

    Game.guiList.timer = {
        noLock:true,
        sprite : null,
        x: Game.width - 210,
        y: 0,
        width: 210,
        height: 215,
        onTouch: function(touch){
            if (touch.touchedEnd){
                if (Game.speed == 1)
                    Game.speed = 2;
                else if (Game.speed == 2)
                    Game.speed = 3;
                else if (Game.speed == 3)
                    Game.speed = 1;
            }
        },
        draw: function(){
        },
        init: function(){
            Game.lvl.timerGui = this;
            this.state = 'normal';
            this.lastText = 1;
            this.buttonsprite = Game.lvl.pool.getSprite(Game.sprites['SpeedGui']);
            this.sprite = Game.lvl.pool.getSprite(Game.sprites['ButtonX'+Game.speed]);
            Game.lvl.guiContainer.addChild(this.buttonsprite);
            Game.lvl.guiContainer.addChild(this.sprite);
            this.position = new Vec2(this.x+this.width/2, this.y+this.height/2);
            this.buttonsprite.position = this.position;
            this.sprite.position = this.position.clone().add(new Vec2(5, -15));
            this.buttonsprite.position = this.position;
            this.update = function() {
                if (this.lastText != Game.speed) {
                    this.lastText = Game.speed;
                    this.sprite = Game.lvl.pool.switchSprite(Game.sprites['ButtonX'+Game.speed], this.sprite);
                    if (this.ballon) {
                        Game.lvl.pool.pull(this.ballon.container);
                        this.ballon = null;
                    }
                }
            }
        }
    };

    Game.guiList.info = {
        noLock:true,
        sprite : null,
        x: Game.width/2,
        y: Game.heightShift - 200,
        width: Game.width/4,
        height:  40,
        onTouch: function(touch){},
        draw: function(){
        },
        init: function() {
            this.checkTouch = function(){return false;};

            this.container = new PIXI.Container();
            this.backSprite = Game.lvl.pool.getSprite(Game.sprites['MonsterBar']);
            //this.backSprite.scale.set(1.2,1);
            this.container.addChild(this.backSprite);
            this.container.position = new Vec2(this.x, this.y);


            this.damage = new SimpleFont(200, '');this.damage.container.scale.set(0.7,0.7);this.damage.container.position.set(-355,0);
            this.hp = new SimpleFont(130000, '');this.hp.container.scale.set(0.7,0.7); this.hp.container.position.set(-160,0);
            this.armor = new SimpleFont('0.1', '');this.armor.container.scale.set(0.7,0.7);this.armor.container.position.set(180,0);
            this.magicarmor = new SimpleFont('0.0', '');this.magicarmor.container.scale.set(0.7,0.7); this.magicarmor.container.position.set(370,0);

            this.damageIcon = Game.lvl.pool.getSprite(Game.sprites.attackIG);
            this.damageIcon.position.set(-430, -5);

            this.hpIcon = Game.lvl.pool.getSprite(Game.sprites.hpIG);
            this.hpIcon.position.set(-210, -5);

            this.armoreIcon = Game.lvl.pool.getSprite(Game.sprites.armoreIG);
            this.armoreIcon.position.set(120, -5);

            this.magicarmoreIcon = Game.lvl.pool.getSprite(Game.sprites.magicArmoreIG);
            this.magicarmoreIcon.position.set(310, -5);

            this.container.addChild(this.damage.container);
            this.container.addChild(this.hp.container);
            this.container.addChild(this.armor.container);
            this.container.addChild(this.magicarmor.container);
            this.container.addChild(this.damageIcon);
            this.container.addChild(this.hpIcon);
            this.container.addChild(this.armoreIcon);
            this.container.addChild(this.magicarmoreIcon);

            this.hpBack = Game.lvl.pool.getSprite(Game.sprites.MonsterBarHPFrame);
            this.hpF = Game.lvl.pool.getSprite(Game.sprites.MonsterBarHP);
            this.hpF.position.set(0,120);
            this.hpBack.position.set(0,120);

            this.fillMask = new PIXI.Graphics();
            this.fillMask.beginFill();
            this.fillMask.moveTo(0, 0);
            this.fillMask.drawRect(0, 0, 940, 80);
            this.fillMask.endFill();
            this.fillMask.position = new Vec2(-940/2, 120-40);
            this.hpF.mask = this.fillMask;

            this.container.addChild(this.hpBack);
            this.container.addChild(this.hpF);
            this.container.addChild(this.fillMask);

            Game.lvl.guiContainer.addChild(this.container);
            Game.lvl.selectedInfo = this;

            this.name = new PIXI.extras.BitmapText("Dragon",
                {
                    font: Game.getFontBitmap(),
                    align: "center"
                });
            this.name.scale.set(0.8,0.8);
            this.name.position.set(-this.name.width/2, Game.language == 'ru' ? 75 : 80);
            this.container.addChild(this.name);
            this.hidden = true;
            this.container.alpha = 0;

            this.setUnit = function(unit) {
                if (unit) {
                    this.unit = unit;

                    this.damage.setText(parseInt(unit.damage*1000/unit.base.timeOut));
                    this.hp.setText(parseInt(unit.maxHitPoints));
                    this.armor.setText(parseFloat(unit.armor).toFixed(1));
                    this.magicarmor.setText(parseFloat(unit.magicArmor).toFixed(1));

                    this.hidden = false;
                    this.container.alpha = 1;

                    this.name.setText(Game.strings[Game.language].monsters[this.unit.base.n].name);
                    this.name.position.set(-this.name.width/2, 80);

                    var hp = this.unit.hitPoints;
                    if (hp < 0)
                        hp =0;
                    else
                        hp = 940*(hp/this.unit.maxHitPoints);

                    this.fillMask.clear();
                    this.fillMask.beginFill();
                    this.fillMask.moveTo(0, 0);
                    this.fillMask.drawRect(0, 0, hp, 80);
                    this.fillMask.endFill();
                } else {
                    this.unit = null;
                    this.hidden = true;
                    this.container.alpha = 0;
                }
            };
            this.update = function() {
                if (!this.hidden)
                    if (this.unit) {
                        var hp = this.unit.hitPoints;
                        if (hp < 0)
                            hp =0;
                        else
                            hp = 940*(hp/this.unit.maxHitPoints);

                        this.fillMask.clear();
                        this.fillMask.beginFill();
                        this.fillMask.moveTo(0, 0);
                        this.fillMask.drawRect(0, 0, hp, 80);
                        this.fillMask.endFill();
                    }
                //if (this.lastText != 'WAVE ' + Game.lvl.gameLogic.wave + '\\'+ Game.lvl.gameLogic.wavesCount) {
                //    this.lastText = 'WAVE ' + Game.lvl.gameLogic.wave + '\\'+ Game.lvl.gameLogic.wavesCount;
                //    this.text.setText(this.lastText);
                //}
            }
        }
    };

    Game.guiList.waves = {
        noLock:true,
        sprite : null,
        x: 26,
        y: 105,
        width: 522,
        height: 120,
        onTouch: function(touch){},
        draw: function(){
        },
        init: function(){
            this.lastText =  Game.strings[Game.language].wave + ' ' + Game.lvl.gameLogic.wave + '\\'+ Game.lvl.gameLogic.wavesCount;
            this.buttonsprite = Game.lvl.pool.getSprite(Game.sprites['wavw-button']);
            Game.lvl.guiContainer.addChild(this.buttonsprite);
            this.position = new Vec2(this.x+this.width/2, this.y+this.height/2);
            this.buttonsprite.position = this.position;

            Game.font = Game.getFont(64);
            Game.textAlign = 'center';
            Game.fillStyle = "#FEF2B3";
            this.text = new PIXI.Text(this.lastText, {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle
            });
            this.text.position = this.position;
            this.text.anchor.set(0.5,0.5);
            Game.lvl.guiContainer.addChild(this.text);

            this.update = function() {
                if (this.lastText != Game.strings[Game.language].wave + ' ' + Game.lvl.gameLogic.wave + '\\'+ Game.lvl.gameLogic.wavesCount) {
                    this.lastText = Game.strings[Game.language].wave + ' ' + Game.lvl.gameLogic.wave + '\\'+ Game.lvl.gameLogic.wavesCount;
                    this.text.setText(this.lastText);
                }
            }
        }
    };

    Game.guiList.resource = {
        noLock:true,
        sprite : null,
        x: 16,
        y: 20,
        width: 592,
        height: 120,
        onTouch: function(touch) {
            if (touch.touchedEnd && !Game.multiplayerLvl) {
                if (++this.touchCounter > 3){
                    this.touchCounter = 0;
                    //Game.lvl.gameLogic.won();
                }
            }
        },
        init: function(){
            this.touchCounter =  0;
            this.state = 'normal';
            this.lastText = 0;
            this.buttonsprite = Game.lvl.pool.getSprite(Game.sprites.TopLeftGui);
            Game.lvl.guiContainer.addChild(this.buttonsprite);
            this.position = new Vec2(this.x+this.width/2, this.y+this.height/2);
            this.buttonsprite.position = this.position.clone().add(new Vec2(24, 38));

            Game.fillStyle = "#FFF2B3";
            Game.textAlign = 'center';
            Game.textBaseline = 'left';
            Game.font = Game.getFont(48);
            this.resource = new SimpleFont();
            this.resource.setText(this.lastText);
            this.resource.container.position = new Vec2(145, 70);
            this.resource.container.scale.set(0.5,0.5);
            Game.lvl.guiContainer.addChild(this.resource.container);

            this.lastTextLives = 20;
            this.lives = new SimpleFont();
            this.lives.setText(this.lastTextLives);
            this.lives.container.position = new Vec2(460, 70);
            this.lives.container.scale.set(0.5,0.5);
            Game.lvl.guiContainer.addChild(this.lives.container);

            this.onDay = function(){
                this.touchCounter = 0;
            }.bind(this);
            Game.lvl.gameLogic.onDayCallBack.push(this.onDay);
            this.update = function() {
                this.lvl = Game.multiplayerLvl ? Game.multiplayerLvl.lvlsMy : Game.lvl;
                if (this.lastText != this.lvl.gameLogic.resource){
                    this.lastText = this.lvl.gameLogic.resource;
                    this.resource.setText(''+this.lastText);
                }
                if (this.lastTextLives != Game.lvl.townHall.hitPoints){
                    this.lastTextLives = Game.lvl.townHall.hitPoints >=0 ? Game.lvl.townHall.hitPoints : 0;
                    this.lives.setText(this.lastTextLives);
                }
            }
        }
    };

    Game.guiList.pauseButton = {
        noLock:true,
        sprite : null,
        x: Game.width/2-160/2,
        y: 0,
        width: 160,
        height: 100,
        onTouch: function(touch){
            if (touch.touchedEnd && !Game.multiplayerLvl) {
                if (Game.lvl.paused){
                    Game.lvl.paused = false;
                    this.state = 'Idle';
                    this.buttonsprite = Game.lvl.pool.switchSprite(Game.sprites['ButtonPause'+ this.state], this.buttonsprite);

                } else {
                    Game.lvl.paused = true;
                    this.state = 'Pressed';
                    this.buttonsprite = Game.lvl.pool.switchSprite(Game.sprites['ButtonPause'+ this.state], this.buttonsprite);
                    //var aaa = new PIXI.filters.BlurFilter();
                    //aaa.blur = 10;
                    //aaa.passes = 5;
                    //Game.lvl.cameraContainer.filters = [aaa];
                    Game.lvl.objGui.push(new Gui(Game.guiList.pause));
                }
            }
        },
        draw: function(){
        },
        init: function(){
            this.state = 'Idle';
            this.buttonspriteback = Game.lvl.pool.getSprite(Game.sprites.PauseGui);
            Game.lvl.guiContainer.addChild(this.buttonspriteback);

            this.buttonsprite = Game.lvl.pool.getSprite(Game.sprites.ButtonPauseIdle);
            Game.lvl.guiContainer.addChild(this.buttonsprite);
            this.position = new Vec2(this.x+this.width/2, this.y+this.height/2+26);
            this.buttonsprite.position = this.position.clone().add(new Vec2(3, -36));
            this.buttonspriteback.position = this.position;
            this.update = function(){
                if (this.state == 'Pressed' && !Game.lvl.paused){
                    this.state = 'Idle';
                    this.buttonsprite = Game.lvl.pool.switchSprite(Game.sprites['ButtonPause'+ this.state], this.buttonsprite);
                }
            }
        }
    };

    Game.guiList.pause = {
        noLock:true,
        sprite : null,
        x: 0,
        y: 0,
        width: Game.width,
        height: Game.height,
        onTouch: function(touch){},
        draw: function(){
        },
        init: function(){
            this.container = new PIXI.DisplayObjectContainer();
            this.container.position.set(0, (Game.heightShift - 1536)/2);
            this.blackS = new PIXI.Graphics();
            this.blackS.alpha = 0.7;
            this.blackS.beginFill(0x000000);
            this.blackS.moveTo(0,0);
            this.blackS.drawRect(0, 0, 1, 1);
            this.blackS.scale.set(341*2, (1200-360+40));
            this.blackS.endFill();
            this.blackS.position.set(Game.width/2-341, 360-20);
            this.container.addChild(this.blackS);

            this.left = Game.lvl.pool.getSprite(Game.sprites.PauseMenuLeft_RightFrame);
            this.left.position = new Vec2(Game.width/2-341, (1200+360)/2);
            this.left.scale.set(-1,1);
            this.container.addChild(this.left);

            this.right = Game.lvl.pool.getSprite(Game.sprites.PauseMenuLeft_RightFrame);
            this.right.position = new Vec2(Game.width/2+341, (1200+360)/2);
            this.container.addChild(this.right);

            this.top = Game.lvl.pool.getSprite(Game.sprites.PauseMenuTop_BottomFrame);
            this.top.position = new Vec2(Game.width/2, 360);
            this.container.addChild(this.top);

            this.bot = Game.lvl.pool.getSprite(Game.sprites.PauseMenuTop_BottomFrame);
            this.bot.position = new Vec2(Game.width/2, 1200);
            this.bot.scale.set(1, -1);
            this.container.addChild(this.bot);


            this.largeAxeL = Game.lvl.pool.getSprite(Game.sprites['Side-Axes_L']);
            this.largeAxeL.position = new Vec2(Game.width/2+440, 730);
            //this.largeAxeL.scale.set(1, -1);
            this.container.addChild(this.largeAxeL);


            this.largeAxeR = Game.lvl.pool.getSprite(Game.sprites['Side-Axes_L']);
            this.largeAxeR.position = new Vec2(Game.width/2-440, 730);
            this.largeAxeR.scale.set(-1, 1);
            this.container.addChild(this.largeAxeR);

            Game.fillStyle = "#FFF2B3";
            Game.textAlign = 'center';
            Game.textBaseline = 'left';

            this.buttonResume = new PIXI.DisplayObjectContainer();
            Game.font = Game.getFont(96);
            this.resume = new PIXI.Text(Game.strings[Game.language].pause.resume, {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle,
                width: 400
            });
            this.resume.position = new Vec2(0,-50);

            this.buttonResumeSprite = Game.lvl.pool.getSprite(Game.sprites.ButtonInPauseIdle);

            this.buttonResume.addChild(this.buttonResumeSprite);
            this.buttonResume.addChild(this.resume);

            this.buttonResume.interactive = true;
            this.buttonResume.mousedown = this.buttonResume.touchstart = function () {
                this.yestochedresume = true;
                this.buttonResumeSprite = Game.menu.pool.switchSprite(Game.sprites.ButtonInPausePressed, this.buttonResumeSprite)
            }.bind(this);

            this.buttonResume.mouseup = this.buttonResume.touchend  = function () {
                this.buttonResumeSprite = Game.menu.pool.switchSprite(Game.sprites.ButtonInPauseIdle, this.buttonResumeSprite);
                if (this.yestochedresume) {
                    Game.lvl.cameraContainer.filters = null;
                    if (Game.lvl.objGui.indexOf(this) != -1)
                        Game.lvl.objGui.splice(Game.lvl.objGui.indexOf(this), 1);

                    Game.lvl.pool.pull(this.container);
                    this.yestochedresume = false;
                    Game.lvl.paused = false;
                }
            }.bind(this);

            this.buttonResume.mouseupoutside = this.buttonResume.touchendoutside = function () {
                this.yestochedresume = false;
                this.buttonResumeSprite = Game.menu.pool.switchSprite(Game.sprites.ButtonInPauseIdle, this.buttonResumeSprite);
            }.bind(this);

            this.buttonResume.position = new Vec2(Game.width/2, 520);
            this.container.addChild(this.buttonResume);

            this.buttonRestart = new PIXI.DisplayObjectContainer();
            Game.font = Game.getFont(82);
            this.restart = new PIXI.Text(Game.strings[Game.language].pause.restart, {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle,
                width: 400
            });
            this.restart.position = new Vec2(0,-43);

            this.buttonRestartSprite = Game.lvl.pool.getSprite(Game.sprites.ButtonInPauseIdle);
            this.buttonRestart.addChild(this.buttonRestartSprite);
            this.buttonRestart.addChild(this.restart);

            this.buttonRestart.interactive = true;
            this.buttonRestart.mousedown = this.buttonRestart.touchstart = function () {
                if (this.restarted)
                    return;
                this.yestochedrestart = true;
                this.buttonRestartSprite = Game.menu.pool.switchSprite(Game.sprites.ButtonInPausePressed, this.buttonRestartSprite)
            }.bind(this);

            this.buttonRestart.mouseup = this.buttonRestart.touchend = function () {
                if (this.restarted)
                    return;
                this.buttonRestartSprite = Game.menu.pool.switchSprite(Game.sprites.ButtonInPauseIdle, this.buttonRestartSprite);
                if (this.yestochedrestart) {
                    Game.noTouch = 1000;
                    this.restarted = true;
                    this.yestochedrestart = false;
                    Game.events.emit('restarted');
                    this.restarted = true;
                    setTimeout(function(){
                        Game.menu.playLvl();
                    }, 1);
                }
            }.bind(this);

            this.buttonRestart.mouseupoutside = this.buttonRestart.touchendoutside = function () {
                if (this.restarted)
                    return;
                this.buttonRestartSprite = Game.menu.pool.switchSprite(Game.sprites.ButtonInPauseIdle, this.buttonRestartSprite);
                this.yestochedrestart = false;
            }.bind(this);

            this.buttonRestart.position = new Vec2(Game.width/2, 720);
            this.container.addChild(this.buttonRestart);


            this.butonQuit = new PIXI.DisplayObjectContainer();
            Game.font = Game.getFont(82);
            this.quit = new PIXI.Text(Game.strings[Game.language].pause.quit, {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle,
                width: 400
            });
            this.quit.position = new Vec2(0,-85);

            this.butonQuitSprite = Game.lvl.pool.getSprite(Game.sprites.BattleNormal);
            this.butonQuitSpritePressed = Game.lvl.pool.getSprite(Game.sprites.BattlePressed);
            this.butonQuit.addChild(this.butonQuitSprite);
            this.butonQuitSpritePressed.position = new Vec2(0, -44);
            this.butonQuitSpritePressed.alpha = 0;
            this.butonQuit.addChild(this.butonQuitSpritePressed);
            this.butonQuit.addChild(this.quit);

            this.butonQuit.interactive = true;
            this.butonQuit.mousedown = this.butonQuit.touchstart = function () {
                if (this.restarted)
                    return;
                this.yestochedquit = true;
                this.butonQuitSpritePressed.alpha = 1;
            }.bind(this);

            this.butonQuit.mouseup = this.butonQuit.touchend = function () {
                if (this.restarted)
                    return;
                this.butonQuitSpritePressed.alpha = 0;
                if (this.yestochedquit) {
                    this.yestochedquit = false;
                    setTimeout(function(){
                        Game.lvl.objMap.background.unload(true);
                        Game.menu.enterMenu(true);
                    }, 1);
                }
            }.bind(this);

            this.butonQuit.mouseupoutside = this.butonQuit.touchendoutside = function () {
                this.butonQuitSpritePressed.alpha = 0;
                this.yestochedquit = false;
            }.bind(this);

            this.butonQuit.position = new Vec2(Game.width/2, 1250);
            this.container.addChild(this.butonQuit);


            this.soundContainer = new PIXI.DisplayObjectContainer();
            this.sound = Game.menu.pool.getSprite(Game.sprites[Game.globallogic.soundEnable ? 'SoundON' : 'SoundOFF']);
            this.sound.scale.set(1.2,1.2);

            Game.font = Game.getFont(48);
            this.soundText = new PIXI.Text(Game.strings[Game.language].pause.sound, {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle,
                width: 400
            });
            this.soundText.position.set(0, 70);
            this.soundContainer.addChild(this.soundText);

            this.soundContainer.position = new Vec2(Game.width/2-130, 940);
            this.soundContainer.addChild(this.sound);
            this.soundContainer.interactive = true;
            this.soundContainer.mousedown = this.soundContainer.touchstart = function () {
                if (this.restarted)
                    return;
                this.yestochedsound = true;
                Game.menu.touchesEnabled = false;
            }.bind(this);
            this.soundContainer.mouseup = this.soundContainer.touchend = this.soundContainer.mouseupoutside = this.soundContainer.touchendoutside =  function () {
                if (this.restarted)
                    return;
                if (this.yestochedsound) {
                    this.yestochedsound = false;
                    Game.menu.touchesEnabled = true;
                    for (var i = Game.touchList.length - 1; i >= 0; i--)
                        Game.touchList[i].del();

                    Game.globallogic.toggleSound();
                    this.sound = Game.menu.pool.switchSprite(Game.sprites[Game.globallogic.soundEnable ? 'SoundON' : 'SoundOFF'], this.sound);
                    this.sound.scale.set(1.2,1.2);
                }
            }.bind(this);
            this.container.addChild(this.soundContainer);


            this.musicContainer = new PIXI.DisplayObjectContainer();
            this.music = Game.menu.pool.getSprite(Game.sprites[Game.globallogic.musicEnable ? 'MusicON' : 'MusicOFF']);
            this.music.scale.set(1.2,1.2);

            Game.font = Game.getFont(48);
            this.musicText = new PIXI.Text(Game.strings[Game.language].pause.music, {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle,
                width: 400
            });
            this.musicText.position.set(0, 70);
            this.musicContainer.addChild(this.musicText);

            this.musicContainer.position = new Vec2(Game.width/2+130, 940);
            this.musicContainer.addChild(this.music);
            this.musicContainer.interactive = true;
            this.musicContainer.mousedown = this.musicContainer.touchstart = function () {
                if (this.restarted)
                    return;
                this.yestochedmusic = true;
                Game.menu.touchesEnabled = false;
            }.bind(this);
            this.musicContainer.mouseup = this.musicContainer.touchend = this.musicContainer.mouseupoutside = this.musicContainer.touchendoutside =  function () {
                if (this.restarted)
                    return;
                if (this.yestochedmusic) {
                    this.yestochedmusic = false;
                    Game.menu.touchesEnabled = true;
                    for (var i = Game.touchList.length - 1; i >= 0; i--)
                        Game.touchList[i].del();

                    Game.globallogic.toggleMusic();
                    this.music = Game.menu.pool.switchSprite(Game.sprites[Game.globallogic.musicEnable ? 'MusicON' : 'MusicOFF'], this.music);
                    this.music.scale.set(1.2,1.2);
                }
            }.bind(this);
            this.container.addChild(this.musicContainer);


            Game.lvl.guiContainer.addChild(this.container);
            this.update = function(){}
        }
    };

    Game.guiList.won =  {
        x: 0,
        y: 0,
        width: Game.width  ,
        height: Game.heightShift,
        onTouch : function(touch) {
        },
        draw : function(){
        },
        init: function(params){
            Game.lvl.pausedUpdate.push(this);
            this.timer = 0;
            this.state = -1;
            this.container = new PIXI.DisplayObjectContainer();
            this.container.position.set(0, (Game.heightShift - 1536)/2 + 176);


            this.blackL = new PIXI.Graphics();
            this.blackL.alpha = 0;
            this.blackL.beginFill(0x000000);
            this.blackL.moveTo(0,0);
            this.blackL.drawRect(0, 0, 1, 1);
            this.blackL.scale.set(Game.width, Game.heightShift);
            this.blackL.endFill();
            this.blackL.position.set(0, -((Game.heightShift - 1536)/2 + 176));
            this.container.addChild(this.blackL);

            Game.fillStyle = "#FFF2B3";
            Game.textAlign = 'center';
            Game.textBaseline = 'left';
            Game.font = Game.getFont(108);

            this.buttonContinue = new PIXI.DisplayObjectContainer();
            this.buttonContinue.scale.set(0, 0);
            this.openChest = Game.lvl.audioPool.get('ChestOpen', 'ChestOpen', 0.3, 1);


            this.Continue = new PIXI.Text(Game.strings[Game.language].wonGui.victory, {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle,
                width: 400
            });
            this.Continue.position = new Vec2(0,-116);

            this.buttonContinueSprite = Game.lvl.pool.getSprite(Game.sprites['Main+Victory']);
            this.buttonContinueSprite2 = Game.lvl.pool.getSprite(Game.sprites['MainAXE']);
            this.buttonContinueSprite2.scale.set(-1,1);
            this.buttonContinueSprite3 = Game.lvl.pool.getSprite(Game.sprites['MainAXE']);

            this.buttonContinueSprite2.position.x = -382;
            this.buttonContinueSprite3.position.x = 382;

            this.buttonContinueSprite2.position.y = 34;
            this.buttonContinueSprite3.position.y = 34;

            this.buttonContinue.addChild(this.buttonContinueSprite2);
            this.buttonContinue.addChild(this.buttonContinueSprite3);
            this.buttonContinue.addChild(this.buttonContinueSprite);

            this.buttonContinueSpriteTouched = Game.lvl.pool.getSprite(Game.sprites.BattlePressed);
            this.buttonContinueSpriteTouched.position.set(0, -44);
            this.buttonContinueSpriteTouched.scale.set(1.81, 1.85);
            this.buttonContinueSpriteTouched.alpha = 0;
            this.buttonContinue.addChild(this.buttonContinueSpriteTouched);
            this.buttonContinue.addChild(this.Continue);

            this.buttonContinueSpriteTouched.interactive = true;
            this.buttonContinueSpriteTouched.mousedown = this.buttonContinueSpriteTouched.touchstart = function () {
                this.yestochedContinue = true;
                this.buttonContinueSpriteTouched.alpha = 0.6;
            }.bind(this);

            this.buttonContinueSpriteTouched.mouseup = this.buttonContinueSpriteTouched.touchend  = function () {
                if (this.yestochedContinue) {
                    Game.lvl.cameraContainer.filters = null;
                    this.buttonContinueSpriteTouched.alpha = 0;
                    this.yestochedContinue = false;
                    setTimeout(function(){
                        Game.lvl.objMap.background.unload(true);
                        Game.menu.enterMenu(true);
                    }, 1);
                }
            }.bind(this);

            this.buttonContinueSpriteTouched.mouseupoutside = this.buttonContinueSpriteTouched.touchendoutside = function () {
                this.buttonContinueSpriteTouched.alpha = 0;
                this.yestochedContinue = false;
            }.bind(this);

            this.buttonContinue.position = new Vec2(Game.width/2, 500);
            this.container.addChild(this.buttonContinue);


            this.escapeContainer = new PIXI.Container();
            this.escapeSprite = Game.lvl.pool.getSprite(Game.sprites['EscapeNormal']);
            this.escapeContainer.scale.set(0, 0);
            this.escapeContainer.interactive = true;
            this.escapeContainer.mousedown = this.escapeContainer.touchstart = function () {
                this.escapeSprite = Game.lvl.pool.switchSprite(Game.sprites['EscapePressed'], this.escapeSprite);
                this.yestoched = true;
            }.bind(this);
            this.escapeContainer.mouseup = this.escapeContainer.touchend = this.escapeContainer.mouseupoutside = this.escapeContainer.touchendoutside = function () {
                this.escapeSprite = Game.lvl.pool.switchSprite(Game.sprites['EscapeNormal'], this.escapeSprite);
                if (this.yestoched) {
                    this.yestoched = false;
                    this.yestochedContinue = false;
                    setTimeout(function(){
                        Game.lvl.objMap.background.unload(true);
                        Game.menu.enterMenu(true);
                    }, 1);
                }
            }.bind(this);
            this.escapeContainer.position.set(1820, 200);
            this.escapeContainer.addChild(this.escapeSprite);
            this.container.addChild(this.escapeContainer);


            this.stars = Game.lvl.pool.getSprite(Game.sprites['starr_empty']);
            this.stars.scale.set(4,4);
            this.stars.alpha = 0;
            this.star0 = Game.lvl.pool.getSprite(Game.sprites['starr']);
            this.star1 = Game.lvl.pool.getSprite(Game.sprites['starr_large']);
            this.star2 = Game.lvl.pool.getSprite(Game.sprites['starr']);
            this.stars.position = new Vec2(Game.width/2, 820);
            this.star0.position = new Vec2(826, 925-100);
            this.star1.position = new Vec2(Game.width/2, 922-100);
            this.star2.position = new Vec2(1222, 925-100);
            this.star0.scale.x = this.star0.scale.y = this.star1.scale.x = this.star1.scale.y = this.star2.scale.x = this.star2.scale.y = 0;
            this.container.addChild(this.stars);
            this.container.addChild(this.star1);
            this.container.addChild(this.star0);
            this.container.addChild(this.star2);

            if (!Game.globallogic.isPriceGot(Game.menu.selectedLvl)) {
                this.treasureFx = new PIXI.DisplayObjectContainer();
                this.treasure = Game.lvl.pool.getAnimation('Treasure');
                this.treasure.special = true;
                this.treasure.loop = false;
                this.treasure.scale.set(0, 0);
                this.treasure.stop();
                this.treasure.position.set(Game.width * 3 / 4 + 170, 940);
                this.container.addChild(this.treasureFx);
                this.container.addChild(this.treasure);

                this.yestochedTreasureAlready = false;
                this.treasure.interactive = true;
                this.treasure.mousedown = this.treasure.touchstart = function () {
                    this.yestochedTreasure = true;
                }.bind(this);

                this.treasure.mouseup = this.treasure.touchend = this.treasure.mouseupoutside = this.treasure.touchendoutside = function () {
                    if (this.yestochedTreasure && !this.yestochedTreasureAlready) {
                        localStorage.setItem(Game.profile+"lvlPrise"+Game.menu.selectedLvl, "true");
                        this.openChest.play();
                        Game.lvl.pool.pull(this.dialog);
                        Game.lvl.pool.pull(this.dialogText);
                        this.treasure.play();
                        this.reasureOpenFx = new PIXI.DisplayObjectContainer();

                        this.yestochedTreasureAlready = true;
                        this.prize = Game.globallogic.getPrize(Game.menu.selectedLvl);
                        this.prize.position.set(this.treasure.position.x, this.treasure.position.y - 64);
                        this.container.addChild(this.prize);
                        this.container.addChild(this.reasureOpenFx);
                        this.prize.scale.set(0, 0);
                        var upscale = function () {
                            this.prize.scale.x = this.prize.scale.y = this.prize.scale.x + 0.1;
                            if (this.prize.scale.x < 1)
                                setTimeout(upscale, 50);
                            else {
                                if (this.prize.interactive) {
                                    this.dialog = Game.lvl.pool.getSprite(Game.sprites.dialog);
                                    this.dialog.scale.set(-0.7, 0.7);
                                    this.dialog.position.set(60, -350);
                                    this.prize.addChild(this.dialog);
                                    Game.font = Game.getFont(42);
                                    this.dialogText = new PIXI.Text(Game.strings[Game.language].wonGui.click, {
                                        font: Game.font,
                                        align: 'center',
                                        fill: 'rgba(1, 1, 1, 1);',
                                        wordWrap: true,
                                        wordWrapWidth: 300
                                    });
                                    this.dialogText.anchor.set(0.5, 0.5);
                                    this.dialogText.position.set(60, -390);
                                    this.prize.addChild(this.dialogText);
                                }
                            }
                        }.bind(this);
                        setTimeout(upscale, 50);

                        var config = clone(Game.particlesList['treasure_sparks_01']);
                        config.pos.x = this.treasure.position.x;
                        config.pos.y = this.treasure.position.y - 86;
                        var textures = [];
                        config.images.forEach(function (image) {
                            textures.push(PIXI.TextureCache[image])
                        });
                        var emiter = new cloudkid.Emitter(
                            this.reasureOpenFx,
                            textures,
                            config
                        );
                        emiter.emit = true;
                        Game.lvl.pausedUpdate.push(emiter);
                        config = clone(Game.particlesList['treasure_sparks_02']);
                        config.pos.x = this.treasure.position.x;
                        config.pos.y = this.treasure.position.y - 86;
                        textures = [];
                        config.images.forEach(function (image) {
                            textures.push(PIXI.TextureCache[image])
                        });
                        emiter = new cloudkid.Emitter(
                            this.reasureOpenFx,
                            textures,
                            config
                        );
                        emiter.emit = true;
                        Game.lvl.pausedUpdate.push(emiter);
                        config = clone(Game.particlesList['treasure_sparks_03']);
                        config.pos.x = this.treasure.position.x;
                        config.pos.y = this.treasure.position.y - 86;
                        textures = [];
                        config.images.forEach(function (image) {
                            textures.push(PIXI.TextureCache[image])
                        });
                        emiter = new cloudkid.Emitter(
                            this.reasureOpenFx,
                            textures,
                            config
                        );
                        emiter.emit = true;
                        Game.lvl.pausedUpdate.push(emiter);
                    }
                }.bind(this);
            }

            Game.lvl.guiContainer.addChild(this.container);
            this.update = function(){
                switch (this.state) {
                    case -1:
                        if (Game.lvl.camera.zoom > 1) {
                            Game.lvl.camera.scale(-0.05)
                        } else {
                            if (this.blackL.alpha < 0.7) {
                                this.blackL.alpha+=0.05;
                            } else {
                                this.state = 0;
                            }
                        }
                        break;
                    case 0:
                        this.timer++;
                        this.buttonContinue.scale.set(this.timer/10, this.timer/10);
                        this.escapeContainer.scale.set(this.timer/10, this.timer/10);
                        if (this.timer > 13) {
                            this.timer = 0;
                            this.state = 1;
                        }
                        break;
                    case 1:
                        if (this.stars.alpha <1) {
                            this.stars.alpha++;
                        } else if (this.star0.scale.x < 3.4) {
                            this.star0.scale.x = this.star0.scale.y = this.star0.scale.x+0.3;
                        } else if ((Game.lvl.objBuildings[0].hitPoints > 5)&&(this.star1.scale.x < 3.4)){
                            this.star1.scale.x = this.star1.scale.y = this.star1.scale.x+0.3;
                        } else if ((Game.lvl.objBuildings[0].hitPoints > 18)&&(this.star2.scale.x < 3.4)) {
                            this.star2.scale.x = this.star2.scale.y = this.star2.scale.x+0.3;
                        } else {
                            this.state = 2;
                            this.timer = 0;
                        }
                        break;
                    case 2:
                        if (!this.rewardedText) {
                            Game.font = Game.getFont(128);
                            this.rewardedText = new PIXI.Text(Game.strings[Game.language].wonGui.earned, {
                                font: Game.font,
                                align: 'center',
                                fill: Game.fillStyle
                            });
                            this.rewardedText.position = new Vec2(250, 800);
                            this.rewardedText.anchor.set(0.5, 0);
                            this.container.addChild(this.rewardedText);
                            Game.fillStyle = "#FFF2B3";
                            this.rewardedTextCount = new PIXI.Text(Game.lvl.gameLogic.skulls, {
                                font: Game.font,
                                align: 'center',
                                fill: Game.fillStyle
                            });
                            this.rewardedTextCount.setText(0);
                            this.rewardedTextCount.position = new Vec2(240, 880);
                            this.rewardedTextCount.anchor.set(0.5, 0);
                            this.container.addChild(this.rewardedTextCount);
                            this.rewardedSkullIcon = Game.lvl.pool.getSprite(Game.sprites['skullsWin']);
                            this.rewardedSkullIcon.scale.set(1,1);
                            this.rewardedSkullIcon.position.set(Game.width/4 - 240, 700);
                            this.container.addChild(this.rewardedSkullIcon);
                        } else {
                            if (++this.timer*3 < Game.lvl.gameLogic.skulls) {
                                this.rewardedTextCount.setText(' ' + this.timer*3);
                            } else {
                                this.rewardedTextCount.setText(' ' +  Game.lvl.gameLogic.skulls);
                                this.state = 3;
                                this.timer = 0;
                            }
                        }
                        break;
                    case 3:
                        if (this.treasure) {
                            if (++this.timer <= 9) {
                                this.treasure.scale.set(this.timer / 5, this.timer / 5)
                            } else {
                                var config = clone(Game.particlesList['treasure_background']);
                                config.pos.x = this.treasure.position.x;
                                config.pos.y = this.treasure.position.y - 12;
                                var textures = [];
                                config.images.forEach(function (image) {
                                    textures.push(PIXI.TextureCache[image])
                                });
                                this.emiter = new cloudkid.Emitter(
                                    this.treasureFx,
                                    textures,
                                    config
                                );
                                this.emiter.emit = true;
                                Game.lvl.pausedUpdate.push(this.emiter);
                                this.dialog = Game.lvl.pool.getSprite(Game.sprites.dialog);
                                this.dialog.scale.set(-0.7, 0.8);
                                this.dialog.position.set(Game.width * 3 / 4 + 180, 740);
                                this.container.addChild(this.dialog);
                                Game.font = Game.getFont(42);
                                this.dialogText = new PIXI.Text(Game.strings[Game.language].wonGui.dialog, {
                                    font: Game.font,
                                    align: 'center',
                                    fill: 'rgba(1, 1, 1, 1);',
                                    wordWrap: true,
                                    wordWrapWidth: 300
                                });
                                this.dialogText.position.set(Game.width * 3 / 4 + 180, 650);
                                this.container.addChild(this.dialogText);
                                this.timer = 0;
                                this.state = 4;
                            }
                        } else {
                            this.timer = 0;
                            this.state = 4;
                        }
                        break;
                    case 4:

                        break;
                }
            }
        }
    };


    Game.guiList.lose =  {
        x: 0,
        y: 0,
        width: Game.width  ,
        height: Game.heightShift,
        onTouch : function(touch) {
            return true;
        },
        draw : function(){
        },
        init: function(params){
            Game.lvl.pausedUpdate.push(this);
            this.timer = 0;
            this.state = -1;
            this.container = new PIXI.DisplayObjectContainer();
            this.container.position.set(0, (Game.heightShift - 1536)/2 + 176);


            this.blackL = new PIXI.Graphics();
            this.blackL.alpha = 0;
            this.blackL.beginFill(0x000000);
            this.blackL.moveTo(0,0);
            this.blackL.drawRect(0, 0, 1, 1);
            this.blackL.scale.set(Game.width, Game.heightShift);
            this.blackL.endFill();
            this.blackL.position.set(0, -((Game.heightShift - 1536)/2 + 176));
            this.container.addChild(this.blackL);

            this.buttonContinue = new PIXI.DisplayObjectContainer();
            this.buttonContinue.scale.set(0, 0);
            this.openChest = Game.lvl.audioPool.get('ChestOpen', 'ChestOpen', 0.3, 1);


            Game.font = Game.getFont(108);
            if (Game.language == "ru") {
                Game.font = Game.getFont(86);
            }
            this.Continue = new PIXI.Text(Game.strings[Game.language].loseGui.lose, {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle,
                width: 400
            });
            this.Continue.position = new Vec2(0,-116);

            this.buttonContinueSprite = Game.lvl.pool.getSprite(Game.sprites['Main+Victory']);
            this.buttonContinueSprite = Game.lvl.pool.getSprite(Game.sprites['Main+Victory']);
            this.buttonContinueSprite2 = Game.lvl.pool.getSprite(Game.sprites['MainAXE']);
            this.buttonContinueSprite2.scale.set(-1,1);
            this.buttonContinueSprite3 = Game.lvl.pool.getSprite(Game.sprites['MainAXE']);
            this.buttonContinueSprite4 = Game.lvl.pool.getSprite(Game.sprites['Defeat']);
            this.buttonContinueSprite4.position = new Vec2(0, -50);

            this.buttonContinueSprite2.position.x = -382;
            this.buttonContinueSprite3.position.x = 382;

            this.buttonContinueSprite2.position.y = 34;
            this.buttonContinueSprite3.position.y = 34;

            this.buttonContinue.addChild(this.buttonContinueSprite2);
            this.buttonContinue.addChild(this.buttonContinueSprite3);
            this.buttonContinue.addChild(this.buttonContinueSprite);
            this.buttonContinue.addChild(this.buttonContinueSprite4);

            this.buttonContinueSpriteTouched = Game.lvl.pool.getSprite(Game.sprites.BattlePressed);
            this.buttonContinueSpriteTouched.position.set(0, -44);
            this.buttonContinueSpriteTouched.scale.set(1.81, 1.85);
            this.buttonContinueSpriteTouched.alpha = 0;
            this.buttonContinue.addChild(this.buttonContinueSpriteTouched);
            this.buttonContinue.addChild(this.Continue);

            this.buttonContinueSpriteTouched.interactive = true;
            this.buttonContinueSpriteTouched.mousedown = this.buttonContinueSpriteTouched.touchstart = function () {
                this.yestochedContinue = true;
                this.buttonContinueSpriteTouched.alpha = 0.6;
            }.bind(this);

            this.buttonContinueSpriteTouched.mouseup = this.buttonContinueSpriteTouched.touchend  = function () {
                if (this.yestochedContinue) {
                    Game.lvl.cameraContainer.filters = null;
                    this.buttonContinueSpriteTouched.alpha = 0;
                    this.yestochedContinue = false;
                    setTimeout(function(){
                        Game.lvl.objMap.background.unload(true);
                        Game.menu.enterMenu(true);
                    }, 1);
                }
            }.bind(this);

            this.buttonContinueSpriteTouched.mouseupoutside = this.buttonContinueSpriteTouched.touchendoutside = function () {
                this.buttonContinueSpriteTouched.alpha = 0;
                this.yestochedContinue = false;
            }.bind(this);

            this.buttonContinue.position = new Vec2(Game.width/2, 500);
            this.container.addChild(this.buttonContinue);


            this.escapeContainer = new PIXI.Container();
            this.escapeSprite = Game.lvl.pool.getSprite(Game.sprites['EscapeNormal']);
            this.escapeContainer.scale.set(0, 0);
            this.escapeContainer.interactive = true;
            this.escapeContainer.mousedown = this.escapeContainer.touchstart = function () {
                this.escapeSprite = Game.lvl.pool.switchSprite(Game.sprites['EscapePressed'], this.escapeSprite);
                this.yestoched = true;
            }.bind(this);
            this.escapeContainer.mouseup = this.escapeContainer.touchend = this.escapeContainer.mouseupoutside = this.escapeContainer.touchendoutside = function () {
                this.escapeSprite = Game.lvl.pool.switchSprite(Game.sprites['EscapeNormal'], this.escapeSprite);
                if (this.yestoched) {
                    this.yestoched = false;
                    this.yestochedContinue = false;
                    setTimeout(function(){
                        Game.lvl.objMap.background.unload(true);
                        Game.menu.enterMenu(true);
                    }, 1);
                }
            }.bind(this);
            this.escapeContainer.position.set(1820, 200);
            this.escapeContainer.addChild(this.escapeSprite);
            this.container.addChild(this.escapeContainer);

            Game.font = Game.getFont(76);
            this.buttonRestart = new PIXI.DisplayObjectContainer();
            this.buttonRestart.scale.set(0, 0);

            Game.fillStyle = "#FFF2B3";
            this.Restart = new PIXI.Text(Game.strings[Game.language].loseGui.restart, {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle,
                width: 400
            });
            this.Restart.position = new Vec2(0,-34);

            this.buttonRestartSprite = Game.lvl.pool.getSprite(Game.sprites.ButtonInPauseIdle);
            this.buttonRestart.addChild(this.buttonRestartSprite);
            this.buttonRestart.addChild(this.Restart);

            this.buttonRestart.interactive = true;
            this.buttonRestart.mousedown = this.buttonRestart.touchstart = function () {
                this.yestochedRestart = true;
                this.buttonRestartSprite = Game.lvl.pool.switchSprite(Game.sprites.ButtonInPausePressed, this.buttonRestartSprite);
            }.bind(this);

            this.buttonRestart.mouseup = this.buttonRestart.touchend  = function () {
                if (this.yestochedRestart) {
                    Game.lvl.cameraContainer.filters = null;
                    this.yestochedRestart = false;
                    setTimeout(function(){
                        Game.menu.playLvl();
                    },1);
                }
            }.bind(this);

            this.buttonRestart.mouseupoutside = this.buttonRestart.touchendoutside = function () {
                this.yestochedRestart = false;
                this.buttonRestartSprite = Game.lvl.pool.switchSprite(Game.sprites.ButtonInPauseIdle, this.buttonRestartSprite);
            }.bind(this);

            this.buttonRestart.position = new Vec2(Game.width/2, 950);
            this.container.addChild(this.buttonRestart);

            Game.lvl.guiContainer.addChild(this.container);

            this.update = function(){
                switch (this.state) {
                    case -1:
                        if (Game.lvl.camera.zoom > 1) {
                            Game.lvl.camera.scale(-0.05)
                        } else {
                            if (this.blackL.alpha < 0.7) {
                                this.blackL.alpha+=0.05;
                            } else {
                                this.state = 0;
                            }
                        }
                        break;
                    case 0:
                        this.timer++;
                        this.buttonContinue.scale.set(this.timer/10, this.timer/10);
                        this.escapeContainer.scale.set(this.timer/10, this.timer/10);
                        if (this.timer > 13) {
                            this.timer = 0;
                            this.state = 1;
                        }
                        break;
                    case 1:
                        if (!this.rewardedText) {
                            Game.fillStyle = "#FFF2B3";
                            Game.font = Game.getFont(128);
                            this.rewardedText = new PIXI.Text(Game.strings[Game.language].wonGui.earned, {
                                font: Game.font,
                                align: 'center',
                                fill: Game.fillStyle
                            });
                            this.rewardedText.position = new Vec2(250, 800);
                            this.rewardedText.anchor.set(0.5, 0);
                            this.container.addChild(this.rewardedText);
                            Game.fillStyle = "#FFF2B3";
                            this.rewardedTextCount = new PIXI.Text(Game.lvl.gameLogic.skulls, {
                                font: Game.font,
                                align: 'center',
                                fill: Game.fillStyle
                            });
                            this.rewardedTextCount.setText(0);
                            this.rewardedTextCount.position = new Vec2(240, 880);
                            this.rewardedTextCount.anchor.set(0.5, 0);
                            this.container.addChild(this.rewardedTextCount);
                            this.rewardedSkullIcon = Game.lvl.pool.getSprite(Game.sprites['skullsWin']);
                            this.rewardedSkullIcon.scale.set(1,1);
                            this.rewardedSkullIcon.position.set(Game.width/4 - 240, 700);
                            this.container.addChild(this.rewardedSkullIcon);
                        } else {
                            if (++this.timer*3 < Game.lvl.gameLogic.skulls) {
                                this.rewardedTextCount.setText(' ' + this.timer*3);
                            } else {
                                this.rewardedTextCount.setText(' ' +  Game.lvl.gameLogic.skulls);
                                this.state = 2;
                                this.timer = 0;
                            }
                        }
                        break;
                    case 2:
                        this.timer++;
                        this.buttonRestart.scale.set(this.timer/10, this.timer/10);
                        if (this.timer == 10) {
                            this.timer = 0;
                            this.state = 3;
                        }
                        break;
                    case 3:
                        break;

                }
            }
        }
    };

    Game.guiList.itemsButton = {
        parent: Game.guiList.ability,
        x: Game.width - (16+170),
        y: Game.heightShift - (16+180),
        width: 160,
        height: 160,
        onTouch: function(touch) {
            Game.lvl.audioPool.get('BagOpen', 'BagOpen', 0.3, 2).play();
            if (this.state == 'Pressed') {
                this.state = '';
                Game.lvl.objGui.forEach(function (gui){
                    if (gui.itemGui)
                        gui.hide();
                })
            } else {
                this.state = 'Pressed';
                Game.lvl.objGui.forEach(function (gui){
                    if (gui.itemGui)
                        gui.show();
                })
            }
            touch.touchedEnd = true;
        },
        init: function (params) {
            this.y = this.base.y = Game.heightShift - (16 + 180);
            this.bonusLineButtons = true;
            this.position = new Vec2((this.x+this.width/2), (this.y+this.height/2));
            this.state = '';
            this.backbutton = Game.lvl.pool.getSprite(Game.sprites['BagGui']);
            this.backbutton.position = this.position;
            this.button = Game.lvl.pool.getSprite(Game.sprites['Bag']);
            this.button.position = this.position.clone().add(new Vec2(10,19));
            Game.lvl.guiContainer.addChild(this.backbutton);
            Game.lvl.guiContainer.addChild(this.button);
        }
    };

    Game.guiList.item =  {
        onTouch : function(touch) {
            if (this.canBeCasted()) {
                if (this.state == 'Pressed') {
                    this.state = '';
                    Game.lvl.objGui[0].handleClick = null;
                    this.cancelSprite.alpha = 0;
                } else {
                    if (Game.lvl.objGui[0].handleClick){
                        Game.lvl.objGui[0].handleClick(false);
                    }
                    Game.lvl.objGui[0].handleClick = this.onMapClick;
                    this.cancelSprite.alpha = 1;
                    this.state = 'Pressed';
                }
                touch.touchedEnd = true;
            }
        },
        draw : function(){
        },
        init: function (params) {
            this.y = this.base.y = Game.heightShift - (16 + 160 * this.base.ynumber);
            this.base = params;
            this.bonusLineButtons = true;
            this.itemGui = true;
            this.position = new Vec2((this.x+this.width/2), (this.y+this.height/2));
            this.position.x += this.width;
            this.hidden = true;
            this.state = '';
            this.moveX = 0;
            this.moveSpeed = 30;
            this.itemName = params.itemName;
            this.cast = params.cast;
            if (params.castSound)
                this.castSound = Game.lvl.audioPool.get('cast'+this.itemName, params.castSound, 0.3, 2);

            this.canBeCasted = function () {
                //return true; //TODO DEBUG
                return Game.globallogic[this.itemName] > 0;
            };
            this.onMapClick = function (touch){
                this.state = '';
                Game.lvl.objGui[0].handleClick = null;
                if (!touch || !this.canBeCasted()) {

                } else {
                    Game.globallogic.useItem(this.itemName);
                    touch.touchedEnd = true;
                    this.castSound && this.castSound.play();
                    this.cast(Game.lvl.camera.getMovedPosition(touch.startPosition.clone()));
                }
                this.countText.setText(Game.globallogic[this.itemName]);
                this.countText.container.position = new Vec2(Game.globallogic[this.itemName] >= 10 ? 48 : 60, -38);
                this.cancelSprite.alpha = 0;
            }.bind(this);

            this.guiContainer = new PIXI.Container();
            this.ability = Game.lvl.pool.getSprite(Game.sprites[this.itemName + 'Scroll']);
            this.ability.scale.set(0.95, 0.95);
            this.cancelSprite = Game.lvl.pool.getSprite(Game.sprites['selectedScroll']);
            this.lockedSprite = Game.lvl.pool.getSprite(Game.sprites['lockedScroll']);
            this.guiContainer.addChild(this.cancelSprite);
            this.guiContainer.addChild(this.ability);
            this.guiContainer.addChild(this.lockedSprite);
            this.guiContainer.position = this.position;
            Game.lvl.guiContainer.addChild(this.guiContainer);
            this.cancelSprite.alpha = 0;

            Game.font = Game.getFont(36);
            Game.fillStyle = "#FF4500";
            Game.textAlign = "center";

            this.countText = new SimpleFont('', 'red');
            this.countText.setText(Game.globallogic[this.itemName]);
            this.countText.container.position = new Vec2(Game.globallogic[this.itemName] >= 10 ? 48 : 60, -38);
            this.countText.container.scale.set(0.4,0.4);

            this.circle = Game.lvl.pool.getSprite(Game.sprites['circleScroll']);
            this.circle.scale.set(1.4, 1.4);
            this.circle.position.set(60, -36);
            this.guiContainer.addChild(this.circle);
            this.guiContainer.addChild(this.countText.container);

            if (!this.canBeCasted()) {
                //this.lockedSprite = Game.lvl.pool.getSprite(Game.sprites['abilityButtonDisabled']);
            }
            this.hide = function () {
                if (Game.lvl.objGui[0].handleClick == this.onMapClick) {
                    Game.lvl.objGui[0].handleClick = null;
                }
                this.moveX += this.width;
                this.hidden = true;
                this.cd = 0;
                this.guiContainer.removeChild(this.grayCircle);
                this.guiContainer.removeChild(this.cdCircle);
            };
            this.show = function (){
                this.hidden = false;
                this.moveX -= this.width;
                this.guiContainer.visible = !this.hidden;
            };

            this.update = function () {
                this.lockedSprite.alpha = Game.globallogic[this.itemName] > 0 ? 0 : 1;
                if (this.moveX != 0) {
                    var toMove = Math.abs(this.moveX) - this.moveSpeed >= 0? this.moveSpeed : this.moveSpeed - Math.abs(Math.abs(this.moveX) - this.moveSpeed);
                    this.position.x += this.moveX > 0 ? toMove : -toMove;
                    this.moveX += this.moveX > 0 ? -toMove : +toMove;
                } else {
                    this.guiContainer.visible = !this.hidden;
                }
            };
        }
    };

    Game.guiList.itemBomb = {
        parent: Game.guiList.item,
        x: Game.width - 220,
        y: Game.heightShift - (16 + 160 * 2),
        ynumber:2,
        width: 220,
        height: 160,
        damage: 1000,
        itemName: 'bomb',
        cast: function (position) {
            Game.lvl.objEffect.push(new BoombScrollFX(position, this.base.damage));
        },
        onTouch: function(touch) {
            this.parent.onTouch.call(this, touch);
        },
        init: function(params) {
            this.parent = params.parent;
            this.parent.init.call(this, params);
        }
    };

    Game.guiList.itemGoldBag = {
        parent: Game.guiList.item,
        x: Game.width - 220,
        y: Game.heightShift - (16 + 160 * 3),
        ynumber:3,
        width: 220,
        height: 160,
        money: 600,
        itemName: 'goldBag',
        castSound:'Gold',
        cast: function (position) {
            var config = clone(Game.particlesList['Coins']);
            config.pos.x = position.x;
            config.pos.y = position.y + 64;
            var textures = [];
            config.images.forEach(function(image){
                textures.push(PIXI.TextureCache[image])
            });
            this.emiter = new cloudkid.Emitter(
                Game.lvl.containerForParticle(config),
                textures,
                config
            );
            this.emiter.emit = true;
            Game.lvl.objPartilces.push(this.emiter);
            Game.lvl.gameLogic.resource += this.base.money;
            Game.lvl.objEffect.push(new moneyEffect(this.base.money, new Vec2(100, 150), true));
        },
        onTouch: function(touch) {
            this.parent.onTouch.call(this, touch);
        },
        draw: function() {
            this.parent.draw.call(this);
        },
        init: function(params) {
            this.parent = params.parent;
            this.parent.init.call(this, params);
        }
    };

    Game.guiList.itemIceStaff = {
        parent: Game.guiList.item,
        x: Game.width - 220,
        y: Game.heightShift - (16 + 160 * 4),
        ynumber: 4,
        width: 220,
        height: 160,
        itemName: 'iceStaff',
        frezeTime: 10000,
        castSound:'IceScroll',
        cast: function (position) {
            var config = clone(Game.particlesList['Snow_Storm']);
            config.pos.x = position.x;
            config.pos.y = position.y + 64;
            var textures = [];
            config.images.forEach(function(image){
                textures.push(PIXI.TextureCache[image])
            });
            this.emiter = new cloudkid.Emitter(
                Game.lvl.containerForParticle(config),
                textures,
                config
            );
            this.emiter.emit = true;
            Game.lvl.objPartilces.push(this.emiter);

            var that = this;
            var tiles = [], tempTile;
            for (var x = -3; x <=3; x++){
                for (var y = -3; y <=3; y++){
                    tempTile = Game.lvl.objMap.getTruthTile(position.clone().add(x*64, y*64));
                    if (tempTile)
                        tiles.push(tempTile);
                }
            }
            var enemies = [];
            tiles.forEach(function (tile) {
                tile.eObjects.forEach(function (enemy) {
                    if (enemy.hitPoints > 0) {
                        enemies.push(enemy);
                        Buf.prototype.addBuf(enemy, 'freze', 'speed', 1, 'div', that.base.frezeTime, null, Game.lvl.effectContainer, 'Ice_Grown', function(){
                            Game.lvl.objEffect.push(new EffectSmall(enemy.position, Game.lvl.effectContainer, Game.animations['Ice_Idle'], that.base.frezeTime - Game.animations['Ice_Grown'].playTime, true, function(){
                                Game.lvl.objEffect.push(new EffectSmall(enemy.position, Game.lvl.effectContainer, Game.animations['Ice_Melt'], Game.animations['Ice_Melt'].playTime, false))
                            }))
                        }, this);
                        enemy.frezeTimeout = that.base.frezeTime;
                        enemy.animation.stop();
                    }
                });
            });
        },
        onTouch: function(touch) {
            this.parent.onTouch.call(this, touch);
        },
        draw: function() {
            this.parent.draw.call(this);
        },
        init: function(params) {
            this.parent = params.parent;
            this.parent.init.call(this, params);
        }
    };

    Game.guiList.itemMeteorite = {
        parent: Game.guiList.item,
        x: Game.width - 220,
        y: Game.heightShift - (16 + 160 * 5),
        ynumber: 5,
        width: 220,
        height: 160,
        damage: 1000,
        itemName: 'meteorite',
        cast: function (position) {
            Game.events.emit('armageddon');
            var that = this;
            var tiles = [], tempTile;
            for (var i = 0; i < myPofigRandom(4,8); i++) {
                setTimeout(function(){
                    Game.lvl.objEffect.push(new MeteoritteFireMage(position.clone().add(new Vec2(-64*3+myRandom(1, 64*6),-64*3+myRandom(1,64*6))), that.base.damage, 2, false));
                }, 150*i)
            }
        },
        onTouch: function(touch) {
            this.parent.onTouch.call(this, touch);
        },
        draw: function() {
            this.parent.draw.call(this);
        },
        init: function(params) {
            this.parent = params.parent;
            this.parent.init.call(this, params);
        }
    };

    Game.guiList.itemLife = {
        parent: Game.guiList.item,
        x: Game.width - 220,
        y: Game.heightShift - (16 + 160 * 6),
        ynumber: 6,
        width: 220,
        height: 160,
        itemName: 'life',
        lifes: 5,
        castSound:'Heal_Scroll',
        cast: function (position) {
            var config = clone(Game.particlesList['Hearts']);
            config.pos.x = position.x;
            config.pos.y = position.y + 64;
            var textures = [];
            config.images.forEach(function(image){
                textures.push(PIXI.TextureCache[image])
            });
            this.emiter = new cloudkid.Emitter(
                Game.lvl.containerForParticle(config),
                textures,
                config
            );
            this.emiter.emit = true;
            Game.lvl.objPartilces.push(this.emiter);

            config = clone(Game.particlesList['Hearts']);
            config.pos.x = Game.lvl.townHall.position.x + Game.lvl.townHall.hitPosition.x*2;
            config.pos.y = Game.lvl.townHall.position.y + Game.lvl.townHall.hitPosition.y;
            textures = [];
            config.images.forEach(function(image){
                textures.push(PIXI.TextureCache[image])
            });
            this.emiter = new cloudkid.Emitter(
                Game.lvl.containerForParticle(config),
                textures,
                config
            );
            this.emiter.emit = true;
            Game.lvl.objPartilces.push(this.emiter);
            Game.lvl.townHall.hitPoints += this.base.lifes;
        },
        onTouch: function(touch) {
            this.parent.onTouch.call(this, touch);
        },
        draw: function() {
            this.parent.draw.call(this);
        },
        init: function(params) {
            this.parent = params.parent;
            this.parent.init.call(this, params);
        }
    };

    Game.guiList.itemResurrection = {
        parent: Game.guiList.item,
        x: Game.width - 220,
        y: Game.heightShift - (16 + 160 * 7),
        ynumber: 7,
        width: 220,
        height: 160,
        itemName: 'resurrection',
        lifes: 5,
        castSound:'Heal_Scroll',
        cast: function (position) {
            Game.lvl.objFriendly.forEach(function(friendly) {
                friendly.hitPoints = friendly.maxHitPoints;
                if (friendly.deadTimer > 0) {
                    friendly.deadTimer = 0;
                    friendly.movePosition(friendly.basePosition);
                }
                Buf.prototype.addBuf(friendly, 'heal', 'hitPoints', 100, 'heal', 1000, null, Game.lvl.effectContainer, 'heal', null);
            })
        },
        onTouch: function(touch) {
            this.parent.onTouch.call(this, touch);
        },
        draw: function() {
            this.parent.draw.call(this);
        },
        init: function(params) {
            this.parent = params.parent;
            this.parent.init.call(this, params);
        }
    };

    Game.guiList.ability =  {
        onTouch : function(touch) {
            if (this.canBeCasted()) {
                if (this.state == 'Pressed') {
                    this.state = '';
                    //this.button = Game.lvl.pool.switchSprite(Game.sprites['abilityButton'+ this.state], this.button);
                    this.guiContainer.removeChild(this.cancelSprite);
                    Game.lvl.objGui[0].handleClick = null;
                } else {
                    if (Game.lvl.objGui[0].handleClick){
                        Game.lvl.objGui[0].handleClick(false);
                    }
                    Game.lvl.objGui[0].handleClick = this.onMapClick;
                    this.state = 'Pressed';
                    //this.button = Game.lvl.pool.switchSprite(Game.sprites['abilityButton'+ this.state], this.button);
                    this.guiContainer.addChild(this.cancelSprite);
                }
                touch.touchedEnd = true;
            }
        },
        draw : function() {},
        init : function(params) {
            this.abilityNumber = params.abilityNumber;

            if (this.abilityNumber == 1) {
                this.y = this.base.y = Game.heightShift - (16+146*2);
            } else {
                this.y = this.base.y = Game.heightShift - (16+139);
            }

            this.hero = Game.lvl.gameLogic.hero;
            this.abilityFunction = this.abilityNumber == 1 ? this.hero.ability1 : this.hero.ability2;

            this.position = new Vec2((this.x+this.width/2), (this.y+this.height/2));
            //this.position.x -= 372;
            this.hidden = false;
            this.state = '';
            this.moveX = 0;
            this.moveSpeed = 30;
            this.onMapClick = function (touch){
                this.state = '';
                this.guiContainer.removeChild(this.cancelSprite);
                Game.lvl.objGui[0].handleClick = null;
                //this.button = Game.lvl.pool.switchSprite(Game.sprites['abilityButton'+ this.state], this.button);
                if (!touch || !this.canBeCasted()) {
                    this.guiContainer.removeChild(this.cancelSprite);
                } else {
                    Game.lvl.gameLogic.lazarus = false;
                    touch.touchedEnd = true;
                    this.abilityFunction(Game.lvl.camera.getMovedPosition(touch.startPosition.clone()), this);
                    this.hero['ability'+this.abilityNumber+'Sound'] && this.hero['ability'+this.abilityNumber+'Sound'].play();
                }
            }.bind(this);

            this.cd = 0;
            this.lastCd = 0;
            this.fullCd = 0;

            //this.grayCircle = new PIXI.Graphics();
            //this.grayCircle.alpha = 0.3;
            //this.grayCircle.beginFill(0x111111);
            //this.grayCircle.moveTo(0,0);
            //this.grayCircle.arc(0, 0, 60, 0, Math.PI*2, false);
            //this.grayCircle.endFill();
            //
            //this.cdCircle = new PIXI.Graphics();
            //this.cdCircle.alpha = 0.7;
            //this.cdCircle.beginFill(0x111111);
            //this.cdCircle.moveTo(0,0);
            //this.cdCircle.arc(0, 0, 60, 0, Math.PI*2, false);
            //this.cdCircle.endFill();

            this.guiContainer = new PIXI.Container();
            //this.button = Game.lvl.pool.getSprite(Game.sprites['abilityButton'+ this.state]);
            this.ability = Game.lvl.pool.getSprite(Game.sprites['abilityes' + (Game.menu.selectedLvl == "0" ? "warrior" :  Game.globallogic.selectedHero.name) + this.abilityNumber]);
            this.ability.position.set(-3,-3);
            this.ability.scale.set(0.8, 0.8);
            //this.guiContainer.addChild(this.button);
            this.guiContainer.addChild(this.ability);
            this.guiContainer.position = this.position;
            Game.lvl.guiContainer.addChild(this.guiContainer);
            this.cancelSprite = Game.lvl.pool.getSprite(Game.sprites['abilityButtonCancel']);
            this.cancelSprite.position = new Vec2(-15,15);
            this.canBeCasted = function (){
                return this.hero.hitPoints > 0 && this.cd <=0;
            };

            if (!this.canBeCasted()){
                this.lockedSprite = Game.lvl.pool.getSprite(Game.sprites['abilityButtonDisabled']);
            }
            this.onDay = function (){
                if (Game.lvl.objGui[0].handleClick == this.onMapClick)
                    Game.lvl.objGui[0].handleClick = null;

                this.position.x = this.x+this.width/2;
                this.moveX -= 372;
                this.hidden = true;
            };
            this.onNight = function (){
                this.hidden = false;
                this.position.x = this.x+this.width/2-372;
                this.moveX += 372;
            };
            this.cd315 = Game.lvl.pool.getSprite(Game.sprites['abilityCd']);
            this.cd270 = Game.lvl.pool.getSprite(Game.sprites['abilityCd']);
            this.cd225 = Game.lvl.pool.getSprite(Game.sprites['abilityCd']);
            this.cd180 = Game.lvl.pool.getSprite(Game.sprites['abilityCd']);
            this.cd135 = Game.lvl.pool.getSprite(Game.sprites['abilityCd']);
            this.cd90 = Game.lvl.pool.getSprite(Game.sprites['abilityCd']);
            this.cd45 = Game.lvl.pool.getSprite(Game.sprites['abilityCd']);
            this.cd0 = Game.lvl.pool.getSprite(Game.sprites['abilityCd']);

            this.cd270.rotation = Math.PI/4;
            this.cd225.rotation = Math.PI/2;
            this.cd180.rotation = Math.PI*3/4;
            this.cd135.rotation = Math.PI;
            this.cd90.rotation = Math.PI*5/4;
            this.cd45.rotation = Math.PI*3/2;
            this.cd0.rotation = Math.PI*7/4;

            this.cd0.alpha = this.cd45.alpha = this.cd90.alpha = this.cd135.alpha = this.cd180.alpha = this.cd225.alpha = this.cd270.alpha = this.cd315.alpha = 0;

            this.guiContainer.addChild(this.cd45);
            this.guiContainer.addChild(this.cd90);
            this.guiContainer.addChild(this.cd135);
            this.guiContainer.addChild(this.cd180);
            this.guiContainer.addChild(this.cd225);
            this.guiContainer.addChild(this.cd270);
            this.guiContainer.addChild(this.cd315);
            this.guiContainer.addChild(this.cd0);
            //Game.lvl.gameLogic.onDayCallBack.push(this.onDay.bind(this));
            //Game.lvl.gameLogic.onNightCallBack.push(this.onNight.bind(this));
            this.lastHp = false;
            this.update = function () {
                if (this.moveX != 0) {
                    var toMove = Math.abs(this.moveX) - this.moveSpeed >= 0? this.moveSpeed : this.moveSpeed - Math.abs(Math.abs(this.moveX) - this.moveSpeed);
                    this.position.x += this.moveX > 0 ? toMove : -toMove;
                    this.moveX += this.moveX > 0 ? -toMove : +toMove;
                }
                if (this.lastCd != this.cd ) {
                    this.cd -= Game.cycleTickTime*Game.speed;
                    if (this.cd > 0 ) {
                        //var from = (this.cd - (this.cd % 45));
                        var from = (this.cd/this.fullCd) * 360;
                        for (var i = 0; i < 360; i+=45){
                            if (i < from) {
                                this['cd'+i] && (this['cd'+i].alpha = 1);
                            } else {
                                this['cd'+i] && (this['cd'+i].alpha = 0);
                            }
                        }
                        //this.guiContainer.addChild(this.grayCircle);
                        //this.cdCircle.clear();
                        //this.cdCircle.beginFill(0x111111);
                        //this.cdCircle.moveTo(0,0);
                        //this.cdCircle.arc(0, 0, 60, Math.PI*3/2 -((this.cd/this.fullCd)*Math.PI*2 -Math.PI*2), Math.PI*2+Math.PI*3/2, false);
                        //this.cdCircle.endFill();
                        //this.guiContainer.addChild(this.cdCircle);
                    } else {
                        this.cd = 0;
                        this.lastCd = 0;
                        this.cd0.alpha = this.cd45.alpha = this.cd90.alpha = this.cd135.alpha = this.cd180.alpha = this.cd225.alpha = this.cd270.alpha = this.cd315.alpha = 0;
                        //this.guiContainer.removeChild(this.grayCircle);
                        //this.guiContainer.removeChild(this.cdCircle);
                    }
                }
                if ((this.hero.hitPoints <=0) != this.lastHp) {
                    this.lastHp = this.hero.hitPoints <=0;
                    if (this.lastHp) {
                        this.onDay();
                    } else {
                        this.onNight();
                    }
                }
            };
        }
    };

    Game.guiList.heroPortarit = {
        parent: Game.guiList.ability,
        x: 32,
        y: Game.heightShift - (16+160) ,
        width: 160,
        height: 160,
        onTouch: function(touch){
            if (this.hero.hitPoints > 0) {
                if (this.state == 'Pressed') {
                    Game.lvl.objGui[0].handleClick = null;
                    this.select(false);
                    if (this.selectedItem) {
                        this.selectedItem.del();
                        Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this.selectedItem), 1);
                        this.selectedItem = null;
                    }
                } else {
                    this.select(true);
                    this.selectedItem = new selectedEffect(this.hero);
                    Game.lvl.objEffect.push(this.selectedItem);
                    if (Game.lvl.objGui[0].handleClick) {
                        Game.lvl.objGui[0].handleClick(false);
                    }
                    Game.lvl.objGui[0].handleClick = this.onMapClick;
                }
                touch.touchedEnd = true;
            }
        },
        init: function (params) {
            this.x = this.base.x = 32;
            this.y = this.base.y = Game.heightShift - (16 + 160);

            this.hero = Game.lvl.gameLogic.hero;
            this.hero.button = this;
            this.position = new Vec2((this.x+this.width/2), (this.y+this.height/2));
            //this.position.x -= 372;
            this.hidden = false;
            this.state = '';
            this.moveX = 0;
            this.moveSpeed = 30;

            this.select = function(on) {
                if (on) {
                    this.hero.heroSelect && this.hero.heroSelect.play();
                    this.state = 'Pressed';
                    this.guiContainer.addChild(this.cancelSprite);
                } else {
                    this.state = '';
                    this.guiContainer.removeChild(this.cancelSprite);
                    if (Game.lvl.objGui[0].selectedEffect) {
                        Game.lvl.objGui[0].selectedEffect.del();
                        if (Game.lvl.objEffect.indexOf(Game.lvl.objGui[0].selectedEffect) != -1)
                            Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(Game.lvl.objGui[0].selectedEffect), 1);
                        Game.lvl.objGui[0].selectedEffect = null;
                        Game.lvl.objGui[0].selectedItem = null;
                    }
                }
            };
            this.onMapClick = function (touch) {
                this.state = '';
                this.guiContainer.removeChild(this.cancelSprite);
                Game.lvl.objGui[0].handleClick = null;
                if (!touch) {
                    this.guiContainer.removeChild(this.cancelSprite);
                } else {
                    this.hero.heroOrder && this.hero.heroOrder.play();
                    touch.touchedEnd = true;
                    Game.lvl.objEffect.push(new Effect(Game.lvl.camera.getMovedPosition(touch.startPosition.clone()), new Vec2(0,0), Game.lvl.objEffect, Game.animations.MoveMarker, Game.animations.MoveMarker.playTime, 1, null, false, true));
                    this.hero.movePosition(Game.lvl.camera.getMovedPosition(touch.startPosition.clone()));
                }
                if (this.selectedItem) {
                    this.selectedItem.del();
                    Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this.selectedItem), 1);
                    this.selectedItem = null;
                }
            }.bind(this);

            this.guiContainer = new PIXI.Container();

            //this.cdCircle = new PIXI.Graphics();
            //this.cdCircle.beginFill();
            //this.cdCircle.moveTo(0,0);
            //this.cdCircle.arc(0, 0, 60, 0, Math.PI*2, false);
            //this.cdCircle.endFill();
            //this.guiContainer.addChild(this.cdCircle);

            this.button = Game.lvl.pool.getSprite(Game.sprites['HeroGui']);
            this.button.pivot = new Vec2(-82, 83);
            this.portrait = Game.lvl.pool.getSprite(Game.sprites['heroIcon'+(Game.menu.selectedLvl == "0" ? "warrior" :  Game.globallogic.selectedHero.name)+'C']);
            //this.portrait.mask = this.cdCircle;
            this.portrait.scale.set(1.1, 1.1);
            this.guiContainer.addChild(this.button);
            this.guiContainer.addChild(this.portrait);
            this.guiContainer.position = this.position;
            Game.lvl.guiContainer.addChild(this.guiContainer);
            this.cancelSprite = Game.lvl.pool.getSprite(Game.sprites['abilityButtonCancel']);

            this.onDay = function () {
                this.position.x = 112;
                this.moveX -= 372;
                this.hidden = true;
            };
            this.onNight = function () {
                this.position.x = 112 - 372;
                this.hidden = false;
                this.moveX += 372;
            };
            this.lastHp = false;
            this.update = function () {
                if (this.moveX != 0) {
                    var toMove = Math.abs(this.moveX) - this.moveSpeed >= 0? this.moveSpeed : this.moveSpeed - Math.abs(Math.abs(this.moveX) - this.moveSpeed);
                    this.position.x += this.moveX > 0 ? toMove : -toMove;
                    this.moveX += this.moveX > 0 ? -toMove : +toMove;
                }
                if ((this.hero.hitPoints <=0) != this.lastHp) {
                    this.lastHp = this.hero.hitPoints <=0;
                    if (this.lastHp) {
                        this.onDay();
                    } else {
                        this.onNight();
                    }
                }
            };
        }
    };


    Game.guiList.ability1 = {
        parent: Game.guiList.ability,
        x: 31,
        y: Game.heightShift - (16+146*2) ,
        width: 142,
        height: 145,
        abilityNumber: 1,
        onTouch: function(touch) {
            this.parent.onTouch.call(this, touch);
        },
        draw: function() {
            this.parent.draw.call(this);
        },
        init: function(params) {
            this.parent = params.parent;
            this.parent.init.call(this, params);
        }
    };

    Game.guiList.ability2 = {
        parent: Game.guiList.ability,
        x: 32+(16+137),
        y: Game.heightShift - (16+139),
        width: 140,
        height: 160,
        abilityNumber: 2,
        onTouch: function(touch){
            this.parent.onTouch.call(this, touch);
        },
        draw: function(){
            this.parent.draw.call(this);
        },
        init: function(params){
            this.parent = params.parent;
            this.parent.init.call(this, params);
        }
    };

    Game.guiList.message =  {
        x: 0,
        y: 0,
        width: Game.width  ,
        height: Game.heightShift,
        onTouch : function(touch) {
            return true;
        },
        draw : function(){},
        init: function() {
            Game.lvl.paused = true;
            Game.lvl.objGui.push(this);
            this.timer = 0;
            this.state = 0;
            this.container = new PIXI.DisplayObjectContainer();
            this.container.position.set(Game.width/2, Game.heightShift/2);

            this.container.addChild(getMessageBackground(function(){
                if (Game.lvl.pausedUpdate.indexOf(this) != -1) {
                    this.touched = false;
                    Game.lvl.objGui.splice(Game.lvl.objGui.indexOf(this), 1);
                    Game.lvl.pausedUpdate.splice(Game.lvl.pausedUpdate.indexOf(this), 1);
                    //this.description._texture.baseTexture.source.dispose && this.description._texture.baseTexture.source.dispose();
                    //this.special._texture.baseTexture.source.dispose && this.special._texture.baseTexture.source.dispose();
                    this.title._texture.baseTexture.source.dispose && this.title._texture.baseTexture.source.dispose();
                    this.title.destroy(true);
                    Game.lvl.pool.pull(this.container);
                    Game.lvl.paused = false;
                    this.onClose && setTimeout(this.onClose,1);
                }
            }.bind(this)));
            this.container.children[0].scale.set(1.5,1.5);

            this.image = new PIXI.DisplayObjectContainer();
            this.image.position = new Vec2(-400, -20);
            this.container.addChild(this.image);


            Game.fillStyle = "#FFFFB3";
            Game.textAlign = 'center';
            Game.font = Game.getFont(64);

            this.description = new PIXI.extras.BitmapText("",
                {
                    font: Game.getFontBitmap(),
                    align: "center",
                    width: 770
                });
            this.description.position = new Vec2(110-550/2, -340);
            this.container.addChild(this.description);

            Game.fillStyle = "#FFFFB3";
            Game.textAlign = 'left';
            Game.font = Game.getFont(48);

            this.special = new PIXI.extras.BitmapText("",
                {
                    font: Game.getFontBitmap(),
                    align: "left",
                    width: 770
                });
            this.special.position = new Vec2(120-550/2, 130);
            this.container.addChild(this.special);


            Game.fillStyle = "#FFFFB3";
            Game.font = Game.getFont(76);
            this.title = new PIXI.Text(' ', {
                font: Game.font,
                align: 'center',
                fill: Game.fillStyle
            });
            this.title.anchor.set(1,0);
            this.title.position = new Vec2(150 + this.title.width/2, -450);
            this.container.addChild(this.title);

            //this.image.scale.set(3,3);
            //this.image.addChild(Game.lvl.pool.getSprite(Game.sprites[Game.animations.goblinFight1.sprites[0]]));
            //this.image.children[0].pivot.set(0,0);
            //this.image.children[0].anchor.set(0.5,0.5);

            this.setDescription = function(text){
                this.description.setText(text);
                return this;
            };

            this.setSpecial = function(text){
                this.special.setText(text);
                return this;
            };

            this.setTitle = function(text){
                this.title.setText(text);
                this.title.position = new Vec2(this.title.width/2, -450);
                return this;
            };
            this.setImage = function(image){
                this.image.addChild(image);
                return this;
            };
            this.setOnClose = function(onClose) {
                this.onClose = onClose;
                return this;
            };

            this.container.scale.set(0,0);
            Game.lvl.guiContainer.addChild(this.container);

            this.update = function(){
                switch (this.state) {
                    case 0:
                        this.timer+=2;
                        if (this.timer > 20){
                            this.timer = 0;
                            this.state = 1;
                            return;
                        }
                        this.container.scale.set(this.timer/20, this.timer/20);
                        this.container.rotation = Math.PI + Math.PI*20/this.timer;
                        break;
                    case 1:
                        break;
                }
            }
        }
    };

    Game.guiList.messageInfo =  {
        x: 0,
        y: 0,
        width: Game.width  ,
        height: Game.heightShift,
        onTouch : function(touch) {
            return true;
        },
        draw : function(){},
        init: function() {
            Game.lvl.paused = true;
            Game.lvl.objGui.push(this);
            this.timer = 0;
            this.state = 0;
            this.container = new PIXI.DisplayObjectContainer();
            this.container.position.set(Game.width/2, Game.heightShift/2);

            this.container.addChild(getMessageBackground(function(){
                if (Game.lvl.pausedUpdate.indexOf(this) != -1) {
                    this.touched = false;
                    Game.lvl.objGui.splice(Game.lvl.objGui.indexOf(this), 1);
                    Game.lvl.pausedUpdate.splice(Game.lvl.pausedUpdate.indexOf(this), 1);
                    this.description._texture.baseTexture.source.dispose && this.description._texture.baseTexture.source.dispose();
                    this.special._texture.baseTexture.source.dispose && this.special._texture.baseTexture.source.dispose();
                    this.title._texture.baseTexture.source.dispose && this.title._texture.baseTexture.source.dispose();
                    this.title.destroy(true);
                    this.description.destroy(true);
                    this.special.destroy(true);
                    Game.lvl.pool.pull(this.container);
                    Game.lvl.paused = false;

                    this.onClose && setTimeout(this.onClose,1);
                }
            }.bind(this)));

            Game.fillStyle = "#FFFFB3";
            Game.textAlign = 'center';
            Game.font = Game.getFont(64);

            this.description = new PIXI.Text(' ', {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle,
                wordWrapWidth: 570,
                wordWrap:true
            });
            this.description.position = new Vec2(260, -80);
            this.container.addChild(this.description);

            Game.fillStyle = "#FFFFB3";
            Game.textAlign = 'left';
            Game.font = Game.getFont(38);

            this.special = new PIXI.Text(' ', {
                font: Game.font,
                fill:Game.fillStyle,
                align: Game.textAlign,
                wordWrapWidth: 570,
                wordWrap:true
            });
            this.special.position = new Vec2(130, 130-this.special.height/2);
            this.container.addChild(this.special);


            Game.fillStyle = "#FFF2B3";
            Game.font = Game.getFont(76);
            this.title = new PIXI.Text(' ', {
                font: Game.font,
                align: 'center',
                fill: Game.fillStyle
            });
            this.title.anchor.set(1,0);
            this.title.position = new Vec2(130 + this.title.width/2, -300);
            this.container.addChild(this.title);

            this.image = new PIXI.DisplayObjectContainer();
            this.image.position = new Vec2(-280, -20);
            this.container.addChild(this.image);
            //this.image.scale.set(3,3);
            //this.image.addChild(Game.lvl.pool.getSprite(Game.sprites[Game.animations.goblinFight1.sprites[0]]));
            //this.image.children[0].pivot.set(0,0);
            //this.image.children[0].anchor.set(0.5,0.5);

            this.setMessage = function(text){
                this.description.setText(text);
                this.description.position = new Vec2(130, -170);
                return this;
            };

            this.setTitle = function(text){
                this.title.setText(text);
                this.title.position = new Vec2(80 + this.title.width/2, -300);
                return this;
            };
            this.setImage = function(image){
                this.image.addChild(image);
                return this;
            };
            this.setOnClose = function(onClose) {
                this.onClose = onClose;
                return this;
            };

            this.container.scale.set(0,0);
            Game.lvl.guiContainer.addChild(this.container);

            this.update = function(){
                switch (this.state) {
                    case 0:
                        this.timer+=2;
                        if (this.timer > 20){
                            this.timer = 0;
                            this.state = 1;
                            return;
                        }
                        this.container.scale.set(this.timer/20, this.timer/20);
                        this.container.rotation = Math.PI + Math.PI*20/this.timer;
                        break;
                    case 1:
                        break;
                }
            }
        }
    };

    Game.guiList.messageIcon =  {
        x: 0,
        y: 0,
        width: 176,
        height: 128,
        onTouch : function(touch) {
            if (touch.touchedEnd) {
                Game.lvl.pausedUpdate.push(new Gui(Game.guiList.message).setSpecial(this.special).setDescription(this.description).setTitle(this.title).setImage(this.image).setOnClose(this.onClose));
                this.del();
            }
        },
        draw : function(){},
        init: function() {
            this.timer = 0;
            this.state = 0;
            this.isMessageIcon = true;
            this.message = this.title = '';
            this.image = new PIXI.DisplayObjectContainer();

            var messages = Game.lvl.objGui.filter(function (gui){return gui.isMessageIcon});
            if (messages.length > 4) {
                for (var i =0; i < Game.lvl.objGui.length; i++){
                    if (Game.lvl.objGui[i].isMessageIcon) {
                        Game.lvl.objGui[i].del();
                        messages.splice(messages.indexOf(Game.lvl.objGui[i]), 1);
                        break;
                    }
                }
            }

            this.del = function () {
                if (Game.lvl.objGui.indexOf(this) != -1) {
                    Game.lvl.objGui.splice(Game.lvl.objGui.indexOf(this), 1);
                    console.log('rem');
                }
                Game.lvl.pool.pull(this.container);
                var position = 0;
                for (var i =0; i < Game.lvl.objGui.length; i++){
                    if (Game.lvl.objGui[i].isMessageIcon) {
                        Game.lvl.objGui[i].container.position.set(96, 256 + position++*128 );
                        Game.lvl.objGui[i].y = Game.lvl.objGui[i].container.position.y - 64;
                    }
                }
            };

            this.container = new PIXI.DisplayObjectContainer();
            this.container.position.set(96, 256 + messages.length*128);
            this.y = this.container.position.y - 64;
            this.back = Game.lvl.pool.getSprite(Game.sprites.letterNewEnemy);
            this.container.addChild(this.back);

            if (localStorage.getItem(Game.profile + 'messageRead') != "true") {
                localStorage.setItem(Game.profile + 'messageRead', "true");
                var ballon = new MessageBalloon(Game.strings[Game.language].tutorTapToRead, new Vec2(32, 0), false, this.container);
                ballon.container.scale.set(-1, 1);
                ballon.balloonText.scale.set(-1, 1);
                ballon.balloonText.position.x -= 36;
            };

            this.setDescription = function(text){
                this.description= text;
                return this;
            };

            this.setSpecial = function(text){
                this.special = text;
                return this;
            };
            this.setTitle = function(text){
                this.title = text;
                return this;
            };
            this.setImage = function(image){
                this.image = image;
                return this;
            };
            this.setIcon = function(icon){
                this.back = Game.lvl.pool.switchSprite(icon, this.back);
                return this;
            };
            this.setOnClose = function(onClose){
                this.onClose = onClose;
                return this;
            };

            this.container.scale.set(0,0);
            Game.lvl.guiContainer.addChild(this.container);

            this.update = function(){
                switch (this.state) {
                    case 0:
                        this.timer+=2;
                        if (this.timer > 20){
                            this.timer = 0;
                            this.state = 1;
                            return;
                        }
                        this.container.scale.set(this.timer/20, this.timer/20);
                        break;
                    case 1:
                        break;
                }
            }
        }
    };

    Game.guiList.tipsInfo =  {
        x: 0,
        y: 0,
        width: Game.width  ,
        height: Game.heightShift,
        onTouch : function(touch) {
            return true;
        },
        draw : function(){},
        init: function() {
            Game.lvl.paused = true;
            Game.lvl.objGui.push(this);
            this.timer = 0;
            this.state = 0;
            this.container = new PIXI.DisplayObjectContainer();
            this.container.position.set(Game.width/2, Game.heightShift/2);

            this.container.addChild(getMessageBackground(function(){
                if (Game.lvl.pausedUpdate.indexOf(this) != -1) {
                    this.touched = false;
                    Game.lvl.objGui.splice(Game.lvl.objGui.indexOf(this), 1);
                    Game.lvl.pausedUpdate.splice(Game.lvl.pausedUpdate.indexOf(this), 1);
                    this.description._texture.baseTexture.source.dispose && this.description._texture.baseTexture.source.dispose();
                    this.title._texture.baseTexture.source.dispose && this.title._texture.baseTexture.source.dispose();
                    this.title.destroy(true);
                    this.description.destroy(true);
                    Game.lvl.pool.pull(this.container);
                    Game.lvl.paused = false;

                    this.onClose && setTimeout(this.onClose,1);
                }
            }.bind(this)));

            Game.fillStyle = "#FFFFB3";
            Game.textAlign = 'center';
            Game.font = Game.getFont(64);

            this.description = new PIXI.Text(' ', {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle,
                wordWrapWidth: 570,
                wordWrap:true
            });
            this.description.position = new Vec2(0, 280);
            this.container.addChild(this.description);

            Game.fillStyle = "#FFFFB3";
            Game.textAlign = 'left';
            Game.font = Game.getFont(38);

            Game.fillStyle = "#FFF2B3";
            Game.font = Game.getFont(64);
            this.title = new PIXI.Text(' ', {
                font: Game.font,
                align: 'center',
                fill: Game.fillStyle
            });
            this.title.anchor.set(0.5, 0);
            this.title.position = new Vec2(0, -330);
            this.container.addChild(this.title);

            this.image = new PIXI.DisplayObjectContainer();
            this.image.position = new Vec2(0, 0);
            this.container.addChild(this.image);

            this.setMessage = function(text){
                this.description.setText(text);
                this.description.position = new Vec2(0, 150);
                return this;
            };

            this.setTitle = function(text){
                this.title.setText(text);
                this.title.position = new Vec2(0, -320);
                return this;
            };
            this.setImage = function(image){
                this.image.addChild(image);
                return this;
            };
            this.setOnClose = function(onClose) {
                this.onClose = onClose;
                return this;
            };

            this.container.scale.set(0,0);
            Game.lvl.guiContainer.addChild(this.container);

            this.update = function() {
                switch (this.state) {
                    case 0:
                        this.timer+=2;
                        if (this.timer > 20){
                            this.timer = 0;
                            this.state = 1;
                            return;
                        }
                        this.container.scale.set(this.timer/20, this.timer/20);
                        this.container.rotation = Math.PI + Math.PI*20/this.timer;
                        break;
                    case 1:
                        break;
                }
            }
        }
    };

    Game.guiList.tipsIcon =  {
        x: 0,
        y: 0,
        width: 176,
        height: 128,
        onTouch : function(touch) {
            if (touch.touchedEnd) {
                Game.lvl.pausedUpdate.push(new Gui(Game.guiList.tipsInfo).setTitle(this.title).setImage(this.image).setMessage(this.description).setOnClose(this.onClose));
                this.del();
            }
        },
        draw : function(){},
        init: function() {
            this.timer = 0;
            this.state = 0;
            this.isMessageIcon = true;
            this.message = this.title = '';
            this.image = new PIXI.DisplayObjectContainer();

            var messages = Game.lvl.objGui.filter(function (gui){return gui.isMessageIcon});
            if (messages.length > 4) {
                for (var i =0; i < Game.lvl.objGui.length; i++){
                    if (Game.lvl.objGui[i].isMessageIcon) {
                        Game.lvl.objGui[i].del();
                        messages.splice(messages.indexOf(Game.lvl.objGui[i]), 1);
                        break;
                    }
                }
            }

            this.del = function () {
                if (Game.lvl.objGui.indexOf(this) != -1) {
                    Game.lvl.objGui.splice(Game.lvl.objGui.indexOf(this), 1);
                    console.log('rem');
                }
                Game.lvl.pool.pull(this.container);
                var position = 0;
                for (var i =0; i < Game.lvl.objGui.length; i++){
                    if (Game.lvl.objGui[i].isMessageIcon) {
                        Game.lvl.objGui[i].container.position.set(96, 256 + position++*128 );
                        Game.lvl.objGui[i].y = Game.lvl.objGui[i].container.position.y - 64;
                    }
                }
            };

            this.container = new PIXI.DisplayObjectContainer();
            this.container.position.set(96, 256 + messages.length*128);
            this.y = this.container.position.y - 64;
            this.back = Game.lvl.pool.getSprite(Game.sprites.letterTIP);
            this.container.addChild(this.back);

            if (localStorage.getItem(Game.profile + 'messageRead') != "true") {
                localStorage.setItem(Game.profile + 'messageRead', "true");
                var ballon = new MessageBalloon(Game.strings[Game.language].tutorTapToRead, new Vec2(32, 0), false, this.container);
                ballon.container.scale.set(-1, 1);
                ballon.balloonText.scale.set(-1, 1);
                ballon.balloonText.position.x -= 36;
            };

            this.setDescription = function(text){
                this.description= text;
                return this;
            };

            this.setTitle = function(text){
                this.title = text;
                return this;
            };

            this.setImage = function(image){
                this.image = image;
                return this;
            };
            this.setIcon = function(icon){
                this.back = Game.lvl.pool.switchSprite(icon, this.back);
                return this;
            };
            this.setOnClose = function(onClose){
                this.onClose = onClose;
                return this;
            };

            this.container.scale.set(0,0);
            Game.lvl.guiContainer.addChild(this.container);

            this.update = function(){
                switch (this.state) {
                    case 0:
                        this.timer+=2;
                        if (this.timer > 20){
                            this.timer = 0;
                            this.state = 1;
                            return;
                        }
                        this.container.scale.set(this.timer/20, this.timer/20);
                        break;
                    case 1:
                        break;
                }
            }
        }
    };

    Game.guiList.heroMove =  {
        x: 0,
        y: 0,
        width: Game.width,
        height: Game.heightShift,
        onTouch : function(touch) {
            if (touch.touchedEnd && this.state == 1 && touch.lastPosition.x < 16+160 && touch.lastPosition.y > Game.heightShift - (16+160)) {
                log('tutor.heroselect', 0);
                Game.lvl.gameLogic.hero.button.select(true);
                this.state = 2;
                Game.lvl.pool.pull(this.ballon.container);
                Game.lvl.pool.pull(this.ballon2.container);
                this.ballon = new MessageBalloon(Game.strings[Game.language].tutorHeroClickMap,  new Vec2(1356, 768+128), true, Game.lvl.effectContainer);
                this.circle.alpha = 1;
                this.circle.position = new Vec2(1356, 768+128+100);
                this.circle.scale.set(2,2);
                this.circle.tick = 0;
            } else if (touch.touchedEnd && this.state == 2 && Game.lvl.camera.getMovedPosition(touch.lastPosition.clone()).sub(new Vec2(1356, 768 + 128 + 100)).getLength() < 300) {
                log('tutor.heromove', 0);
                Game.lvl.gameLogic.hero.button.select(false);
                Game.lvl.gameLogic.moveHero(Game.lvl.camera.getMovedPosition(touch.lastPosition));
                Game.lvl.objEffect.push(new Effect(Game.lvl.camera.getMovedPosition(touch.lastPosition), new Vec2(0,0), Game.lvl.objEffect, Game.animations.MoveMarker, Game.animations.MoveMarker.playTime, 1, null, false, true));
                Game.lvl.pool.pull(this.container);
                Game.lvl.pool.pull(this.ballon.container);
                Game.lvl.pool.pull(this.circle);
                if (Game.lvl.objGui.indexOf(this) != -1)
                    Game.lvl.objGui.splice(Game.lvl.objGui.indexOf(this), 1);

                if (Game.lvl.pausedUpdate.indexOf(this) != -1)
                    Game.lvl.pausedUpdate.splice(Game.lvl.pausedUpdate.indexOf(this), 1);

                this.state = 3;
                Game.lvl.paused = false;
            }
        },
        draw : function(){
        },
        init: function(params) {
            this.state = -1;
            this.timer = 0;
            this.circle = getCircle();
            this.circle.alpha = 0;
            this.tipsAnimation = 1;
            Game.lvl.pausedUpdate.push(this);
            this.container = new PIXI.DisplayObjectContainer();
            Game.lvl.guiContainer.addChild(this.container);
            Game.lvl.effectContainer.addChild(this.circle);
            this.update = function() {
                switch (this.state) {
                    case -1:
                        if (Game.lvl.camera.zoom > 1) {
                            Game.lvl.camera.scale(-0.05)
                        } else {
                            this.state = 0;
                        }
                        break;
                    case 0:
                        this.timer ++;
                        if (this.timer > 30){
                            this.timer = 0;
                            this.state = 1;
                            var sprite = Game.lvl.pool.getSprite(Game.sprites.heroIdle0);
                            sprite.anchor.set(0.5, 0.5);
                            sprite.scale.set(1.5, 1.5);
                            Game.lvl.pausedUpdate.push(new Gui(Game.guiList.messageInfo).setMessage(Game.strings[Game.language].heroHintMessage).setTitle(Game.strings[Game.language].heroHintTitle).setImage(sprite).setOnClose(function(){
                                Game.lvl.paused = true;
                                this.ballon = new MessageBalloon(Game.strings[Game.language].tutorHero,  Game.lvl.gameLogic.hero.position.clone(), false, Game.lvl.effectContainer);
                                this.ballon2 = new MessageBalloon(Game.strings[Game.language].tutorClickToSelect,  new Vec2(32+128,  Game.heightShift - (16+64)), false, Game.lvl.guiContainer);
                                this.ballon2.container.scale.set(-1,1);
                                this.ballon2.balloonText.scale.set(-1,1);
                            }.bind(this)));
                        }
                        break;
                    case 1:
                        var scale2 = ++this.tipsAnimation > 10 ? (1.05 - ((this.tipsAnimation-10)/200)) : (1 + this.tipsAnimation/200);
                        if (this.tipsAnimation >= 20)
                            this.tipsAnimation = 0;

                        this.ballon2 && this.ballon2.container.scale.set(scale2*-1, scale2);
                        break;
                    case 2:
                        var scale = ++this.circle.tick > 10 ? (2.05 - ((this.circle.tick-10)/200)) : (2 + this.circle.tick/200);
                        if (this.circle.tick >= 20)
                            this.circle.tick = 0;
                        this.circle.scale.set(scale,scale);
                        var scale3 = ++this.tipsAnimation > 10 ? (1.05 - ((this.tipsAnimation-10)/200)) : (1 + this.tipsAnimation/200);
                        if (this.tipsAnimation >= 20)
                            this.tipsAnimation = 0;

                        this.ballon && this.ballon.container.scale.set(scale3, scale3);
                        break;
                }
                Game.lvl.objGui.filter(function(g){return g.hero}).forEach(function(g){g.update()});
            }
        }
    };

    Game.guiList.heroCast =  {
        x: 0,
        y: 0,
        width: Game.width,
        height: Game.heightShift,
        onTouch : function(touch) {
            if (touch.touchedEnd && this.state == 1 && touch.lastPosition.clone().sub(new Vec2(32 + 70, Game.heightShift - (16+146*2)+ 70)).getLength() < 100) {
                log('tutor.abilityselect', 0);
                this.button.guiContainer.addChild(this.button.cancelSprite);
                this.state = 2;
                this.circle.alpha = 1;
                this.circle.position = Game.lvl.gameLogic.hero.target.position.clone();
                this.circle.scale.set(2,2);
                this.circle.tick = 0;
                Game.lvl.pool.pull(this.ballon.container);
                this.ballon = new MessageBalloon(Game.strings[Game.language].tutorClickToCast, Game.lvl.gameLogic.hero.target.position.clone().add(new Vec2(32, -96)), true, Game.lvl.effectContainer);
            } else if (touch.touchedEnd && this.state == 2 && Game.lvl.camera.getMovedPosition(touch.lastPosition.clone()).sub(Game.lvl.gameLogic.hero.target.position.clone()).getLength() < 300) {
                log('tutor.abilitycast', 0);
                this.button.onMapClick(touch);
                Game.lvl.pool.pull(this.ballon.container);
                Game.lvl.pool.pull(this.circle);
                if (Game.lvl.objGui.indexOf(this) != -1)
                    Game.lvl.objGui.splice(Game.lvl.objGui.indexOf(this), 1);

                if (Game.lvl.pausedUpdate.indexOf(this) != -1)
                    Game.lvl.pausedUpdate.splice(Game.lvl.pausedUpdate.indexOf(this), 1);

                this.state = 3;
                Game.lvl.paused = false;
            }
        },
        draw : function(){
        },
        init: function(params){
            this.state = -1;
            this.timer = 0;
            this.button =  Game.lvl.objGui.filter(function(g){return g.abilityNumber == 1}).pop();
            Game.lvl.objGui.filter(function(g){return g.hero}).forEach(function(g){g.cd = 0;});
            Game.lvl.pausedUpdate.push(this);
            this.circle = getCircle();
            this.circle.alpha = 0;
            Game.lvl.effectContainer.addChild(this.circle);
            this.tipsAnimation = 1;
            this.update = function() {
                var scale;
                switch (this.state) {
                    case -1:
                        if (Game.lvl.camera.zoom > 1) {
                            Game.lvl.camera.scale(-0.05)
                        } else {
                            this.state = 0;
                        }
                        break;
                    case 0:
                        this.state = 1;
                        this.ballon = new MessageBalloon(Game.strings[Game.language].tutorClickToSelectAbility,  new Vec2(32+106,  Game.heightShift - (16+146*2)+70), false, Game.lvl.guiContainer);
                        this.ballon.container.scale.set(-1,1);
                        this.ballon.balloonText.scale.set(-1,1);
                        //this.ballon.balloonText.position.x -= 24;
                        break;
                    case 1:
                        scale = ++this.tipsAnimation > 10 ? (1.05 - ((this.tipsAnimation-10)/200)) : (1 + this.tipsAnimation/200);
                        if (this.tipsAnimation >= 20)
                            this.tipsAnimation = 0;

                        this.ballon && this.ballon.container.scale.set(scale*-1, scale);
                        break;
                    case 2:
                        scale = ++this.circle.tick > 10 ? (2.05 - ((this.circle.tick-10)/200)) : (2 + this.circle.tick/200);
                        if (this.circle.tick >= 20)
                            this.circle.tick = 0;
                        this.circle.scale.set(scale,scale);
                        scale = ++this.tipsAnimation > 10 ? (1.05 - ((this.tipsAnimation-10)/200)) : (1 + this.tipsAnimation/200);
                        if (this.tipsAnimation >= 20)
                            this.tipsAnimation = 0;

                        this.ballon && this.ballon.container.scale.set(scale, scale);
                        break;
                }
                Game.lvl.objGui.filter(function(g){return g.hero}).forEach(function(g){g.update()});
            }
        }
    };

    Game.guiList.messageTowers =  {
        x: 0,
        y: 0,
        width: Game.width  ,
        height: Game.heightShift,
        onTouch : function(touch) {
            return true;
        },
        draw : function(){},
        init: function() {
            Game.lvl.paused = true;
            Game.lvl.objGui.push(this);
            this.timer = 0;
            this.state = 0;
            this.container = new PIXI.DisplayObjectContainer();
            this.container.position.set(Game.width/2, Game.heightShift/2);

            this.backContainer = getMessageBackground(function(){
                if (Game.lvl.pausedUpdate.indexOf(this) != -1) {
                    this.touched = false;
                    Game.lvl.objGui.splice(Game.lvl.objGui.indexOf(this), 1);
                    Game.lvl.pausedUpdate.splice(Game.lvl.pausedUpdate.indexOf(this), 1);
                    this.message1._texture.baseTexture.source.dispose && this.message1._texture.baseTexture.source.dispose();
                    this.message2._texture.baseTexture.source.dispose && this.message2._texture.baseTexture.source.dispose();
                    this.title._texture.baseTexture.source.dispose && this.title._texture.baseTexture.source.dispose();
                    this.title1._texture.baseTexture.source.dispose && this.title1._texture.baseTexture.source.dispose();
                    this.title2._texture.baseTexture.source.dispose && this.title2._texture.baseTexture.source.dispose();
                    this.title.destroy(true);
                    this.title2.destroy(true);
                    this.title1.destroy(true);
                    this.message1.destroy(true);
                    this.message2.destroy(true);
                    Game.lvl.pool.pull(this.container);
                    Game.lvl.paused = false;
                    this.onClose && this.onClose();
                }
            }.bind(this));
            this.container.addChild(this.backContainer);

            Game.fillStyle = "#FFFFB3";
            Game.font = Game.getFont(76);
            this.title = new PIXI.Text(Game.strings[Game.language].tutorTowers, {
                font: Game.font,
                align: 'center',
                fill: Game.fillStyle
            });
            this.title.anchor.set(1,0);
            this.title.position = new Vec2(this.title.width/2, -320);
            this.container.addChild(this.title);


            Game.fillStyle = "#FFF2B3";
            Game.font = Game.getFont(52);
            this.title2 = new PIXI.Text(Game.strings[Game.language].buildings.names.tower, {
                font: Game.font,
                align: 'center',
                fill: Game.fillStyle
            });
            this.title2.anchor.set(1,0);
            this.title2.position = new Vec2(-240+this.title2.width/2, -206);
            this.container.addChild(this.title2);

            var image = Game.lvl.pool.getSprite(Game.sprites.tower1);
            image.anchor.set(0.5,0.5);
            image.position.set(-250, 0);
            image.scale.set(1.5, 1.5);
            this.container.addChild(image);


            Game.textAlign = 'left';
            Game.font = Game.getFont(42);
            Game.fillStyle = "#FFFFB3";
            this.message2 = new PIXI.Text(Game.strings[Game.language].buildings.tips.tower, {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle
            });
            this.message2.position = new Vec2(-250, 90);
            this.container.addChild(this.message2);

            Game.fillStyle = "#FFF2B3";
            Game.font = Game.getFont(52);
            this.title1 = new PIXI.Text(Game.strings[Game.language].buildings.names.house, {
                font: Game.font,
                align: 'center',
                fill: Game.fillStyle
            });
            this.title1.anchor.set(1,0);
            this.title1.position = new Vec2(220 + this.title1.width/2, -206);
            this.container.addChild(this.title1);

            image = Game.lvl.pool.getSprite(Game.sprites.house1);
            image.anchor.set(0.5,0.5);
            image.position.set(260, -30);
            image.scale.set(1.5, 1.5);
            this.container.addChild(image);

            image = Game.lvl.pool.getSprite(Game.sprites.goblinBaseIdle0);
            image.anchor.set(0.5,0.5);
            image.position.set(70, -20);
            image.scale.set(-1.5, 1.5);
            this.container.addChild(image);

            image = Game.lvl.pool.getSprite(Game.sprites.goblinBaseIdle0);
            image.anchor.set(0.5,0.5);
            image.position.set(150, -20);
            image.scale.set(1.5, 1.5);
            this.container.addChild(image);

            image = Game.lvl.pool.getSprite(Game.sprites.goblinBaseIdle0);
            image.anchor.set(0.5,0.5);
            image.position.set(110, 10);
            image.scale.set(1.5, 1.5);
            this.container.addChild(image);


            Game.textAlign = 'left';
            Game.font = Game.getFont(42);
            Game.fillStyle = "#FFFFB3";
            this.message1 = new PIXI.Text(Game.strings[Game.language].buildings.tips.house, {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle,
                wordWrap: true,
                wordWrapWidth: 400
            });
            this.message1.position = new Vec2(250, 90);
            this.container.addChild(this.message1);

            this.container.scale.set(0,0);
            Game.lvl.guiContainer.addChild(this.container);

            this.update = function(){
                switch (this.state) {
                    case 0:
                        this.timer+=4;
                        if (this.timer > 20){
                            this.timer = 0;
                            this.state = 1;
                            return;
                        }
                        this.container.scale.set(this.timer/20, this.timer/20);
                        this.container.rotation = Math.PI + Math.PI*20/this.timer;
                        break;
                    case 1:
                        break;
                }
            }
        }
    };

    Game.guiList.messageTowers2 =  {
        x: 0,
        y: 0,
        width: Game.width  ,
        height: Game.heightShift,
        onTouch : function(touch) {
            return true;
        },
        draw : function(){},
        init: function() {
            Game.lvl.paused = true;
            Game.lvl.objGui.push(this);
            this.timer = 0;
            this.state = 0;
            this.container = new PIXI.DisplayObjectContainer();
            this.container.position.set(Game.width/2, Game.heightShift/2);

            this.container.addChild(getMessageBackground(
                function(){
                    if (Game.lvl.pausedUpdate.indexOf(this) != -1) {
                        this.touched = false;
                        Game.lvl.objGui.splice(Game.lvl.objGui.indexOf(this), 1);
                        Game.lvl.pausedUpdate.splice(Game.lvl.pausedUpdate.indexOf(this), 1);
                        this.message1._texture.baseTexture.source.dispose && this.message1._texture.baseTexture.source.dispose();
                        this.message2._texture.baseTexture.source.dispose && this.message2._texture.baseTexture.source.dispose();
                        this.title._texture.baseTexture.source.dispose && this.title._texture.baseTexture.source.dispose();
                        this.title1._texture.baseTexture.source.dispose && this.title1._texture.baseTexture.source.dispose();
                        this.title2._texture.baseTexture.source.dispose && this.title2._texture.baseTexture.source.dispose();
                        this.title.destroy(true);
                        this.title2.destroy(true);
                        this.title1.destroy(true);
                        this.message1.destroy(true);
                        this.message2.destroy(true);
                        Game.lvl.pool.pull(this.container);
                        Game.lvl.paused = false;
                        this.onClose && this.onClose();
                        if (Game.buildingsList.orcHouse.isOpen) {
                            Game.lvl.gameLogic.ballon = new MessageBalloon(Game.strings[Game.language].tutorTapToUpgrade, new Vec2(800, 956), true, Game.lvl.gameContainer);
                            Game.lvl.gameLogic.state = 'tutorUpgrade';
                        }
                    }
                }.bind(this)
            ));

            Game.fillStyle = "#FFFFB3";
            Game.font = Game.getFont(76);
            this.title = new PIXI.Text(Game.strings[Game.language].tutorTowers2, {
                font: Game.font,
                align: 'center',
                fill: Game.fillStyle
            });
            this.title.anchor.set(1,0);
            this.title.position = new Vec2(this.title.width/2, -320);
            this.container.addChild(this.title);


            Game.fillStyle = "#FFF2B3";
            Game.font = Game.getFont(52);
            this.title2 = new PIXI.Text(Game.strings[Game.language].buildings.names.magicTower, {
                font: Game.font,
                align: 'center',
                fill: Game.fillStyle
            });
            this.title2.anchor.set(1,0);
            this.title2.position = new Vec2(-250+this.title2.width/2, -206);
            if (Game.language == "ru"){
                this.title2.setText(Game.strings[Game.language].buildings.names.magicTower.split(' ').join('\r\n'));
                this.title2.position = new Vec2(-250+this.title2.width/2, -206);
            }
            this.container.addChild(this.title2);

            var image = Game.lvl.pool.getSprite(Game.sprites.magicTower1);
            image.anchor.set(0.5,0.5);
            image.position.set(-250, 0);
            image.scale.set(1.5, 1.5);
            this.container.addChild(image);


            Game.textAlign = 'left';
            Game.font = Game.getFont(42);

            this.message2 = new PIXI.Text(Game.strings[Game.language].buildings.tips.magicTower, {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle
            });
            this.message2.position = new Vec2(-240, 90);
            this.container.addChild(this.message2);


            Game.font = Game.getFont(52);
            this.title1 = new PIXI.Text(Game.strings[Game.language].buildings.names.catapulta, {
                font: Game.font,
                align: 'center',
                fill: Game.fillStyle
            });
            this.title1.anchor.set(1,0);
            this.title1.position = new Vec2(220 + this.title1.width/2, -206);
            this.container.addChild(this.title1);

            image = Game.lvl.pool.getSprite(Game.sprites.catapulta1);
            image.anchor.set(0.5,0.5);
            image.position.set(220, 30);
            image.scale.set(1.5, 1.5);
            this.container.addChild(image);

            image = Game.lvl.pool.getSprite(Game.sprites.catapultaTop1350);
            image.anchor.set(0.5,0.5);
            image.position.set(220, -30);
            image.scale.set(1.5, 1.5);
            this.container.addChild(image);

            Game.textAlign = 'left';
            Game.font = Game.getFont(42);

            this.message1 = new PIXI.Text(Game.strings[Game.language].buildings.tips.catapulta, {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle
            });
            this.message1.position = new Vec2(230, 130);
            this.container.addChild(this.message1);

            this.container.scale.set(0,0);
            Game.lvl.guiContainer.addChild(this.container);

            this.update = function(){
                switch (this.state) {
                    case 0:
                        this.timer+=4;
                        if (this.timer > 20){
                            this.timer = 0;
                            this.state = 1;
                            return;
                        }
                        this.container.scale.set(this.timer/20, this.timer/20);
                        this.container.rotation = Math.PI + Math.PI*20/this.timer;
                        break;
                    case 1:
                        break;
                }
            }
        }
    };
}

function getMessageBackground(closeCallback){
    this.backContainer = new PIXI.Container();

    this.blackS = new PIXI.Graphics();
    this.blackS.alpha = 0.9;
    this.blackS.beginFill(0x000000);
    this.blackS.moveTo(0,0);
    this.blackS.drawRect(0, 0, 1, 1);
    this.blackS.scale.set(880, 655);
    this.blackS.endFill();
    this.blackS.position.set(-440, -325);
    this.backContainer.addChild(this.blackS);

    this.tBar = Game.lvl.pool.getSprite(Game.sprites.barUp_barDwn);
    this.tBar.position.y = -330;
    this.tBar.scale.set(1,1);
    this.backContainer.addChild(this.tBar);
    this.bBar = Game.lvl.pool.getSprite(Game.sprites.barUp_barDwn);
    this.bBar.position.y = 324;
    this.bBar.scale.set(1,-1);
    this.backContainer.addChild(this.bBar);

    this.lBar = Game.lvl.pool.getSprite(Game.sprites.barL_barR);
    this.lBar.position.x = -442;
    this.lBar.position.y = 3;
    this.lBar.scale.set(-1,10);
    this.backContainer.addChild(this.lBar);
    this.rBar = Game.lvl.pool.getSprite(Game.sprites.barL_barR);
    this.rBar.position.x = 442;
    this.rBar.position.y = 3;
    this.rBar.scale.set(1,10);
    this.backContainer.addChild(this.rBar);

    this.ltCorner = Game.lvl.pool.getSprite(Game.sprites.Corner);
    this.ltCorner.position.y = -325;
    this.ltCorner.position.x = -436;
    this.ltCorner.scale.set(-1,1);
    this.backContainer.addChild(this.ltCorner);
    this.lbCorner = Game.lvl.pool.getSprite(Game.sprites.Corner);
    this.lbCorner.position.y = 320;
    this.lbCorner.position.x = -436;
    this.lbCorner.scale.set(-1,-1);
    this.backContainer.addChild(this.lbCorner);
    this.rtCorner = Game.lvl.pool.getSprite(Game.sprites.Corner);
    this.rtCorner.position.y = -325;
    this.rtCorner.position.x = 436;
    this.rtCorner.scale.set(1,1);
    this.backContainer.addChild(this.rtCorner);
    this.rlCorner = Game.lvl.pool.getSprite(Game.sprites.Corner);
    this.rlCorner.position.y = 320;
    this.rlCorner.position.x = 436;
    this.rlCorner.scale.set(1,-1);
    this.backContainer.addChild(this.rlCorner);

    this.escapeContainer = new PIXI.Container();
    this.escapeSprite = Game.lvl.pool.getSprite(Game.sprites['EscapeNormal']);
    this.escapeContainer.scale.set(0.8,0.8);
    this.escapeContainer.interactive = true;
    this.escapeContainer.mousedown = this.escapeContainer.touchstart = function () {
        this.escapeSprite = Game.lvl.pool.switchSprite(Game.sprites['EscapePressed'], this.escapeSprite);
        this.yestoched = true;
    }.bind(this);
    this.escapeContainer.mouseup = this.escapeContainer.touchend = this.escapeContainer.mouseupoutside = this.escapeContainer.touchendoutside = function () {
        this.escapeSprite = Game.lvl.pool.switchSprite(Game.sprites['EscapeNormal'], this.escapeSprite);
        if (this.yestoched) {
            closeCallback && closeCallback();
            this.yestoched = false;
        }
    }.bind(this);
    this.escapeContainer.position.set(420, -320);
    this.escapeContainer.addChild(this.escapeSprite);

    this.backContainer.addChild(this.escapeContainer);
    return this.backContainer;
}

function getCircle() {
    this.guiContainer = new PIXI.Container();
    this.cd315 = Game.lvl.pool.getSprite(Game.sprites['abilityCd']);
    this.cd270 = Game.lvl.pool.getSprite(Game.sprites['abilityCd']);
    this.cd225 = Game.lvl.pool.getSprite(Game.sprites['abilityCd']);
    this.cd180 = Game.lvl.pool.getSprite(Game.sprites['abilityCd']);
    this.cd135 = Game.lvl.pool.getSprite(Game.sprites['abilityCd']);
    this.cd90 = Game.lvl.pool.getSprite(Game.sprites['abilityCd']);
    this.cd45 = Game.lvl.pool.getSprite(Game.sprites['abilityCd']);
    this.cd0 = Game.lvl.pool.getSprite(Game.sprites['abilityCd']);

    this.cd270.rotation = Math.PI/4;
    this.cd225.rotation = Math.PI/2;
    this.cd180.rotation = Math.PI*3/4;
    this.cd135.rotation = Math.PI;
    this.cd90.rotation = Math.PI*5/4;
    this.cd45.rotation = Math.PI*3/2;
    this.cd0.rotation = Math.PI*7/4;

    this.cd0.alpha = this.cd45.alpha = this.cd90.alpha = this.cd135.alpha = this.cd180.alpha = this.cd225.alpha = this.cd270.alpha = this.cd315.alpha = 1;

    this.guiContainer.addChild(this.cd45);
    this.guiContainer.addChild(this.cd90);
    this.guiContainer.addChild(this.cd135);
    this.guiContainer.addChild(this.cd180);
    this.guiContainer.addChild(this.cd225);
    this.guiContainer.addChild(this.cd270);
    this.guiContainer.addChild(this.cd315);
    this.guiContainer.addChild(this.cd0);
    return this.guiContainer;
}