﻿function loadGuiMenu(){

    Game.guiList.mainMenu = {
        noLock:true,
        sprite : null,
        x: 0,
        y: 0,
        width: Game.width,
        height: Game.heightShift,
        onTouch: function(touch) {
        },
        draw: function(){
        },
        update: function(){
            //this.objPartilces.forEach(function(particle) {
            //    particle.update(0.05);
            //});
            if (this.timeout >= 0){
                this.timeout -= 1;
            } else {}
        },
        init:function() {
            this.guiContainer = new PIXI.Container();
            this.timeout = 100;
            this.backSprite = Game.menu.pool.getSprite(Game.sprites.TitleBackground1024);
            this.backSprite.scale = new Vec2(Game.windowWidth/Game.windowHeight*4/3, 1.5);
            this.backSprite.position = new Vec2(1024, 1152/2);
            this.guiContainer.addChild(this.backSprite);
            this.backSpriteLogo = Game.menu.pool.getSprite(Game.sprites.LOGO);
            this.backSpriteLogo.scale.set(1.3, 1.3);
            this.backSpriteLogo.position = new Vec2(1024, 1152/4);
            this.guiContainer.addChild(this.backSpriteLogo);
            this.guiContainer.position = new Vec2(Game.menuWidth/2, Game.menuHeight/2);
            this.guiContainer.pivot = new Vec2(2048/2, 1152/2);
        }
    };

    Game.guiList.campaignButton = {
        noLock:true,
        sprite : null,
        x: 0,
        y: 0,
        width: Game.width,
        height: Game.heightShift,
        update: function() {
            this.text.setText(Game.strings[Game.language].campaign);
            if (this.timeout >= 0) {
                this.timeout -= 1;
            } else {
                if (this.guiContainer.alpha < 1) {
                    this.guiContainer.alpha += 0.1;
                    if (this.guiContainer.alpha > 1) {
                        this.guiContainer.alpha = 1;
                    }
                }
            }
        },
        init:function() {
            this.guiContainer = new PIXI.Container();
            this.guiContainer.alpha = 0.01;

            this.timeout = 100;

            this.backSprite = Game.menu.pool.getSprite(Game.sprites.VICDORY_DEFEAT);
            this.backSprite.scale.set(1, 1);
            this.backSpriteTouched = Game.menu.pool.getSprite(Game.sprites.BattlePressed);
            this.backSpriteTouched.position.set(0, 26);
            this.backSpriteTouched.scale.set(1.6, 1);
            this.backSpriteTouched.alpha = 0;

            this.guiContainer.addChild(this.backSprite);
            this.guiContainer.addChild(this.backSpriteTouched);

            this.guiContainer.position = new Vec2(Game.menuWidth/2, Game.menuHeight/2+300);
            Game.font = Game.getFont(96);
            Game.textAlign = 'center';
            Game.fillStyle = "#FEF2B3";
            this.text = new PIXI.Text(Game.strings[Game.language].campaign, {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle
            });
            this.text.position.y = - 26;
            this.guiContainer.addChild(this.text);
            this.guiContainer.interactive = true;
            this.guiContainer.mousedown = this.guiContainer.touchstart = function () {
                this.yestoched = true;
                this.backSpriteTouched.alpha = 1;
            }.bind(this);

            this.guiContainer.mouseup = this.guiContainer.touchend = this.guiContainer.mouseupoutside = this.guiContainer.touchendoutside =  function () {
                if (this.yestoched) {
                    Game.noTouch = 500;
                    setTimeout(function(){
                        this.backSpriteTouched.alpha = 0;
                        this.yestoched = false;
                        Game.menu.container.removeChild(Game.menu.pages[Game.menu.currentPage].container);
                        Game.menu.currentPage = 'map';
                        Game.menu.container.addChild(Game.menu.pages['map'].container);
                    }.bind(this),100)
                }
            }.bind(this);
        }
    };

    Game.guiList.mainParticles = {
        noLock:true,
        sprite : null,
        x: 0,
        y: 0,
        width: Game.width,
        height: Game.heightShift,
        onTouch: function(touch) {
        },
        draw: function(){
        },
        update: function(){
            this.objPartilces.forEach(function(particle) {
                particle.update(0.05);
            });
        },
        init:function() {
            this.guiContainer = new PIXI.Container();

            this.guiContainer.position = new Vec2(Game.menuWidth/2, Game.menuHeight/2);
            this.guiContainer.pivot = new Vec2(2048/2, 1152/2);

            this.objPartilces = [];

            var config = clone(Game.particlesList['TitlleSmoke']);
            config.pos.x = 1024;
            config.pos.y = 768;
            var textures = [];
            config.images.forEach(function(image){
                textures.push(PIXI.TextureCache[image])
            });

            this.objPartilces.push(new cloudkid.Emitter(
                    this.guiContainer,
                    textures,
                    config
                )
            );

            config = clone(Game.particlesList['TitlleSparks']);
            config.pos.x = 1024;
            config.pos.y = 768;
            textures = [];
            config.images.forEach(function(image){
                textures.push(PIXI.TextureCache[image])
            });

            this.objPartilces.push(new cloudkid.Emitter(
                    this.guiContainer,
                    textures,
                    config
                )
            )
        }
    };

    Game.guiList.description = {
        noLock:true,
        sprite : null,
        x: 0,
        y: 0,
        width: Game.width,
        height: Game.heightShift,
        onTouch: function(touch) {
        },
        draw: function(){
        },
        update: function(){
            if (this.state == 1) {
                if ((this.text.alpha -= 0.1) <= 0) {
                    this.state = 2;
                }
            } else if (this.state == 2){
                this.text.setText(Game.strings[Game.language].lvls[Game.menu.selectedLvl][this.textNumber]);
                this.state = 3;
            } else if (this.state == 3){
                if ((this.text.alpha += 0.1) >= 1) {
                    this.state = 4;
                }
            }
            //this.objPartilces.forEach(function(particle) {
            //    particle.update(0.05);
            //});
            if (this.timeout >= 0){
                this.timeout -= 1;
            } else {}
        },
        init:function() {

            this.textNumber = 0;

            this.show = function() {
                this.text.setText(Game.strings[Game.language].lvls[Game.menu.selectedLvl][this.textNumber]);
                //this.title.setText(Game.strings[Game.language].titles[Game.menu.selectedLvl]);
            };


            this.next = function() {
                if (++this.textNumber >= Game.strings[Game.language].lvls[Game.menu.selectedLvl].length) {
                    Game.noTouch = 1000;
                    if (Game.menu.selectedLvl != "27") {
                        setTimeout(function () {
                            Game.menu.playLvl();
                        }, 1);
                    } else {
                        Game.menu.container.removeChild(Game.menu.pages[Game.menu.currentPage].container);
                        Game.menu.currentPage = 'map';
                    }
                } else {
                    this.state = 1;
                }
            };

            this.guiContainer = new PIXI.Container();
            this.backSprite = Game.menu.pool.getSprite(Game.sprites.TitleBackground1024);
            this.backSprite.scale = new Vec2(Game.windowWidth/Game.windowHeight*4/3, 1.5);
            this.backSprite.position = new Vec2(1024, 1152/2);
            this.guiContainer.addChild(this.backSprite);

            this.guiContainer.position = new Vec2(Game.menuWidth/2, Game.menuHeight/2);
            this.guiContainer.pivot = new Vec2(2048/2, 1152/2);

            this.blackL = new PIXI.Graphics();
            this.blackL.alpha = 0.7;
            this.blackL.beginFill(0x000000);
            this.blackL.moveTo(0,0);
            this.blackL.drawRect(0, 0, 1, 1);
            this.blackL.scale.set(1270, 715);
            this.blackL.endFill();
            this.blackL.position.set(378, 200);
            this.guiContainer.addChild(this.blackL);
            this.largeBot = Game.menu.pool.getSprite(Game.sprites['Large-Frame-Bott']);
            this.largeBot.position = new Vec2(1014, 910);
            this.largeBot.scale.x = 1.6;
            this.guiContainer.addChild(this.largeBot);
            this.largeTop = Game.menu.pool.getSprite(Game.sprites['Large-Frame-Top']);
            this.largeTop.scale.x = 1.6;
            this.largeTop.position = new Vec2(1014, 200);
            this.guiContainer.addChild(this.largeTop);
            this.largeAxes = Game.menu.pool.getSprite(Game.sprites['Large-Axes']);
            this.largeAxes.position = new Vec2(1014, 958);
            this.guiContainer.addChild(this.largeAxes);
            this.largeFrameLeft = Game.menu.pool.getSprite(Game.sprites['Large-Frame-Right']);
            this.largeFrameLeft.scale.x = -1;
            this.largeFrameLeft.position = new Vec2(382, 555);
            this.guiContainer.addChild(this.largeFrameLeft);
            this.largeFrameRight = Game.menu.pool.getSprite(Game.sprites['Large-Frame-Right']);
            this.largeFrameRight.position = new Vec2(1633, 555);
            this.guiContainer.addChild(this.largeFrameRight);
            this.sideAxesR = Game.menu.pool.getSprite(Game.sprites['Side-Axes_L']);
            this.sideAxesR.position = new Vec2(1745, 547);
            this.guiContainer.addChild(this.sideAxesR);
            this.sideAxesL = Game.menu.pool.getSprite(Game.sprites['Side-Axes_L']);
            this.sideAxesL.position = new Vec2(270, 547);
            this.sideAxesL.scale.x = -1;
            this.guiContainer.addChild(this.sideAxesL);

            this.text = new PIXI.extras.BitmapText(Game.strings[Game.language].lvls[Game.menu.selectedLvl][this.textNumber],
                {
                    font: Game.getFontBitmap(),
                    align: "center",
                    width: 1640-418
                });
            //this.text.anchor.set(0.5, 0);\
            this.text.position = new Vec2(383, 220);
            this.guiContainer.addChild(this.text);
        }
    };

    Game.guiList.descriptionButton = {
        noLock:true,
        sprite : null,
        x: 0,
        y: 0,
        width: Game.width,
        height: Game.heightShift,
        update: function() {
            //this.text.setText(Game.strings[Game.language].campaign);
            //if (this.timeout >= 0) {
            //    this.timeout -= 1;
            //} else {
            //    if (this.guiContainer.alpha < 1) {
            //        this.guiContainer.alpha += 0.1;
            //        if (this.guiContainer.alpha > 1) {
            //            this.guiContainer.alpha = 1;
            //        }
            //    }
            //}
        },
        init:function() {
            this.guiContainer = new PIXI.Container();
            //this.guiContainer.alpha = 0.01;
            //
            //this.timeout = 100;

            this.backSprite = Game.menu.pool.getSprite(Game.sprites.VICDORY_DEFEAT);
            this.backSprite.scale.set(0.5, 0.5);
            this.backSpriteTouched = Game.menu.pool.getSprite(Game.sprites.BattlePressed);
            this.backSpriteTouched.position.set(0, 26/2);
            this.backSpriteTouched.scale.set(0.8, 0.5);
            this.backSpriteTouched.alpha = 0;

            this.guiContainer.addChild(this.backSprite);
            this.guiContainer.addChild(this.backSpriteTouched);

            this.guiContainer.position = new Vec2(Game.menuWidth/2, Game.menuHeight-100);
            Game.font = Game.getFont(36);
            Game.textAlign = 'center';
            Game.fillStyle = "#FEF2B3";
            this.text = new PIXI.Text(Game.strings[Game.language].menuMap.continue, {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle
            });
            this.text.position.y = - 18/2;
            this.guiContainer.addChild(this.text);
            this.guiContainer.interactive = true;
            this.guiContainer.mousedown = this.guiContainer.touchstart = function () {
                this.yestoched = true;
                this.backSpriteTouched.alpha = 1;
            }.bind(this);

            this.guiContainer.mouseup = this.guiContainer.touchend = this.guiContainer.mouseupoutside = this.guiContainer.touchendoutside =  function () {
                if (this.yestoched) {
                    this.backSpriteTouched.alpha = 0;
                    Game.menu.pages["description"].objGui[0].next();
                }
            }.bind(this);
        }
    };

    Game.guiList.descriptionParticles = {
        noLock:true,
        sprite : null,
        x: 0,
        y: 0,
        width: Game.width,
        height: Game.heightShift,
        onTouch: function(touch) {
        },
        draw: function(){
        },
        update: function(){
            this.objPartilces.forEach(function(particle) {
                particle.update(0.05);
            });
        },
        init:function() {
            this.guiContainer = new PIXI.Container();

            this.guiContainer.position = new Vec2(Game.menuWidth/2, Game.menuHeight/2);
            this.guiContainer.pivot = new Vec2(2048/2, 1152/2);

            this.objPartilces = [];

            var config = clone(Game.particlesList['TitlleSmoke']);
            config.pos.x = 1024;
            config.pos.y = 768;
            var textures = [];
            config.images.forEach(function(image){
                textures.push(PIXI.TextureCache[image])
            });

            this.objPartilces.push(new cloudkid.Emitter(
                    this.guiContainer,
                    textures,
                    config
                )
            );

            config = clone(Game.particlesList['TitlleSparks']);
            config.pos.x = 1024;
            config.pos.y = 768;
            textures = [];
            config.images.forEach(function(image){
                textures.push(PIXI.TextureCache[image])
            });

            this.objPartilces.push(new cloudkid.Emitter(
                    this.guiContainer,
                    textures,
                    config
                )
            )
        }
    };

    Game.guiList.quitButton = {
        noLock:true,
        sprite : null,
        x: 0,
        y: 0,
        width: Game.width,
        height: Game.heightShift,
        init:function() {
            this.guiContainer = new PIXI.Container();
            this.backSprite = Game.menu.pool.getSprite(Game.sprites.menu_button_hover);
            this.guiContainer.addChild(this.backSprite);
            this.guiContainer.position = new Vec2(Game.menuWidth/2, Game.menuHeight/2+400);
            this.guiContainer.scale = new Vec2(1.6, 1.6);
            Game.font = Game.getFont(36);
            Game.fillStyle = "#FEF2B3";
            this.text = new PIXI.Text(Game.strings[Game.language].quit, {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle
            });
            this.text.y = - 26;
            this.guiContainer.addChild(this.text);
            this.guiContainer.interactive = true;
            this.guiContainer.mousedown = this.guiContainer.touchstart = function () {
                this.yestoched = true;
                this.backSprite = Game.menu.pool.switchSprite(Game.sprites.menu_button_normal, this.backSprite);
                //this.guiContainer.scale = new Vec2(1.4, 1.4);
            }.bind(this);

            this.guiContainer.mouseup = this.guiContainer.touchend = this.guiContainer.mouseupoutside = this.guiContainer.touchendoutside =  function () {
                //TODO Open multiplayer
                this.backSprite = Game.menu.pool.switchSprite(Game.sprites.menu_button_hover, this.backSprite);
                if (this.yestoched) {
                    this.yestoched = false;
                    this.guiContainer.scale = new Vec2(1.6, 1.6);
                }
            }.bind(this);
        }
    };

    Game.guiList.menuMap = {
        noLock:true,
        sprite : null,
        x: 0,
        y: 0,
        width: Game.width,
        height: Game.heightShift,
        onTouch: function(touch) {
            //TODO DEBUG
            if (!Game.menu.touchesEnabled)
                return;

            this.selectedItem = null;
            if (this.touches.indexOf(touch)== -1){
                this.touches.push(touch);
                if (this.touches.length == 1){
                    this.isMoved  = false;
                    this.state = 'move';
                    this.lastX = touch.lastPosition.x;
                    this.lastY = touch.lastPosition.y;
                } else {
                    this.state = 'idle';
                }
            }

            if (this.state == 'move') {
                if (touch.lastPosition.clone().sub(touch.startPosition).getLength() > 50)
                    this.isMoved = true;

                if (!this.isMoved) {
                    var selectedLvl;
                    var movedPosition = (new Vec2(this.camera.position.x, this.camera.position.y).add(new Vec2(this.lastX, this.lastY).multiply(Game.scale))).multiply((1/2));
                    for (var key in Game.globallogic.lvls){
                        if (Game.globallogic.lvls[key].checkTouch(movedPosition)) {
                            selectedLvl = Game.globallogic.lvls[key];
                            if ((this.selectedItem == null)||(selectedLvl.position.clone().sub(movedPosition).getLength() < this.selectedItem.position.clone().sub(movedPosition).getLength()))
                                this.selectedItem = selectedLvl;
                        }
                    }
                    if (this.selectedItem) {
                        //if (this.selectedEffect)
                        //    this.flagsContainer.removeChild(this.selectedEffect);
                        //this.selectedEffect = Game.menu.pool.getSprite(Game.sprites['crater1']);
                        //this.selectedEffect.position = this.selectedItem.position.clone().multiply(2);
                        //this.flagsContainer.addChild(this.selectedEffect);
                    }
                } else {
                    this.camera.move(new Vec2(this.lastX-touch.lastPosition.x, this.lastY-touch.lastPosition.y).multiply(Game.scale));
                    this.lastX = touch.lastPosition.x;
                    this.lastY = touch.lastPosition.y;
                }
            }

            if (touch.touchedEnd) {
                //if (this.selectedEffect) {
                //    this.flagsContainer.removeChild(this.selectedEffect);
                //    this.selectedEffect = null;
                //}
                if (this.state === 'move') {
                    if (this.selectedItem) {
                        Game.menu.selectedLvl = this.selectedItem.name;
                        Game.menu.pages[Game.menu.currentPage].objGui.forEach(function(gui){
                            gui.hide();
                        });
                        if (this.tips) {
                            log('tutor.flag', 0);
                        }
                        setTimeout(function() {
                            if (Game.globallogic.isEpisodeUnlocked(parseInt(parseInt(Game.menu.selectedLvl-1)/10)))
                                Game.menu.currentPage = 'selected';
                            else
                                Game.menu.currentPage = 'purchaseEpisode';

                            Game.menu.container.addChild(Game.menu.pages[Game.menu.currentPage].container);
                            Game.menu.pages[Game.menu.currentPage].objGui.forEach(function (gui) {
                                gui.show();
                            });
                        }, 5*Game.cycleTickTime);
                    }
                } else {
                }
                this.selectedItem = null;
                this.state = 'idle';
                this.touches.splice(this.touches.indexOf(touch),1);
            }
        },
        draw: function(){
        },
        cameraPrototype : function () {
            this.position = new Vec2 (0, 0);
            this.spritePosition = new Vec2(0,0);
            this.windowSize = new Vec2(Game.windowWidth, Game.windowHeight);



            this.width = 2728;
            this.height = 1536;
            this.move = function(direction){
                this.position.add(direction);
                this.checkViewport();
                this.spritePosition.set(this.position.multiplyed(1));

                //if (Game.isWindowsPhone)
                //    this.spritePosition.set(this.position.multiplyed(1 / 0.8));

                Game.globallogic.mapPosition.set(this.position);
            };

            this.checkViewport = function() {
                if(this.position.x < 0)
                    this.position.x = 0;

                if (this.position.y < 0)
                    this.position.y = 0;

                if(this.position.x > this.width - this.windowSize.x)
                    this.position.x = this.width - this.windowSize.x;

                if (this.position.y > this.height - this.windowSize.y)
                    this.position.y = this.height - this.windowSize.y;
            };
        },

        init:function() {
            this.touches = [];
            this.state = 'idle';
            this.isMoved = false;
            this.lastX = 0;
            this.lastY = 0;
            this.lastScale = 0;
            this.selectedItem = null;
            this.camera = new Game.guiList.menuMap.cameraPrototype();
            if (isNaN(parseInt(localStorage.getItem(Game.profile + 'mapX')))) {
                Game.globallogic.mapPosition.set(734*2 - this.camera.windowSize.x/2, 716*2 - this.camera.windowSize.y/2);
            }
            this.camera.move(Game.globallogic.mapPosition);
            this.sprite = Game.menu.pool.getSprite(Game.sprites.mapBack);
            this.sprite.pivot = new Vec2(-1024, -1152/2);
            this.guiContainer = new PIXI.Container();
            this.guiContainer.addChild(this.sprite);

            Game.fillStyle = "#FFF2D0";

            this.backSpriteLogo = Game.menu.pool.getSprite(Game.sprites.LOGO);
            this.backSpriteLogo.position = new Vec2(550, 120);
            this.guiContainer.addChild(this.backSpriteLogo);

            this.sprite.scale.x = this.sprite.scale.y = (1536/1152);

            if (Game.isWindowsPhone) {
                //this.sprite.scale.x = this.sprite.scale.y = (1536 / 1152) / 0.8;
                //this.sprite.pivot.multiply(0.8);
            }

            this.guiContainer.scale.x = this.guiContainer.scale.y = 1152/Game.windowHeight;
            this.guiContainer.pivot = this.camera.spritePosition;
            this.flagsContainer = new PIXI.Container();
            this.guiContainer.addChild(this.flagsContainer);
            this.guiContainer.interactive = true;
            this.guiContainer.mousedown = this.guiContainer.touchstart = function () {
                this.yestoched = true;
            }.bind(this);
            this.guiContainer.mouseup = this.guiContainer.touchend = this.guiContainer.mouseupoutside = this.guiContainer.touchendoutside =  function () {
                if (this.yestoched) {
                    this.yestoched = false;
                }
            }.bind(this);
            this.tipsAnimation = 1;

            if (!Game.globallogic.getLvlWithName("1").isOpen()) {
                this.tips = new MessageBalloonMenu(Game.strings[Game.language].menuMap.playHere, Game.globallogic.getLvlWithName("0").position.multiplyed(2).add(new Vec2(-98, -166)), true);
                this.guiContainer.addChild(this.tips);
            }

            function getPathName(lvl) {
                switch(lvl.episode) {
                    case 'desert':
                        return 'Path' + (parseInt(lvl.name) + 2) + '.png';
                        break;
                    case 'forest':
                        if (parseInt(lvl.name) <= 12)
                            return 'Path' + (parseInt(lvl.name)) + '.png';
                        else
                            return 'Path' + (parseInt(lvl.name) + 1) + '.png';
                        break;
                    case 'graveyard':
                        if (parseInt(lvl.name) <= 22)
                            return 'Path' + (parseInt(lvl.name)) + '.png';
                        else
                            return 'Path' + (parseInt(lvl.name) + 2) + '.png';
                        break;
                }
            }
            Game.globallogic.lvls.forEach(function(lvl){
                var pathName = getPathName(lvl);
                var sprite = Game.sprites[pathName];
                if ((sprite)&&(lvl.isOpen())) {
                    var disp = Game.menu.pool.getSprite(sprite);
                    disp.anchor.set(0.5, 0.5);
                    disp.pivot = disp.texture.basePivot;
                    disp.position = lvl.position.multiplyed(2);
                    this.flagsContainer.addChild(disp);
                }
            }.bind(this));

            Game.globallogic.lvls.forEach(function(lvl){
                var animation = Game.animations['BannerAlly'];

                switch (lvl .episode) {
                    case 'desert':
                        animation = Game.animations['BannerOrcs'];
                        break;
                    case 'forest':
                        animation = Game.animations['BannerElfes'];
                        break;
                    case 'graveyard':
                        animation = Game.animations['BannerNecro'];
                        break;
                }

                if (lvl.isOpen()) {
                    var disp = Game.menu.pool.getSprite(Game.sprites['FlagPoint']);
                    disp.position = lvl.position.multiplyed(2);
                    disp.anchor.set(0.5, 0.5);
                    disp.pivot = disp.texture.basePivot;
                    this.flagsContainer.addChild(disp);
                    var anim = Game.menu.pool.getAnimation(animation.name);
                    anim.anchor.set(0.5, 0.5);
                    anim.pivot = anim.texture.basePivot;
                    anim.position = lvl.position.multiplyed(2);
                    //anim.scale.x = anim.scale.y = 2;
                    this.flagsContainer.addChild(anim);
                }
                for (var i = 1; i <= lvl.passed; i++) {
                    var starr = Game.menu.pool.getSprite(Game.sprites['starr']);
                    starr.position = lvl.position.multiplyed(2).add(new Vec2(-32 + 16*i, -76));
                    starr.anchor.set(0.5, 0.5);
                    starr.scale.set(0.3,0.3);
                    this.flagsContainer.addChild(starr);
                }
                if (lvl.passed > 0) {
                    var sname = lvl.difficulty;
                    sname = sname[0].toUpperCase() + sname.slice(1, sname.length);
                    var passed = Game.menu.pool.getSprite(Game.sprites[sname+'Idle']);
                    passed.position = lvl.position.multiplyed(2).add(new Vec2(0, -120));
                    passed.scale.set(0.3,0.3);
                    this.flagsContainer.addChild(passed);
                }
            }.bind(this));

            this.blackS = new PIXI.Graphics();
            this.blackS.beginFill(0x000000);
            this.blackS.moveTo(0,0);
            this.blackS.drawRect(0, 0, 1, 1);
            this.blackS.scale.set(2800, 1536);
            this.blackS.endFill();
            this.blackS.position.set(0, 0);
            this.blackS.alpha = 0;
            this.guiContainer.addChild(this.blackS);

            this.show = function() {
                this.hidden = false;
            };

            this.hide = function(){
                this.hidden = true;
            };
        },
        update: function() {
            if (this.tips) {
                var scale = ++this.tipsAnimation > 10 ? (1.05 - ((this.tipsAnimation-10)/200)) : (1 + this.tipsAnimation/200);
                if (this.tipsAnimation >= 20)
                    this.tipsAnimation = 0;
                if (Game.windowHeight < 1024) {
                    scale /= 2;
                    this.tips.pivot.set(-88, -95);
                }

                this.tips.scale.set(scale, scale);
            }
            if (this.hidden && this.blackS.alpha < 0.6){
                this.blackS.alpha += 0.1;
            } else if (!this.hidden && this.blackS.alpha > 0) {
                this.blackS.alpha -= 0.1;
            }
        }
    };

    Game.guiList.upgradesButton = {
        noLock:true,
        sprite : null,
        xp: 20,
        yp: 1152 - 180,
        x: 20,
        y: 1536 - 180,
        width: 227,
        height: 171,
        delay: 5,
        draw: function(){
        },
        init:function(params) {
            this.params = params;
            this.xp = params.xp; this.yp = params.yp;

            this.pressed = false;
            this.showAnimation = {startX: this.xp, toX:this.xp, startY:this.yp+500, toY:this.yp, iterations:5};

            this.checkTouch = function(touch) {
                if (touch.startPosition.x > this.params.x && touch.startPosition.x < this.params.x+this.width && (touch.startPosition.y > this.params.y )&& (touch.startPosition.y<this.params.y+this.height))
                {
                    return true;
                }
                return false;
            };

            this.guiContainer = new PIXI.Container();
            this.disp = Game.menu.pool.getSprite(Game.sprites['MapButtonsOFF']);
            this.icon = Game.menu.pool.getSprite(Game.sprites['UpgradesICO']);
            this.guiContainer.addChild(this.disp);
            this.guiContainer.addChild(this.icon);
            Game.font = Game.getFont(36);
            Game.fillStyle = "#FFF2B3";
            this.text = new PIXI.Text(Game.strings[Game.language].upgradesPageTitle, {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle
            });
            this.text.position.set(0, 26);
            this.guiContainer.addChild(this.text);

            this.guiContainer.position = new Vec2(this.xp + this.width/2, this.yp + this.height/2);
            this.guiContainer.interactive = true;
            this.guiContainer.mousedown = this.guiContainer.touchstart = function () {
                this.yestoched = true;
                Game.menu.touchesEnabled = false;
                this.disp = Game.menu.pool.switchSprite(Game.sprites['MapButtonsON'], this.disp);
            }.bind(this);
            this.guiContainer.mouseup = this.guiContainer.touchend = this.guiContainer.mouseupoutside = this.guiContainer.touchendoutside =  function () {
                if (this.yestoched) {
                    this.yestoched = false;
                    Game.menu.touchesEnabled = true;
                    for (var i = Game.touchList.length - 1; i >= 0; i--)
                        Game.touchList[i].del();

                    this.hideMe();

                    if (this.tips1) {
                        log('tutor.upgrades', 0);
                        localStorage.setItem("upgradesOpened", "true");
                        this.guiContainer.removeChild(this.tips1);
                    }
                    this.disp = Game.menu.pool.switchSprite(Game.sprites['MapButtonsOFF'], this.disp);
                }
            }.bind(this);

            this.show = function() {
                this.startAnimation(this.showAnimation, null, false, 0);
            };

            this.hide = function(){
                this.startAnimation(this.showAnimation, function() {}, true, 0);
            };

            this.hideMe = function(){
                for (var i = 0; i < Game.menu.pages[Game.menu.currentPage].objGui.length; i++){
                    if (Game.menu.pages[Game.menu.currentPage].objGui[i] != this)
                        Game.menu.pages[Game.menu.currentPage].objGui[i].hide();
                }
                this.startAnimation(this.showAnimation, function() {
                    Game.menu.currentPage = 'upgrades';
                    Game.menu.container.addChild(Game.menu.pages[Game.menu.currentPage].container);
                    Game.menu.pages[Game.menu.currentPage].objGui.forEach(function(gui){
                        gui.show();
                    });
                }, true, 0);
            };

            var opened = localStorage.getItem("upgradesOpened");
            if (Game.globallogic.getLvlWithName("1").isOpen() && opened != "true") {

                var ballon = new MessageBalloon(Game.strings[Game.language].menuMap.newTowers, new Vec2(0, -90), true, this.guiContainer);
                ballon.container.scale.set(0.8,0.8);
                this.tips1 = ballon.container;
                this.tipsAnimation = 0;
            }
        },
        update: function () {
            if (this.tips1) {
                var scale = ++this.tipsAnimation > 10 ? (1.05 - ((this.tipsAnimation - 10) / 200)) : (1 + this.tipsAnimation / 200);
                if (this.tipsAnimation >= 20)
                    this.tipsAnimation = 0;

                this.tips1.scale.set(scale, scale);
            }
        }
    };

    Game.guiList.heroesButton = {
        noLock:true,
        sprite : null,
        xp: 20*2 + 227,
        yp: 1152 - 180,
        x: 20*2 + 227,
        y: 1536 - 180,
        width: 227,
        height: 171,
        delay: 5,
        draw: function(){
        },
        init:function(params) {
            this.params = params;
            this.xp = params.xp; this.yp = params.yp;
            this.pressed = false;
            this.showAnimation = {startX: this.xp, toX:this.xp, startY:this.yp+500, toY:this.yp, iterations:5};

            this.checkTouch = function(touch) {
                if (touch.startPosition.x > this.params.x && touch.startPosition.x < this.params.x+this.width && (touch.startPosition.y > this.params.y )&& (touch.startPosition.y<this.params.y+this.height))
                {
                    return true;
                }
                return false;
            };

            this.guiContainer = new PIXI.Container();
            this.disp = Game.menu.pool.getSprite(Game.sprites['MapButtonsOFF']);
            this.icon = Game.menu.pool.getSprite(Game.sprites['HeroesIco']);
            this.guiContainer.addChild(this.disp);
            this.guiContainer.addChild(this.icon);
            Game.font = Game.getFont(36);
            Game.fillStyle = "#FFF2B3";
            this.text = new PIXI.Text(Game.strings[Game.language].heroesPageTitle, {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle
            });
            this.text.position.set(0, 26);
            this.guiContainer.addChild(this.text);
            this.guiContainer.position = new Vec2(this.xp + this.width/2, this.yp + this.height/2);
            this.guiContainer.interactive = true;
            this.guiContainer.mousedown = this.guiContainer.touchstart = function () {
                this.yestoched = true;
                Game.menu.touchesEnabled = false;
                this.disp = Game.menu.pool.switchSprite(Game.sprites['MapButtonsON'], this.disp);
            }.bind(this);
            this.guiContainer.mouseup = this.guiContainer.touchend = this.guiContainer.mouseupoutside = this.guiContainer.touchendoutside =  function () {
                if (this.yestoched) {
                    this.yestoched = false;
                    Game.menu.touchesEnabled = true;
                    for (var i = Game.touchList.length - 1; i >= 0; i--)
                        Game.touchList[i].del();

                    this.hideMe();
                    this.disp = Game.menu.pool.switchSprite(Game.sprites['MapButtonsOFF'], this.disp);
                }
            }.bind(this);

            this.show = function() {
                this.startAnimation(this.showAnimation, function() {}, false, 0);
            };
            this.hide = function(){
                this.startAnimation(this.showAnimation, function() {}, true, 0);
            };
            this.hideMe = function(){
                for (var i = 0; i < Game.menu.pages[Game.menu.currentPage].objGui.length; i++){
                    if (Game.menu.pages[Game.menu.currentPage].objGui[i] != this)
                        Game.menu.pages[Game.menu.currentPage].objGui[i].hide();
                }
                this.startAnimation(this.showAnimation, function() {
                    Game.menu.currentPage = 'heroes';
                    Game.menu.container.addChild(Game.menu.pages[Game.menu.currentPage].container);
                    Game.menu.pages[Game.menu.currentPage].objGui.forEach(function(gui){
                        gui.show();
                    });
                }, true, 0);
            };
        }
    };


    Game.guiList.shopButton = {
        noLock:true,
        sprite : null,
        xp: 20*3 + 227*2,
        yp: 1152 - 180,
        x: 20*3 + 227*2,
        y: 1536 - 180,
        width: 227,
        height: 171,
        delay: 5,
        draw: function(){
        },
        init:function(params) {
            this.params = params;
            this.xp = params.xp; this.yp = params.yp;
            this.pressed = false;
            this.showAnimation = {startX: this.xp, toX:this.xp, startY:this.yp+500, toY:this.yp, iterations:5};

            this.checkTouch = function(touch) {
                if (touch.startPosition.x > this.params.x && touch.startPosition.x < this.params.x+this.width && (touch.startPosition.y > this.params.y )&& (touch.startPosition.y<this.params.y+this.height))
                {
                    return true;
                }
                return false;
            };

            this.guiContainer = new PIXI.Container();
            this.disp = Game.menu.pool.getSprite(Game.sprites['MapButtonsOFF']);
            this.icon = Game.menu.pool.getSprite(Game.sprites['MarketICO']);
            this.guiContainer.addChild(this.disp);
            this.guiContainer.addChild(this.icon);
            Game.font = Game.getFont(36);
            Game.fillStyle = "#FFF2B3";
            this.text = new PIXI.Text(Game.strings[Game.language].shopPageTitle, {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle
            });
            this.text.position.set(0, 26);
            this.guiContainer.addChild(this.text);
            this.guiContainer.position = new Vec2(this.xp + this.width/2, this.yp + this.height/2);
            this.guiContainer.interactive = true;
            this.guiContainer.mousedown = this.guiContainer.touchstart = function () {
                this.yestoched = true;
                Game.menu.touchesEnabled = false;
                this.disp = Game.menu.pool.switchSprite(Game.sprites['MapButtonsON'], this.disp);
            }.bind(this);
            this.guiContainer.mouseup = this.guiContainer.touchend = this.guiContainer.mouseupoutside = this.guiContainer.touchendoutside =  function () {
                if (this.yestoched) {
                    this.yestoched = false;

                    Game.menu.touchesEnabled = true;
                    for (var i = Game.touchList.length - 1; i >= 0; i--)
                        Game.touchList[i].del();

                    this.hideMe();
                    this.disp = Game.menu.pool.switchSprite(Game.sprites['MapButtonsOFF'], this.disp);
                }
            }.bind(this);

            this.show = function() {
                this.startAnimation(this.showAnimation, null, false, 0);
            };

            this.hide = function(){
                this.startAnimation(this.showAnimation, function() {}, true, 0);
            };

            this.hideMe = function(){
                for (var i = 0; i < Game.menu.pages[Game.menu.currentPage].objGui.length; i++){
                    if (Game.menu.pages[Game.menu.currentPage].objGui[i] != this)
                        Game.menu.pages[Game.menu.currentPage].objGui[i].hide();
                }
                this.startAnimation(this.showAnimation, function() {
                    Game.menu.currentPage = 'shop';
                    Game.menu.container.addChild(Game.menu.pages[Game.menu.currentPage].container);
                    Game.menu.pages[Game.menu.currentPage].objGui.forEach(function(gui){
                        gui.show();
                    });
                }, true, 0);
            };
        }
    };

    Game.guiList.backButton = {
        noLock:true,
        sprite : null,
        x: 2048 - 227-20,
        y: 1536 - 180,
        xp: Game.windowWidth*(1152/Game.windowHeight) - 227-10,
        yp: 1152 - 180,
        width: 227,
        height: 171,
        delay: 5,
        draw: function(){
        },
        init:function(params) {
            this.params = params;
            this.xp = params.xp; this.yp = params.yp;

            this.pressed = false;
            this.showAnimation = {startX: this.xp, toX:this.xp, startY:this.yp+500, toY:this.yp, iterations:5};

            this.checkTouch = function(touch) {
                if (touch.startPosition.x > this.params.x && touch.startPosition.x < this.params.x+this.width && (touch.startPosition.y > this.params.y )&& (touch.startPosition.y<this.params.y+this.height))
                {
                    return true;
                }
                return false;
            };

            this.guiContainer = new PIXI.Container();
            this.disp = Game.menu.pool.getSprite(Game.sprites['MapButtonsOFF']);
            this.icon = Game.menu.pool.getSprite(Game.sprites['ExitICO']);
            this.guiContainer.addChild(this.disp);
            this.guiContainer.addChild(this.icon);
            Game.font = Game.getFont(36);
            Game.fillStyle = "#FFF2B3";
            this.text = new PIXI.Text(Game.strings[Game.language].exit, {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle
            });
            this.text.position.set(0, 26);
            this.guiContainer.addChild(this.text);

            this.guiContainer.position = new Vec2(this.xp + this.width/2, this.yp + this.height/2);
            this.guiContainer.interactive = true;
            this.guiContainer.mousedown = this.guiContainer.touchstart = function () {
                this.yestoched = true;
                Game.menu.touchesEnabled = false;
                this.disp = Game.menu.pool.switchSprite(Game.sprites['MapButtonsON'], this.disp);
            }.bind(this);
            this.guiContainer.mouseup = this.guiContainer.touchend = this.guiContainer.mouseupoutside = this.guiContainer.touchendoutside =  function () {
                if (this.yestoched) {
                    this.yestoched = false;
                    Game.menu.touchesEnabled = true;
                    for (var i = Game.touchList.length - 1; i >= 0; i--)
                        Game.touchList[i].del();

                    this.disp = Game.menu.pool.switchSprite(Game.sprites['MapButtonsOFF'], this.disp);

                    Game.menu.container.removeChild(Game.menu.pages[Game.menu.currentPage].container);
                    Game.menu.currentPage = 'main';
                    Game.menu.container.addChild(Game.menu.pages['main'].container);

                }
            }.bind(this);

            this.show = function() {
                this.startAnimation(this.showAnimation, null, false, 0);
            };
            this.hide = function(){
                this.startAnimation(this.showAnimation, function() {}, true, 0);
            };

            this.hideMe = function(){
                for (var i = 0; i < Game.menu.pages[Game.menu.currentPage].objGui.length; i++){
                    if (Game.menu.pages[Game.menu.currentPage].objGui[i] != this)
                        Game.menu.pages[Game.menu.currentPage].objGui[i].hide();
                }
                this.startAnimation(this.showAnimation, function() {
                    Game.menu.currentPage = 'upgrades';
                    Game.menu.container.addChild(Game.menu.pages[Game.menu.currentPage].container);
                    Game.menu.pages[Game.menu.currentPage].objGui.forEach(function(gui){
                        gui.show();
                    });
                }, true, 0);
            };
        }
    };


    Game.guiList.soundButton = {
        noLock:true,
        sprite : null,
        x: 2048 - 120*2-20,
        y: 10,
        xp: Game.windowWidth*(1152/Game.windowHeight) - 120*2-20,
        yp: 10,
        width: 120,
        height: 120,
        delay: 5,
        draw: function() {
        },
        init:function(params) {
            this.params = params;
            this.xp = params.xp; this.yp = params.yp;

            this.pressed = false;
            this.showAnimation = {startX: this.xp, toX:this.xp, startY:this.yp-500, toY:this.yp, iterations:5};

            this.checkTouch = function(touch) {
                if (touch.startPosition.x > this.params.x && touch.startPosition.x < this.params.x+this.width && (touch.startPosition.y > this.params.y )&& (touch.startPosition.y<this.params.y+this.height))
                {
                    return true;
                }
                return false;
            };

            this.guiContainer = new PIXI.Container();
            this.disp = Game.menu.pool.getSprite(Game.sprites[Game.globallogic.soundEnable ? 'SoundON' : 'SoundOFF']);
            this.guiContainer.addChild(this.disp);
            this.guiContainer.position = new Vec2(this.xp + this.width/2, this.yp + this.height/2);
            this.guiContainer.interactive = true;
            this.guiContainer.mousedown = this.guiContainer.touchstart = function () {
                this.yestoched = true;
                Game.menu.touchesEnabled = false;
            }.bind(this);
            this.guiContainer.mouseup = this.guiContainer.touchend = this.guiContainer.mouseupoutside = this.guiContainer.touchendoutside =  function () {
                if (this.yestoched) {
                    this.yestoched = false;
                    Game.menu.touchesEnabled = true;
                    for (var i = Game.touchList.length - 1; i >= 0; i--)
                        Game.touchList[i].del();

                    Game.globallogic.toggleSound();
                    this.disp = Game.menu.pool.switchSprite(Game.sprites[Game.globallogic.soundEnable ? 'SoundON' : 'SoundOFF'], this.disp);
                }
            }.bind(this);

            this.show = function() {
                this.startAnimation(this.showAnimation, null, false, 0);
            };
            this.hide = function(){
                this.startAnimation(this.showAnimation, function() {}, true, 0);
            };
        }
    };

    Game.guiList.musicButton = {
        noLock:true,
        sprite : null,
        x: 2048 - 120-10,
        y: 10,
        xp: Game.windowWidth*(1152/Game.windowHeight) - 120-10,
        yp: 10,
        width: 120,
        height: 120,
        delay: 5,
        draw: function(){
        },
        init:function(params) {
            this.params = params;
            this.xp = params.xp; this.yp = params.yp;

            this.pressed = false;
            this.showAnimation = {startX: this.xp, toX:this.xp, startY:this.yp-500, toY:this.yp, iterations:5};

            this.checkTouch = function(touch) {
                if (touch.startPosition.x > this.params.x && touch.startPosition.x < this.params.x+this.width && (touch.startPosition.y > this.params.y )&& (touch.startPosition.y<this.params.y+this.height))
                {
                    return true;
                }
                return false;
            };

            this.guiContainer = new PIXI.Container();
            this.disp = Game.menu.pool.getSprite(Game.sprites[Game.globallogic.musicEnable ? 'MusicON' : 'MusicOFF']);
            this.guiContainer.addChild(this.disp);

            this.guiContainer.position = new Vec2(this.xp + this.width/2, this.yp + this.height/2);
            this.guiContainer.interactive = true;
            this.guiContainer.mousedown = this.guiContainer.touchstart = function () {
                this.yestoched = true;
                Game.menu.touchesEnabled = false;
            }.bind(this);
            this.guiContainer.mouseup = this.guiContainer.touchend = this.guiContainer.mouseupoutside = this.guiContainer.touchendoutside =  function () {
                if (this.yestoched) {
                    this.yestoched = false;
                    Game.menu.touchesEnabled = true;
                    for (var i = Game.touchList.length - 1; i >= 0; i--)
                        Game.touchList[i].del();

                    Game.globallogic.toggleMusic();
                    this.disp = Game.menu.pool.switchSprite(Game.sprites[Game.globallogic.musicEnable ? 'MusicON' : 'MusicOFF'], this.disp);
                }
            }.bind(this);

            this.show = function() {
                this.startAnimation(this.showAnimation, null, false, 0);
            };
            this.hide = function(){
                this.startAnimation(this.showAnimation, function() {}, true, 0);
            };
        }
    };

    Game.guiList.achievementButton = {
        noLock:true,
        sprite : null,
        x: 10,
        y: 10,
        xp: 10,
        yp: 10,
        width: 120,
        height: 120,
        delay: 5,
        draw: function(){
        },
        init:function(params) {
            this.params = params;
            this.xp = params.xp; this.yp = params.yp;

            this.pressed = false;
            this.showAnimation = {startX: this.xp, toX:this.xp, startY:this.yp-500, toY:this.yp, iterations:5};

            this.checkTouch = function(touch) {
                if (touch.startPosition.x > this.params.x && touch.startPosition.x < this.params.x+this.width && (touch.startPosition.y > this.params.y )&& (touch.startPosition.y<this.params.y+this.height))
                {
                    return true;
                }
                return false;
            };

            this.guiContainer = new PIXI.Container();
            this.disp = Game.menu.pool.getSprite(Game.sprites.cup);
            this.disp.scale.set(0.7, 0.7);
            this.guiContainer.addChild(this.disp);

            this.guiContainer.position = new Vec2(this.xp + this.width/2, this.yp + this.height/2);
            this.guiContainer.interactive = true;
            this.guiContainer.mousedown = this.guiContainer.touchstart = function () {
                this.yestoched = true;
                Game.menu.touchesEnabled = false;
            }.bind(this);
            this.guiContainer.mouseup = this.guiContainer.touchend = this.guiContainer.mouseupoutside = this.guiContainer.touchendoutside =  function () {
                if (this.yestoched) {
                    this.yestoched = false;
                    Game.menu.touchesEnabled = true;
                    Game.globallogic.showAchievements();
                }
            }.bind(this);

            this.show = function() {
                this.startAnimation(this.showAnimation, null, false, 0);
            };
            this.hide = function(){
                this.startAnimation(this.showAnimation, function() {}, true, 0);
            };
        }
    };

    Game.guiList.libraryButton = {
        noLock:true,
        sprite : null,
        x: 10,
        y: 10,
        xp: 180,
        yp: 10,
        width: 120,
        height: 120,
        delay: 5,
        draw: function(){
        },
        init:function(params) {
            this.params = params;
            this.xp = params.xp; this.yp = params.yp;

            this.pressed = false;
            this.showAnimation = {startX: this.xp, toX:this.xp, startY:this.yp-500, toY:this.yp, iterations:5};

            this.checkTouch = function(touch) {
                if (touch.startPosition.x > this.params.x && touch.startPosition.x < this.params.x+this.width && (touch.startPosition.y > this.params.y )&& (touch.startPosition.y<this.params.y+this.height))
                {
                    return true;
                }
                return false;
            };

            this.guiContainer = new PIXI.Container();
            this.disp = Game.menu.pool.getSprite(Game.sprites.BookIco);
            this.disp.scale.set(0.7, 0.7);
            this.guiContainer.addChild(this.disp);

            this.guiContainer.position = new Vec2(this.xp + this.width/2, this.yp + this.height/2);
            this.guiContainer.interactive = true;
            this.guiContainer.mousedown = this.guiContainer.touchstart = function () {
                this.yestoched = true;
                Game.menu.touchesEnabled = false;
            }.bind(this);
            this.guiContainer.mouseup = this.guiContainer.touchend = this.guiContainer.mouseupoutside = this.guiContainer.touchendoutside =  function () {
                if (this.yestoched) {
                    this.yestoched = false;
                    Game.menu.touchesEnabled = true;
                    Game.globallogic.showLibrary();
                }
            }.bind(this);

            this.show = function() {
                this.startAnimation(this.showAnimation, null, false, 0);
            };
            this.hide = function(){
                this.startAnimation(this.showAnimation, function() {}, true, 0);
            };
        }
    };

    Game.guiList.shopPage = {
        noLock:true,
        sprite : null,
        x: 0,
        y: 0,
        width: Game.menuWidth,
        height: Game.menuHeight,
        draw: function(){
        },
        init:function() {

            this.checkTouch = function () {
                return false;
            };

            this.guiContainer = new PIXI.Container();
            this.guiContainer.position = new Vec2(Game.menuWidth/2, Game.menuHeight/2);
            this.guiContainer.pivot = new Vec2(2048/2, 1152/2);

            this.blackL = new PIXI.Graphics();
            this.blackL.alpha = 0.7;
            this.blackL.beginFill(0x000000);
            this.blackL.moveTo(0,0);
            this.blackL.drawRect(0, 0, 1, 1);
            this.blackL.scale.set(850, 715);
            this.blackL.endFill();
            this.blackL.position.set(800, 300);
            this.guiContainer.addChild(this.blackL);
            this.largeBot = Game.menu.pool.getSprite(Game.sprites['Large-Frame-Bott']);
            this.largeBot.position = new Vec2(1224, 1010);
            this.guiContainer.addChild(this.largeBot);
            this.largeTop = Game.menu.pool.getSprite(Game.sprites['Large-Frame-Top']);
            this.largeTop.position = new Vec2(1224, 300);
            this.guiContainer.addChild(this.largeTop);
            this.largeAxes = Game.menu.pool.getSprite(Game.sprites['Large-Axes']);
            this.largeAxes.position = new Vec2(1224, 1058);
            this.guiContainer.addChild(this.largeAxes);
            this.largeFrameLeft = Game.menu.pool.getSprite(Game.sprites['Large-Frame-Left']);
            this.largeFrameLeft.position = new Vec2(806, 655);
            this.guiContainer.addChild(this.largeFrameLeft);
            this.largeFrameRight = Game.menu.pool.getSprite(Game.sprites['Large-Frame-Right']);
            this.largeFrameRight.position = new Vec2(1633, 655);
            this.guiContainer.addChild(this.largeFrameRight);
            this.sideAxesR = Game.menu.pool.getSprite(Game.sprites['Side-Axes_L']);
            this.sideAxesR.position = new Vec2(1745, 647);
            this.guiContainer.addChild(this.sideAxesR);


            this.blackM = new PIXI.Graphics();
            this.blackM.alpha = 0.7;
            this.blackM.beginFill(0x000000);
            this.blackM.moveTo(0,0);
            this.blackM.drawRect(0, 0, 1, 1);
            this.blackM.scale.set(360, 710);
            this.blackM.endFill();
            this.blackM.position.set(374, 300);
            this.guiContainer.addChild(this.blackM);
            this.midBot = Game.menu.pool.getSprite(Game.sprites['Mid-Frame-Bot']);
            this.midBot.position = new Vec2(555, 1010);
            this.guiContainer.addChild(this.midBot);
            this.midTop = Game.menu.pool.getSprite(Game.sprites['Mid-Frame-Top']);
            this.midTop.position = new Vec2(555, 300);
            this.guiContainer.addChild(this.midTop);
            this.midAxes = Game.menu.pool.getSprite(Game.sprites['Small-Axes']);
            this.midAxes.position = new Vec2(555, 1058);
            this.guiContainer.addChild(this.midAxes);
            this.midFrameLeft = Game.menu.pool.getSprite(Game.sprites['Mid-Frame-Left']);
            this.midFrameLeft.position = new Vec2(384, 655);
            this.guiContainer.addChild(this.midFrameLeft);
            this.midFrameRight = Game.menu.pool.getSprite(Game.sprites['Mid-Frame-Right']);
            this.midFrameRight.position = new Vec2(730, 655);
            this.guiContainer.addChild(this.midFrameRight);
            this.sideAxesL = Game.menu.pool.getSprite(Game.sprites['Side-Axes_L']);
            this.sideAxesL.position = new Vec2(275, 647);
            this.sideAxesL.scale.set(-1,1);
            this.guiContainer.addChild(this.sideAxesL);


            this.blackS = new PIXI.Graphics();
            this.blackS.alpha = 0.7;
            this.blackS.beginFill(0x000000);
            this.blackS.moveTo(0,0);
            this.blackS.drawRect(0, 0, 1, 1);
            this.blackS.scale.set(360, 135);
            this.blackS.endFill();
            this.blackS.position.set(374, 115);
            this.guiContainer.addChild(this.blackS);
            this.sFrame = Game.menu.pool.getSprite(Game.sprites['Small-Frame']);
            this.sFrame.position = new Vec2(553, 180);
            this.guiContainer.addChild(this.sFrame);
            this.smallAxes = Game.menu.pool.getSprite(Game.sprites['Small-Axes']);
            this.smallAxes.position = new Vec2(555, 73);
            this.smallAxes.scale.set(1,-1);
            this.guiContainer.addChild(this.smallAxes);


            //this.guiContainer = new PIXI.Container();
            //this.backSprite = Game.menu.pool.getSprite(Game.sprites.shopBack);
            //this.backSprite.pivot = new Vec2(-1024, -1152/2);
            //this.guiContainer.addChild(this.backSprite);
            //this.guiContainer.position = new Vec2(Game.menuWidth/2, Game.menuHeight/2);
            //this.guiContainer.pivot = new Vec2(2048/2, 1152/2);
            //
            //Game.font = Game.getFont(64);
            //Game.fillStyle = "rgb(255, 255, 0)";
            //this.pageText = new PIXI.Text(Game.strings[Game.language].shopPageTitle, {
            //    font: Game.font,
            //    fill: Game.fillStyle
            //});
            //this.guiContainer.addChild(this.pageText);
            //this.pageText.position = new Vec2(600, 140);
            //
            this.updateItems = [];

            this.update = function () {
                this.skullText.setText(Game.globallogic.skulls);
//                if (this.oldHero != this.hero)
                //                  this.initDescription();
                this.updateItems.forEach(function (item){
                    item.call(this);
                }.bind(this));
                this['skulls1Price'].setText(Game.globallogic.getPurchasePrice(1));
                this['skulls2Price'].setText(Game.globallogic.getPurchasePrice(2));
                this['skulls3Price'].setText(Game.globallogic.getPurchasePrice(3));
                Gui.prototype.update.call(this);
            };

            this.skulls = Game.menu.pool.getSprite(Game.sprites.skullsShopPage);
            this.skulls.scale.set(1,1);
            this.skulls.position = new Vec2(650, 180);
            this.guiContainer.addChild(this.skulls);

            Game.font = Game.getFont(64);
            Game.fillStyle = "#FFF2B3";
            this.skullText = new PIXI.Text(Game.globallogic.skulls, {
                font: Game.font,
                fill: Game.fillStyle
            });
            this.guiContainer.addChild(this.skullText);
            this.skullText.position = new Vec2(530, 150);

            Game.fillStyle = "#FFF2B3";
            Game.font = Game.getFont(48);
            this.pageDescription = new PIXI.Text(Game.strings[Game.language].shopDescription, {
                font: Game.font,
                fill: Game.fillStyle,
                wordWrapWidth: 340,
                wordWrap:true,
                align: 'center'
            });
            this.pageDescription.width = 300;
            this.pageDescription.anchor.y = 0.5;
            this.pageDescription.position = new Vec2(560, 628);
            this.guiContainer.addChild(this.pageDescription);


            this.initProduct = function (name, x, y) {
                this[name] = new PIXI.Container();
                this[name+'Sprite'] = Game.menu.pool.getSprite(Game.sprites[name+'Scroll']);
                this[name+'SpriteSelected'] = Game.menu.pool.getSprite(Game.sprites['selectedScroll']);
                this[name].addChild(this[name+'SpriteSelected']);
                this[name+'SpriteSelected'].alpha = 0;
                this[name+'SpriteSelected'].scale.set(1.1,1.1);
                this[name].position = new Vec2(x, y);
                this[name].addChild(this[name+'Sprite']);
                this.guiContainer.addChild( this[name]);

                this[name+'CountBack'] = Game.menu.pool.getSprite(Game.sprites.shopCountBackground);
                this[name+'CountBack'].position = new Vec2(50, -40);

                Game.font = Game.getFont(32);
                Game.fillStyle = "rgb(255, 255, 0)";
                this[name].addChild(this[name+'CountBack']);
                this[name+'Count'] = new PIXI.Text(Game.globallogic[name], {
                    font: Game.font,
                    fill: Game.fillStyle
                });
                this[name].addChild(this[name+'Count']);
                this[name+'Count'].position = new Vec2(50, -60);

                this[name+'skullPriceIcon'] = Game.menu.pool.getSprite(Game.sprites.skullsShopPriceIcon);
                this[name+'skullPriceIcon'].position = new Vec2(60, 100);
                this[name].addChild(this[name+'skullPriceIcon']);

                Game.font = Game.getFont(48);
                Game.fillStyle = "rgb(255, 255, 0)";
                this[name+'Price'] = new PIXI.Text(Game.globallogic.getItemPrice(name), {
                    font: Game.font,
                    fill: Game.fillStyle
                });
                this[name+'Price'].position = new Vec2(-30, 80);
                this[name].addChild(this[name+'Price']);

                this.updateItems.push(function(){
                    this[name+'Count'].setText(Game.globallogic[name]);
                });

                this[name].interactive = true;
                this[name].mousedown = this[name].touchstart = function () {
                    this[name].touch = true;
                }.bind(this);

                this[name].mouseup = this[name].touchend = function () {
                    //this[name+'Sprite'] = Game.menu.pool.switchSprite(Game.sprites[name+'Shop'], this[name+'Sprite']);
                    if (this[name].touch) {
                        this[name+'SpriteSelected'].alpha = 1;
                        this[name].touch = false;
                        if (this.selectedItem && this.selectedItem != name) {
                            this[this.selectedItem + 'SpriteSelected'].alpha = 0;
                        }

                        if (this.buyButton && this.buyButton.alpha == 0) {
                            this.buyButton.alpha = 1;
                        }

                        this.selectedItem = name;
                        if (this.pageDescription)
                            this.pageDescription.setText(Game.strings[Game.language].shop[this.selectedItem]);
                    }
                }.bind(this);

                this[name].mouseupoutside = this[name].touchendoutside = function () {
                    //this[name+'Sprite'] = Game.menu.pool.switchSprite(Game.sprites[name+'Shop'], this[name+'Sprite']);
                }.bind(this);
            };

            this.initProduct('bomb', 924, 380);
            this.initProduct('iceStaff', 1214, 380);
            this.initProduct('goldBag', 1504, 380);
            this.initProduct('meteorite', 924, 620);
            this.initProduct('life', 1214, 620);
            this.initProduct('resurrection', 1504, 620);

            this.initSkulls = function (count, x, y) {
                this['skulls'+count] = new PIXI.Container();
                this['skulls'+count+'Sprite'] = Game.menu.pool.getSprite(Game.sprites['buySkullsIcon'+count]);
                this['skulls'+count+'Sprite'].scale.set(1,1);
                //this['skulls'+count+'SpriteSelected'] = new PIXI.Graphics();
                //this['skulls'+count+'SpriteSelected'].beginFill(0xFFFF00);
                //this['skulls'+count+'SpriteSelected'].lineStyle(5, 0xFF0000);
                //this['skulls'+count+'SpriteSelected'].drawRect(0, 0, 400, 400);
                //this['skulls'+count+'SpriteSelected'].pivot.set(200, 200);

                //this['skulls'+count+'SpriteSelected'].anchor.set(0.5, 0.5);
                this['skulls'+count+'SpriteSelected'] = Game.menu.pool.getSprite(Game.sprites['buySkullsIcon'+count]);
                this['skulls'+count+'SpriteSelected'].scale.set(1.1,1.1);
                this['skulls'+count].addChild(this['skulls'+count+'SpriteSelected']);
                this['skulls'+count+'SpriteSelected'].alpha = 0;
                this['skulls'+count].position = new Vec2(x, y);
                this['skulls'+count].addChild(this['skulls'+count+'Sprite']);
                this.guiContainer.addChild( this['skulls'+count]);

                Game.font = Game.getFont(48);
                Game.fillStyle = "rgb(255, 255, 0)";
                this['skulls'+count+'Price'] = new PIXI.Text('', {
                    font: Game.font,
                    fill: Game.fillStyle
                });
                this['skulls'+count+'Price'].position = new Vec2(0, 80);
                this['skulls'+count].addChild(this['skulls'+count+'Price']);

                this['skulls'+count].interactive = true;
                this['skulls'+count].mousedown = this['skulls'+count].touchstart = function () {
                    this['skulls'+count].touch = true;
                }.bind(this);

                this['skulls'+count].mouseup = this['skulls'+count].touchend = function () {
                    if (this['skulls'+count].touch) {

                        if (this['skulls'+count+'SpriteSelected'])
                            this['skulls'+count+'SpriteSelected'].alpha = 1;

                        this['skulls'+count].touch = false;

                        if (this.selectedItem && this.selectedItem != 'skulls'+count) {
                            this[this.selectedItem + 'SpriteSelected'].alpha = 0;
                        }

                        if (this.buyButton && this.buyButton.alpha == 0) {
                            this.buyButton.alpha = 1;
                        }

                        this.selectedItem = 'skulls'+count;
                        if (this.pageDescription)
                            this.pageDescription.setText(Game.strings[Game.language].shop[this.selectedItem]);
                    }
                }.bind(this);
            };

            this.initSkulls(1, 924, 860);
            this.initSkulls(2, 1214, 860);
            this.initSkulls(3, 1504, 860);

            this.buyButton = new PIXI.Container();
            this.buyButtonSprite = Game.menu.pool.getSprite(Game.sprites.MapButtonsOFF);
            this.buyButton.addChild(this.buyButtonSprite);
            Game.font = Game.getFont(36);
            Game.fillStyle = "#FFF2B3";
            this.buyButtonText = new PIXI.Text(Game.strings[Game.language].shopBuy, {
                font: Game.font,
                fill: Game.fillStyle
            });
            this.buyButtonText.position = new Vec2(0, 0);
            this.buyButton.addChild(this.buyButtonText);
            this.buyButton.position = new Vec2(1220, 160);
            this.guiContainer.addChild(this.buyButton);

            this.buyButton.interactive = true;
            this.buyButton.mousedown = this.buyButton.touchstart = function () {
                this.yestoched = true;
                this.buyButtonSprite = Game.menu.pool.switchSprite(Game.sprites.MapButtonsON, this.buyButtonSprite)
            }.bind(this);

            this.buyButton.mouseup = this.buyButton.touchend = this.buyButton.mouseupoutside = this.buyButton.touchendoutside = function () {
                this.buyButtonSprite = Game.menu.pool.switchSprite(Game.sprites.MapButtonsOFF, this.buyButtonSprite);
                if (this.yestoched) {
                    this.yestoched = false;
                    if (this.selectedItem.indexOf('skull') == -1) {
                        if (Game.globallogic.skulls >= Game.globallogic.getItemPrice(this.selectedItem)) {
                            Game.lastSpendSkull = 1 * Game.globallogic.getItemPrice(this.selectedItem);
                            Game.events.emit('spendSkull');
                            Game.globallogic.addSkulls(-1 * Game.globallogic.getItemPrice(this.selectedItem));
                            Game.globallogic.addItem(this.selectedItem);
                        } else {
                            //alert('Not enough skulls'); TODO
                        }
                    } else {
                        Game.globallogic.buyPurchase(this.selectedItem.split('skulls')[1])
                    }

                }
            }.bind(this);

            this.buyButton.alpha = 0;


            this.showAnimation = {startX: this.x, toX:this.x, startY:this.y - 1152, toY:this.y, iterations:10};
            this.show = function(){
                this.startAnimation(this.showAnimation);
            };
            this.hide = function(){
                this.startAnimation(this.showAnimation, function(){
                    if (Game.menu.startLvl){
                        Game.menu.currentPage = 'map';
                        Game.menu.pages[Game.menu.currentPage].objGui.forEach(function(gui){
                            gui.show();
                        });
                    } else {
                        Game.menu.currentPage = 'map';
                        Game.menu.pages[Game.menu.currentPage].objGui.forEach(function(gui){
                            gui.show();
                        });
                    }
                }, true, Game.guiList.back.delay);
            };
        }
    };


    Game.guiList.heroesPage = {
        noLock:true,
        sprite : null,
        x: 0,
        y: 0,
        width: Game.menuWidth,
        height: Game.menuHeight,
        draw: function(){
        },
        init:function() {
            this.checkTouch = function () {
                return false;
            };

            this.guiContainer = new PIXI.Container();
            this.guiContainer.position = new Vec2(Game.menuWidth/2, Game.menuHeight/2);
            this.guiContainer.pivot = new Vec2(2048/2, 1152/2);

            this.blackL = new PIXI.Graphics();
            this.blackL.alpha = 0.7;
            this.blackL.beginFill(0x000000);
            this.blackL.moveTo(0,0);
            this.blackL.drawRect(0, 0, 1, 1);
            this.blackL.scale.set(850, 520);
            this.blackL.endFill();
            this.blackL.position.set(810, 490);
            this.guiContainer.addChild(this.blackL);

            this.blackLL = new PIXI.Graphics();
            this.blackLL.alpha = 0.7;
            this.blackLL.beginFill(0x000000);
            this.blackLL.moveTo(0,0);
            this.blackLL.drawRect(0, 0, 1, 1);
            this.blackLL.scale.set(420, 520);
            this.blackLL.endFill();
            this.blackLL.position.set(370, 490);
            this.guiContainer.addChild(this.blackLL);

            this.largeBot = Game.menu.pool.getSprite(Game.sprites['Main-Frame-Bott']);
            this.largeBot.position = new Vec2(1013, 990);
            this.guiContainer.addChild(this.largeBot);
            this.largeTop = Game.menu.pool.getSprite(Game.sprites['Main-Frame-Top']);
            this.largeTop.position = new Vec2(1024, 505);

            this.guiContainer.addChild(this.largeTop);
            this.largeAxes = Game.menu.pool.getSprite(Game.sprites['Large-Axes']);
            this.largeAxes.position = new Vec2(1224, 1058);
            this.guiContainer.addChild(this.largeAxes);

            this.largeFrameMid = Game.menu.pool.getSprite(Game.sprites['Main-Frame-Mid']);
            this.largeFrameMid.position = new Vec2(788, 745);
            this.guiContainer.addChild(this.largeFrameMid);

            this.largeFrameLeft = Game.menu.pool.getSprite(Game.sprites['Main-Frame-Left']);
            this.largeFrameLeft.position = new Vec2(389, 755);
            this.guiContainer.addChild(this.largeFrameLeft);

            this.largeFrameRight = Game.menu.pool.getSprite(Game.sprites['Main-Frame-Right']);
            this.largeFrameRight.position = new Vec2(1640, 764);
            this.guiContainer.addChild(this.largeFrameRight);

            this.blackLong = new PIXI.Graphics();
            this.blackLong.alpha = 0.7;
            this.blackLong.beginFill(0x000000);
            this.blackLong.moveTo(0,0);
            this.blackLong.drawRect(0, 0, 1, 1);
            this.blackLong.scale.set(1285, 180);
            this.blackLong.endFill();
            this.blackLong.position.set(374, 280);
            this.guiContainer.addChild(this.blackLong);

            this.longBot = Game.menu.pool.getSprite(Game.sprites['Long-Frame-TopBott']);
            this.longBot.position = new Vec2(1012, 463);
            this.guiContainer.addChild(this.longBot);
            this.longTop = Game.menu.pool.getSprite(Game.sprites['Long-Frame-TopBott']);
            this.longTop.position = new Vec2(1012, 285);
            this.guiContainer.addChild(this.longTop);
            this.longFrameLeft = Game.menu.pool.getSprite(Game.sprites['Long-Frame-Left']);
            this.longFrameLeft.position = new Vec2(407, 375);
            this.guiContainer.addChild(this.longFrameLeft);
            this.longFrameRight = Game.menu.pool.getSprite(Game.sprites['Long-Frame-Right']);
            this.longFrameRight.position = new Vec2(1652, 375);
            this.guiContainer.addChild(this.longFrameRight);


            this.blackS = new PIXI.Graphics();
            this.blackS.alpha = 0.7;
            this.blackS.beginFill(0x000000);
            this.blackS.moveTo(0,0);
            this.blackS.drawRect(0, 0, 1, 1);
            this.blackS.scale.set(360, 135);
            this.blackS.endFill();
            this.blackS.position.set(374, 115);
            this.guiContainer.addChild(this.blackS);
            this.sFrame = Game.menu.pool.getSprite(Game.sprites['Small-Frame']);
            this.sFrame.position = new Vec2(553, 180);
            this.guiContainer.addChild(this.sFrame);
            this.smallAxes = Game.menu.pool.getSprite(Game.sprites['Small-Axes']);
            this.smallAxes.position = new Vec2(555, 73);
            this.smallAxes.scale.set(1,-1);
            this.guiContainer.addChild(this.smallAxes);

            this.hero = Game.globallogic.selectedHero;


            this.portrait = Game.menu.pool.getSprite(this.hero ? this.hero.portrait : Game.sprites.FlagPoint);
            this.portrait.x = 580;
            this.portrait.y = 830;
            this.guiContainer.addChild(this.portrait);

            this.lvlBack = Game.menu.pool.getSprite(Game.sprites.LVLWindow);
            this.lvlBack.x = 570;
            this.lvlBack.y = 600;
            this.lvlBack.scale.set(0.7, 0.7);
            this.guiContainer.addChild(this.lvlBack);

            this.lvlFront = Game.menu.pool.getSprite(Game.sprites.XP_Bar);
            this.lvlFront.x = 570;
            this.lvlFront.y = 640;
            this.lvlFront.scale.set(0.7, 0.7);
            this.guiContainer.addChild(this.lvlFront);

            var exp = this.hero.experience;
            var needed = this.hero.getEpxNeed();
            var prev = this.hero.getEpxNeed() - (this.hero.lvl+1)*1000;
            this.lastExpBar = 320/((needed - prev)/(exp - prev));
            this.xpMask = new PIXI.Graphics();
            this.xpMask.beginFill();
            this.xpMask.moveTo(0,0);
            this.xpMask.drawRect(0, 0, this.lastExpBar, 60);
            this.xpMask.endFill();
            this.xpMask.position.x = 410;
            this.xpMask.position.y = 600;
            this.guiContainer.addChild(this.xpMask);
            this.lvlFront.mask = this.xpMask;
            //320
            Game.font = Game.getFont(48);
            Game.fillStyle = "#FFF2B3";
            this.lvlTextTitle = new PIXI.Text(Game.strings[Game.language].lvl, {
                font: Game.font,
                fill: Game.fillStyle
            });
            this.lvlTextTitle.position = new Vec2(570, 490);
            this.guiContainer.addChild(this.lvlTextTitle);

            this.priceTitle = new PIXI.Text('', {
                font: Game.font,
                fill: Game.fillStyle
            });
            this.priceTitle.position = new Vec2(570, 950);
            this.guiContainer.addChild(this.priceTitle);


            Game.font = Game.getFont(64);
            Game.fillStyle = "#FFF2B3";
            this.pageText = new PIXI.Text(Game.strings[Game.language].heroesPageTitle, {
                font: Game.font,
                fill: Game.fillStyle
            });
            this.guiContainer.addChild(this.pageText);
            this.pageText.position = new Vec2(560, 150);

            Game.font = Game.getFont(52);
            this.lvlText = new PIXI.Text(this.hero.lvl, {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle
            });
            this.lvlText.position = new Vec2(570, 570);
            this.guiContainer.addChild(this.lvlText);

            this.gradient = Game.menu.pool.getSprite(Game.sprites.Gradient);
            this.gradient.x = 1025;
            this.gradient.y = 765;
            this.guiContainer.addChild(this.gradient);
            this.gradient.scale.set(2.3, 2.3);

            this.statsIcons = Game.menu.pool.getSprite(Game.sprites.StatsIcons);
            this.statsIcons.x = 885;
            this.statsIcons.y = 852;
            this.statsIcons.scale.set(0.7, 0.7);
            this.guiContainer.addChild(this.statsIcons);

            this.stats = Game.menu.pool.getSprite(Game.sprites[this.hero.name + 'Stats']);
            this.stats.x = 1050;
            this.stats.y = 852;
            this.stats.scale.set(0.7, 0.7);
            this.guiContainer.addChild(this.stats);

            this.abilityButton1Back = Game.menu.pool.getSprite(Game.sprites.RadialGui_B);
            this.abilityButton1Back.x = 885;
            this.abilityButton1Back.y = 550;
            this.abilityButton1Back.scale.set(0.7, 0.7);
            this.guiContainer.addChild(this.abilityButton1Back);

            this.abilityButton2Back = Game.menu.pool.getSprite(Game.sprites.RadialGui_B);
            this.abilityButton2Back.x = 885;
            this.abilityButton2Back.y = 660;
            this.abilityButton2Back.scale.set(0.7, 0.7);
            this.guiContainer.addChild(this.abilityButton2Back);

            this.abilityImage1 = Game.menu.pool.getSprite(Game.sprites['abilityes' + this.hero.name + 1]);
            this.abilityImage1.position.set(885, 550);
            this.abilityImage1.scale.set(0.62, 0.62);
            this.guiContainer.addChild(this.abilityImage1);

            this.abilityImage2 = Game.menu.pool.getSprite(Game.sprites['abilityes' + this.hero.name + 2]);
            this.abilityImage2.position.set(885, 660);
            this.abilityImage2.scale.set(0.62, 0.62);
            this.guiContainer.addChild(this.abilityImage2);

            Game.font = Game.getFont(42);
            this.abilityText1 = new PIXI.Text(this.hero.getAbilityName(1), {
                font: Game.font,
                align: 'left',
                fill: Game.fillStyle,
                wordWrap: true,
                wordWrapWidth:600
            });
            this.abilityText1.position = new Vec2(1245, 530);
            this.guiContainer.addChild(this.abilityText1);

            Game.font = Game.getFont(42);
            this.abilityText2 = new PIXI.Text(this.hero.getAbilityName(2), {
                font: Game.font,
                align: 'left',
                fill: Game.fillStyle,
                wordWrap: true,
                wordWrapWidth:600
            });
            this.abilityText2.position = new Vec2(1245, 640);
            this.guiContainer.addChild(this.abilityText2);

            Game.font = Game.getFont(36);
            this.heroDescription = new PIXI.Text(this.hero.getHeroDescription(), {
                font: Game.font,
                align: 'center',
                fill: Game.fillStyle,
                wordWrap: true,
                wordWrapWidth:430
            });
            this.heroDescription.position = new Vec2(1435, 560);
            this.guiContainer.addChild(this.heroDescription);

            Game.font = Game.getFont(42);
            this.heroName = new PIXI.Text(this.hero.getHeroName(), {
                font: Game.font,
                fill: Game.fillStyle
            });
            this.heroName.position = new Vec2(1435, 500);
            this.guiContainer.addChild(this.heroName);

            this.update = function () {
                this.portrait = Game.menu.pool.switchSprite(this.hero ? this.hero.portrait : Game.sprites.FlagPoint, this.portrait);
                this.portrait.scale.set(0.7, 0.7);
                if (this.oldHero != this.hero)
                    this.initDescription();

                this.priceTitle.setText(this.hero && !this.hero.purchased ? Game.globallogic.purchasePrice[this.hero.purchaseId] || '' : '')
                Gui.prototype.update.call(this);
            };

            this.initDescription = function(){
                this.oldHero = this.hero;
                this.lvlText.setText(this.hero.lvl);
                var exp = this.hero.experience;
                var needed = this.hero.getEpxNeed();
                var prev = this.hero.getEpxNeed() - (this.hero.lvl+1)*1000;
                if (this.lastExpBar != 320/((needed - prev)/(exp - prev))) {
                    this.xpMask.clear();
                    this.lastExpBar = 320/((needed - prev)/(exp - prev));
                    this.xpMask.beginFill();
                    this.xpMask.moveTo(0, 0);
                    this.xpMask.drawRect(0, 0, this.lastExpBar, 60);
                    this.xpMask.endFill();
                }
                this.stats = Game.menu.pool.switchSprite(Game.sprites[this.hero.name + 'Stats'], this.stats);
                this.stats.scale.set(0.7, 0.7);

                this.abilityImage1 = Game.menu.pool.switchSprite(Game.sprites['abilityes' + this.hero.name + 1], this.abilityImage1);
                this.abilityImage1.scale.set(0.62, 0.62);

                this.abilityImage2 = Game.menu.pool.switchSprite(Game.sprites['abilityes' + this.hero.name + 2], this.abilityImage2);
                this.abilityImage2.scale.set(0.62, 0.62);

                this.abilityText1.setText(this.hero.getAbilityName(1));
                this.abilityText2.setText(this.hero.getAbilityName(2));

                this.heroDescription.setText(this.hero.getHeroDescription());
                this.heroName.setText(this.hero.getHeroName());
            };

            this.initDescription();
            this.showAnimation = {startX: this.x, toX:this.x, startY:this.y - 1152, toY:this.y, iterations:10};
            this.show = function(){
                this.startAnimation(this.showAnimation);
            };
            this.hide = function(){
                this.startAnimation(this.showAnimation, function(){
                    if (Game.menu.startLvl){
                        Game.menu.currentPage = 'map';
                        Game.menu.pages[Game.menu.currentPage].objGui.forEach(function(gui){
                            gui.show();
                        });
                    } else {
                        Game.menu.currentPage = 'map';
                        Game.menu.pages[Game.menu.currentPage].objGui.forEach(function(gui){
                            gui.show();
                        });
                    }
                }, true, Game.guiList.back.delay);
            };
        }
    };

    Game.guiList.selectButton = {
        noLock:true,
        sprite : null,
        x: 2048/2 - 50 + (Game.menuWidth - 1536)/2,
        y: 160,
        width: 0,
        height:0,
        onTouch: function(touch) {
            this.pressed = this.checkLastTouch(touch.lastPosition.multiplyed(Game.scale));
            if (touch.touchedEnd)
            {
                if (this.pressed) {
                    if (!this.page.hero.openLabel()) {
                        if (this.page.hero.purchased) {
                            Game.globallogic.setSelectedHero(this.page.hero);
                        } else
                            Game.globallogic.buyHero(this.page.hero.name);
                    }
                    this.pressed = false;
                }
            }
        },
        draw: function(){},
        init:function() {
            this.pressed = false;
            this.selected = false;
            this.showAnimation = {startX: this.x, toX:this.x, startY:this.y - 1152, toY:this.y, iterations:10};

            //this.guiContainer = new PIXI.Container();
            //this.disp = Game.menu.pool.getSprite(this.sprite[this.selected]);
            //this.guiContainer.addChild(this.disp);

            this.guiContainer = new PIXI.Container();
            this.disp = Game.menu.pool.getSprite(Game.sprites['MapButtonsOFF']);
            this.guiContainer.addChild(this.disp);
            Game.font = Game.getFont(36);
            Game.fillStyle = "#FFF2B3";
            this.text = new PIXI.Text(Game.strings[Game.language].selected, {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle
            });
            this.guiContainer.addChild(this.text);
            this.guiContainer.position = new Vec2(this.x, this.y);

            this.update = function () {
                this.selected = this.page.hero == Game.globallogic.selectedHero;
                this.text.setText(this.page.hero.purchased ? (this.selected ? Game.strings[Game.language].selected : Game.strings[Game.language].select) : Game.strings[Game.language].buyHero);
                if (this.selected)
                    this.disp = Game.menu.pool.switchSprite(Game.sprites['MapButtonsON'], this.disp);
                else
                    this.disp = Game.menu.pool.switchSprite(Game.sprites['MapButtonsOFF'], this.disp);

                Gui.prototype.update.call(this);
            };

            this.show = function(){
                this.page = Game.menu.pages['heroes'].objGui[1];
                this.selected = this.page.hero == Game.globallogic.selectedHero;
                this.startAnimation(this.showAnimation);
            };
            this.hide = function(){
                this.startAnimation(this.showAnimation, null, true, Game.guiList.back.delay);
            };

            this.guiContainer.interactive = true;
            this.guiContainer.mousedown = this.guiContainer.touchstart = function () {
                this.yestoched = true;
            }.bind(this);

            this.guiContainer.mouseup = this.guiContainer.touchend = this.guiContainer.mouseupoutside = this.guiContainer.touchendoutside =  function () {
                if (this.yestoched) {
                    this.yestoched = false;

                    if (!this.selected)
                        if (this.page.hero.purchased) {
                            Game.globallogic.setSelectedHero(this.page.hero);
                        } else
                            Game.globallogic.buyHero(this.page.hero.name);
                }
            }.bind(this);

        }
    };

    for (var i = 0; i<6; i++) {
        (function () {
            Game.guiList['selectHero'+i] = {
                noLock:true,
                sprite : null,
                x: 2048/2 - 815 + 220*i + (Game.menuWidth - 1536)/2,
                y: 1152/2 - 205,
                width: 0,
                height: 0,
                heroCounter: i,
                delay: 5,
                draw: function(){
                    Game.ctx.translate(this.x + this.width/2, this.y + this.height/2);
                    Game.ctx.scale(Game.menuScale, Game.menuScale);
                    Game.ctx.scale(1.1, 1.1);
                    if ((this.selected)||(this.pressed))
                        Game.sprites['HeroFrameSelect'].draw();
                    else
                        Game.sprites['HeroFrameIdle'].draw();
                    this.sprite.draw();
                    Game.ctx.scale(1/1.1, 1/1.1);
                    Game.ctx.scale(1/Game.menuScale, 1/Game.menuScale);
                    Game.ctx.translate(-(this.x + this.width/2), -(this.y + this.height/2));
                },
                init:function(params) {
                    this.params = params;
                    this.hero = Game.globallogic.heroes[params.heroCounter];
                    this.sprite = Game.sprites['heroIcon'+this.hero.name];
                    this.showAnimation = {startX: this.x, toX:this.x, startY:this.y - 1152, toY:this.y, iterations:10};
                    this.fonSprite = {false:Game.sprites['HeroFrameIdle'], true:Game.sprites['HeroFrameSelect']};
                    this.selected = false;

                    this.guiContainer = new PIXI.Container();
                    this.disp = Game.menu.pool.getSprite(this.sprite);
                    this.fon = Game.menu.pool.getSprite(this.fonSprite[this.selected]);
                    this.guiContainer.addChild(this.fon);
                    this.guiContainer.addChild(this.disp);
                    this.guiContainer.scale.x = this.guiContainer.scale.y = 1.2;
                    this.guiContainer.position = new Vec2(this.x + this.width/2, this.y + this.height/2);

                    this.update = function () {
                        this.fon = Game.menu.pool.switchSprite(this.fonSprite[this.selected], this.fon);
                        Gui.prototype.update.call(this);
                    };

                    this.show = function() {
                        this.page =  Game.menu.pages['heroes'].objGui[1];
                        this.selected =  (this.page.hero == this.hero);
                        this.choosen = (Game.globallogic.selectedHero == this.hero);
                        this.startAnimation(this.showAnimation, null, false, 0);
                    };
                    this.hide = function() {
                        this.startAnimation(this.showAnimation, null, true, 5);
                    };

                    this.guiContainer.interactive = true;
                    this.guiContainer.mousedown = this.guiContainer.touchstart = function () {
                        this.yestoched = true;
                        this.guiContainer.scale.x = this.guiContainer.scale.y = 1.1;
                    }.bind(this);

                    this.guiContainer.mouseup = this.guiContainer.touchend = this.guiContainer.mouseupoutside = this.guiContainer.touchendoutside =  function () {
                        if (this.yestoched) {
                            this.yestoched = false;
                            this.selected = true;
                            this.guiContainer.scale.x = this.guiContainer.scale.y = 1.2;
                            Game.menu.pages['heroes'].objGui.forEach(function (gui) {
                                if ((gui.params) && (gui.selected) && (!isNaN(gui.params.heroCounter)))
                                    gui.selected = false;
                            });
                            this.page.state = 0;
                            this.selected = true;
                            this.pressed = false;
                            this.page.hero = this.hero;
                        }
                    }.bind(this);
                }
            };
        })();
    }

    Game.guiList['abilitiesInfo'] = {
        noLock:true,
        sprite : null,
        x: Game.windowWidth/2 - 120,
        y: Game.windowHeight/2 + 300*Game.menuScale,
        width: 120*Game.menuScale,
        height: 120*Game.menuScale,
        abilityCounter: 0,
        delay: 5,
        onTouch: function(touch){
            this.pressed = this.checkLastTouch(touch.lastPosition.multiplyed(Game.scale));
            if (touch.touchedEnd)
            {
                if (this.pressed){
                    if (this.page.state != this.params.abilityCounter){
                        this.pressed = false;
                        this.page.state = this.params.abilityCounter;
                    }
                }
            }
        },
        draw: function(){
        },
        init:function(params) {
            this.params = params;
            this.pressed = false;
            this.selected = false;
            this.showAnimation = {startX: this.x, toX:this.x, startY:this.y - 1152, toY:this.y, iterations:10};

            this.guiContainer = new PIXI.Container();
            this.guiContainer.scale.x = this.guiContainer.scale.y = Game.menuScale;
            this.guiContainer.position = new Vec2(this.x + this.width/2, this.y + this.height/2);
            //this.update = function () {
            //    this.disp = Game.menu.pool.switchSprite(this.sprite[this.pressed], this.disp);
            //    Gui.prototype.update.call(this);
            //};



            this.show = function(){
                this.page =  Game.menu.pages['heroes'].objGui[1];
                if (!this.disp) {
                    this.disp = Game.menu.pool.getSprite(Game.sprites['abilityesInfo']);
                    this.guiContainer.addChild(this.disp);
                }
                this.selected =  false;
                this.startAnimation(this.showAnimation, null, false, 0);
            };
            this.hide = function(){
                this.startAnimation(this.showAnimation, null, true, 5);
            };
            this.checkTouch = this.checkMenuTouch;
        }
    };

    Game.guiList.selectedLvl = {
        noLock:true,
        sprite : null,
        x: 0,
        y: 0,
        width: Game.menuWidth,
        height: Game.menuHeight,
        onTouch: function(touch){

        },
        draw: function(){
        },
        init:function() {
            this.showAnimation = {startX: this.x, toX:this.x, startY:this.y - 1152, toY:this.y, iterations:10};
            this.show = function(){
                this.backgorundImageContainer.removeChildren();
                Game.previewBackground && Game.menu.pool.pull(Game.previewBackground.container);
                Game.previewBackground && Game.previewBackground.unload() && (Game.previewBackground = null);
                var n = Game.globallogic.getLvlWithName(Game.menu.selectedLvl).episode + (parseInt(Game.globallogic.getLvlWithName(Game.menu.selectedLvl).name)%10);
                if (!Game.pc)
                    Game.previewBackground = new BackgroundPreview(n);
                else {
                    Game.previewBackground = Game.backgroundsPreviewList.filter(function(back){return back.name == n}).pop();
                }
                Game.previewBackground.load();
                this.backgorundImageContainer.addChild(Game.previewBackground.container);
                this.startAnimation(this.showAnimation);
            };
            this.hide = function(){
                this.startAnimation(this.showAnimation, function(){
                    if (Game.menu.startLvl) {
                        if (Game.menu.selectedLvl != "0" && Game.menu.selectedLvl != "10" && Game.menu.selectedLvl != "20"){
                            Game.menu.currentPage = 'map';
                            Game.menu.pages[Game.menu.currentPage].objGui.forEach(function(gui){
                                gui.show();
                            });
                            if (this.tips1) {
                                log('tutor.play', 0);
                            }
                            Game.menu.playLvl();
                        } else {
                            Game.menu.currentPage = 'description';
                            Game.menu.pages[Game.menu.currentPage].objGui.forEach(function(gui){
                                gui.show();
                            });
                            if (this.tips1) {
                                log('tutor.play', 0);
                            }
                            Game.menu.container.addChild(Game.menu.pages[Game.menu.currentPage].container);
                        }
                    } else {
                        Game.menu.currentPage = 'map';
                        Game.menu.pages[Game.menu.currentPage].objGui.forEach(function(gui){
                            gui.show();
                        });
                    }
                }, true, Game.guiList.back.delay);
            };

            this.guiContainer = new PIXI.Container();
            this.guiContainer.position = new Vec2(Game.menuWidth/2, Game.menuHeight/2);
            this.guiContainer.pivot = new Vec2(2048/2, 1152/2);

            this.blackL = new PIXI.Graphics();
            this.blackL.alpha = 0.7;
            this.blackL.beginFill(0x000000);
            this.blackL.moveTo(0,0);
            this.blackL.drawRect(0, 0, 1, 1);
            this.blackL.scale.set(685, 515);
            this.blackL.endFill();
            this.blackL.position.set(682, 283);
            this.guiContainer.addChild(this.blackL);

            this.backgorundImageContainer = new PIXI.DisplayObjectContainer();
            this.guiContainer.addChild(this.backgorundImageContainer);
            this.backgorundImageContainer.position = new Vec2(1024,768-228);
            this.backgorundImageContainer.scale.set(1.3,1.3);

            this.largeBot = Game.menu.pool.getSprite(Game.sprites['Large-Frame-Top']);
            this.largeBot.position = new Vec2(1026, 795);
            this.largeBot.scale = new Vec2(0.8, -0.72);
            this.guiContainer.addChild(this.largeBot);

            this.largeTop = Game.menu.pool.getSprite(Game.sprites['Large-Frame-Bott']);
            this.largeTop.position = new Vec2(1026, 284);
            this.largeTop.scale = new Vec2(0.8, -0.72);
            this.guiContainer.addChild(this.largeTop);

            this.largeFrameLeft = Game.menu.pool.getSprite(Game.sprites['Large-Frame-Left']);
            this.largeFrameLeft.scale.set(-0.72,0.72);
            this.largeFrameLeft.position = new Vec2(1355, 540);
            this.guiContainer.addChild(this.largeFrameLeft);

            this.largeFrameRight = Game.menu.pool.getSprite(Game.sprites['Large-Frame-Left']);
            this.largeFrameRight.scale.set(0.72, 0.72);
            this.largeFrameRight.position = new Vec2(695,540);
            this.guiContainer.addChild(this.largeFrameRight);

            this.escapeContainer = new PIXI.Container();
            this.escape = Game.menu.pool.getSprite(Game.sprites['EscapeNormal']);
            this.escapeContainer.scale.set(0.8,0.8);
            this.escapeContainer.interactive = true;
            this.escapeContainer.mousedown = this.escapeContainer.touchstart = function () {
                this.escape = Game.menu.pool.switchSprite(Game.sprites['EscapePressed'], this.escape);
                this.yestoched = true;
            }.bind(this);
            this.escapeContainer.mouseup = this.escapeContainer.touchend = this.escapeContainer.mouseupoutside = this.escapeContainer.touchendoutside = function () {
                this.escape = Game.menu.pool.switchSprite(Game.sprites['EscapeNormal'], this.escape);
                if (this.yestoched) {
                    this.hide();
                    this.yestoched = false;
                }
            }.bind(this);
            this.escapeContainer.position.set(1370, 284);
            this.escapeContainer.addChild(this.escape);
            this.guiContainer.addChild(this.escapeContainer);

            this.difficultyContainer = new PIXI.Container();
            this.bar = Game.menu.pool.getSprite(Game.sprites['DifficultyBar']);
            this.difficultyContainer.scale.set(0.8,0.8);
            this.difficultyContainer.position.set(1024, 840);
            this.difficultyContainer.addChild(this.bar);


            this.easy = new PIXI.Container();
            this.easy.interactive = true;
            this.easyImage =  Game.menu.pool.getSprite(Game.sprites['EasyIdle']);
            if (Game.globallogic.difficulty == 'easy')
                this.easyImage =  Game.menu.pool.switchSprite(Game.sprites['EasySelect'], this.easyImage);

            this.easy.addChild(this.easyImage);
            this.easy.position = new Vec2(-230, -50);
            this.difficultyContainer.addChild(this.easy);
            this.easy.mousedown = this.easy.touchstart = function () {
                this.yestoched = true;
            }.bind(this);
            this.easy.mouseup = this.easy.touchend = this.easy.mouseupoutside = this.easy.touchendoutside = function () {
                if (this.yestoched) {
                    Game.globallogic.setDifficulty('easy');
                    this.yestoched = false;
                }
            }.bind(this);
            this.guiContainer.addChild(this.difficultyContainer);


            this.normal = new PIXI.Container();
            this.normal.interactive = true;
            this.normalImage =  Game.menu.pool.getSprite(Game.sprites['NormalIdle']);
            if (Game.globallogic.difficulty == 'normal')
                this.normalImage =  Game.menu.pool.switchSprite(Game.sprites['NormalSelect'], this.normalImage);

            this.normal.addChild(this.normalImage);
            this.normal.position = new Vec2(-15, 50);
            this.difficultyContainer.addChild(this.normal);
            this.normal.mousedown = this.normal.touchstart = function () {
                this.yestoched = true;
            }.bind(this);
            this.normal.mouseup = this.normal.touchend = this.normal.mouseupoutside = this.normal.touchendoutside = function () {
                if (this.yestoched) {
                    Game.globallogic.setDifficulty('normal');
                    this.yestoched = false;
                }
            }.bind(this);
            this.guiContainer.addChild(this.difficultyContainer);

            this.hard = new PIXI.Container();
            this.hardImage =  Game.menu.pool.getSprite(Game.sprites['HardIdle']);
            if (Game.globallogic.difficulty == 'hard')
                this.hardImage =  Game.menu.pool.switchSprite(Game.sprites['HardSelect'], this.hardImage);

            this.hard.addChild(this.hardImage);
            this.hard.interactive = true;
            this.hard.position = new Vec2(212, -50);
            this.difficultyContainer.addChild(this.hard);
            this.hard.mousedown = this.hard.touchstart = function () {
                this.yestoched = true;
            }.bind(this);
            this.hard.mouseup = this.hard.touchend = this.hard.mouseupoutside = this.hard.touchendoutside = function () {
                if (this.yestoched) {
                    Game.globallogic.setDifficulty('hard');
                    this.yestoched = false;
                }
            }.bind(this);

            Game.textAlign = "center";
            Game.textBaseline = 'middle';
            Game.fillStyle = "#FEF2B3";
            Game.font = Game.getFont(48);
            this.difficultyText = new PIXI.Text('', {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle
            });
            this.difficultyText.position = new Vec2(0, -74);
            this.difficultyContainer.addChild(this.difficultyText);
            this.guiContainer.addChild(this.difficultyContainer);

            this.battleContainer = new PIXI.Container();
            this.battleButton = Game.menu.pool.getSprite(Game.sprites['BattleNormal']);
            this.battleButtonPressed = Game.menu.pool.getSprite(Game.sprites['BattlePressed']);
            this.battleButtonPressed.alpha = 0;
            this.battleButtonPressed.y = -42;
            this.battleContainer.scale.set(0.8,0.8);
            this.battleContainer.interactive = true;
            this.battleContainer.mousedown = this.battleContainer.touchstart = function () {
                this.battleButtonPressed.alpha = 1;
                this.yestoched = true;
            }.bind(this);
            this.battleContainer.mouseup = this.battleContainer.touchend = this.battleContainer.mouseupoutside = this.battleContainer.touchendoutside = function () {
                this.battleButtonPressed.alpha = 0;
                if (this.yestoched) {
                    this.yestoched = false;
                    if (parseInt(Game.menu.selectedLvl) >= 10 && Game.isWindowsPhone && Game.isTrial) {
                        var messagedialogpopup = new Windows.UI.Popups.MessageDialog("Trial expired", "Purchase to continue");
                        messagedialogpopup.commands.append(new Windows.UI.Popups.UICommand("Ok", null, 1));
                        messagedialogpopup.commands.append(new Windows.UI.Popups.UICommand("Cancel", null, 2));
                        messagedialogpopup.defaultCommandIndex = 0;
                        messagedialogpopup.showAsync().done(function (command) {
                            if (command)
                                if (command.id == 1)
                                    Game.currentApp.requestAppPurchaseAsync(false).done(function (result) {
                                        Game.isTrial = Game.currentApp.licenseInformation.isTrial;
                                    }, function () {
                                        var Dialog = new Windows.UI.Popups.MessageDialog("Canceled", "Purchase error.");
                                        Dialog.showAsync();
                                    });
                        });
                    } else if (Game.menu.selectedLvl == "3" && localStorage.getItem("rated2") != "true" && !Game.pc) {
                        localStorage.setItem("rated2", "true");
                        askGameRate();
                    } else if (parseInt(Game.menu.selectedLvl) > 24 && localStorage.getItem("rated3") != "true" && !Game.pc) {
                        localStorage.setItem("rated3", "true");
                        askGameRate();
                    } else {
                        Game.menu.startLvl = true;
                        this.hide();
                    }
                }
            }.bind(this);
            this.battleContainer.position.set(1024, 284);
            this.battleContainer.addChild(this.battleButton);
            this.battleContainer.addChild(this.battleButtonPressed);

            Game.textAlign = "center";
            Game.textBaseline = 'middle';
            Game.fillStyle = "rgb(255, 255, 0)";
            Game.font = Game.getFont(64);
            var battle = new PIXI.Text(Game.strings[Game.language].selectedLvl.tobattle, {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle
            });
            battle.position = new Vec2(0, -74);
            this.battleContainer.addChild(battle);

            this.guiContainer.addChild(this.battleContainer);

            if (!Game.globallogic.getLvlWithName("1").isOpen()) {
                var ballon = new MessageBalloon(Game.strings[Game.language].selectedLvl.startBattle, new Vec2(1024, 150), true, this.guiContainer);
                this.tips1 = ballon.container;
                ballon = new MessageBalloon(Game.strings[Game.language].selectedLvl.selectDifficulty, new Vec2(1024, 728), true, this.guiContainer);
                this.tips2 = ballon.container;
            }

            this.update = function () {
                this.hardImage =  Game.menu.pool.switchSprite(Game.sprites['Hard' + (Game.globallogic.difficulty == 'hard' ? 'Select' : 'Idle')], this.hardImage);
                this.easyImage =  Game.menu.pool.switchSprite(Game.sprites['Easy' + (Game.globallogic.difficulty == 'easy' ? 'Select' : 'Idle')], this.easyImage);
                this.normalImage =  Game.menu.pool.switchSprite(Game.sprites['Normal' + (Game.globallogic.difficulty == 'normal' ? 'Select' : 'Idle')], this.normalImage);

                switch (Game.globallogic.difficulty){
                    case 'easy':

                        break;
                    case 'normal':

                        break;
                    case 'hard':

                        break;
                }
                this.difficultyText.setText(Game.strings[Game.language].menuMap[Game.globallogic.difficulty]);
                this.difficultyText.position = this[Game.globallogic.difficulty].position.clone().add(new Vec2(0, 128));
                Gui.prototype.update.call(this);
            };
        }
    };

    Game.guiList.purchaseEpisode = {
        noLock:true,
        sprite : null,
        x: 0,
        y: 0,
        width: Game.menuWidth,
        height: Game.menuHeight,
        onTouch: function(touch){

        },
        draw: function(){
        },
        init:function() {
            this.showAnimation = {startX: this.x, toX:this.x, startY:this.y - 1152, toY:this.y, iterations:10};
            this.show = function(){
                this.backgorundImageContainer.removeChildren();
                Game.previewBackground && Game.menu.pool.pull(Game.previewBackground.container);
                Game.previewBackground && Game.previewBackground.unload() && (Game.previewBackground = null);
                Game.previewBackground = new EpisodePreview(parseInt(Game.menu.selectedLvl/10));
                Game.previewBackground.load();
                this.backgorundImageContainer.addChild(Game.previewBackground.container);
                this.startAnimation(this.showAnimation);
            };
            this.hide = function() {
                this.startAnimation(this.showAnimation, function() {
                    if (Game.menu.startLvl) {
                        Game.menu.currentPage = 'map';
                        Game.menu.pages[Game.menu.currentPage].objGui.forEach(function(gui){
                            gui.show();
                        });
                        Game.menu.playLvl();
                    } else {
                        Game.menu.currentPage = 'map';
                        Game.menu.pages[Game.menu.currentPage].objGui.forEach(function(gui){
                            gui.show();
                        });
                    }
                }, true, Game.guiList.back.delay);
            };

            this.guiContainer = new PIXI.Container();
            this.guiContainer.position = new Vec2(Game.menuWidth/2, Game.menuHeight/2);
            this.guiContainer.pivot = new Vec2(2048/2, 1152/2);

            this.blackL = new PIXI.Graphics();
            this.blackL.alpha = 0.7;
            this.blackL.beginFill(0x000000);
            this.blackL.moveTo(0,0);
            this.blackL.drawRect(0, 0, 1, 1);
            this.blackL.scale.set(685, 515);
            this.blackL.endFill();
            this.blackL.position.set(682, 283);
            this.guiContainer.addChild(this.blackL);

            this.backgorundImageContainer = new PIXI.DisplayObjectContainer();
            this.guiContainer.addChild(this.backgorundImageContainer);
            this.backgorundImageContainer.position = new Vec2(515, 140);
            //this.backgorundImageContainer.scale.set(1.3,1.3);

            this.largeBot = Game.menu.pool.getSprite(Game.sprites['Large-Frame-Top']);
            this.largeBot.position = new Vec2(1026, 903);
            this.largeBot.scale = new Vec2(1.3, 1);
            this.guiContainer.addChild(this.largeBot);

            this.largeTop = Game.menu.pool.getSprite(Game.sprites['Large-Frame-Bott']);
            this.largeTop.position = new Vec2(1026, 136);
            this.largeTop.scale = new Vec2(1.3, -1);
            this.guiContainer.addChild(this.largeTop);

            this.largeFrameLeft = Game.menu.pool.getSprite(Game.sprites['Large-Frame-Left']);
            this.largeFrameLeft.scale.set(-0.72,1.08);
            this.largeFrameLeft.position = new Vec2(1538, 520);
            this.guiContainer.addChild(this.largeFrameLeft);

            this.largeFrameRight = Game.menu.pool.getSprite(Game.sprites['Large-Frame-Left']);
            this.largeFrameRight.scale.set(0.72,  1.08);
            this.largeFrameRight.position = new Vec2(510,520);
            this.guiContainer.addChild(this.largeFrameRight);

            this.escapeContainer = new PIXI.Container();
            this.escape = Game.menu.pool.getSprite(Game.sprites['EscapeNormal']);
            this.escapeContainer.scale.set(0.8,0.8);
            this.escapeContainer.interactive = true;
            this.escapeContainer.mousedown = this.escapeContainer.touchstart = function () {
                this.escape = Game.menu.pool.switchSprite(Game.sprites['EscapePressed'], this.escape);
                this.yestoched = true;
            }.bind(this);
            this.escapeContainer.mouseup = this.escapeContainer.touchend = this.escapeContainer.mouseupoutside = this.escapeContainer.touchendoutside = function () {
                this.escape = Game.menu.pool.switchSprite(Game.sprites['EscapeNormal'], this.escape);
                if (this.yestoched) {
                    this.hide();
                    this.yestoched = false;
                }
            }.bind(this);
            this.escapeContainer.position.set(1540, 133);
            this.escapeContainer.addChild(this.escape);
            this.guiContainer.addChild(this.escapeContainer);

            this.battleContainer = new PIXI.Container();
            this.battleButton = Game.menu.pool.getSprite(Game.sprites['BattleNormal']);
            this.battleButtonPressed = Game.menu.pool.getSprite(Game.sprites['BattlePressed']);
            this.battleButtonPressed.alpha = 0;
            this.battleButtonPressed.y = -42;
            this.battleContainer.scale.set(1,1);
            this.battleContainer.interactive = true;
            this.battleContainer.mousedown = this.battleContainer.touchstart = function () {
                this.battleButtonPressed.alpha = 1;
                this.yestoched = true;
            }.bind(this);
            this.battleContainer.mouseup = this.battleContainer.touchend = this.battleContainer.mouseupoutside = this.battleContainer.touchendoutside = function () {
                this.battleButtonPressed.alpha = 0;
                if (this.yestoched) {
                    this.yestoched = false;
                    Game.globallogic.purchaseEpisode(parseInt(Game.menu.selectedLvl/10));
                    Game.purchaseEpisodeCallback = function() {
                        Game.menu.startLvl = true;
                        this.hide();
                    }.bind(this)
                }
            }.bind(this);
            this.battleContainer.position.set(1024, 984);
            this.battleContainer.addChild(this.battleButton);
            this.battleContainer.addChild(this.battleButtonPressed);

            Game.textAlign = "center";
            Game.textBaseline = 'middle';
            Game.fillStyle = "rgb(255, 255, 0)";
            Game.font = Game.getFont(56);
            var battle = new PIXI.Text(Game.strings[Game.language].selectedLvl.purchaseEpisode, {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle
            });
            battle.position = new Vec2(0, -74);
            this.battleContainer.addChild(battle);

            this.guiContainer.addChild(this.battleContainer);

            if (!Game.globallogic.getLvlWithName("1").isOpen()) {
                var ballon = new MessageBalloon(Game.strings[Game.language].selectedLvl.startBattle, new Vec2(1024, 150), true, this.guiContainer);
                this.tips1 = ballon.container;
                ballon = new MessageBalloon(Game.strings[Game.language].selectedLvl.selectDifficulty, new Vec2(1024, 728), true, this.guiContainer);
                this.tips2 = ballon.container;
            }
        }
    };


    Game.guiList.back = {
        noLock:true,
        sprite : null,
        x: 2048/2 + 100 + (Game.menuWidth - 1536)/2,
        y: 120,
        width: 0,
        height:0,
        delay: 5,
        onTouch: function(touch){
            this.pressed = this.checkLastTouch(touch.lastPosition.multiplyed(Game.scale));
            if (touch.touchedEnd)
            {
                if (this.pressed){
                    this.pressed = false;
                    Game.menu.pages[Game.menu.currentPage].objGui.forEach(function(gui){
                        gui.hide();
                    });
                }
            }
        },
        draw: function(){
            Game.menu.pages['map'].objGui[0].draw();
            Game.ctx.translate(this.x + this.width/2, this.y + this.height/2);
            Game.ctx.scale(Game.menuScale, Game.menuScale);
            this.sprite[this.pressed].draw();
            Game.ctx.scale(1/Game.menuScale, 1/Game.menuScale);
            Game.ctx.translate(-(this.x + this.width/2), -(this.y + this.height/2));
        },
        init:function() {
            this.sprite = {'false':Game.sprites['backButton'], 'true':Game.sprites['backButtonPressed']};
            this.pressed = false;
            this.checkTouch = this.checkMenuTouch;
            this.showAnimation = {startX: this.x+1500, toX:this.x, startY:this.y, toY:this.y, iterations:5};

            this.guiContainer = new PIXI.Container();
            this.disp = Game.menu.pool.getSprite(this.sprite[this.pressed]);
            this.guiContainer.addChild(this.disp);
            this.guiContainer.scale.x = this.guiContainer.scale.y = 1.2;
            this.guiContainer.position = new Vec2(this.x, this.y);
            this.update = function () {
                this.disp = Game.menu.pool.switchSprite(this.sprite[this.pressed], this.disp);
                Gui.prototype.update.call(this);
            };

            this.show = function(){
                this.startAnimation(this.showAnimation, null, false, 10);
            };
            this.hide = function(){
                this.startAnimation(this.showAnimation, null, true, 0);
            };

            this.guiContainer.interactive = true;
            this.guiContainer.mousedown = this.guiContainer.touchstart = function () {
                this.yestoched = true;
                this.pressed = true;
            }.bind(this);

            this.guiContainer.mouseup = this.guiContainer.touchend = this.guiContainer.mouseupoutside = this.guiContainer.touchendoutside =  function () {
                if (this.yestoched) {
                    this.yestoched = false;
                    this.pressed = false;
                    Game.menu.pages[Game.menu.currentPage].objGui.forEach(function (gui) {
                        gui.hide();
                    });
                }
            }.bind(this);

        }
    };

    Game.guiList.backHeroes = {
        noLock:true,
        sprite : null,
        x: 2048/2 + 230 + (Game.menuWidth - 1536)/2,
        y: 160,
        width: 0,
        height:0,
        delay: 5,
        onTouch: function(touch){
        },
        draw: function(){
        },
        init:function() {
            this.sprite = Game.sprites['GuiButtonSmall'];

            this.pressed = false;
            this.checkTouch = this.checkMenuTouch;
            this.showAnimation = {startX: this.x+1500, toX:this.x, startY:this.y, toY:this.y, iterations:5};

            this.guiContainer = new PIXI.Container();
            this.disp = Game.menu.pool.getSprite(Game.sprites['MapButtonsOFF']);
            this.guiContainer.addChild(this.disp);
            Game.font = Game.getFont(36);
            Game.fillStyle = "#FFF2B3";
            this.text = new PIXI.Text(Game.strings[Game.language].done, {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle
            });
            this.guiContainer.addChild(this.text);
            this.guiContainer.position = new Vec2(this.x, this.y);

            this.show = function(){
                this.startAnimation(this.showAnimation, null, false, 10);
            };
            this.hide = function(){
                this.startAnimation(this.showAnimation, null, true, 0);
            };

            this.guiContainer.interactive = true;
            this.guiContainer.mousedown = this.guiContainer.touchstart = function () {
                this.yestoched = true;
                this.disp = Game.menu.pool.switchSprite(Game.sprites['MapButtonsON'], this.disp);
                this.pressed = true;
            }.bind(this);

            this.guiContainer.mouseup = this.guiContainer.touchend = this.guiContainer.mouseupoutside = this.guiContainer.touchendoutside =  function () {
                if (this.yestoched) {
                    this.yestoched = false;
                    this.disp = Game.menu.pool.switchSprite(Game.sprites['MapButtonsOFF'], this.disp);
                    Game.menu.pages[Game.menu.currentPage].objGui.forEach(function (gui) {
                        gui.hide();
                    });
                }
            }.bind(this);

        }
    };

    Game.guiList.backShop = {
        noLock:true,
        sprite : null,
        x: 2048/2 + 230 + (Game.menuWidth - 1536)/2,
        y: 160,
        width: 0,
        height:0,
        delay: 5,
        onTouch: function(touch){
        },
        draw: function(){
        },
        init:function() {
            this.sprite = Game.sprites['GuiButtonSmall'];

            this.pressed = false;
            this.checkTouch = this.checkMenuTouch;
            this.showAnimation = {startX: this.x+1500, toX:this.x, startY:this.y, toY:this.y, iterations:5};

            this.guiContainer = new PIXI.Container();

            this.disp = Game.menu.pool.getSprite(Game.sprites['MapButtonsOFF']);
            this.guiContainer.addChild(this.disp);
            Game.font = Game.getFont(36);
            Game.fillStyle = "#FFF2B3";
            this.text = new PIXI.Text(Game.strings[Game.language].done, {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle
            });
            this.guiContainer.addChild(this.text);
            this.guiContainer.position = new Vec2(this.x, this.y);

            this.show = function(){
                this.startAnimation(this.showAnimation, null, false, 10);
            };
            this.hide = function(){
                this.startAnimation(this.showAnimation, null, true, 0);
            };

            this.guiContainer.interactive = true;
            this.guiContainer.mousedown = this.guiContainer.touchstart = function () {
                this.yestoched = true;
                this.disp = Game.menu.pool.switchSprite(Game.sprites['MapButtonsON'], this.disp);
                this.pressed = true;
            }.bind(this);

            this.guiContainer.mouseup = this.guiContainer.touchend = this.guiContainer.mouseupoutside = this.guiContainer.touchendoutside =  function () {
                if (this.yestoched) {
                    this.yestoched = false;
                    this.disp = Game.menu.pool.switchSprite(Game.sprites['MapButtonsOFF'], this.disp);
                    Game.menu.pages[Game.menu.currentPage].objGui.forEach(function (gui) {
                        gui.hide();
                    });
                }
            }.bind(this);
        }
    };

    Game.guiList.backUpgrades = {
        noLock:true,
        sprite : null,
        x: 2048/2 + 230 + (Game.menuWidth - 1536)/2,
        y: 160,
        width: 0,
        height:0,
        delay: 5,
        onTouch: function(touch){
        },
        draw: function(){
            Game.menu.pages['map'].objGui[0].draw();
            Game.ctx.translate(this.x + this.width/2, this.y + this.height/2);
            Game.ctx.scale(Game.menuScale, Game.menuScale);
            this.sprite[this.pressed].draw();
            Game.ctx.scale(1/Game.menuScale, 1/Game.menuScale);
            Game.ctx.translate(-(this.x + this.width/2), -(this.y + this.height/2));
        },
        init:function() {
            this.sprite = Game.sprites['GuiButtonSmall'];

            this.pressed = false;
            this.checkTouch = this.checkMenuTouch;
            this.showAnimation = {startX: this.x+1500, toX:this.x, startY:this.y, toY:this.y, iterations:5};

            this.guiContainer = new PIXI.Container();
            this.disp = Game.menu.pool.getSprite(Game.sprites['MapButtonsOFF']);
            this.guiContainer.addChild(this.disp);
            Game.font = Game.getFont(36);
            Game.fillStyle = "#FFF2B3";
            this.text = new PIXI.Text(Game.strings[Game.language].done, {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle
            });
            this.guiContainer.addChild(this.text);
            this.guiContainer.position = new Vec2(this.x, this.y);


            this.show = function(){
                this.startAnimation(this.showAnimation, null, false, 10);
            };
            this.hide = function(){
                this.startAnimation(this.showAnimation, null, true, 0);
            };

            this.guiContainer.interactive = true;
            this.guiContainer.mousedown = this.guiContainer.touchstart = function () {
                this.yestoched = true;
                this.disp = Game.menu.pool.switchSprite(Game.sprites['MapButtonsON'], this.disp);
                this.pressed = true;
            }.bind(this);

            this.guiContainer.mouseup = this.guiContainer.touchend = this.guiContainer.mouseupoutside = this.guiContainer.touchendoutside =  function () {
                if (this.yestoched) {
                    this.yestoched = false;
                    this.disp = Game.menu.pool.switchSprite(Game.sprites['MapButtonsOFF'], this.disp);
                    Game.menu.pages[Game.menu.currentPage].objGui.forEach(function (gui) {
                        gui.hide();
                    });
                }
            }.bind(this);
        }
    };

    Game.guiList.resetUpgrades = {
        noLock:true,
        sprite : null,
        x: 2048/2 - 50 + (Game.menuWidth - 1536)/2,
        y: 160,
        width: 0,
        height:0,
        delay: 5,
        onTouch: function(touch){
        },
        draw: function(){
            Game.menu.pages['map'].objGui[0].draw();
            Game.ctx.translate(this.x + this.width/2, this.y + this.height/2);
            Game.ctx.scale(Game.menuScale, Game.menuScale);
            this.sprite[this.pressed].draw();
            Game.ctx.scale(1/Game.menuScale, 1/Game.menuScale);
            Game.ctx.translate(-(this.x + this.width/2), -(this.y + this.height/2));
        },
        init:function() {
            this.sprite = Game.sprites['GuiButtonSmall'];

            this.pressed = false;
            this.checkTouch = this.checkMenuTouch;
            this.showAnimation = {startX: this.x+1500, toX:this.x, startY:this.y, toY:this.y, iterations:5};

            this.guiContainer = new PIXI.Container();
            this.disp = Game.menu.pool.getSprite(Game.sprites['MapButtonsOFF']);
            this.guiContainer.addChild(this.disp);
            Game.font = Game.getFont(36);
            Game.fillStyle = "#FFF2B3";
            this.text = new PIXI.Text(Game.strings[Game.language].reset, {
                font: Game.font,
                align: Game.textAlign,
                fill: Game.fillStyle
            });
            this.guiContainer.addChild(this.text);
            this.guiContainer.position = new Vec2(this.x, this.y);

            this.show = function(){
                this.startAnimation(this.showAnimation, null, false, 10);
            };
            this.hide = function(){
                this.startAnimation(this.showAnimation, null, true, 0);
            };

            this.guiContainer.interactive = true;
            this.guiContainer.mousedown = this.guiContainer.touchstart = function () {
                this.yestoched = true;
                this.disp = Game.menu.pool.switchSprite(Game.sprites['MapButtonsON'], this.disp);
                this.pressed = true;
            }.bind(this);

            this.guiContainer.mouseup = this.guiContainer.touchend = this.guiContainer.mouseupoutside = this.guiContainer.touchendoutside =  function () {
                if (this.yestoched) {
                    if (!Game.globallogic.getLvlWithName("2").isOpen())
                        return;

                    this.yestoched = false;
                    this.disp = Game.menu.pool.switchSprite(Game.sprites['MapButtonsOFF'], this.disp);
                    Game.globallogic.resetUpgrades();
                    Game.menu.pages[Game.menu.currentPage].objGui[0].initDescription();
                }
            }.bind(this);

            if (!Game.globallogic.getLvlWithName("2").isOpen()){
                this.guiContainer.alpha = 0;
            }
        }
    };

    Game.guiList.upgradesPage = {
        noLock:true,
        sprite : null,
        x: 0,
        y: 0,
        width: Game.menuWidth,
        height: Game.menuHeight,
        onTouch: function (touch) {},
        draw: function(){
        },
        init:function() {
            this.touches = [];

            this.guiContainer = new PIXI.Container();
            this.guiContainer.position = new Vec2(Game.menuWidth/2, Game.menuHeight/2);
            this.guiContainer.pivot = new Vec2(2048/2, 1152/2);

            this.blackL = new PIXI.Graphics();
            this.blackL.alpha = 0.7;
            this.blackL.beginFill(0x000000);
            this.blackL.moveTo(0,0);
            this.blackL.drawRect(0, 0, 1, 1);
            this.blackL.scale.set(1270, 715);
            this.blackL.endFill();
            this.blackL.position.set(378, 300);
            this.guiContainer.addChild(this.blackL);
            this.largeBot = Game.menu.pool.getSprite(Game.sprites['Large-Frame-Bott']);
            this.largeBot.position = new Vec2(1014, 1010);
            this.largeBot.scale.x = 1.6;
            this.guiContainer.addChild(this.largeBot);
            this.largeTop = Game.menu.pool.getSprite(Game.sprites['Large-Frame-Top']);
            this.largeTop.scale.x = 1.6;
            this.largeTop.position = new Vec2(1014, 300);
            this.guiContainer.addChild(this.largeTop);
            this.largeAxes = Game.menu.pool.getSprite(Game.sprites['Large-Axes']);
            this.largeAxes.position = new Vec2(1014, 1058);
            this.guiContainer.addChild(this.largeAxes);
            this.largeFrameLeft = Game.menu.pool.getSprite(Game.sprites['Large-Frame-Right']);
            this.largeFrameLeft.scale.x = -1;
            this.largeFrameLeft.position = new Vec2(382, 655);
            this.guiContainer.addChild(this.largeFrameLeft);
            this.largeFrameRight = Game.menu.pool.getSprite(Game.sprites['Large-Frame-Right']);
            this.largeFrameRight.position = new Vec2(1633, 655);
            this.guiContainer.addChild(this.largeFrameRight);
            this.sideAxesR = Game.menu.pool.getSprite(Game.sprites['Side-Axes_L']);
            this.sideAxesR.position = new Vec2(1745, 647);
            this.guiContainer.addChild(this.sideAxesR);
            this.sideAxesL = Game.menu.pool.getSprite(Game.sprites['Side-Axes_L']);
            this.sideAxesL.position = new Vec2(270, 647);
            this.sideAxesL.scale.x = -1;
            this.guiContainer.addChild(this.sideAxesL);


            this.blackS = new PIXI.Graphics();
            this.blackS.alpha = 0.7;
            this.blackS.beginFill(0x000000);
            this.blackS.moveTo(0,0);
            this.blackS.drawRect(0, 0, 1, 1);
            this.blackS.scale.set(360, 135);
            this.blackS.endFill();
            this.blackS.position.set(374, 115);
            this.guiContainer.addChild(this.blackS);
            this.sFrame = Game.menu.pool.getSprite(Game.sprites['Small-Frame']);
            this.sFrame.position = new Vec2(553, 180);
            this.guiContainer.addChild(this.sFrame);
            this.smallAxes = Game.menu.pool.getSprite(Game.sprites['Small-Axes']);
            this.smallAxes.position = new Vec2(555, 73);
            this.smallAxes.scale.set(1,-1);
            this.guiContainer.addChild(this.smallAxes);


            Game.font = Game.getFont(64);
            Game.fillStyle = "#FFF2B3";
            this.starsText = new PIXI.Text(Game.globallogic.availableStars, {
                font: Game.font,
                fill: Game.fillStyle
            });
            this.guiContainer.addChild(this.starsText);
            this.starsText.position = new Vec2(530, 150);
            this.starsContainer = new PIXI.Container();
            this.starsContainer.addChild(Game.menu.pool.getSprite(Game.sprites['starr']));
            this.starsContainer.position = new Vec2(650, 180);
            this.starsContainer.scale.x = this.starsContainer.scale.y = 1.2;
            this.guiContainer.addChild(this.starsContainer);

            this.update = function () {
                if (this.oldSelectedUpgrade != this.selectedUpgrade)
                    this.initDescription();

                this.buttons.forEach(function (button) {
                    button.update();
                }.bind(this));

                this.emiter.update(0.05);
                this.starsText.setText(Game.globallogic.availableStars);
                Gui.prototype.update.call(this);
            };
            this.upgradesFXContainer = new PIXI.Container();
            this.upgradesFXContainer.position = new Vec2(380, 328);
            var config = clone(Game.particlesList['treasure_background']);
            config.scale = clone(config.scale);
            config.scale.start = 2;
            config.scale.end = 2.3;
            config.pos.x = 0;
            config.pos.y = 0;
            var textures = [];
            config.images.forEach(function(image){
                textures.push(PIXI.TextureCache[image])
            });
            this.emiter = new cloudkid.Emitter(
                this.upgradesFXContainer,
                textures,
                config
            );
            this.emiter.emit = false;


            this.upgradesContainer = new PIXI.Container();
            this.upgradesContainer.position = new Vec2(380, 328);
            this.initDescription = function(){
                Game.font = Game.getFont(32);
                Game.fillStyle = "#FFF2B3";

                this.oldSelectedUpgrade = this.selectedUpgrade;

                if (this.purchaseButtonContainer)
                    Game.menu.pool.pull(this.purchaseButtonContainer);

                this.selectedDescription.setText(this.selectedUpgrade ? Game.strings[Game.language].buildings.names[this.selectedUpgrade.legalName] : '');
                if (this.selectedUpgrade && !this.selectedUpgrade.purchased && this.selectedUpgrade.isAvailable() && this.selectedUpgrade.cost <= Game.globallogic.availableStars){
                    this.purchaseButtonContainer = new PIXI.Container();
                    this.purchaseButtonDisp = Game.menu.pool.getSprite(Game.sprites['MapButtonsOFF']);
                    this.purchaseButtonContainer.addChild(this.purchaseButtonDisp);
                    this.purchaseButtonContainer.position = new Vec2(950, 160);
                    Game.font = Game.getFont(36);
                    var textt = new PIXI.Text(Game.strings[Game.language].purchase, {
                        font: Game.font,
                        align: Game.textAlign,
                        fill: Game.fillStyle
                    });
                    this.purchaseButtonContainer.addChild(textt);


                    this.purchaseButtonContainer.interactive = true;
                    this.purchaseButtonContainer.mousedown = this.purchaseButtonContainer.touchstart = function () {
                        this.yestoched = true;
                        this.purchaseButtonDisp = Game.menu.pool.switchSprite(Game.sprites['MapButtonsON'], this.purchaseButtonDisp);
                    }.bind(this);

                    this.purchaseButtonContainer.mouseup = this.purchaseButtonContainer.touchend = this.purchaseButtonContainer.mouseupoutside = this.purchaseButtonContainer.touchendoutside = function () {
                        if (this.yestoched) {
                            this.yestoched = false;
                            this.purchaseButtonDisp = Game.menu.pool.switchSprite(Game.sprites['MapButtonsOFF'], this.purchaseButtonDisp);
                            Game.globallogic.purchase(this.selectedUpgrade);
                            this.initDescription();
                            setTimeout(function(){
                                if (this.tips3) {
                                    log('tutor.upgrage.purchase', 0);
                                    this.guiContainer.removeChild(this.tips3);
                                    this.tips3 = null;

                                    if (!Game.globallogic.getLvlWithName("2").isOpen()) {
                                        Game.menu.pages.map.objGui[0].tips = new MessageBalloonMenu(Game.strings[Game.language].menuMap.secondLvl, Game.globallogic.getLvlWithName("1").position.multiplyed(2).add(new Vec2(-98, -166)), true);
                                        Game.menu.pages.map.objGui[0].guiContainer.addChild(Game.menu.pages.map.objGui[0].tips);
                                        Game.menu.pages.map.objGui[0].update();
                                    }
                                }
                            }.bind(this),1)
                        }
                    }.bind(this);
                    this.guiContainer.addChild(this.purchaseButtonContainer);
                }
            };
            this.guiContainer.addChild(this.upgradesFXContainer);
            this.guiContainer.addChild(this.upgradesContainer);
            this.showAnimation = {startX: this.x, toX:this.x, startY:this.y - 1152, toY:this.y, iterations:10};
            this.show = function() {
                this.startAnimation(this.showAnimation);
            };
            this.hide = function(){
                this.startAnimation(this.showAnimation, function(){
                    Game.menu.currentPage = 'map';
                    Game.menu.pages[Game.menu.currentPage].objGui.forEach(function(gui){
                        gui.show();
                    });
                }, true, Game.guiList.back.delay);
            };

            this.buttonBackgrounds = {purchased:Game.sprites['Frame'], available:Game.sprites['Frame'], unavailable:Game.sprites['Frame2']};
            this.buttons = [];
            this.backgrounds = [];
            var that = this;

            Game.globallogic.upgrades.forEach(function (upgrade) {
                var button = {};
                button.page = that;

                Game.font = Game.getFont(42);
                Game.fillStyle = "#FFF2B3";
                button.starsText = new PIXI.Text(upgrade.cost, {
                    font: Game.font,
                    fill: Game.fillStyle
                });
                button.starsText.position.set(44,29);

                that.buttons.push(button);
                button.guiContainer = new PIXI.Container();
                button.guiContainer.position = upgrade.position;
                button.sprite = {purchased:Game.sprites['u'+upgrade.name], available:Game.sprites['u'+upgrade.name+'Y'], unavailable:Game.sprites['u'+upgrade.name+'N']};
                button.state = upgrade.purchased ? 'purchased' : upgrade.isAvailable() ? 'available' : 'unavailable';
                button.background = Game.menu.pool.getSprite(that.buttonBackgrounds[button.state]);
                button.spriteD = Game.menu.pool.getSprite(button.sprite[button.state]);
                if (upgrade.chainNext) {
                    button.chain =  Game.menu.pool.getSprite(Game.sprites[upgrade.chainNext == 'a'  ? 'MenuButtonChainA' : 'ChainB']);
                    button.chain.position = upgrade.position.clone().add(new Vec2(0, 10));
                    button.chain.scale.set(0.6, 0.6);
                    button.chain.rotation = -Math.PI/2;
                    that.upgradesContainer.addChild(button.chain);
                }
                button.guiContainer.addChild(button.spriteD);
                button.guiContainer.addChild(button.background);
                button.guiContainer.addChild(button.starsText);
                button.update = function () {
                    button.state = upgrade.purchased ? 'purchased' : upgrade.isAvailable() ? 'available' : 'unavailable';
                    button.spriteD = Game.menu.pool.switchSprite(button.sprite[button.state], button.spriteD);
                    button.background = Game.menu.pool.switchSprite(that.buttonBackgrounds[button.state], button.background);
                    Gui.prototype.update.call(this);
                };
                button.guiContainer.interactive = true;
                button.guiContainer.mousedown = button.guiContainer.touchstart = function ()
                {
                    button.touched = true;
                    button.guiContainer.scale.set(0.6, 0.6);
                }.bind(button);

                button.guiContainer.mouseup = button.guiContainer.touchend = button.guiContainer.mouseupoutside = button.guiContainer.touchendoutside = function () {
                    if (button.touched) {
                        button.page.emiter.updateSpawnPos(button.guiContainer.position.x, button.guiContainer.position.y);
                        button.page.emiter.emit = true;
                        if (button.page.tips && button.page.tips2) {
                            if (upgrade.name == 'orcWarrior')
                                log('tutor.warriors', 0);
                            button.page.guiContainer.removeChild(button.page.tips);
                            button.page.guiContainer.removeChild(button.page.tips2);
                            button.page.tips = null; button.page.tips2 = null;

                            if (upgrade.name == 'orcWarrior') {
                                var ballon = new MessageBalloon(Game.strings[Game.language].menuMap.purchase, new Vec2(948, 300), true, button.page.guiContainer);
                                ballon.container.scale.set(1, -1);
                                ballon.balloonText.scale.set(1, -1);
                                button.page.tips3 = ballon.container;
                            }
                        }
                        button.touched = false;
                        if (!this.page.isMoved) {
                            button.page.selectedUpgrade = upgrade;
                        }
                        button.guiContainer.scale.set(0.7, 0.7);
                    }
                }.bind(button);
                button.guiContainer.scale.set(0.7, 0.7);
            });

            this.buttons.forEach(function (button) {
                this.upgradesContainer.addChild(button.guiContainer);
            }.bind(this));

            this.selectedDescriptionBack = Game.menu.pool.getSprite(Game.sprites.descriptionBox);
            this.selectedDescriptionBack.scale.set(1.5, 1.2);
            this.selectedDescriptionBack.position.set(640, 720);
            this.upgradesContainer.addChild(this.selectedDescriptionBack);

            Game.font = Game.getFont(48);
            Game.fillStyle = "#FFF2B3";
            this.selectedDescription = new PIXI.Text(' ', {
                font: Game.font,
                fill: Game.fillStyle
            });
            this.selectedDescription.position.set(640, 700);
            this.upgradesContainer.addChild(this.selectedDescription);

            if (Game.globallogic.getLvlWithName("1").isOpen() && localStorage.getItem("upgradesOpened") != "true") {
                this.tips = new PIXI.DisplayObjectContainer();
                var ballon = new MessageBalloon(Game.strings[Game.language].menuMap.selectWarriors, new Vec2(588, 650), true, this.guiContainer);
                this.tips = ballon.container;

                ballon = new MessageBalloon(Game.strings[Game.language].menuMap.youStars.split(',')[0] + Game.globallogic.availableStars + Game.strings[Game.language].menuMap.youStars.split(',')[1], new Vec2(660, 190), false, this.guiContainer);
                this.tips2 = ballon.container;
                ballon.container.scale.set(-1,1);
                ballon.balloonText.scale.set(-1,1);
            }
        }
    };
}