﻿if (window.location.href.indexOf('frame=1') !== -1) {
    window.innerWidthVirtual = 2048;
    window.innerHeightVirtual = 1536;
    window.touchMultiplyer = 2048/window.innerWidth;
} else if (window.MSPointerEvent && window.location.href.indexOf('kongregate') == -1) {
    window.innerWidthVirtual = parseInt(window.innerWidth * window.screen.deviceXDPI / window.screen.logicalXDPI);
    window.innerHeightVirtual = parseInt(window.innerHeight * window.screen.deviceYDPI / window.screen.logicalYDPI) + 1;
    window.touchMultiplyer = window.screen.deviceXDPI / window.screen.logicalXDPI;
} else {
    window.innerWidthVirtual =  window.innerWidth;
    window.innerHeightVirtual = window.innerHeight;
    window.touchMultiplyer = 1;
}

Game = {
    loadedAtlases: [],
    isWindowsPhone: false,
    isCongregate: false,
    audioList: [],
    sprites: [],
    profile: 'profile_1:',
    menu: null,
    debug: false,
    release: true,
    pc: false,
    adsConfigured:false,
    uid: 1,
    platform:3,
    first: true,
    isRedactor: false,
    atlases: [],
    animations: [],
    enemyList: [],
    friendlyList: [],
    audioFormat: ".ogg",
    musicFormat: '.ogg',
    buildingsList: [],
    tileList: [],
    backgroundsList: [],
    backgroundsPreviewList: [],
    TextTexturesCache: [],
    atlasList: [],
    strategy: [], // list of enemy strategies
    touchList: [], // list of touches
    guiList: [],
    environmentList: [],
    inputList: [], // list of inputs
    isMenu: false, //switch menu/game
    cycleTickTime: 50, //cycle time(setinterval)
    noTouch: 0,  //times without touches in ms
    currEpisode: 'desert',
    lastDrawTime: Date.now(),
    redrawTime: 50,
    drawCount: 0,
    drawCountIterator: 0,
    drawCountAvr:0,
    atlasCompress: 2,
    width: 2048, //window width
    height: 1536, //game height
    windowWidth: window.innerWidthVirtual,
    windowHeight: window.innerHeightVirtual,
    heightShift: 1536/(window.innerWidthVirtual/(window.innerHeightVirtual*4/3)),
    scale: (window.innerWidthVirtual)/2048,
    menuScale: window.innerHeightVirtual/1152,
    menuWidth: window.innerWidthVirtual / (window.innerHeightVirtual/1152),
    menuHeight: window.innerHeightVirtual / (window.innerHeightVirtual/1152),
    language: "en",
    mapWidth: 32, //Tile counts in row
    mapHeight: 24, //Tile counts in column
    tileWidth: 64,
    tileHeight: 64,
    dayTime: 40000,
    nightTime: 30000,
    particlesList:{},
    spawnTagCounter: 0,
    speed: 1, //TODO DEBUG
    onresize: [],
    fromLvlBegin: 0 //TODO DEBUG
};
function init() {
    if (Cocoon && Cocoon.Utils && Cocoon.nativeAvailable) {
        //console.log('texture reduced!');
        if (window.innerWidth < 1025)
            Cocoon.Utils.textureReduction(1024);

		Cocoon.Utils.setWebGLEnabled(true);
        Cocoon.Utils.setTextCacheSize(1);
    }
    console.log(window.innerWidthVirtual, window.innerHeightVirtual);
    window.onresize = function () {
        if (Game.isWindowsPhone) {
            window.innerWidthVirtual = parseInt(window.innerWidth * window.screen.deviceXDPI / window.screen.logicalXDPI);
            window.innerHeightVirtual = parseInt(window.innerHeight * window.screen.deviceYDPI / window.screen.logicalYDPI) + 1;
        } else {
            window.innerWidthVirtual = window.innerWidth;
            window.innerHeightVirtual = window.innerHeight;
        }
        Game.windowWidth = window.innerWidthVirtual;
        Game.windowHeight = window.innerHeightVirtual;
        Game.heightShift = 1536/(window.innerWidthVirtual/(window.innerHeightVirtual*4/3));
        Game.scale = window.innerWidthVirtual/2048;
        Game.menuScale = window.innerHeightVirtual/1152;
        Game.menuWidth = window.innerWidthVirtual / (window.innerHeightVirtual / 1152);
        Game.menuHeight = window.innerHeightVirtual / (window.innerHeightVirtual / 1152);
        Game.renderer.resize(Game.windowWidth, Game.windowHeight);
        Game.onresize.forEach(function (handler) {
            handler();
        });
    };
    
     if (navigator.language && navigator.language.indexOf('ru') != -1)
            Game.language = 'ru';

     console.log('navigarot', navigator.language);
        
    if (Game.isWindowsPhone) {
        Game.platform = 2;
        var deviceId = "";
        var packageSpecificToken =
            Windows.System.Profile.HardwareIdentification
                .getPackageSpecificToken(null);
        var hardwareId = packageSpecificToken.id;
        var dataReader =
            Windows.Storage.Streams.DataReader
                .fromBuffer(hardwareId);

        var array = new Array(hardwareId.length);
        dataReader.readBytes(array);
        for (var i = 0; i < array.length; i++) {
            deviceId += array[i].toString();
        }
        Game.uid = deviceId;
        Game.player = new Em.Media.Playback.AudioPlayer();
        Game.currentApp = Windows.ApplicationModel.Store.CurrentApp;
        Game.isTrial = Game.currentApp.licenseInformation.isTrial;
        Game.isLowMemory = MemoryChekerPhone.Cheker.isLowMemory() < 200;
        console.log('Is low memory ', Game.isLowMemory);
        
        if (false || !Game.release) {
            //console.log(MemoryChekerPhone.Cheker.isLowMemory());
            var appmodel = Windows.ApplicationModel;
            var storage = Windows.Storage;
            var appdata = Windows.Storage.ApplicationData;
            appdata.current.localFolder.createFolderAsync("Microsoft\\Windows Store\\ApiData",
                storage.CreationCollisionOption.openIfExists).then(
                function (folder) {
                    appmodel.Package.current.installedLocation.getFileAsync("data\\license.xml").then(
                        function (file) {
                            Windows.ApplicationModel.Store.CurrentAppSimulator.reloadSimulatorAsync(file).done(function () {
                                console.log(Game.currentApp.licenseInformation);
                            }, function () {
                                console.log('fail');
                            });
                            folder.createFileAsync("WindowsStoreProxy.xml", storage.CreationCollisionOption.replaceExisting).then(
                                function (newFile) {
                                    file.copyAndReplaceAsync(newFile);
                                });
                        });
                });
        }
    } else {

        if (navigator.isCocoonJS)
        {
            Game.uid = Cocoon.Device.getDeviceId();
            console.log('uid is ', Game.uid);
            if (/ios/.test(navigator.userAgent))
            {
                Game.platform = 0;
            }
            else if (/android/.test(navigator.userAgent))
            {
                Game.platform = 1;
            }
            if (Cocoon.nativeAvailable) {
                console.log('configure ads');
                Cocoon.Ad.Chartboost.configure({
                    appId: '56337f0a43150f4e6d6f2584',
                    appSignature: 'fce0f3548d900e2660db6a4ca922e4862a498e50'
                });
                Game.adsProvider = Cocoon.Ad.Chartboost.createInterstitial();
                Game.adsProvider.load();
                Game.adsProvider.on("load", function(){
                    Game.adsConfigured = true;
                });
                Game.adsProvider.on("fail", function(error){
                    console.log("interstitialChartboost failed", JSON.stringify(error));
                });
                Game.adsProvider.on("show", function(){
                    console.log("interstitialChartboost shown");
                });
                Game.adsProvider.on("dismiss", function(){
                    Game.adsProvider.load();
                });
            }
        }
    }
}