﻿function Map(params, preEnviromenrList, unWalkable, blockedTiles, flyAble, cristalTiles, aTiles, bTiles, cTiles, callback) {
    this.previousPathFind = 0;
    this.pathFindIteration = 0;
    this.blockOnlyByTerrain = false;
    this.isFlying = false;
    this.init(unWalkable, blockedTiles, flyAble, cristalTiles, aTiles, bTiles, cTiles);
    if (params.init)
        params.init.call(this);

    //this.backgroundTexture = new PIXI.RenderTexture(2048, 1536);
    this.container = new PIXI.Container();

    if (!Game.pc) {
        if (Game.cachedBackground && Game.cachedBackground.name == params.background) {
            this.background = Game.cachedBackground;
        } else {
            Game.cachedBackground = this.background = new Background(params.background);
        }
    } else {
        this.background = Game.backgroundsList.filter(function(back){return back.name == params.background}).pop();
    }

    this.background.load(
        function () {
            var sprite;
            var environments = preEnviromenrList.sort(function (a, b) {
                if (a.y < b.y)return -1;
                if (a.y > b.y)return 1;
                return 0;
            });
            this.container.addChild(this.background.container);

            if (!Game.release) {
                for (var key in environments) {
                    sprite = PIXI.Sprite.fromFrame(Game.sprites[environments[key].name].name);
                    sprite.position.x = environments[key].x;
                    sprite.position.y = environments[key].y;
                    //sprite.anchor = new PIXI.Point((sprite.texture.width + sprite.texture.basePivot.x)/sprite.texture.width -0.5, (sprite.texture.height + sprite.texture.basePivot.y)/sprite.texture.height -0.5);
                    sprite.pivot = sprite.texture.framePivot;
                    sprite.anchor = new PIXI.Point(0.5, 0.5);
                    this.container.addChild(sprite);
                }
            }
            //this.backgroundTexture.render(this.container);

            Game.lvl.mapContainer.addChild(this.container);
            //this.background.unload();

            Game.lvl.loaded = true;
            callback();
    }.bind(this));
}

Map.prototype.init = function(unWalkable, blockedTiles, flyAble, cristalTiles, aTiles, bTiles, cTiles) {
    var key;
    this.tiles = [];
    for (var i =0; i<Game.mapWidth * Game.mapHeight; i++){
        var position = new Vec2((i%Game.mapWidth)*Game.tileWidth + Game.tileWidth/2, i.div(Game.mapWidth) * Game.tileHeight + Game.tileHeight/2);
        var positionInArray = new Vec2(i%Game.mapWidth, i.div(Game.mapWidth));
        this.tiles.push(new Tile(Game.tileList.grass, position, positionInArray));
    }

    for (key in unWalkable)
        if (this.getNodeAt(unWalkable[key].x, unWalkable[key].y) != null) this.getNodeAt(unWalkable[key].x, unWalkable[key].y).setFullUnwalkAble();

    for (key in blockedTiles)
        if (this.getNodeAt(blockedTiles[key].x, blockedTiles[key].y) != null) this.getNodeAt(blockedTiles[key].x, blockedTiles[key].y).setUnwalkAble();

    for (key in flyAble)
        if (this.getNodeAt(flyAble[key].x, flyAble[key].y) != null) this.getNodeAt(flyAble[key].x, flyAble[key].y).setFlyAble(true);

    for (key in cristalTiles)
        if (this.getNodeAt(cristalTiles[key].x, cristalTiles[key].y) != null) this.getNodeAt(cristalTiles[key].x, cristalTiles[key].y).setCristal();

    for (key in aTiles)
        if (this.getNodeAt(aTiles[key].x, aTiles[key].y) != null) this.getNodeAt(aTiles[key].x, aTiles[key].y).setATile();

    for (key in bTiles)
        if (this.getNodeAt(bTiles[key].x, bTiles[key].y) != null) this.getNodeAt(bTiles[key].x, bTiles[key].y).setBTile();

    for (key in cTiles)
        if (this.getNodeAt(cTiles[key].x, cTiles[key].y) != null) this.getNodeAt(cTiles[key].x, cTiles[key].y).setCTile();

};

Map.prototype.update  = function () {};

Map.prototype.initMapCanvas = function (background){};

Map.prototype.drawOnBackground = function (sprite, x, y, sizeMultiplyed) {
    var spr = Game.lvl.pool.getSprite(sprite);
    Game.lvl.objEffect.push(new BackObject(new Vec2(x, y), spr, sizeMultiplyed));
};

function BackObject(startPosition, sprite, size){
    this.position = startPosition;
    this.timePassed = 0;
    this.container = sprite;
    this.container.position = this.position;
    this.container.scale.set(size, size);
    Game.lvl.underEffectContainer.addChild(this.container);
}


BackObject.prototype.update = function () {
    this.timePassed += Game.cycleTickTime*Game.speed;
    if (this.timePassed > 10000) {
        this.container.alpha = (5000 + (10000-this.timePassed))/5000;
        if (this.timePassed >= 15000) {
            if (Game.lvl.objEffect.indexOf(this) != -1)
                Game.lvl.objEffect.splice(Game.lvl.objEffect.indexOf(this), 1);
            this.container.alpha = 1;
            this.container.scale.set(1,1);
            Game.lvl.pool.pull(this.container);
        }
    }
};

Map.prototype.getTile = function(position) {
    if (!(position instanceof Vec2))
        throw new Error("argument error");
    if ((position.x <0)||(position.x >= Game.width)||(position.y<0)||(position.y >= Game.height))
    {
        position = position.clone();
        if (position.x < 0)
            position.x = 1;

        if (position.x >=Game.width)
            position.x = Game.width-1;

        if (position.y < 0)
            position.y = 1;

        if (position.y >=Game.height)
            position.y = Game.height-1;
        return this.getTile(position);
    }
    return this.tiles[position.x.div(Game.tileWidth) + position.y.div(Game.tileWidth)*Game.mapWidth];
};

Map.prototype.getClosesWalkAbleTileFromWithRange = function(position, from, range) {
    var tile, i, nodes;
    i = 0;
    while (tile == null){
        if ((nodes = this.getNodeWithRange(position, i++)).length === 0 )
            break;
        for(var node in nodes)
        {
            if (nodes[node].isGlobalyWalkable && from.clone().sub(nodes[node].position).getLength() < range && ((tile == null) ||(position.clone().sub(tile.position).getLength()>position.clone().sub(nodes[node].position).getLength())))
                tile = nodes[node];
        }
    }
    return tile;
};

Map.prototype.getTileForMonster = function(position, spawnTag) {
    if (!(position instanceof Vec2))
        throw new Error("argument error");

    if ((position.x <0)||(position.x >= Game.width)||(position.y<0)||(position.y >= Game.height))
    {
        position = position.clone();
        if (position.x < 0)
            position.x = 1;

        if (position.x >=Game.width)
            position.x = Game.width-1;

        if (position.y < 0)
            position.y = 1;

        if (position.y >=Game.height)
            position.y = Game.height-1;
    }
    return this.getClosesWalkAbleTile(position, spawnTag);
};


Map.prototype.getTruthTile = function(position){
    if (!(position instanceof Vec2))
        throw new Error("argument error");

    if (isNaN(position.x) || isNaN(position.y))
        return null;

    if ((position.x < 0)||(position.x >= Game.width)||(position.y<0)||(position.y >= Game.height))
        return null;

    return this.tiles[position.x.div(Game.tileWidth) + position.y.div(Game.tileWidth)*Game.mapWidth];
};

Map.prototype.getClosesEmptyTile = function(position){
    var tile, i, nodes;
    i = 0;
    while (tile == null){
        if ((nodes = this.getNodeWithRange(position, i++)).length === 0 )
            break;
        for(var node in nodes)
        {
            if ((nodes[node].wObjects.length === 0)&&(nodes[node].objects.length === 0) && nodes[node].isWalkable && nodes[node].canBeWalk() && ((tile == null) ||(position.clone().sub(tile.position).getLength()>position.clone().sub(nodes[node].position).getLength())))
                tile = nodes[node];
        }
    }
    return tile;
};

Map.prototype.getClosesAnchorTile = function(position){
    var tile, i, nodes;
    i = 0;
    while (tile == null && i < 99){
        if ((nodes = this.getNodeWithRange(position, i++)).length === 0 )
            break;
        for(var node in nodes)
        {
            if ((nodes[node].anchor) && ((tile == null) ||(position.clone().sub(tile.position).getLength()>position.clone().sub(nodes[node].position).getLength())))
                tile = nodes[node];
        }
    }
    return tile;
};


Map.prototype.getClosesWalkAbleTile = function(position, range) {
    var tile, i, nodes;
    i = range || 0;
    while (tile == null){
        if ((nodes = this.getNodeWithRange(position, i++)).length === 0 )
            break;
        for(var node in nodes)
        {
            if ((nodes[node].isWalkable) && ((tile == null) ||(position.clone().sub(tile.position).getLength()>position.clone().sub(nodes[node].position).getLength())))
                tile = nodes[node];
        }
    }
    return tile;
};

Map.prototype.getClosesWalkAbleTileFrom = function(position, fromPosition){
    var tile, i, nodes;
    i = 0;
    while (tile == null){
        if ((nodes = this.getNodeWithRange(position, i++)).length === 0 )
            break;
        for(var node in nodes)
        {
            if (nodes[node].objects.length == 0 &&nodes[node].isGlobalyWalkable && ((tile == null) ||(fromPosition.clone().sub(tile.position).getLength()>fromPosition.clone().sub(nodes[node].position).getLength())))
                tile = nodes[node];
        }
    }
    return tile;
};

Map.prototype.getTileForTownHall = function (position, spawnTag){
    var tile, nodes = [], node, curNode, i = 1, spawnCounter = 0;
    for (var x = -1; x <= 4; x+=5) {
        for (var y = 0; y <= 3; y ++) {
            nodes.push(this.getTile(Game.lvl.townHall.position.clone().add(new Vec2(Game.tileWidth*x, Game.tileHeight*y))));
            nodes.push(this.getTile(Game.lvl.townHall.position.clone().add(new Vec2(Game.tileWidth*x, Game.tileHeight*y))));
            nodes.push(this.getTile(Game.lvl.townHall.position.clone().add(new Vec2(Game.tileWidth*x, Game.tileHeight*y))));
        }
    }
    for (var x = -1; x <5; x++) {
        for (var y = -1; y <= 4; y +=5) {
            nodes.push(this.getTile(Game.lvl.townHall.position.clone().add(new Vec2(Game.tileWidth*x, Game.tileHeight*y))));
            nodes.push(this.getTile(Game.lvl.townHall.position.clone().add(new Vec2(Game.tileWidth*x, Game.tileHeight*y))));
            nodes.push(this.getTile(Game.lvl.townHall.position.clone().add(new Vec2(Game.tileWidth*x, Game.tileHeight*y))));
        }
    }
    for (node in nodes)
    {
        curNode = nodes[node];
        if ((!curNode.spawnTags[spawnTag]) && (curNode.isGlobalyWalkable || this.isFlying)) {
            curNode.spawnTags[spawnTag] = 1;
            tile = curNode;
            break;
        } else if (((curNode.isGlobalyWalkable)&&(curNode.objects.length === 0))|| this.isFlying) {
            if ((spawnCounter > curNode.spawnTags[spawnTag]) || (spawnCounter == 0))
                spawnCounter = curNode.spawnTags[spawnTag];
        }
    }
    if ((spawnCounter > 0)&&(!tile)){
        for (node in nodes) {
            curNode = nodes[node];
            if ((curNode.spawnTags[spawnTag] == spawnCounter) && (curNode.isGlobalyWalkable || this.isFlying)) {
                tile = curNode;
                curNode.spawnTags[spawnTag]++;
                break;
            }
        }
    }

    return tile || this.getTile(Game.lvl.townHall.position);
};


Map.prototype.getClosesWalkAbleTileForRandomMonster = function(position, spawnTag, from, next){
    var tile, nodes, node, curNode, i = 1, spawnCounter = 0, fromLength =  position.clone().sub(from.position).getLength() + 31, toNext = position.clone().sub(next.position).getLength() + 31;

    nodes = this.getNodeWithRange(position, i);
    for (node in nodes)
    {
        curNode = nodes[node];
        if (fromLength > curNode.position.clone().sub(from.position).getLength() && curNode.position.clone().sub(next.position).getLength() < toNext) {
            if (!curNode.spawnTags[spawnTag] && curNode.isGlobalyWalkable) {
                curNode.spawnTags[spawnTag] = 1;
                spawnCounter = 1;
                tile = curNode;
                break;
            } else if (curNode.isGlobalyWalkable) {
                if ((spawnCounter > curNode.spawnTags[spawnTag]) || (spawnCounter == 0))
                    spawnCounter = curNode.spawnTags[spawnTag];
            }
        }
    }
    if ((spawnCounter > 0) && !tile) {
        for (node in nodes) {
            curNode = nodes[node];
            if ((curNode.spawnTags[spawnTag] == spawnCounter) && (curNode.isGlobalyWalkable)) {
                tile = curNode;
                curNode.spawnTags[spawnTag]++;
                break;
            }
        }
    }

    if (!tile)
        return this.getClosesWalkAbleTile(position);
    return tile;
};

Map.prototype.getNodeWithRange = function(position, range){
    var x, y, tiles, tile = this.getTile(position);
    if (range === 0)
        if (tile)
            return [tile];
        else
            return [];

    tiles = [];
    x = tile.positionInArray.x;
    y = tile.positionInArray.y;

    for (var i =  - range; i <  + range; i ++){
        if ((tile = this.getNodeAt(x + i, y +range)))
            tiles.push(tile);
        if ((tile = this.getNodeAt(x + i, y - range)))
            tiles.push(tile);
        if ((tile = this.getNodeAt(x + range, y + i)))
            tiles.push(tile);
        if ((tile = this.getNodeAt(x - range, y + i)))
            tiles.push(tile);
    }
    return tiles;
};

Map.prototype.getSubTile = function(position){
    if ((position.x <0)||(position.x >Game.width)||(position.y<0)||(position.y > Game.height))
        return null;
    return this.subTiles[position.x.div(Game.tileWidth/2)][position.y.div(Game.tileWidth/2)];
};


Map.prototype.getObject = function(position){
    if ((position.x <0)||(position.x >Game.width)||(position.y<0)||(position.y > Game.height))
        return null;
    var tile = this.tiles[position.x.div(Game.tileWidth) + position.y.div(Game.tileWidth)*Game.mapWidth];
    if (tile.objects)
        return tile.objects[0];
    else
        return null;
};



Map.prototype.getClosedEnemy = function(position)
{
    var len, target, tmpLen;
    Game.lvl.objEnemy.forEach(function(enemy){
        if (((tmpLen = enemy.position.clone().add(enemy.hitPosition).sub(position).getLength()) < (enemy.base.boss ? 128 : 86) && (!len || len > tmpLen))) {
            len = tmpLen;
            target = enemy;
        }
    });
    return target;
};

Map.prototype.getSelected = function(position, depth)
{
    if (Game.lvl.gameLogic.state === 'tutorBuild') {
        if (position.clone().sub(new Vec2(1376, 736)).getLength() < 96){
            return Game.lvl.flags.filter(function(flag){return flag.position.clone().sub(position).getLength()<96}).pop();
        } else {
            return null;
        }
    } else if (Game.lvl.gameLogic.state === 'tutorUpgrade') {
        if (position.clone().sub(new Vec2(800, 1056)).getLength() < 96) {
            return this.getClosesBuilding(position);;
        } else {
            return null;
        }
    } else {
        var unit = this.getClosesUnit(position);
        var building = this.getClosesBuilding(position);
        var tmpLng;
        if (building)
            return building;

        if (unit)
            return unit;

        return null;
    }
};

Map.prototype.getClosesUnit = function(position){
    var len, target, tmpLen;
    if (Game.lvl.gameLogic.hero && Game.lvl.gameLogic.hero.hitPoints > 0 && Game.lvl.gameLogic.hero.position.clone().sub(position).getLength()< 128)
        return Game.lvl.gameLogic.hero;
    //for (var key in Game.lvl.objFriendly){
    //    if (((tmpLen = Game.lvl.objFriendly[key].position.clone().sub(position).getLength()) < 96) && (!len || len > tmpLen) && Game.lvl.objFriendly[key].hitPoints > 0){
    //        len = tmpLen;
    //        target = Game.lvl.objFriendly[key];
    //    }
    //}
    return null;
};

Map.prototype.getClosesFlag = function(position){
    var len, key, target, tmpLen;
    for (key in Game.lvl.flags) {
        if (((tmpLen = Game.lvl.flags[key].position.clone().sub(position).getLength()) < 64 && (!len || len > tmpLen))) {
            len = tmpLen;
            target = Game.lvl.flags[key];
        }
    }
    return target;
};

Map.prototype.getClosesBuilding = function(position){
    var len, key, target, tmpLen;
    for (key in Game.lvl.objBuildings) {
        if (Game.lvl.objBuildings[key].disabled <= 0 && ((tmpLen = Game.lvl.objBuildings[key].position.clone().add(Game.lvl.objBuildings[key].hitPosition).sub(position).getLength()) < 96 && (!len || len > tmpLen) && Game.lvl.objBuildings[key] != Game.lvl.townHall && Game.lvl.objBuildings[key].hitPoints > 0)){
            len = tmpLen;
            target = Game.lvl.objBuildings[key];
        }
    }
    var flag = this.getClosesFlag(position);
    if (flag && flag.disabled <=0 && flag.tile.objects.length === 0 && ((tmpLen = flag.position.clone().sub(position).getLength()) < 96 && (!len || len > tmpLen))){
        len = tmpLen;
        target = flag;
    }
    return target;
};

Map.prototype.getBuilding = function(position){
    if ((position.x <0)||(position.x >Game.width)||(position.y<0)||(position.y > Game.height))
        return null;
    var tile = this.tiles[position.x.div(Game.tileWidth) + position.y.div(Game.tileWidth)*Game.mapWidth];

    if (tile.objects)
        return tile.objects[0];
};

Map.prototype.getUnit = function(position){
    if ((position.x <0)||(position.x >Game.width)||(position.y<0)||(position.y > Game.height))
        return null;
    var tile = this.tiles[position.x.div(Game.tileWidth) + position.y.div(Game.tileWidth)*Game.mapWidth];

    if (tile.wObjects)
        return tile.wObjects[0];

};

Map.prototype.getPathForMonster = function(startPosition, endPosition, enemy){
    var path = [], spawnTag = enemy.spawnTag;

    if ((!startPosition) || (!(startPosition instanceof Vec2))||(!endPosition) || (!(endPosition instanceof Vec2)))
        throw new Error('argument error');


    this.isFlying = false;
    this.blockOnlyByTerrain = true;
    this.friendly = false;

    path = this.getPathForMonsterImpl(endPosition, startPosition, spawnTag);

    if (path.length == 0) {
        console.log("can't find path for monster " + startPosition.x + ' ' + startPosition.y);
        return [this.getTile(endPosition)];
    } else {
        return path;
    }

    // fail to find the path
};

Map.prototype.getPathForMonsterImpl = function(startPosition, endPosition, spawnTag){

    this.pathFindIteration++;

    if (this.pathFindIteration > 999999)
        this.pathFindIteration = 0;
    this.openList = [];
    this.openList.push = function() {
        Array.prototype.push.call(this, arguments[0]);
        this.openList = Array.prototype.sort.call(this, function(a, b){return  b.f - a.f;});
    };

    this.anchorPosition = null;
    this.maxLength = null;

    var startNode = this.startNode =  this.getClosesWalkAbleTile(startPosition);
    var endNode = this.endNode = this.getClosesWalkAbleTile(this.getTile(endPosition).position);
    if (endNode.specialColor.length > 0){
        this.specialColorPath = endNode.specialColor[0];
    } else {
        this.specialColorPath = null;
    }
    startNode.g = 0;
    startNode.f = 0;
    startNode.parent = null;
    this.openList.push(startNode);
    startNode.opened = true;
    while (this.openList.length > 0) {
        // pop the position of node which has the minimum `f` value.
        //this.openList = this.openList.sort(function(a, b){return a.f - b.f;});
        var node = this.openList.pop();
        node.closed = this.pathFindIteration;
        if (node == this.endNode) {
            return this.expandPathMonster(endNode, spawnTag).reverse();
        }
        this._identifySuccessors(node);
    }

    // fail to find the path
    return [];
};

Map.prototype.getPathForFlying = function(startPosition, endPosition, enemy){
    var path = [], spawnTag = enemy.spawnTag, type = enemy.strategyType;

    if ((!startPosition) || (!(startPosition instanceof Vec2))||(!endPosition) || (!(endPosition instanceof Vec2)))
        throw new Error('argument error');

    this.isFlying = true;
    this.blockOnlyByTerrain = true;
    this.friendly = false;
    path = this.getPathForMonsterImpl(endPosition, startPosition, spawnTag);


    if (path.length == 0) {
        console.log('cant find path for flying');
        return [this.getTile(endPosition)];
    } else {
        path.reverse();
        path.push(this.getTile(endPosition));
        path.reverse();
        return path;
    }
    // fail to find the path
};

Map.prototype.getPath = function(startPosition, endPosition, anchorPosition, maxLength){
    this.pathFindIteration++;
    this.blockOnlyByTerrain = false;
    this.friendly = true;
    if (this.pathFindIteration> 999999)
        this.pathFindIteration = 0;
    this.openList = [];
    this.openList.push = function(){
        Array.prototype.push.call(this, arguments[0]);
        this.openList = Array.prototype.sort.call(this, function(a, b){return  b.f - a.f;});
    };
    if (anchorPosition)
        this.anchorPosition = this.getTile(anchorPosition).positionInArray;
    else
        this.anchorPosition = null;

    if (maxLength)
        this.maxLength = maxLength/64;
    else
        this.maxLength = null;

    var startNode = this.startNode =  this.getTile(startPosition);
    var endNode = this.endNode = this.getTile(endPosition);
    startNode.g = 0;
    startNode.f = 0;
    startNode.parent = null;
    this.openList.push(startNode);
    startNode.opened = true;
    while (this.openList.length > 0) {
        // pop the position of node which has the minimum `f` value.
        //this.openList = this.openList.sort(function(a, b){return a.f - b.f;});
        var node = this.openList.pop();
        node.closed = this.pathFindIteration;
        if (node == this.endNode) {
            return this.backtrace(endNode);
        }
        this._identifySuccessors(node);
    }

    return [];
};

Map.prototype._identifySuccessors = function(node) {

    //var openList = this.openList,
    var endX = this.endNode.positionInArray.x,
        endY = this.endNode.positionInArray.y,
        neighbors, neighbor,
        jumpPoint, i, l,
        x = node.positionInArray.x, y = node.positionInArray.y,
        jx, jy, dx, dy, d, ng, jumpNode,
        abs = Math.abs, max = Math.max;

    neighbors = this._findNeighbors(node);
    for(i = 0, l = neighbors.length; i < l; ++i) {
        neighbor = neighbors[i];
        jumpPoint = this._jump(neighbor[0], neighbor[1], x, y);
        if (jumpPoint) {
            //console.log(jumpPoint);
            jx = jumpPoint[0];
            jy = jumpPoint[1];
            jumpNode = this.getNodeAt(jx, jy);

            if (jumpNode.closed == this.pathFindIteration) {
                continue;
            }

            // include distance, as parent may not be immediately adjacent:
            d = (abs(jx - x) + abs(jy - y));
            ng = node.g + d; // next `g` value

            if ((jumpNode.opened != this.pathFindIteration) || ng < jumpNode.g) {
                jumpNode.g = ng;
                jumpNode.h = jumpNode.h ||  (abs(jx - endX) + abs(jy - endY));
                jumpNode.f = jumpNode.g + jumpNode.h;
                jumpNode.parent = node;

                if ((jumpNode.opened != this.pathFindIteration)) {
                    this.openList.push(jumpNode);
                    jumpNode.opened = this.pathFindIteration;
                } else {
                    this.openList= this.openList.sort(function(a, b){a.f - b.f;});
                }
            } else {
            }
        }
    }
};

Map.prototype._findNeighbors = function(node) {
    var parent = node.parent,
        x = node.positionInArray.x, y = node.positionInArray.y,
        px, py, nx, ny, dx, dy,
        neighbors = [], neighborNodes, neighborNode, i, l;


    // directed pruning: can ignore most neighbors, unless forced.
    if (parent) {
        px = parent.positionInArray.x;
        py = parent.positionInArray.y;
        // get the normalized direction of travel
        dx = (x - px) / Math.max(Math.abs(x - px), 1);
        dy = (y - py) / Math.max(Math.abs(y - py), 1);

        // search diagonally
        if (dx !== 0 && dy !== 0) {
            if (this.isWalkableAt(x, y + dy)) {
                neighbors.push([x, y + dy]);
            }
            if (this.isWalkableAt(x + dx, y)) {
                neighbors.push([x + dx, y]);
            }
            if (this.isWalkableAt(x, y + dy) || this.isWalkableAt(x + dx, y)) {
                neighbors.push([x + dx, y + dy]);
            }
            if (!this.isWalkableAt(x - dx, y) && this.isWalkableAt(x, y + dy)) {
                neighbors.push([x - dx, y + dy]);
            }
            if (!this.isWalkableAt(x, y - dy) && this.isWalkableAt(x + dx, y)) {
                neighbors.push([x + dx, y - dy]);
            }
        }
        // search horizontally/vertically
        else {
            if(dx === 0) {
                if (this.isWalkableAt(x, y + dy)) {
                    neighbors.push([x, y + dy]);
                    if (!this.isWalkableAt(x + 1, y)) {
                        neighbors.push([x + 1, y + dy]);
                    }
                    if (!this.isWalkableAt(x - 1, y)) {
                        neighbors.push([x - 1, y + dy]);
                    }
                }
            }
            else {
                if (this.isWalkableAt(x + dx, y)) {
                    neighbors.push([x + dx, y]);
                    if (!this.isWalkableAt(x, y + 1)) {
                        neighbors.push([x + dx, y + 1]);
                    }
                    if (!this.isWalkableAt(x, y - 1)) {
                        neighbors.push([x + dx, y - 1]);
                    }
                }
            }
        }
    }
    // return all neighbors
    else {
        neighborNodes = this.getNeighbors(node, true);
        for (i = 0, l = neighborNodes.length; i < l; ++i) {
            neighborNode = neighborNodes[i];
            neighbors.push([neighborNode.positionInArray.x, neighborNode.positionInArray.y]);
        }
    }

    return neighbors;
};

Map.prototype.getNeighbors = function(node, allowDiagonal, dontCrossCorners) {
    var x = node.positionInArray.x,
        y = node.positionInArray.y,
        neighbors = [],
        s0 = false, d0 = false,
        s1 = false, d1 = false,
        s2 = false, d2 = false,
        s3 = false, d3 = false;

    // ↑
    if (this.isWalkableAt(x, y - 1)) {
        neighbors.push(this.getNodeAt(x, y-1));
        s0 = true;
    }
    // →
    if (this.isWalkableAt(x + 1, y)) {
        neighbors.push(this.getNodeAt(x+1, y));
        s1 = true;
    }
    // ↓
    if (this.isWalkableAt(x, y + 1)) {
        neighbors.push(this.getNodeAt(x, y+1));
        s2 = true;
    }
    // ←
    if (this.isWalkableAt(x - 1, y)) {
        neighbors.push(this.getNodeAt(x-1, y));
        s3 = true;
    }

    if (!allowDiagonal) {
        return neighbors;
    }

    if (dontCrossCorners) {
        d0 = s3 && s0;
        d1 = s0 && s1;
        d2 = s1 && s2;
        d3 = s2 && s3;
    } else {
        d0 = s3 || s0;
        d1 = s0 || s1;
        d2 = s1 || s2;
        d3 = s2 || s3;
    }

    // ↖
    if (d0 && this.isWalkableAt(x - 1, y - 1)) {
        neighbors.push(this.getNodeAt(x - 1,y - 1));
    }
    // ↗
    if (d1 && this.isWalkableAt(x + 1, y - 1)) {
        neighbors.push(this.getNodeAt(x + 1,y - 1));
    }
    // ↘
    if (d2 && this.isWalkableAt(x + 1, y + 1)) {
        neighbors.push(this.getNodeAt(x + 1,y + 1));
    }
    // ↙
    if (d3 && this.isWalkableAt(x - 1, y + 1)) {
        neighbors.push(this.getNodeAt(x - 1, y + 1));
    }

    return neighbors;
};

Map.prototype.isWalkableAt = function(x, y){
    if ((x <0)||(x >= Game.mapWidth)||(y<0)||(y >= Game.mapHeight))
        return false;

    if (!this.friendly) {
        if (!this.isFlying)
            return this.tiles[x + y * Game.mapWidth].isWalkable && (!this.specialColorPath || this.tiles[x + y * Game.mapWidth].specialColor.indexOf(this.specialColorPath)!=-1);
        else
            return ((this.tiles[x + y * Game.mapWidth].isWalkable || this.tiles[x + y * Game.mapWidth].flyAble)&& (!this.specialColorPath || this.tiles[x + y * Game.mapWidth].specialColor.indexOf(this.specialColorPath)!=-1 ));
    } else
        return this.tiles[x + y * Game.mapWidth].isGlobalyWalkable || this.tiles[x + y * Game.mapWidth].cristal;
};

Map.prototype.getNodeAt = function(x, y){
    if ((x <0)||(x >=Game.mapWidth)||(y<0)||(y >= Game.mapHeight))
        return null;
    return this.tiles[x + (y * Game.mapWidth)];
};

Map.prototype.backtrace = function(node) {
    var path = [node];
    while (node.parent) {
        node = node.parent;
        if (node.parent)
            path.push(node);
    }
    return path;
};

Map.prototype.expandPathMonster = function(node, spawnTag) {
    var endNode, path = [node], prevNode = node;
    while (node.parent) {
        node = node.parent;
        //var _node =  node.parent && node.parent ? this.getClosesWalkAbleTileForRandomMonster(node.position, spawnTag, prevNode, node.parent) : node;
        //prevNode = _node;
        path.push(node);
    }
    return path;
};


Map.prototype.expandPath = function(node) {
    var path = [node];
    while (node.parent) {
        node = node.parent;
        path.push(node);
    }
    return path;
};

Map.prototype.interpolate = function(x0, y0, x1, y1) {
    var abs = Math.abs,
        line = [],
        sx, sy, dx, dy, err, e2;

    dx = abs(x1 - x0);
    dy = abs(y1 - y0);

    sx = (x0 < x1) ? 1 : -1;
    sy = (y0 < y1) ? 1 : -1;

    err = dx - dy;

    while (true) {
        line.push([x0, y0]);

        if (x0 === x1 && y0 === y1) {
            break;
        }

        e2 = 2 * err;
        if (e2 > -dy) {
            err = err - dy;
            x0 = x0 + sx;
        }
        if (e2 < dx) {
            err = err + dx;
            y0 = y0 + sy;
        }
    }

    return line;
};


Map.prototype._jump = function(x, y, px, py) {
    var dx = x - px, dy = y - py;

    if (this.maxLength)
        if (this.anchorPosition.clone().sub(new Vec2(x, y)).getLength() > this.maxLength)
            return null;

    if (!this.isWalkableAt(x, y)) {
        return null;
    }

    if(this.trackJumpRecursion === true) {
        this.getNodeAt(x, y).tested = true;
    }

    if (this.getNodeAt(x, y) === this.endNode) {
        return [x, y];
    }

    // check for forced neighbors
    // along the diagonal
    if (dx !== 0 && dy !== 0) {
        if ((this.isWalkableAt(x - dx, y + dy) && !this.isWalkableAt(x - dx, y)) ||
            (this.isWalkableAt(x + dx, y - dy) && !this.isWalkableAt(x, y - dy))) {
            return [x, y];
        }
    }
    // horizontally/vertically
    else {
        if( dx !== 0 ) { // moving along x
            if((this.isWalkableAt(x + dx, y + 1) && !this.isWalkableAt(x, y + 1)) ||
                (this.isWalkableAt(x + dx, y - 1) && !this.isWalkableAt(x, y - 1))) {
                return [x, y];
            }
        }
        else {
            if((this.isWalkableAt(x + 1, y + dy) && !this.isWalkableAt(x + 1, y)) ||
                (this.isWalkableAt(x - 1, y + dy) && !this.isWalkableAt(x - 1, y))) {
                return [x, y];
            }
        }
    }

    // when moving diagonally, must check for vertical/horizontal jump points
    if (dx !== 0 && dy !== 0) {
        if (this._jump(x + dx, y, x, y) || this._jump(x, y + dy, x, y)) {
            return [x, y];
        }
    }

    // moving diagonally, must make sure one of the vertical/horizontal
    // neighbors is open to allow the path
    if (this.isWalkableAt(x + dx, y) || this.isWalkableAt(x, y + dy)) {
        return this._jump(x + dx, y + dy, x, y);
    } else {
        return null;
    }
};

