﻿var Menu = function() {
    this.pages = [];
    this.stage = new PIXI.Stage(0x000000);
    //this.stage.pivot = new Vec2(Game.windowWidth/2, Game.windowHeight/2);
    this.container = new PIXI.Container();
    this.container.scale.x = this.container.scale.y = Game.windowHeight/1152;
    this.stage.addChild(this.container);
    this.currentPage = 'main';
    this.selectedLvl = 0;
    this.startLvl = false;
    this.pool = new SpritePool();
    this.inited = false;
    this.touchesEnabled = true;

    this.playLvl = function () {
        console.log('play lvl ' + this.selectedLvl);
        this.startLvl = false;
        Game.lvl.paused = false;
        var lvl = Game.globallogic.getLvlWithName(this.selectedLvl);
        Game.currEpisode = lvl.episode;
        Game.isMenu = false;
        Game.menu.container.removeChildren();
        Game.menu.container.addChild(this.loadingScreen);
        //this.stage.removeChild(this.container);
        if (Game.menu.stage)
            Game.renderer.render(Game.menu.stage);
        else
            Game.renderer.render(Game.emptyStage);

        Game.menu.container.removeChildren();
        Game.menu.stage = null;

        Game.lvl.init(Game.episodes[Game.currEpisode].lvls[parseInt(this.selectedLvl)%10]);
        localStorage.setItem(Game.profile + 'mapY', Game.globallogic.mapPosition.y);
        localStorage.setItem(Game.profile + 'mapX', Game.globallogic.mapPosition.x);
    };

    this.enterMenu = function(isMap) {
        Game.noTouch = 2000;
        Game.menu = new Menu();
        Game.stage = Game.menu.stage;
        Game.lvl.loaded = false;
        if (Game.lvl && Game.lvl.objMap && Game.lvl.objMap.backgroundTexture) {
            Game.lvl.objMap.backgroundTexture.baseTexture.destroy();
        }

        Game.menu.load(function () {
            this.music = new MyAudio('map', true, 0.2);
            this.music.play();
            Game.isMenu = true;
            Game.menu.container.addChild(Game.menu.pages[Game.menu.currentPage].container);
            if (isMap) {
                Game.menu.currentPage = 'map';
                Game.menu.container.addChild(Game.menu.pages[Game.menu.currentPage].container);
                if (Game.lastSujet) {
                    Game.lastSujet = false;
                    Game.menu.selectedLvl = "27";
                    Game.menu.currentPage = 'description';
                    Game.menu.container.addChild(Game.menu.pages[Game.menu.currentPage].container);
                    Game.menu.pages[Game.menu.currentPage].objGui.forEach(function(gui){
                        gui.show();
                    });
                }
            }
        }.bind(this));
    };

	this.draw = function() {
         for (var key in this.pages[this.currentPage].objGui){
             this.pages[this.currentPage].objGui[key].draw();
         }
	};

    this.update = function () {
        this.pages[this.currentPage].objGui.forEach(function(gui) {
            gui.update();
        })
    };

    this.load = function(callback) {
        this.loadingScreen = new PIXI.Container();

        if (Game.first)
            setTimeout(function () {
                Game.font = Game.getFont(16);
                Game.fillStyle = "#C8B7AF";
                this.text1 = new PIXI.Text(Game.strings[Game.language].name, {
                    font: Game.font,
                    align: Game.textAlign,
                    fill: Game.fillStyle,
                    strokeThickness: 8,
                    stroke: 'rgba(0,0,0,0.1);',
                    dropShadowDistance: 8,
                    dropShadow: true,
                    dropShadowColor: 'rgba(0,0,0,0.4);'
                });
                this.text1.position = new Vec2(1024, 1152 / 2 - 480);
                this.loadingScreen.addChildAt(this.text1, 0);
            }.bind(this), 1);



        this.backSprite = Game.menu.pool.getSprite(Game.sprites.TitleBackground1024);
        this.backSpriteLogo = Game.menu.pool.getSprite(Game.sprites.LOGO);
        this.backShadow = Game.menu.pool.getSprite(Game.sprites.shadowL);
        this.backSpriteLogo.position = new Vec2(1024, 1152 / 4);
        this.backSpriteLogo.scale.set(1.3, 1.3);
        this.backSprite.position = new Vec2(1024, 1152 / 2);
        this.backSprite.scale = new Vec2(Game.windowWidth / Game.windowHeight * 4 / 3, 1.5);
        this.loadingScreen.addChild(this.backSprite);
        this.loadingScreen.addChild(this.backSpriteLogo);
        this.loadingScreen.addChild(this.backShadow);

        this.loadingFrame = Game.menu.pool.getSprite(Game.sprites.loading_frame);
        this.loadingFrame.position = new Vec2(1024, 758 + 200);
        this.loadingFill = Game.menu.pool.getSprite(Game.sprites.loading_fill_bar);
        this.loadingFill.position = new Vec2(1024, 752 + 200);
        this.fillMask = new PIXI.Graphics();
        this.fillMask.beginFill();
        this.fillMask.moveTo(0, 0);
        this.fillMask.drawRect(0, 0, 0, 40);
        this.fillMask.endFill();
        this.fillMask.position = new Vec2(1024 - 400, 752 + 200 - 20);
        this.loadingFill.mask = this.fillMask;

        this.loadingScreen.addChild(this.loadingFrame);
        this.loadingScreen.addChild(this.fillMask);
        this.loadingScreen.addChild(this.loadingFill);
        this.lastProcent = 0;


        this.text = new PIXI.extras.BitmapText('',
            {
                font: Game.getFontBitmap(),
                align: "center",
                width: 1640-330
            });


        if (!Game.globallogic.getLvlWithName("1").isOpen()) {
            this.text.setText(Game.strings[Game.language].tips[0]);
        } else if (!Game.globallogic.getLvlWithName("2").isOpen()) {
            this.text.setText(Game.strings[Game.language].tips[1]);
        } else {
            var tipNumber = parseInt(localStorage.getItem("tipNumber")) || 2;
            this.text.setText(Game.strings[Game.language].tips[tipNumber % Game.strings[Game.language].tips.length]);
            localStorage.setItem("tipNumber", ++tipNumber);
        }
        //this.text.position = new Vec2((Game.menuWidth)/2, 768);
        this.text.position = new Vec2(1024 - this.text.width/2, 768);
        this.backShadow.position = new Vec2(1024, 768+this.text.height/2);
        this.backShadow.scale.set(6, this.text.height/(Game.language =='en' ? 64 : 42) + 0.8);
        //this.text.pivot = new Vec2(2048/2, 1152/2);

        this.loadingScreen.addChild(this.text);

        this.loadingFrame.alpha = 0;
        this.loadingFill.alpha = 0;

        if (Game.first && Game.release) {
            this.text.alpha = 0;
            this.backShadow.alpha = 0;
            if (Game.pc){
                this.loadingFrame.alpha = 1;
                this.loadingFill.alpha = 1;
            }
        }

        this.loadingScreen.position = new Vec2(Game.menuWidth / 2, Game.menuHeight / 2);
        this.loadingScreen.pivot = new Vec2(2048 / 2, 1152 / 2);
        this.container.addChild(this.loadingScreen);



        Game.menuLoaded = false;
        Atlas.loadAtlasesForEpisode('gui', function () {
            this.container.removeChild(this.loadingScreen);
            if (Game.first) {
                this.loadingScreen.removeChild(this.text1);
                Game.first = false;
                //this.loadingFrame.alpha = 1;
                this.text.alpha = 1;
                this.backShadow.alpha = 1;
            }
            if (!this.inited) {
                this.init(Game.menuPrefs);
            }
            Game.menuLoaded = true;
            this.loadingFrame.alpha = 0;
            this.loadingFill.alpha = 0;
            callback();
        }.bind(this), function (procent) {
            if (Game.first && Game.pc)
                if (procent > this.lastProcent) {
                    this.lastProcent = procent;
                    this.fillMask.beginFill();
                    this.fillMask.moveTo(0, 0);
                    this.fillMask.drawRect(0, 0, 1000 * procent, 200);
                    this.fillMask.endFill();
                }
        }.bind(this));
    };
};

Menu.prototype.init = function(params){
    this.pages = [];
    for (var key in params){
        this.pages[key] = new Page(params[key]);
    }
};

Menu.prototype.touch = function() {
    for (var i=Game.touchList.length-1; i>=0; i--) {
        var touch = Game.touchList[i];
        if (!touch.gui) {
            for (var i2 = this.pages[this.currentPage].objGui.length - 1; i2 >= 0; i2--) {
                if (this.pages[this.currentPage].objGui[i2].checkTouch(touch)) {
                    touch.gui = this.pages[this.currentPage].objGui[i2];
                    break;
                }
            }
        } else
            touch.gui.onTouch(touch);

        if ((touch)&&(touch.touchedEnd)){
            touch.del();
        }
    }
};

var Page = function (params){
    this.objGui = [];
    this.container = new PIXI.Container();
    this.init(params);
};

Page.prototype.init = function (params) {
    var gui, key;
    for (key in params) {
        if (params.hasOwnProperty(key)) {
            gui = new Gui(params[key]);
            this.container.addChild(gui.guiContainer);
            this.objGui.push(gui);
        }
    }
};
