﻿var multitouchInit = function (myCanvas) {
    function onStart ( touchEvent ) {
        touchEvent.preventDefault();
    }
    myCanvas.addEventListener( "touchstart", function(e){ onStart(e); }, false );
    myCanvas.addEventListener( "touchmove", function(e){ onStart(e); }, false );
    myCanvas.addEventListener( "touchend", function(e){ onStart(e); }, false );

    function wheel(event) {
        event = event || window.event;
        var delta = event.deltaY || event.detail || event.wheelDelta;
        delta *= -1;
        delta = delta/Math.abs(delta);
        if (Game.lvl)
            if (Game.lvl.camera)
                if (Game.lvl.camera.scale)
                    Game.lvl.camera.scale(0.1*(delta), new Vec2((event.x || event.clientX)*Game.width/Game.windowWidth, (event.y || event.clientY)*Game.width/Game.windowWidth));
    }

    function addHandler(elem) {
        if (elem.addEventListener) {
            if ('onwheel' in document) {
                elem.addEventListener("wheel", wheel, false);
            } else if ('onmousewheel' in document) {
                elem.addEventListener("mousewheel", wheel, false);
            } else {
                elem.addEventListener("MozMousePixelScroll", wheel, false);
            }
        } else { // IE<9
            elem.attachEvent("onmousewheel", wheel);
        }
    }

    //addHandler(document);
    //addHandler(window);
    addHandler(myCanvas);
    if (true) {
        if (!window.MSPointerEvent) {
            myCanvas.addEventListener("touchmove", function (touchEvent) {
                var alife;
                for (var i2 = 0; i2 < touchEvent.changedTouches.length; i2++) {
                    for (var i = 0; i < Game.touchList.length; i++) {
                        if (Game.touchList[i].id == touchEvent.changedTouches[i2].identifier) {
                            Game.touchList[i].move(touchEvent.changedTouches[i2].pageX, touchEvent.changedTouches[i2].pageY);
                        }
                    }
                }
                if (Game.touchList.length > touchEvent.touches.length) {
                    for (i2 = 0; i2 < Game.touchList.length; i2++) {
                        alife = false;
                        for (i = 0; i < touchEvent.touches.length; i++) {
                            if (Game.touchList[i2].id == touchEvent.touches[i].identifier)
                                alife = true;
                        }
                        if (!alife)
                            Game.touchList[i2].end();
                    }
                }
            }.bind(this));

            myCanvas.addEventListener("touchstart", function (touchEvent) {
                Game.touched = true;
                for (var i = 0; i < touchEvent.changedTouches.length; i++) {
                    Game.touchList.push(new touch(touchEvent.changedTouches[i].pageX, touchEvent.changedTouches[i].pageY, touchEvent.changedTouches[i].identifier));
                }
            }.bind(this));

            myCanvas.addEventListener("touchend", function (touchEvent) {
                for (var i2 = 0; i2 < touchEvent.changedTouches.length; i2++) {
                    for (var i = 0; i < Game.touchList.length; i++) {
                        if (Game.touchList[i].id == touchEvent.changedTouches[i2].identifier) { Game.touchList[i].end(); }
                    }
                }
            }.bind(this));

            myCanvas.addEventListener("mousemove", function (mouseEvent) {
                if (Game.touchList.length > 0) {
                    Game.touchList[0].move(mouseEvent.pageX, mouseEvent.pageY);
                }
            }.bind(this));

            myCanvas.addEventListener("mousedown", function (mouseEvent) {
                onStart(mouseEvent);
                if (Game.noTouch < 1)
                    Game.touchList.push(new touch(mouseEvent.pageX, mouseEvent.pageY, 0));
            }.bind(this));

            myCanvas.addEventListener("mouseup", function (mouseEvent) {
                if (Game.touchList.length > 0) {
                    for (var i = 0; i < Game.touchList.length; i++)
                        Game.touchList[i].end();
                }
            }.bind(this));

            myCanvas.addEventListener("mouseout", function (mouseEvent) {
                if (Game.touchList.length > 0) {
                    for (var i = 0; i < Game.touchList.length; i++)
                        Game.touchList[i].end();
                }
            }.bind(this));
        } else {
            myCanvas.addEventListener("MSPointerDown", function (evt) {
                Game.touchList.push(new touch(evt.pageX, evt.pageY, evt.pointerId));
            });

            myCanvas.addEventListener("MSPointerMove", function (evt) {
                    for (var i = 0; i < Game.touchList.length; i++) {
                        if (Game.touchList[i].id == evt.pointerId) {
                            Game.touchList[i].move(evt.pageX, evt.pageY);
                        }
                    }
            });
            myCanvas.addEventListener("MSPointerUp", function (evt) {
                for (var i = 0; i < Game.touchList.length; i++) {
                    if (Game.touchList[i].id == evt.pointerId) { Game.touchList[i].end(); }
                }
            });

            myCanvas.addEventListener("MSPointerOut", function (evt) {
                for (var i = 0; i < Game.touchList.length; i++) {
                    if (Game.touchList[i].id == evt.pointerId) { Game.touchList[i].end(); }
                }
            });
        }
        //setup keyboard Input
    }
};


var touch = function  (_ex, _ey, _id){
    _ex *= Game.width/Game.windowWidth;
    _ey *= Game.width/Game.windowWidth;
    if (Game.isWindowsPhone) {
        _ex *= window.screen.deviceXDPI / window.screen.logicalXDPI;
        _ey *= window.screen.deviceYDPI / window.screen.logicalYDPI;
    } else {
        _ex *= window.touchMultiplyer;
        _ey *= window.touchMultiplyer;
    }
    this.gui = null;
    this.id= _id;
    this.startPosition = new Vec2(_ex, _ey);
    this.lastPosition = new Vec2(_ex, _ey);
    this.touchedEnd = false;

    this.move = function (newX, newY) {
        this.lastPosition.x =  newX*window.touchMultiplyer*Game.width/Game.windowWidth;
        this.lastPosition.y = newY*window.touchMultiplyer*Game.width/Game.windowWidth;
    };

    this.end = function (){
        this.touchedEnd = true;
    };

    this.del = function () {
        if (Game.touchList.indexOf(this) !== -1)
            Game.touchList.splice(Game.touchList.indexOf(this), 1);
    }
};

var input = function  (_id){
    this.id= _id;
    this.del = function (){
        Game.inputList.splice(Game.inputList.indexOf(this), 1);
    }
};
