﻿function loadSpritesAndAnimations (callback) {
    var key;
    Game.backgrounds = {};

    var loadAtlases = function(data){
        for(key in data.sprites) {
            Game.sprites[data.sprites[key].name] = data.sprites[key];
        }

        for(key in data.atlases){
            Game.atlases.push(new Atlas(data.atlases[key].file, data.atlases[key].tag))
        }

        for(key in data.animations){
            Game.animations[data.animations[key].name] = new Animation(data.animations[key]);
            Game.animations[data.animations[key].name].name = data.animations[key].name;
        }
        callback();
    }.bind(this);




    var loadJSON = function (path, success, error)
    {
        var xhr = new XMLHttpRequest();
        xhr.onreadystatechange = function()
        {
            if (xhr.readyState === 4) {
                if (xhr.status === 200) {
                    if (success)
                        success(JSON.parse(xhr.responseText));
                } else {
                    if (error)
                        error(xhr);
                }
            }
        };
        xhr.open("GET", path, true);
        xhr.send();
    };

    loadJSON((!Game.isWindowsPhone || !Game.isLowMemory) ? "atlases/info.json" : "atlases2/info.json", loadAtlases, null);
}